    
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Charting Functions
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
 
var global_selected_cycle_as_number = 0;
var global_selected_cycle_end_as_number = 0;
var global_selected_cycle_offset = 0;
var global_last_analysis_screen = 1;
var global_num_ev_rows = -1;
var global_Block_Global_Analysis_Pages = false;

var INTERCOURSE_EVENT_INDEX = 38;
var PROTECTED_INTERCOURSE_EVENT_INDEX = 42;
var POS_PREG_TEST_EVENT_INDEX = 62;
var SPOTTING_EVENT_INDEX = 30;

var MAX_NUMBER_OF_CHART_COLUMNS = 40;
var MAX_NUMBER_OF_GRAPH_COLUMNS = 40;
var NUMBER_OF_TEMP_ROWS = 15;
var CHART_BOTTOM_Y_AXIS = 242;
var NUMBER_OF_LOWER_SYMPTOMS;

var CYC_TYPE = 0;
var PREG_TYPE = 1;
var POSTPARTUM_TYPE = 2;

var lowestAxisTemp;
var highestAxisTemp;

// Function draws a symptothermal chart given passed data arrays. 
function PopulateChart_Data(temp, mucus, mens, monitor, ovtest_am, ovtest_pm, cervix, saliva, intdays, bcontrol, discard, unsure, tempRange, mflow, fweight, cerv_cons, cerv_dia, muc_sens, muc_acons, bbt_cov, chartSettings)
{    
LogCall('1e');
    var tempExtremeDiff;
    var tempInterval;
    var tempExtremeDiffTest;
    var tempIntervalTest;
    var num_temp_rows = NUMBER_OF_TEMP_ROWS;
    var useTempRangeC = false;
    var row_offset;
    var width;
    var height;
    var img_index;
    var cols_to_handle;
    var i = 0;
    
    // Initialize
    var MAX_CIRCLE_CELL_BOXES = MAX_NUMBER_OF_CHART_COLUMNS;
    for (img_index=1; img_index <= MAX_CIRCLE_CELL_BOXES; img_index++)
    {
        document.getElementById('circle_cell_' + img_index).style.display = "none";      // Initialize not to be visible 
    }
    var MAX_BBT_CROSS_HAIRS = 2;
    for (img_index=1; img_index<=MAX_BBT_CROSS_HAIRS; img_index++)
    {
        // Initialize not to be visible
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            document.getElementById('bbt_cross_horzU_' + img_index).style.display = "none";
            document.getElementById('bbt_cross_horzL_' + img_index).style.display = "none";
        }
        else
        {
            document.getElementById('bbt_cross_horz_' + img_index).style.display = "none";
            document.getElementById('bbt_cross_vert_' + img_index).style.display = "none";
        }
    }
    var MAX_UNSURE_CIRCLES = MAX_NUMBER_OF_CHART_COLUMNS;
    for (img_index=1; img_index<=MAX_UNSURE_CIRCLES; img_index++)
    {
        document.getElementById('unsure_' + img_index).style.display = "none";      // Initialize not to be visible
    }
    
    // Decide how many columns to iterate
    if (temp.length < chartSettings.chart_num_of_cols) 
    {
        cols_to_handle = temp.length;
    }
    else
    {
        cols_to_handle = chartSettings.chart_num_of_cols;
    }

    // Determine the temp scale needed for the y-axis
    if (tempRange.MinTemp <= tempRange.MaxTemp)
    {
        // There is temperature data to consider: Auto-scale temperature axis
        tempExtremeDiff = Math.floor((tempRange.MaxTemp - tempRange.MinTemp + 0.0001) * 10);
        tempInterval = Math.ceil((tempExtremeDiff / (num_temp_rows - 1)));
        if (tempInterval == 0)
        {
            tempInterval = 1;
        }
        lowestAxisTemp = tempRange.MinTemp - Math.floor(((tempInterval * (num_temp_rows - 1)) - tempExtremeDiff) / 2) / 10;
        highestAxisTemp = lowestAxisTemp + ((tempInterval / 10) * (num_temp_rows - 1));
        tempInterval = tempInterval / 10;
    }
    else
    {
        if (useTempRangeC == true)
        {
            lowestAxisTemp = 35.9;
            tempInterval = 0.1;
            highestAxisTemp = lowestAxisTemp + (tempInterval * (num_temp_rows - 1));
        }
        else
        {
            lowestAxisTemp = 97.9;
            tempInterval = 0.1;
            highestAxisTemp = lowestAxisTemp + (tempInterval * (num_temp_rows - 1));
        }
    }

    // Populate Y axis Values
    for( i = 1; i <= num_temp_rows; i++)
    {
        document.getElementById('ChartingY_R' + i).innerHTML = (highestAxisTemp - ((i - 1) * tempInterval)).toFixed(1);
    }
	
    // Populate the temperature points
    var y_pos;
    var x_pos;
    var last_y_pos = 0;
    var last_x_pos = 0;
    var line_height = 0;
    var unsure_counter = 1;
    
    // Loop through all supplied temperatures
    for( i = 0; i < cols_to_handle; i++)
    {
        // Only plot those that are non-zero
        if ((temp[i] > 0) && (discard[i] == 0))
        {
            y_pos = chartSettings.chart_bottom_y_axis - ((temp[i] - lowestAxisTemp) / (highestAxisTemp - lowestAxisTemp)) * (chartSettings.chart_row_height * (num_temp_rows - 1));
            y_pos = Math.round(y_pos);
            x_pos = chartSettings.chart_day1_x_offset + 5 + (chartSettings.chart_col_width * i);
            document.getElementById('temp_' + i).style.display = "block";
            document.getElementById('temp_' + i).style.top = y_pos + "px";
            document.getElementById('temp_' + i).style.left = x_pos + "px";
            
            // Number PreShift 6 for CCL
            if (BUILD_TARGET == BUILD_4_CCL)
            {
                // Change which image is shown
                if ((chartSettings.cclst_cov[i] > 0) && (chartSettings.cclst_cov[i] <= 6))
                {
                    // Days 2-6 preceding the shift
                    document.getElementById('temp_' + i).innerHTML = '<img src="images/dot' + chartSettings.cclst_cov[i] + '.png" />';
                }
                else if (chartSettings.cclst_cov[i] > 0)
                {
                    // Day 1 preceding the shift (the day of ovulation)
                    document.getElementById('temp_' + i).innerHTML = '<img src="images/dot1.png" />';
                }
                else
                {
                    // Not the day of the shift nor any of the 6 days prior
                    document.getElementById('temp_' + i).innerHTML = '<img src="images/dot.png" />';
                }
            }
            
            // Circle temp if marked unsure
            if ((unsure[i] != 0) && (unsure_counter <= MAX_UNSURE_CIRCLES))
            {
                document.getElementById('unsure_' + unsure_counter).style.display = "block";
                document.getElementById('unsure_' + unsure_counter).style.top = (y_pos-4) + "px";
                document.getElementById('unsure_' + unsure_counter).style.left = (x_pos-4) + "px";
                unsure_counter = unsure_counter + 1;
            }
            
            // Draw connecting lines
            if ((last_x_pos != 0) && (last_y_pos != 0))
            {
                line_height = y_pos - last_y_pos
    
                document.getElementById('line_' + i).style.display = "block";
                document.getElementById('line_' + i).style.left = (last_x_pos + 5) + "px";
                document.getElementById('line_img_' + i).style.width = chartSettings.chart_col_width + "px";
                
                if (line_height < 0)
                {
                    document.getElementById('line_' + i).style.top = (last_y_pos + line_height + 5) + "px";
                    document.getElementById('line_img_' + i).style.height = (-1)*(line_height) + "px";
                    document.getElementById('line_img_' + i).src = 'images/line_up.png';
                }
                else if (line_height > 0)
                {
                    document.getElementById('line_' + i).style.top = (last_y_pos + 5) + "px";
                    document.getElementById('line_img_' + i).style.height = line_height + "px";
                    document.getElementById('line_img_' + i).src = 'images/line_down.png';
                }
                else
                {
                    document.getElementById('line_' + i).style.top = (last_y_pos - 4) + "px";
                    document.getElementById('line_img_' + i).style.height = "1px";
                    document.getElementById('line_img_' + i).src = 'images/line_straight.png';
                }
            }
            else if (i > 0)
            {
                document.getElementById('line_' + i).style.display = "none";
            }
            
            //save last temperature points
            last_y_pos = y_pos
            last_x_pos = x_pos
        }
        else 
        {
            // No point shown.  Also set last points to zero so it doesn't try to draw a connecting line
            document.getElementById('temp_' + i).style.display = "none";
            if (i > 0)
            {
                document.getElementById('line_' + i).style.display = "none";
            }
            last_y_pos = 0;
            last_x_pos = 0;
        }
    }
    // Hide any other temperatures points and lines beyond what needs plotted
    for(i=cols_to_handle; i<MAX_NUMBER_OF_CHART_COLUMNS; i++)
    {
        document.getElementById('temp_' + i).style.display = "none";
        document.getElementById('line_' + i).style.display = "none";
    }

    // Draw cross hairs where needed
    var counter = 1;
    var EXTRA_THICKNESS = 4;
    var coverline;
    for(var column=0; column<bbt_cov.length; column++)
    {
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            // Pick applicable coverline to use
            if (chartSettings.phase_iii_use_st)
            {
                coverline = chartSettings.cclst_cov[column];    // ST Rule
            }
            else
            {
                coverline = bbt_cov[column];                    // Temp Only Rule 
            }
        }
        else
        {
            coverline = bbt_cov[column];
        }
        if ((coverline > 6) && (counter <= MAX_BBT_CROSS_HAIRS))            // Any real temp will be > 6.  For CCL, remapping to 1-6 are reserved for pre-shift numbering.
        {
            // Horizontal line - Calculations
            var start_column = column - 5;  // values are zero indexed
            var end_column = column + 3;    // values are zero indexed
            if (start_column < 0)
            {
                start_column = 0;
            }
            if (end_column > (chartSettings.chart_num_of_cols-1))
            {
                end_column = chartSettings.chart_num_of_cols-1;
            }
            x_pos = chartSettings.chart_day1_x_offset + (chartSettings.chart_col_width * start_column) - EXTRA_THICKNESS/2 + 1;
            y_pos = chartSettings.chart_bottom_y_axis - ((coverline - lowestAxisTemp) / (highestAxisTemp - lowestAxisTemp)) * (chartSettings.chart_row_height * (num_temp_rows - 1));
            y_pos = Math.round(y_pos) - EXTRA_THICKNESS/2 - 1;
            width = (end_column - start_column + 1) * chartSettings.chart_col_width + 3;
            height = 3;
            // Horizontal line - Placement
            if (BUILD_TARGET == BUILD_4_CCL)
            {
                var x_pos_Lower;
                var y_pos_Lower;
                var CCL_UPPER_LINE_SHIFT = 0.4;
                document.getElementById('bbt_cross_horzL_' + counter).style.display = "block";
                document.getElementById('bbt_cross_horzL_' + counter).style.left = x_pos + "px";
                document.getElementById('bbt_cross_horzL_' + counter).style.top = y_pos + "px";
                document.getElementById('bbt_cross_horzL_img_' + counter).style.width = width + "px";
                document.getElementById('bbt_cross_horzL_img_' + counter).style.height = height + "px";   
                // Additionally show an upper line for CCL
                if ((coverline + CCL_UPPER_LINE_SHIFT - 0.05) <= highestAxisTemp)
                {
                    // Second horizontal line is 3 days later (+3 at end)
                    start_column = column - 5 + 3;  // values are zero indexed
                    end_column = column + 3 + 3;    // values are zero indexed
                    if (start_column < 0)
                    {
                        start_column = 0;
                    }
                    if (end_column > (chartSettings.chart_num_of_cols-1))
                    {
                        end_column = chartSettings.chart_num_of_cols-1;
                    }
                    width = (end_column - start_column + 1) * chartSettings.chart_col_width + 3;
                    x_pos_Lower = chartSettings.chart_day1_x_offset + (chartSettings.chart_col_width * start_column) - EXTRA_THICKNESS/2 + 1;
                    y_pos_Lower = y_pos - (CCL_UPPER_LINE_SHIFT / (highestAxisTemp - lowestAxisTemp)) * (chartSettings.chart_row_height * (num_temp_rows - 1));
                    document.getElementById('bbt_cross_horzU_' + counter).style.display = "block";
                    document.getElementById('bbt_cross_horzU_' + counter).style.left = x_pos_Lower + "px";
                    document.getElementById('bbt_cross_horzU_' + counter).style.top = y_pos_Lower + "px";
                    document.getElementById('bbt_cross_horzU_img_' + counter).style.width = width + "px";
                    document.getElementById('bbt_cross_horzU_img_' + counter).style.height = height + "px"; 
                }                
            }
            else
            {
                document.getElementById('bbt_cross_horz_' + counter).style.display = "block";
                document.getElementById('bbt_cross_horz_' + counter).style.left = x_pos + "px";
                document.getElementById('bbt_cross_horz_' + counter).style.top = y_pos + "px";
                document.getElementById('bbt_cross_horz_img_' + counter).style.width = width + "px";
                document.getElementById('bbt_cross_horz_img_' + counter).style.height = height + "px";
            }
            
            // Vertical line - Calculations
            if (BUILD_TARGET != BUILD_4_CCL)
            {
                var top_point = y_pos - 3.0 * (chartSettings.chart_row_height);
                var bottom_point = y_pos + 4.0 * (chartSettings.chart_row_height);
                if (top_point < 0)
                {
                    top_point = 0;
                }
                if (bottom_point > (bottom_point * num_temp_rows))
                {
                    bottom_point = (bottom_point * num_temp_rows);
                }
                x_pos = chartSettings.chart_day1_x_offset + (chartSettings.chart_col_width * (column+1)) - EXTRA_THICKNESS/2 + 1;
                y_pos = top_point;
                width = 3;
                height = bottom_point - top_point;
                // Vertical line - Placement
                document.getElementById('bbt_cross_vert_' + counter).style.display = "block";
                document.getElementById('bbt_cross_vert_' + counter).style.left = x_pos + "px";
                document.getElementById('bbt_cross_vert_' + counter).style.top = y_pos + "px";
                document.getElementById('bbt_cross_vert_img_' + counter).style.width = width + "px";
                document.getElementById('bbt_cross_vert_img_' + counter).style.height = height + "px";
            }
            counter = counter + 1;
        }
    }
    
    if (BUILD_TARGET == BUILD_4_CCL)
    {
        // Update lower rows.  First start by indicating Intercourse and Birth Control by circling Cycle Days
        row_offset = 1 + num_temp_rows;
        var EXTRA_THICKNESS = 4;
        var circle_cell_counter = 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            if (intdays[column-1] == 1)
            {
                document.getElementById('ChtEvCoitus_C' + column).innerHTML = 'X';
            }
            else
            {
                document.getElementById('ChtEvCoitus_C' + column).innerHTML = '';
            }
        }

        // Show Menses Flow
        row_offset = row_offset + 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            switch(mflow[column-1])
            {
                case 'na':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '';
                    break;
                case 'Sp':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '<img src="images/ccl_spotting.png">';
                    break;
                case 'Li':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '<img src="images/ccl_light.png">';
                    break;
                case 'He':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '<img src="images/ccl_heavy.png">';
                    break;
            }
        }

        // Display Peak Day
        row_offset = row_offset + 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            if (chartSettings.bill_itp_mucus_peak[column-1] == 'X')
            {
                document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = 'P';
            }
            else if (parseInt(chartSettings.bill_itp_mucus_peak[column-1]) > 0)
            {
                document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = chartSettings.bill_itp_mucus_peak[column-1];
            }
            else
            {
                document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '';
            }
        }
       
        // Mucus Symbol
        row_offset = row_offset + 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            switch(mucus[column-1])
            {
                case 'D':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '<img src="images/ccl_mucus_d.png">';
                    break;
                case 'M':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '<img src="images/ccl_mucus_m.png">';
                    break;
                case 'F':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '<img src="images/ccl_mucus_f.png">';
                    break;
                default:
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '';
                    break;
            }
        }
        
        // Sensations
        row_offset = row_offset + 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            switch(muc_sens[column-1])
            {
                case 'D':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '<div style="margin-top:7px;">d</div>';
                    break;
                case 'M-':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '<div style="margin-top:7px;">m</div>';
                    break;
                case 'M+':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '<div style="margin-top:7px;">w</div>';
                    break;
                case 'F':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '<div style="margin-top:7px;">sl</div>';
                    break;
                case 'MF':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = 'w<br>sl';
                    break;
                default:
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '';
                    break;
            }
        }
        
        // Characteristics
        row_offset = row_offset + 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            switch(muc_acons[column-1])
            {
                case 'D':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = 'n';
                    break;
                case 'M+':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = 't';
                    break;
                case 'F':
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = 's';
                    break;
                default:
                    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '';
                    break;
            }
        }
        
        // Cervix Position
        row_offset = row_offset + 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            var cervixStr = '';
            switch(cerv_cons[column-1])
            {
                case 'L':
                    cervixStr += 'h<br>';
                    break;
                case 'H':
                    cervixStr += 'so<br>';
                    break;
                default:
                    cervixStr += '&nbsp;<br>';
                    break;
            }
            switch(cerv_dia[column-1])
            {
                case 'L':
                    cervixStr += '<span style="font-size:14px"><b>.</b></span>';
                    break;
                case 'M':
                    cervixStr += '<span style="font-size:7px">o</span>';
                    break;
                case 'H':
                    cervixStr += '<span style="font-size:12px">o</span>';
                    break;
                case 'P':
                    cervixStr += '<span style="font-size:14px">O</span>';
                    break;
            }
            document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = cervixStr;
        }

        // Display Recorded Test Results
        var tracking_symptom = false;
        row_offset = row_offset + 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            if ( (ovtest_am[column-1] != '') && (ovtest_pm[column-1] != '') )
            {
                document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = yesno2plusminus(ovtest_am[column-1]) + '&nbsp;' + yesno2plusminus(ovtest_pm[column-1]);
                tracking_symptom = true;
            }
            else if (ovtest_am[column-1] != '')
            {
                document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = yesno2plusminus(ovtest_am[column-1]) + '&nbsp;&nbsp;';
                tracking_symptom = true;
            }
            else if (ovtest_pm[column-1] != '')
            {
                document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '&nbsp;&nbsp;' + yesno2plusminus(ovtest_pm[column-1]);
                tracking_symptom = true;
            }
        }
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            // Dynamically show or hide row. Coded different for CCL b/c this field is on a different row in the chart.
            if (tracking_symptom)
            {
                // Show LH tracking row in chart
                document.getElementById('ChtExtendRowsN23').style.display = 'block';
                document.getElementById('ChtExtendRows23').style.display = 'block';
                // Adjust any peak day X 
                if (chartSettings.monitorPeak_x_cell_counter > 0)
                {
                    var y_pos = document.getElementById('x_cell_' + chartSettings.monitorPeak_x_cell_counter).style.top;
                    var pos = y_pos.search("px");
                    if (pos > 0)
                    {
                        y_pos = Math.floor(y_pos.substring(0, pos)) + 2;
                    }
                    document.getElementById('x_cell_' + chartSettings.monitorPeak_x_cell_counter).style.top = (y_pos + chartSettings.chart_row_height) + "px";
                }
            }
            else
            {
                // Hide LH tracking row in chart
                document.getElementById('ChtExtendRowsN23').style.display = 'none';
                document.getElementById('ChtExtendRows23').style.display = 'none';  
            }
        }
        
        // Display Fertility Monitor Row Value
        tracking_symptom = false;
        row_offset = row_offset + 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            if (monitor[column-1] != '')
            {
                document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = monitor[column-1];
                tracking_symptom = true;
            }
            else
            {
                document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '';
            }
        }
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            // Dynamically show or hide row. Coded different for CCL b/c this field is on a different row in the chart.
            if (tracking_symptom)
            {
                // Show LH tracking row in chart
                document.getElementById('ChtExtendRowsN24').style.display = 'block';
                document.getElementById('ChtExtendRows24').style.display = 'block';
            }
            else
            {
                // Hide LH tracking row in chart
                document.getElementById('ChtExtendRowsN24').style.display = 'none';
                document.getElementById('ChtExtendRows24').style.display = 'none';  
            }
        }
    }
    else
    {
        // Update lower rows.  First start by indicating Intercourse and Birth Control by circling Cycle Days
        row_offset = 1 + num_temp_rows;
        var EXTRA_THICKNESS = 4;
        var circle_cell_counter = 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            if (((bcontrol[column-1] == 1) || (intdays[column-1] == 1)) && (circle_cell_counter <= MAX_CIRCLE_CELL_BOXES))
            {
                // Calculate position
                x_pos = chartSettings.chart_day1_x_offset + (chartSettings.chart_col_width * (column-1)) - EXTRA_THICKNESS/2 + 1;
                y_pos = (row_offset - 1) * chartSettings.chart_row_height - EXTRA_THICKNESS/2 + 1;
                width = chartSettings.chart_col_width + EXTRA_THICKNESS;
                height = chartSettings.chart_row_height + EXTRA_THICKNESS - 1;
                // Determine which image to show
                if (bcontrol[column-1] == 1)
                {
                    document.getElementById('circle_cell_img_' + circle_cell_counter).src = 'images/circle_yellow.png';
                }
                else
                {
                    document.getElementById('circle_cell_img_' + circle_cell_counter).src = 'images/circle_black.png';
                }
                // Place and stretch image
                document.getElementById('circle_cell_' + circle_cell_counter).style.display = "block";
                document.getElementById('circle_cell_' + circle_cell_counter).style.left = x_pos + "px";
                document.getElementById('circle_cell_' + circle_cell_counter).style.top = y_pos + "px";
                document.getElementById('circle_cell_img_' + circle_cell_counter).style.width = width + "px";
                document.getElementById('circle_cell_img_' + circle_cell_counter).style.height = height + "px";
                circle_cell_counter = circle_cell_counter + 1;
            }
        }
        
        // Shade Cervical Mucus Row and Print Value
        row_offset = row_offset + 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = assign_if_not_na(mucus[column-1]);
            // If menstruation is recorded, it supercedes the mucus specified value. 
            if (mens[column-1] == 1)
            {
                document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = 'P';
                document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).style.backgroundColor = "#FF00FF";
            }
        }

        // Display Recorded Test Results
        row_offset = row_offset + 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            if ( (ovtest_am[column-1] != 'na') && (ovtest_pm[column-1] != 'na') )
            {
                document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = yesno2plusminus(ovtest_am[column-1]) + '&nbsp;' + yesno2plusminus(ovtest_pm[column-1]);
            }
            else if (ovtest_am[column-1] != 'na')
            {
                document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = yesno2plusminus(ovtest_am[column-1]) + '&nbsp;&nbsp;';
            }
            else if (ovtest_pm[column-1] != 'na')
            {
                document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = '&nbsp;&nbsp;' + yesno2plusminus(ovtest_pm[column-1]);
            }
        }
        
        // Display Fertility Monitor Row Value
        row_offset = row_offset + 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = assign_if_not_na(monitor[column-1]);
        }
        
        // Display Cervix Value
        row_offset = row_offset + 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = assign_if_not_na(cervix[column-1]);
        }
        
        // Display Saliva Ferning Value
        //row_offset = row_offset + 1;
        //for( var column = 1; column <= cols_to_handle; column++ )
        //{
        //    document.getElementById('ChartingCell_R' + (row_offset) + '_C' + (column)).innerHTML = assign_if_not_na(saliva[column-1]);
        //}  
    }

    return;
}

function PopulateChart_Interp(fpct_all, fpct_cm, fpct_saliva, fpct_mon, fpct_bbt, fpct_rhy, fpct_lh, fpct_cervix, cyc_day, dpo_day, caldates, year, all_ov, fwin, cm_ov, mon_ov, bill_itp_mucus_peak, cycle_start, chartSettings)
{  
LogCall('1f');
    var num_temp_rows = NUMBER_OF_TEMP_ROWS;
    var row_offset = 0;
    var x_pos;
    var y_pos;
    var height;
    var width;
    var counter;
    var x_cell_counter;
    var cols_to_handle;
    var EXTRA_THICKNESS = 4;
    var NUMBER_OF_ROWS = 21;

    // First size up the chart appropriately by looping through columns and deciding which should be visible
    for (var i=1; i<=MAX_NUMBER_OF_CHART_COLUMNS; i++)
    {
        if (i <= chartSettings.chart_num_of_cols)
        {
            // Make this column visible at the top symptom part of the chart (events are handled separately)
            document.getElementById('ChartColumn_' + i).style.display = "block";
            
            
            if (BUILD_TARGET == BUILD_4_CCL)
            {
				document.getElementById('ChartingCell_R21_C' + i).style.display = "block";            
				document.getElementById('ChartingCell_R22_C' + i).style.display = "block";
                document.getElementById('ChartingCell_R23_C' + i).style.display = "block";
                document.getElementById('ChartingCell_R24_C' + i).style.display = "block";
                document.getElementById('ChartingDateCell_C' + i).style.display = "block";
                document.getElementById('ChtEvCoitus_C' + i).style.display = "block";
            }
        }
        else
        {
            // Make this column invisible at the top symptom part of the chart (events are handled separately)
            document.getElementById('ChartColumn_' + i).style.display = "none";
            if (BUILD_TARGET == BUILD_4_CCL)
            {
                document.getElementById('ChartingCell_R21_C' + i).style.display = "none";
                document.getElementById('ChartingCell_R22_C' + i).style.display = "none";
                document.getElementById('ChartingCell_R23_C' + i).style.display = "none";
                document.getElementById('ChartingCell_R24_C' + i).style.display = "none";
                document.getElementById('ChartingDateCell_C' + i).style.display = "none";
                document.getElementById('ChtEvCoitus_C' + i).style.display = "none";
            }
        }
    }
    
    // Initialize
    var MAX_X_CELL_BOXES = 5;
    chartSettings.monitorPeak_x_cell_counter = -1;
    for (var img_index=1; img_index <= MAX_X_CELL_BOXES; img_index++)
    {
        document.getElementById('x_cell_' + img_index).style.display = "none";      // Initialize not to be visible 
    }
    
    // Decide how many columns to iterate
    if (fpct_all.length < chartSettings.chart_num_of_cols) 
    {
        cols_to_handle = fpct_all.length;
    }
    else
    {
        cols_to_handle = chartSettings.chart_num_of_cols;
    }
    
    // Shade Temp Cells
    row_offset = 1;
    for( var column = 1; column <= cols_to_handle; column++ )
	{
        for( var row = row_offset; row < (num_temp_rows + row_offset); row++ )
        {
            applyShadingToDiv('ChartingCell_R' + (row) + '_C' + (column), fpct_bbt[column-1]);
        }
	}

    // Shade Day of Cycle Row with Rhythm Method and Label Cycle/DPO Days
    row_offset = num_temp_rows + 1;
    var date_obj = NumberToDate(cycle_start);
    var weekday_ctr = (date_obj.getDay() + 6) % 7;
    for( var column = 1; column <= cols_to_handle; column++ )
	{
        div_str = 'ChartingCell_R' + (row_offset) + '_C' + (column);
        applyShadingToDiv(div_str, fpct_rhy[column-1]);
        switch (chartSettings.pregnancy)
        {
        case CYC_TYPE:
            document.getElementById(div_str).innerHTML = cyc_day[column-1];
            break;
        case PREG_TYPE:
            document.getElementById(div_str).innerHTML = (parseInt((cyc_day[column-1]-2)/7)+1);
            break;
        case POSTPARTUM_TYPE:
            if (cyc_day[column-1] == 1)
            {
                document.getElementById(div_str).innerHTML = '0';
            }
            else
            {
                document.getElementById(div_str).innerHTML = (parseInt((cyc_day[column-1]-2)/7)+1);
            }
            break;
        }
        if (weekday_ctr <= 4)
        {
            document.getElementById(div_str).style.color = "#0000C0";
        }
        else
        {
            document.getElementById(div_str).style.color = "#000000";
        }
        weekday_ctr = (weekday_ctr + 1) % 7;
        document.getElementById('ChartingCell_R1_C' + (column)).innerHTML = dpo_day[column-1]; 
    }
    if (chartSettings.pregnancy == PREG_TYPE)
    {
        document.getElementById('ChartingY_R16').innerHTML = 'Week of Preg';
    }
    else if (chartSettings.pregnancy == POSTPARTUM_TYPE)
    {
        document.getElementById('ChartingY_R16').innerHTML = 'Week PostP';
    }
    else
    {
        document.getElementById('ChartingY_R16').innerHTML = 'Day of Cycle';
    }

    // Shade Cervical Mucus Row and Draw Ovulation X if needed
    row_offset = row_offset + 1;
    x_cell_counter = 1;
    for( var column = 1; column <= cols_to_handle; column++ )
	{
        applyShadingToDiv('ChartingCell_R' + (row_offset) + '_C' + (column), fpct_cm[column-1]);
        if (((cm_ov[column-1] == 1) && (x_cell_counter <= MAX_X_CELL_BOXES)) && (BUILD_TARGET != BUILD_4_CCL))
        {
            // Calculate position
            x_pos = chartSettings.chart_day1_x_offset + (chartSettings.chart_col_width * (column-1)) - EXTRA_THICKNESS/2 + 1;
            y_pos = (row_offset - 1) * chartSettings.chart_row_height - EXTRA_THICKNESS/2 + 1;
            width = chartSettings.chart_col_width + EXTRA_THICKNESS;
            height = chartSettings.chart_row_height + EXTRA_THICKNESS - 1;
            // Place and stretch image
            document.getElementById('x_cell_img_' + x_cell_counter).src = 'images/x_black.png';
            document.getElementById('x_cell_' + x_cell_counter).style.display = "block";
            document.getElementById('x_cell_' + x_cell_counter).style.left = x_pos + "px";
            document.getElementById('x_cell_' + x_cell_counter).style.top = y_pos + "px";
            document.getElementById('x_cell_img_' + x_cell_counter).style.width = width + "px";
            document.getElementById('x_cell_img_' + x_cell_counter).style.height = height + "px";
            x_cell_counter = x_cell_counter + 1;
        }
    }
    
    // Shade Ovulation Test Row 
    row_offset = row_offset + 1;
    for( var column = 1; column <= cols_to_handle; column++ )
	{
        applyShadingToDiv('ChartingCell_R' + (row_offset) + '_C' + (column), fpct_lh[column-1]);
    }

    // Shade Fertility Monitor Row and Draw Ovulation X if needed
    row_offset = row_offset + 1;
    for( var column = 1; column <= cols_to_handle; column++ )
	{
        applyShadingToDiv('ChartingCell_R' + (row_offset) + '_C' + (column), fpct_mon[column-1]);
        if ((mon_ov[column-1] == 1) && (x_cell_counter <= MAX_X_CELL_BOXES))
        {
            // CCL has diff row ordering
            var mon_row_offset = row_offset;
            if (BUILD_TARGET == BUILD_4_CCL)
            {
                mon_row_offset = row_offset + 5.7;
            }
            // Calculate position
            x_pos = chartSettings.chart_day1_x_offset + (chartSettings.chart_col_width * (column-1)) - EXTRA_THICKNESS/2 + 1;
            y_pos = (mon_row_offset - 1) * chartSettings.chart_row_height - EXTRA_THICKNESS/2 + 1;
            width = chartSettings.chart_col_width + EXTRA_THICKNESS;
            height = chartSettings.chart_row_height + EXTRA_THICKNESS - 1;
            // Place and stretch image
            document.getElementById('x_cell_img_' + x_cell_counter).src = 'images/x_black.png';
            document.getElementById('x_cell_' + x_cell_counter).style.display = "block";
            document.getElementById('x_cell_' + x_cell_counter).style.left = x_pos + "px";
            document.getElementById('x_cell_' + x_cell_counter).style.top = y_pos + "px";
            document.getElementById('x_cell_img_' + x_cell_counter).style.width = width + "px";
            document.getElementById('x_cell_img_' + x_cell_counter).style.height = height + "px";
            chartSettings.monitorPeak_x_cell_counter = x_cell_counter;
            x_cell_counter = x_cell_counter + 1;            
        }
    }
    
    // Shade Cervix Row
    row_offset = row_offset + 1;
    for( var column = 1; column <= cols_to_handle; column++ )
	{
        applyShadingToDiv('ChartingCell_R' + (row_offset) + '_C' + (column), fpct_cervix[column-1]);
    }
    
    if (BUILD_TARGET == BUILD_4_CCL)
    {
        // CCL has 4 additional rows (Mucus Char, Cervix, Ov Testing, and Fert Monitor), so shade all four of these with the standard column color
        row_offset = row_offset + 1;
        for( var column = 1; column <= cols_to_handle; column++ )
        {
            applyShadingToDiv('ChartingCell_R' + (row_offset) + '_C' + (column), fpct_all[column-1]);
            applyShadingToDiv('ChartingCell_R' + (row_offset+1) + '_C' + (column), fpct_all[column-1]);
            applyShadingToDiv('ChartingCell_R' + (row_offset+2) + '_C' + (column), fpct_all[column-1]);
            applyShadingToDiv('ChartingCell_R' + (row_offset+3) + '_C' + (column), fpct_all[column-1]);
        }
    }

    // Label dates at the bottom
    for( var column = 1; column <= cols_to_handle; column++ )
	{
        document.getElementById('ChartingDateCell_C' + (column)).innerHTML = caldates[column-1];
    }   
    document.getElementById('ChartingYearCell').innerHTML = year;     
  
    
    if (BUILD_TARGET != BUILD_4_CCL)
    {
        // Depict Overall Ovulation Date and Fertility Window
        counter = 1;
        var MAX_OV_BOXES = 6;
        for (var img_index=1; img_index <= MAX_OV_BOXES; img_index++)
        {
            document.getElementById('ov_box_' + img_index).style.display = "none";      // Initialize not to be visible 
        }
        for( var column = 0; ((column < cols_to_handle) && (counter <= MAX_OV_BOXES)); column++ )
        {
            // Overall Ovulation Date
            if (all_ov[column] > 0)
            {
                // Calculate position
                x_pos = chartSettings.chart_day1_x_offset + (chartSettings.chart_col_width * column) - EXTRA_THICKNESS/2 + 1;
                y_pos = 0;
                width = chartSettings.chart_col_width + EXTRA_THICKNESS;
                height = row_offset * chartSettings.chart_row_height + 1;
                // Determine appropriate image
                if (all_ov[column] == 1)
                {
                    document.getElementById('ov_box_img_' + counter).src = 'images/ovbox_black.png';
                }
                else
                {
                    document.getElementById('ov_box_img_' + counter).src = 'images/ovbox_blue.png';
                }
                // Place and stretch image
                document.getElementById('ov_box_' + counter).style.display = "block";
                document.getElementById('ov_box_' + counter).style.left = x_pos + "px";
                document.getElementById('ov_box_' + counter).style.top = y_pos + "px";
                document.getElementById('ov_box_img_' + counter).style.width = width + "px";
                document.getElementById('ov_box_img_' + counter).style.height = height + "px";
                counter = counter + 1;
            }
            // Fertility Window
            if ((fwin[column] > 0) && (counter <= MAX_OV_BOXES))
            {
                // Calculate position
                x_pos = chartSettings.chart_day1_x_offset + (chartSettings.chart_col_width * column) - EXTRA_THICKNESS/2 + 1;
                y_pos = 0;
                width = chartSettings.chart_col_width + EXTRA_THICKNESS;
                height = row_offset * chartSettings.chart_row_height + 1;

                // Determine appropriate image
                switch(fwin[column])
                {
                case 1:
                    // Window starts here but is not finalized
                    document.getElementById('ov_box_img_' + counter).src = 'images/fwin_left_gray.png';
                    break;
                case 2:
                    // Window starts here but is not finalized
                    document.getElementById('ov_box_img_' + counter).src = 'images/fwin_left_black.png';
                    break;
                case 8:
                    // Window starts here but is not finalized
                    document.getElementById('ov_box_img_' + counter).src = 'images/fwin_right_gray.png';
                    break;
                case 9:
                    // Window starts here but is not finalized
                    document.getElementById('ov_box_img_' + counter).src = 'images/fwin_right_black.png';
                    break;
                default:
                    printDebug('default case should not happen!!!');
                    break;
                }
                
                // Place and stretch image
                document.getElementById('ov_box_' + counter).style.display = "block";
                document.getElementById('ov_box_' + counter).style.left = x_pos + "px";
                document.getElementById('ov_box_' + counter).style.top = y_pos + "px";
                document.getElementById('ov_box_img_' + counter).style.width = width + "px";
                document.getElementById('ov_box_img_' + counter).style.height = height + "px";
                counter = counter + 1;
            }
        }  
    }
    return;
}

// Function adds shading style to div
function applyShadingToDiv(div_id, percentage)
{
    if (BUILD_TARGET == BUILD_4_CCL)
    {
        var CCL_FPCT_PHASE_II_III_TRANSITION_108 = 108;
        
        if (percentage == CCL_FPCT_PHASE_II_III_TRANSITION_108)
        {
            // Special shading where we want to use a gradient to switch between colors
            document.getElementById(div_id).style.backgroundColor = '#9AC88C';
            document.getElementById(div_id).style.background = '-moz-linear-gradient(left, #9AC88C, #8E87E7)';
            document.getElementById(div_id).style.background = '-webkit-gradient(linear, left center, right center, from(#9AC88C), to(#8E87E7))';
        }
        else
        {
            // Shade Normally
            document.getElementById(div_id).style.background = '';
            document.getElementById(div_id).style.backgroundColor = '#' + calcShadePercent(percentage);
        }
    }
    else
    {
        // Normal shading
        document.getElementById(div_id).style.backgroundColor = '#' + calcShadePercent(percentage);
    }
}

// Function takes a percentage between 0 and 100 and returns a color as a RRGGBB hex value
function calcShadePercent(percentage)
{
    var jsRedUpper = 128;
    var jsRedLower = 255;
    var jsGreenUpper = 0;
    var jsGreenLower = 255;
    var jsBlueUpper = 255;
    var jsBlueLower = 255
    var color_r;
    var color_g;
    var color_b;
    var ret_str;
    
    var CCL_FPCT_PHASE_I_101 = 101;
    var CCL_FPCT_PHASE_II_102 = 102;
    var CCL_FPCT_PHASE_III_103 = 103;
    var CCL_FPCT_MISSING_MUCUS_104 = 104;
    var CCL_FPCT_PHASE_II_III_TRANSITION_108 = 108;
    
    if (percentage < 0)
    {
        // Leave empty (no shading) if unknown
        percentage = 0;
    }
    
    if (BUILD_TARGET == BUILD_4_CCL)
    {
        // Compute shading for CCL
        switch(percentage)
        {
        case CCL_FPCT_PHASE_I_101:
            // Phase I
            color_r = 253;
            color_g = 226;
            color_b = 105;
            break;
        case CCL_FPCT_PHASE_II_102:
            // Phase II
            color_r = 155;
            color_g = 200;
            color_b = 140;
            break;
        case CCL_FPCT_PHASE_III_103:
            // Phase III
            color_r = 118;
            color_g = 140;
            color_b = 233;
            break;
        case CCL_FPCT_PHASE_II_III_TRANSITION_108:
            // Phase II transitioning to Phase III (just returns Phase II here)
            color_r = 155;
            color_g = 200;
            color_b = 140;
            break;
        case CCL_FPCT_MISSING_MUCUS_104:
            // Disable coloring when the user fails to record mucus when they should have
            color_r = 255;
            color_g = 255;
            color_b = 255;
            break;
        default:
            // Traditional shading
            color_r = Math.floor(((jsRedLower - jsRedUpper) * (100 - percentage)) / 100) + jsRedUpper;
            color_g = Math.floor(((jsGreenLower - jsGreenUpper) * (100 - percentage)) / 100) + jsGreenUpper;
            color_b = Math.floor(((jsBlueLower - jsBlueUpper) * (100 - percentage)) / 100) + jsBlueUpper;
            break;
        } 
    }
    else
    {
        // Compute colors for general shading
        color_r = Math.floor(((jsRedLower - jsRedUpper) * (100 - percentage)) / 100) + jsRedUpper;
        color_g = Math.floor(((jsGreenLower - jsGreenUpper) * (100 - percentage)) / 100) + jsGreenUpper;
        color_b = Math.floor(((jsBlueLower - jsBlueUpper) * (100 - percentage)) / 100) + jsBlueUpper;
    }

    // Assemble the return string in hex.  Check for small values that require a leading zero to be explicitly added
    ret_str = '';
    if (color_r < 16)
    {
        ret_str += '0';
    }
    ret_str += color_r.toString(16);
    if (color_g < 16)
    {
        ret_str += '0';
    }
    ret_str += color_g.toString(16);
    if (color_b < 16)
    {
        ret_str += '0';
    }
    ret_str += color_b.toString(16);
    
    return ret_str;
}


// Function draws a graph given passed data arrays
function printGraph(jsBarHts, jsDayLbl, jsDateLbl, chartSettings) 
{    
LogCall('1g');
    var jsRedUpper = 128;
    var jsRedLower = 255;
    var jsGreenUpper = 0;
    var jsGreenLower = 255;
    var jsBlueUpper = 255;
    var jsBlueLower = 255

    var div_element;  
    var maxDays = MAX_NUMBER_OF_GRAPH_COLUMNS;
    var MAX_HEIGHT = 200;
    var temp_height;
    var index;
    
    // Set Width
    document.getElementById('fertBarGraph').style.width = (chartSettings.graph_num_of_cols * chartSettings.graph_col_width + 1) + "px";
    
    // Loop through and render graph
    for(var i=1; i<=maxDays; i++)
    {
        if (i <= chartSettings.graph_num_of_cols)
        {
            index = i-1;
            if (jsBarHts[index] <= 0)
            {
                jsBarHts[index] = 1;
            }
            div_element = document.getElementById('cssDay' + i);
            temp_height = Math.round((jsBarHts[index] * MAX_HEIGHT) / 100);   
            div_element.style.height = temp_height + "px";
            div_element.style.top = MAX_HEIGHT - temp_height + 30 + "px";
            div_element.style.backgroundColor = "rgb(" + Math.round((jsRedUpper - jsRedLower)*(jsBarHts[index]/MAX_HEIGHT) + jsRedLower) + ", " + Math.round((jsGreenUpper - jsGreenLower)*(jsBarHts[index]/MAX_HEIGHT) + jsGreenLower) + ", " + Math.round((jsBlueUpper - jsBlueLower)*(jsBarHts[index]/MAX_HEIGHT) + jsBlueLower) + ")";
            
            div_element = document.getElementById('cssDayLabel' + i);
            if (jsDayLbl[index] != -1) 
            {
                div_element.innerHTML = jsDayLbl[index];
            }
            else
            {
                div_element.innerHTML = "-";
            }
            
            div_element = document.getElementById('cssDate' + i);
            div_element.innerHTML = jsDateLbl[index];
            
            // Make column visible
            document.getElementById('graphC' + i).style.display = 'block';
        }
        else
        {
            // Hide this column since it is not used
            document.getElementById('graphC' + i).style.display = 'none';
        }
    }
}
function navBetweenAnalysisScreens(state, target_screen, param_1, param_2, param_3)
{
    var strSql = '';
    var tx = param_1;
    var CYCLE_PICKER_SCREEN_BASE_3 = 3;
    var cycleSelect;
    var optionsList;
    
    // Abort this function if we shouldn't be running it in the first place.  This occurs mistakenly only in iOS 4.3 when the cycle picker closes the listbox and wants to reload the page and call this function again)
    if (global_Block_Global_Analysis_Pages)
    {
        printDebug('quitting because global_Block_Global_Analysis_Pages');
        return;
    }
    
    // Get drop down control control for cycle picker
    if (target_screen == ANALYSIS_PAGES_PICKER_INDEX)
    {
        cycleSelect = $('#Analysis_CyclePickerSelect');
        if(cycleSelect.prop) 
        {
            optionsList = cycleSelect.prop('options');
        }
        else 
        {
            optionsList = cycleSelect.attr('options');
        }
    }
    
    printDebug("State " + state + " of navBetweenAnalysisScreens target=" + target_screen);
    switch(state)
    {
    case 1:
LogCall('g1');
        // Open local database
        db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
        global_db_ios_fail_NavBtAnalysisScreens_1 = DB_IOS_RETRY_LIMIT;
        db.transaction(     function(tx) 
                            {
                                global_db_ios_fail_NavBtAnalysisScreens_1 = -1;
                                navBetweenAnalysisScreens(state+1, target_screen, tx, '', '');
                            },
                            errorCB,
                            function(tx)
                            {
                                // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                if (global_db_ios_fail_NavBtAnalysisScreens_1 > 0)
                                {
                                    global_db_ios_fail_NavBtAnalysisScreens_1 = global_db_ios_fail_NavBtAnalysisScreens_1 - 1;
                                    printDebug('iOS db.transaction failed navBetweenAnalysis. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_NavBtAnalysisScreens_1));
                                    navBetweenAnalysisScreens(state, target_screen, param_1, param_2, param_3);
                                }
                                else if (global_db_ios_fail_NavBtAnalysisScreens_1 == 0)
                                {
                                    printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                }
                                else
                                {
                                    successCB();
                                }
                            }
                       );
        // Set dynamic build content for loaded page
        setDynamicContentForAppInstance(global_Analysis_Pages[target_screen]);
        break;
    
    case 2:
LogCall('g2');

        // Special case for cycle picker
        if (target_screen == ANALYSIS_PAGES_PICKER_INDEX)
        {
            strSql = 'SELECT * FROM Cycles_DB ORDER BY cyc_started ASC;';
            printStatus('Loading');
            
            // Query values from local database. 
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                navBetweenAnalysisScreens(CYCLE_PICKER_SCREEN_BASE_3, target_screen, tx, results, '');
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local DataRecs database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
        }
        else  // any other screen
        {
            // Decide if we should re-load the analysis content because it has been a while (the timestamp will be
            // old) or because the user changed something (the timestamps will have been wiped out).  Since this 
            // function is only called to show the calendar again with the same displayed month, there is no need
            // to even load data from the local database unless something has changed (the g_LoadTimestamps object
            // will get dumped) or it has been a while since the remote server was checked (the g_LoadTimestamps
            // timestamp will be very old).
            if (does_timestamp_say_to_reload('same_cycle') == true)
            {
                // See if we should pre-skew cycle to include today
                var todays_date = new Date();
                var todays_date_i = DateToNumber(todays_date);
                var todays_date_diff = todays_date_i - global_selected_cycle_as_number;
                if ((todays_date_diff>=MAX_NUMBER_OF_CHART_COLUMNS) && (todays_date_i<global_selected_cycle_end_as_number))
                {
                    global_selected_cycle_offset = todays_date_diff - MAX_NUMBER_OF_CHART_COLUMNS + 1;
                    global_selected_cycle_offset = (parseInt(global_selected_cycle_offset/7) + 1) * 7 + 1;
                }
                // Full update of data and rendering of UI
                printDebug('Need to load cycle from ' + global_selected_cycle_as_number + ' to ' + global_selected_cycle_end_as_number);
                data_load_fsm(1, false, global_selected_cycle_as_number, global_selected_cycle_end_as_number, '', '', '', '');
                
                // Warn user about potential limitations
                CheckAndWarnIfOfflineOnly();
                if (global_active_subscription == 0)
                {
                    WarnIfNoActiveSubscription();
                }  
            }
            else
            {
                // Only need to re-render the UI
                printStatus('Loading');
                printDebug('No need to reload cycle so just re-rendering it.');
                RenderAnalysisScreensFromLocalDatabase(     1,
                                        function(tx) 
                                        {
                                            HideAct();
                                            HideAct_Legacy();
                                            printStatus('');
                                        },
                                        tx,
                                        '',
                                        '',
                                        true,
                                        global_selected_cycle_as_number + global_selected_cycle_offset, 
                                        global_selected_cycle_end_as_number,
                                        '',
                                        ''
                                   );
            }
        }
        HideAct_Legacy();
        break;

    case CYCLE_PICKER_SCREEN_BASE_3:   // Cycle Picker Screen - Scan local database for cycles
LogCall('g3');
        results = param_2;
        var len = results.rows.length;
        var cyc_date_value;
        var cyc_date_str;
        var cyc_date = new Date();
        
        // Clear list
        $('option', cycleSelect).remove();
        
        // Loop through results and populate cycle
        if (len == 0)
        {
            optionsList[optionsList.length] = new Option('No cycles recorded yet', 0);
            if (BUILD_TARGET == BUILD_4_CCL)
            {
                document.getElementById('Analysis_CyclePicker_Note').innerHTML = '<br>How to record a cycle:<ol><li>Tap on the Calendar icon at the bottom</li><li>Tap on the date that your last cycle started on the calendar</li><li>Expand the "Other Info/Notes" section and check the "This day should start a new cycle" box.</li></ul>';
            }
            else
            {
                document.getElementById('Analysis_CyclePicker_Note').innerHTML = '<br>How to record a cycle:<ol><li>Tap on the Calendar icon at the bottom</li><li>Tap on the date that your last cycle started on the calendar</li><li>Expand the "Basic Symptoms" section and check the "Menstruation" box to record menses</li></ul>';
            }
        }
        else
        {
            optionsList[optionsList.length] = new Option('Please select a cycle', 0);
            document.getElementById('Analysis_CyclePicker_Note').innerHTML = '';
        }
        for (var i=len-1; i>=0; i--)
        {
            cyc_date_value = results.rows.item(i)['cyc_started'];
            cyc_date = NumberToDate(cyc_date_value);
            if (BUILD_TARGET == BUILD_4_CCL)
            {
                if (results.rows.item(i)['id_txt'] != '0')
                {
                    cyc_date_str = PrintDate(cyc_date) + ' [Cht ' + results.rows.item(i)['id_txt'] + ']';
                }
                else
                {
                    cyc_date_str = PrintDate(cyc_date);
                }
            }
            else
            {
                cyc_date_str = PrintDate(cyc_date);
            }
            optionsList[optionsList.length] = new Option(cyc_date_str, cyc_date_value);
        }
        // Note how many cycles we found in the Cycles_DB so we can distinguish between which are in there and which
        // are inferred based upon menstruation values.
        CycleDB_Stopping_Point = len;
        
        // Refresh control after update and make a default selection
        cycleSelect[0].selectedIndex = 0;
        cycleSelect.selectmenu("refresh");

        // Look for other cycles in menstruation data
        strSql = 'SELECT * FROM Data_Recs_DB where mens=1 ORDER BY record_date ASC;';
        suspend_scrolling(true, '');
        tx.executeSql(  strSql, 
                        [], 
                        function(tx, results) 
                        {
                            suspend_scrolling(false, 0);
                            navBetweenAnalysisScreens(state+1, target_screen, tx, results, CycleDB_Stopping_Point);
                        },
                        function(tx, err)
                        {
                            crash_and_burn(err, 'Error querying local DataRecs database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                        }
                     );
        break;

    case (CYCLE_PICKER_SCREEN_BASE_3+1): // Cycle Picker Screen - Scan local database for cycles
LogCall('g4');
        results = param_2;
        var len = results.rows.length;
        var record_date_val;
        var last_record_date_val = -999;
        // Loop through results and populate cycle
        for (var i=0; i<len; i++)
        {
            record_date_val = results.rows.item(i)['record_date'];
            if (record_date_val != (last_record_date_val + 1))
            {
                // This is the start of a new cycle.  Add it if it is not already on the list
                var on_list = false;
                for (var j=0; j<optionsList.length; j++)
                {
                    if (optionsList[j].value == record_date_val)
                    {
                        on_list = true;
                        break;
                    }
                }
                if (on_list == false)
                {
                    // Create a new default since we not have a cycle instead of where we are missing any
                    if (optionsList.length == 1)
                    {
                        $('option', cycleSelect).remove();
                        optionsList[optionsList.length] = new Option('Please select a cycle', 0);
                    }
                    // Add new element
                    optionsList[optionsList.length] = new Option(PrintDate(NumberToDate(record_date_val)), record_date_val);
                    document.getElementById('Analysis_CyclePicker_Note').innerHTML = '';
                }
            }
            last_record_date_val = record_date_val;
        }
        
        // Look for other cycles in menstruation data
        strSql = 'SELECT * FROM Preg_DB where 1 ORDER BY preg_started ASC;';
        suspend_scrolling(true, '');
        tx.executeSql(  strSql, 
                        [], 
                        function(tx, results) 
                        {
                            suspend_scrolling(false, 0);
                            navBetweenAnalysisScreens(state+1, target_screen, tx, results, param_3);
                        },
                        function(tx, err)
                        {
                            crash_and_burn(err, 'Error querying local DataRecs database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                        }
                     );
        break;
        
    case (CYCLE_PICKER_SCREEN_BASE_3+2):         
LogCall('g5');        
        results = param_2;
        var len = results.rows.length;
        var preg_date_value;
        var preg_date_str;
        var preg_date = new Date();
        var currDate = new Date();

        for (var i=len-1; i>=0; i--)
        {
            // Add entry for pregnancy
            preg_date_value = results.rows.item(i)['preg_started'];
            preg_date = NumberToDate(preg_date_value);
            preg_date_str = PrintDate(preg_date) + ' [Pregnancy]';
            optionsList[optionsList.length] = new Option(preg_date_str, preg_date_value);
            // Add entry for postpartum
            preg_date_value = results.rows.item(i)['preg_started'] + results.rows.item(i)['preg_len'];
            if (preg_date_value < DateToNumber(currDate))
            {
                preg_date = NumberToDate(preg_date_value);
                preg_date_str = PrintDate(preg_date) + ' [Postpartum]';
                optionsList[optionsList.length] = new Option(preg_date_str, preg_date_value);
            }
        }
        
        // Refresh control after update and make a default selection
        cycleSelect[0].selectedIndex = 0;
        cycleSelect.selectmenu("refresh");

        // Check if we need to reload the cycle picker
        if (does_timestamp_say_to_reload('cpick') == false)
        {
            // No need to go any further.  We synchronized with the server fairly recently.
            printStatus('');
        } 
        else if ((global_EnableRemoteAnalysis == 0) || (global_online_status == 0))
        {
            // No need to talk to remote server.  Quit here. 
            printOfflineStatus(); 
        }
        else
        {
            // Upload any and all data that is out of sync with the remote server
            printStatus('Loading');
            UploadSyncToServer(     1,
                                function(tx) 
                                {
                                    navBetweenAnalysisScreens(state+1, target_screen, tx, '', param_3);
                                },
                                tx,
                                '',
                                0
                           ); 
        }
        // Refresh the list control since we are at an intermediate step or even a potential end point 
        cycleSelect.selectmenu("refresh");
        break;

    case (CYCLE_PICKER_SCREEN_BASE_3+3):         
LogCall('g6');

        // Query server for more cycle start dates
        printStatus('Updating');
        var uploadParameters = {};
        var url_str = global_server_prefix + 'apps_get_data.aspx?' + new Date().getTime();
        
        uploadParameters['un'] = global_username;
        uploadParameters['pw'] = global_password;
        uploadParameters['cycles'] = '1';
        uploadParameters['debug'] = global_Debug_Enabled;
        uploadParameters['app_ver'] = global_app_ver_str;
        uploadParameters['device_id'] = global_device_id_str;
        
       // Use jQuery to upload the data to the server
        $.ajax({
            type: 'POST',
            // The URL of the request
            url: url_str,
            // Values to upload
            data: uploadParameters,
            // The success callback with result from server
            success: function(newContent) {
                // Handles response this function and advance to the next state.  Notice that the tx
                // cannot be passed to this legitimately because it is not being created as a call
                // to this registered function (it only has a newContent argument) because this 
                // callback has nothing to do with databases.  Therefore we will have to re-establish
                // the tx variable when we want to resume database operations.
                navBetweenAnalysisScreens(state+1, target_screen, tx, newContent, param_3);
            },
            dataType: 'html'
        });
        printStatus(WAITING_STATUS_MSG);
        HideAct();
        break;
        
    case (CYCLE_PICKER_SCREEN_BASE_3+4): 
LogCall('g7');
        // Re-generate the tx variable so we can continue to perform database operations.  It was lost
        // in the prior state because the last callback into the state machine involved a remote server
        // transfer and not a local database access.  Therefore the local database parameter was not
        // carried forward and needs to be regenerated.
        global_db_ios_fail_NavBtAnalysisScreens_6 = DB_IOS_RETRY_LIMIT;
        db.transaction(     function(tx) 
                            {
                                global_db_ios_fail_NavBtAnalysisScreens_6 = -1;
                                navBetweenAnalysisScreens(state+1, target_screen, tx, param_2, param_3);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Could not open local database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            },
                            function(tx)
                            {
                                // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                if (global_db_ios_fail_NavBtAnalysisScreens_6 > 0)
                                {
                                    global_db_ios_fail_NavBtAnalysisScreens_6 = global_db_ios_fail_NavBtAnalysisScreens_6 - 1;
                                    printDebug('iOS db.transaction failed NavBtAnalysis state 6. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_NavBtAnalysisScreens_6));
                                    navBetweenAnalysisScreens(state, target_screen, param_1, param_2, param_3);
                                }
                                else if (global_db_ios_fail_NavBtAnalysisScreens_6 == 0)
                                {
                                    printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                }
                                else
                                {
                                    successCB();
                                }
                            }
                       );
        printStatus('Analyzing');
        break;
        
    case (CYCLE_PICKER_SCREEN_BASE_3+5): // Cycle Picker Screen - Analyze server returned list of cycles
LogCall('g8');
        var index2_CycStart_field=new Array();
        var index2_CycLen_field=new Array();
        var index2_CycLutLen_field=new Array();
        var index2_CycOvCd_field=new Array();
        var index2_CycOvType_field=new Array();
        var index2_IdTxt_field=new Array();
        var index2_PregStart_field=new Array();
        var index2_PregLen_field=new Array();
        var index2_PregStatus_field=new Array();
    
        var desiredStrStart=new Array();
        var desiredStrEnd=new Array();
        var respParamsStr=new Array();
        var matched_up = new Array();
        var num_cycles;
        var num_pregs;
        var tx = param_1;
        var newContent = param_2;
        var strSql;
        var j;
        var error_or_warning = CheckForStandardErrors(newContent);
        continue_execution = HandleServerErrorOrWarning(error_or_warning);
        if (continue_execution == 0)
        {
            // Stop execution because of a fatal error
            printDebug('Halting execution due to server returned error.');
            printStatus('Server Offline?');
            hideStatusSpinner();
            break;
        }
        
        // Prepare variables to extract from response
        desiredStrStart[desiredStrStart.length]='TOTAL_CYC=';
        desiredStrEnd[desiredStrEnd.length]=" ";
        
        desiredStrStart[desiredStrStart.length]='TOTAL_PREG=';
        desiredStrEnd[desiredStrEnd.length]=" ";

        // Initially parse the response to find the number of cycles
        respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
        num_cycles = respParamsStr[0];
        num_pregs = respParamsStr[1];
      
        // Prepare variables to extract from response for all returned cycles
        desiredStrStart.length = 0;
        desiredStrEnd.length = 0;
        for (var i=1; i<=num_cycles; i++)
        {
            index2_CycStart_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='CYC_' + i + '_DATE=';
            desiredStrEnd[desiredStrEnd.length]=" ";
            
            index2_CycLen_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='CYC_' + i + '_LEN=';
            desiredStrEnd[desiredStrEnd.length]=" ";
            
            index2_CycLutLen_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='CYC_' + i + '_LUT_LEN=';
            desiredStrEnd[desiredStrEnd.length]=" ";

            index2_CycOvCd_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='CYC_' + i + '_OV_CD=';
            desiredStrEnd[desiredStrEnd.length]=" ";
            
            index2_CycOvType_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='CYC_' + i + '_OV_TYPE=';
            desiredStrEnd[desiredStrEnd.length]=" ";
            
            if (BUILD_TARGET == BUILD_4_CCL)
            {
                index2_IdTxt_field[i-1] = desiredStrStart.length;
                desiredStrStart[desiredStrStart.length]='CYC_' + i + '_IDTXT=';
                desiredStrEnd[desiredStrEnd.length]=" ";            
            }
        }
        for (var i=1; i<=num_pregs; i++)
        {
            index2_PregStart_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='PREG_' + i + '_STARTED=';
            desiredStrEnd[desiredStrEnd.length]=" ";
            
            index2_PregLen_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='PREG_' + i + '_LEN=';
            desiredStrEnd[desiredStrEnd.length]=" ";
        }
       
        // Parse the response again
        respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);

        // Mark all existing cycles as not being matched up so we know which need deleted
        for (j=0; j<optionsList.length; j++)
        {
            matched_up[j] = false;
        }
        // Loop through returned cycles
        var on_list;
        var on_list_but_not_in_database;
        var date_obj;
        var year;
        var month;
        var day;
        var CycleDB_Stopping_Point = param_3;
        
        // Search cycles
        for (var i=0; i<num_cycles; i++)
        {
            date_obj = ConvertYYYY_MM_DD_toDate(respParamsStr[index2_CycStart_field[i]]);
            date_val = DateToNumber(date_obj);
            if (date_val > 0)
            {
                // See if it is already on the list
                on_list = false;
                on_list_but_not_in_database = false;
                for (j=0; j<optionsList.length; j++)
                {
                    if (optionsList[j].value == date_val)
                    {
                        on_list = true;
                        matched_up[j] = true;
                        if (j>CycleDB_Stopping_Point)
                        {
                            on_list_but_not_in_database = true;
                        }
                    }
                }
                if (on_list == false)
                {                
                    // Create a new default since we not have a cycle instead of where we are missing any
                    if (optionsList.length == 1)
                    {
                        $('option', cycleSelect).remove();
                        optionsList[optionsList.length] = new Option('Please select a cycle', 0);
                    }
                    // Add new element
                    optionsList[optionsList.length] = new Option(PrintDate(NumberToDate(date_val)), date_val);
                    document.getElementById('Analysis_CyclePicker_Note').innerHTML = '';
                }
                if ((on_list == true) && (on_list_but_not_in_database == false))
                {
                    // Update existing local database record in case any of the parameters changed
                    strSql = 'UPDATE Cycles_DB SET cyc_len=' + respParamsStr[index2_CycLen_field[i]] + ', cyc_lut_len=' + respParamsStr[index2_CycLutLen_field[i]] + ', cyc_ov_cd=' + respParamsStr[index2_CycOvCd_field[i]] + ', all_ov_type=' + respParamsStr[index2_CycOvType_field[i]];
                    if (BUILD_TARGET == BUILD_4_CCL)
                    {
                        strSql += ', id_txt=' + respParamsStr[index2_IdTxt_field[i]];
                    }
                    strSql += ' WHERE cyc_started=' + date_val + ';';
                    suspend_scrolling(true, '');
                    tx.executeSql(  strSql, 
                                    [], 
                                    function(tx, results) 
                                    {
                                        suspend_scrolling(false, 0);
                                        successCB();
                                    },
                                    errorCB
                                 );
                }
                else
                {
                    // Create local database record
                    var ccl_fields = '';
                    var ccl_vals = '';
                    if (BUILD_TARGET == BUILD_4_CCL)
                    {
                        ccl_fields = ' id_txt,';
                        ccl_vals = ', ' + respParamsStr[index2_IdTxt_field[i]];
                    }
                    strSql = 'INSERT INTO Cycles_DB (cyc_started, cyc_len, cyc_lut_len, cyc_ov_cd, all_ov_type,' + ccl_fields + ' cdata_chg, cdata_pnd, mkr) ';
                    strSql += 'VALUES (' + date_val + ', ' + respParamsStr[index2_CycLen_field[i]] + ', ' + respParamsStr[index2_CycLutLen_field[i]] + ', ' + respParamsStr[index2_CycOvCd_field[i]] + ', ' + respParamsStr[index2_CycOvType_field[i]] + ccl_vals + ', 0, 0, 0);';
                    suspend_scrolling(true, '');
                    tx.executeSql(  strSql, 
                                    [], 
                                    function(tx, results) 
                                    {
                                        suspend_scrolling(false, 0);
                                        successCB();
                                    },
                                    errorCB
                                 );
                }
            }
            else
            {
                printDebug('Returned invalid date: ' + respParamsStr[index2_CycStart_field[i]]);
            }
        }   

        // Search pregnancies
        var postpartum_date_val;
        for (var i=0; i<num_pregs; i++)
        {
            date_obj = ConvertYYYY_MM_DD_toDate(respParamsStr[index2_PregStart_field[i]]);
            date_val = DateToNumber(date_obj);
            if (date_val > 0)
            {
                // See if it is already on the list
                on_list = false;
                on_list_but_not_in_database = false;
                for (j=0; j<optionsList.length; j++)
                {
                    if (optionsList[j].value == date_val)
                    {
                        on_list = true;
                        matched_up[j] = true;
                        // Match postpartum entry (which should follow)
                        if (j<optionsList.length-1)
                        {
                            postpartum_date_val = date_val + Number(respParamsStr[index2_PregLen_field[i]]);
                            if (optionsList[j+1].value == postpartum_date_val)
                            {
                                matched_up[j+1] = true;
                            }
                        }
                        break;
                    }
                }
                if (on_list == false)
                {                
                    // Add new element
                    var currDate = new Date();
                    postpartum_date_val = date_val + respParamsStr[index2_PregLen_field[i]];
                    optionsList[optionsList.length] = new Option(PrintDate(NumberToDate(date_val)) + ' [Pregnancy]', date_val);
                    if (postpartum_date_val < DateToNumber(currDate))
                    {
                        optionsList[optionsList.length] = new Option(PrintDate(NumberToDate(postpartum_date_val)) + ' [Postpartum]', postpartum_date_val);
                    }
                }
            }
            else
            {
                printDebug('Returned invalid date: ' + respParamsStr[index2_PregStart_field[i]]);
            }
        }

        // Circle back through to see which cycle start dates were never matched up.  Done backwards because we will be removing
        // from the list and I don't want to screw up the indices
        for (j=matched_up.length-1; j>=0; j--)
        {
            // Cycles that never got matched up with something returned by the server need deleted
            if (matched_up[j] == false)
            {
                date_val = optionsList[j].value;
                if (date_val > 0)
                {
                    optionsList[j].text = "(n/a - this cycle has changed)";
                    optionsList[j].value = 0;
                    strSql = 'DELETE FROM Cycles_DB WHERE cyc_started=' + date_val + ';';
                    suspend_scrolling(true, '');
                    tx.executeSql(  strSql, 
                                    [], 
                                    function(tx, results) 
                                    {
                                        suspend_scrolling(false, 0);
                                        successCB();
                                    },
                                    errorCB
                                 );
                }
            }
        }
        
        // Refresh control after update
        cycleSelect.selectmenu("refresh");
        printStatus('');
        
        break;

    default:
        break;
    }
    return;
}
function findNextPrevCycle(state, direction, curr_cycle, param_1, param_2)
{
    printDebug("State " + state + " of findNextPrevCycle");
    
    switch(state)
    {
    case 1:
LogCall('r1');
        printStatus('Loading');
        
        // Open local database
        db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
        global_db_ios_fail_FindNextPrev_1 = DB_IOS_RETRY_LIMIT;
        db.transaction(     function(tx) 
                            {
                                global_db_ios_fail_FindNextPrev_1 = -1;
                                findNextPrevCycle(state+1, direction, curr_cycle, tx, '');
                            },
                            errorCB,
                            function(tx)
                            {
                                // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                if (global_db_ios_fail_FindNextPrev_1 > 0)
                                {
                                    global_db_ios_fail_FindNextPrev_1 = global_db_ios_fail_FindNextPrev_1 - 1;
                                    printDebug('iOS db.transaction failed navBetweenAnalysis. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_FindNextPrev_1));
                                    findNextPrevCycle(state, direction, curr_cycle, param_1, param_2);
                                }
                                else if (global_db_ios_fail_FindNextPrev_1 == 0)
                                {
                                    printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    printStatus('');
                                }
                                else
                                {
                                    successCB();
                                }
                            }
                       );
        break;
    
    case 2:
LogCall('r2');

        var strSql = 'SELECT * FROM Cycles_DB ORDER BY cyc_started ASC;';
        var tx = param_1;
        
        // Query values from local database. 
        suspend_scrolling(true, '');
        tx.executeSql(  strSql, 
                        [], 
                        function(tx, results) 
                        {
                            suspend_scrolling(false, 0);
                            findNextPrevCycle(state+1, direction, curr_cycle, tx, results);
                        },
                        function(tx, err)
                        {
                            crash_and_burn(err, 'Error querying local DataRecs database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                        }
                     );
        break;

    case 3:  
LogCall('g3');
        var results = param_2;
        var len = results.rows.length;
        var cyc_date_value;
        var cyc_date = new Date();
        var cycleStartDateVals=new Array();

        // Loop through results
        for (var i=len-1; i>=0; i--)
        {
            cyc_date_value = results.rows.item(i)['cyc_started'];
            cycleStartDateVals[cycleStartDateVals.length] = cyc_date_value;
        }
        
        // Sort the array in numerical order
        if (direction > 0) 
        {
            // Sort cycle start dates in ascending numerical order
            cycleStartDateVals.sort(function(a,b){return a - b});
        }
        else
        {
            // Sort cycle start dates in reverse numerical order
            cycleStartDateVals.sort(function(a,b){return b - a});
        }
        
        // Try to find the specified "next" cycle (where "next" is prev/next based on prior sorting
        var date_str = Date.parse(document.getElementById(curr_cycle).innerHTML + ' 1:00:00');
        var sel_date = new Date(date_str);
        var selected_cycle = DateToNumber(sel_date);
        var cyclesPastFinding = 0;
        var desired_cycle = -1;
        var desired_cycle_len = 100;
        
        for (var i=0; i<cycleStartDateVals.length; i++)
        {
            // Immediately follows the match
            if (direction > 0)
            {
                // Working forwards req 1 more cycle to determine len
                if (cyclesPastFinding >= 2)
                {
                    desired_cycle_len = cycleStartDateVals[i] - desired_cycle;
                    break;
                }
                else if (cyclesPastFinding >= 1) 
                {
                    // This is the next cycle but we need to look for 1 more too
                    desired_cycle = cycleStartDateVals[i];
                    cyclesPastFinding = 2;
                }
            }
            else
            {
                // Working backwards is easy to calculate len
                if (cyclesPastFinding >= 1) 
                {
                    desired_cycle = cycleStartDateVals[i];
                    desired_cycle_len = selected_cycle - desired_cycle;
                    break;
                }
            }
            // Look for the currently loaded cycle
            if (selected_cycle == cycleStartDateVals[i])
            {
                cyclesPastFinding = 1;
            }
        }
        if (desired_cycle > 0)
        {
            // Make call to load cycle
            printDebug('found cycle: ' + desired_cycle);
            userPickedCycle(2, '', desired_cycle, desired_cycle_len);
        }
        else
        {        
            // Note: We stop here and do not scan for local cycles that are in the Mens database but not the cycles database.
            //       This is for simplicity.  To get these to show up, the user needs to navigate through the Cycle Picker screen.
            //       If the next/prev cycle they are looking for is not found, it may be because it hasn't been put in the "Cycles"
            //       database if they created it on the device and haven't sync'd or haven't gone through the cycle picker. For
            //       this case, we show a warning and point them to that picker.
            
            // TODO
            ShowPopupMessage('This is the last cycle in the sequence.  If you expected to see another cycle, try using the <a href="#" onclick="javascript:ClosePopupMessage();TransitionToSubscreen(\'analysis_picker\', \'none\');">Pick Another Cycle</a> option to select it.  This method will force a refresh of all cycles to ensure that new ones are identified.', 'No Cycle Available', '');
            printStatus('');
        }
        break;
    }
    return;
}
function userPickedCycle(state, param_1, param_2, param_3)
{
LogCall('1h');
printDebug('userPickedCycle state ' + state);
    switch(state)
    {
    case 1:
        // As the cycle picker closes, it may try to reload the page unnecessarily.  Block this from happening if it tries.
        global_Block_Global_Analysis_Pages = true;
        
        // Schedule a callback to this function to give the app time to finish processing the closing of the list control.  Otherwise the 
        // list control tries to navigate back to the original page and that overrides me attempting to go to a different page.  This
        // delay is intended to avoid losing this race condition.
        ShowAct();
        setTimeout("userPickedCycle(2, '', '', '');", 250);
        break;
        
    case 2:     // Some code calls straight into this state, so don't change value here without changing where called too
    
        var prespecified_date = param_2;
        var last_cycle_start = global_selected_cycle_as_number;
        var last_cycle_end = global_selected_cycle_end_as_number;  
        
        if (prespecified_date != '')
        {
            // Caller is supplying cycle
            var prespecified_len = param_3;
            
            // Set start/end dates for specified cycle
            global_selected_cycle_as_number = prespecified_date;
            global_selected_cycle_end_as_number = global_selected_cycle_as_number + prespecified_len;
        }
        else
        {
            // Get the selection
            global_selected_cycle_as_number = Number(document.getElementById('Analysis_CyclePickerSelect').value);
            global_selected_cycle_offset = 0;

            // Check that a valid cycle has been chosen.  If not, then display error and abort immediately.
            if (global_selected_cycle_as_number <= 0)
            {
                // The user picked an invalid cycle choice (perhaps one that was deleted or is otherwise disallowed)
                printInfoMessage('The cycle you selected is invalid.  Please select another cycle date and try again.');
                break;
            }
            
            // Note the subsequent cycle too
            var cycleSelect = $('#Analysis_CyclePickerSelect');
            var optionsList;
        
            // Get drop down control control for cycle picker
            if(cycleSelect.prop) 
            {
                optionsList = cycleSelect.prop('options');
            }
            else 
            {
                optionsList = cycleSelect.attr('options');
            }
            var sel_id = optionsList.selectedIndex;
            global_selected_cycle_end_as_number = 99999;
            if (optionsList[sel_id].text.search('Pregnancy') >= 0)
            {
                max_cycle_adder = 320;
            }
            else if (optionsList[sel_id].text.search('Postpartum') >= 0)
            {
                max_cycle_adder = 679;
            }
            else
            {
                max_cycle_adder = 120;
            }
            // Search for the closest subsequent cycle
            for (var i=0; i<optionsList.length; i++)
            {
                if (sel_id != i)
                {
                    if (optionsList[i].value > global_selected_cycle_as_number)
                    {
                        var temp = optionsList[i].value - 1;
                        if ((temp > 0) && (temp < global_selected_cycle_end_as_number))
                        {
                            // For now this is the closest "next" cycle so use that as the assigned value
                            global_selected_cycle_end_as_number = temp;
                        }
                    }
                }
            }
            if (global_selected_cycle_end_as_number >= 99999)
            {
                // No next cycle found.  Just project so many days past last cycle
                global_selected_cycle_end_as_number = global_selected_cycle_as_number + max_cycle_adder;
            }
        }

        // If we are changing cycles, clear the flag that indicates when we last loaded the data since we now need to 
        // load it for the new cycle regardless of when we did it for some other previous cycle
        if ((last_cycle_start != global_selected_cycle_as_number) || (last_cycle_end != global_selected_cycle_end_as_number))
        {
            g_LoadTimestamps['same_cycle'] = '';
        }
        
        // Go back to the last subscreen they were on.  If they have never been to a subscreen (-1) then just use a default one to start with
        if (global_last_analysis_screen == -1)
        {
            global_last_analysis_screen = 0;
        }
        global_Block_Global_Analysis_Pages = false;
        // See if they're already on the page such that we need to call "pageinit" function manually
        if (global_Analysis_Pages[global_last_analysis_screen] == GetCurrentPage())
        {
            printDebug('manually calling pageinit since already on page');
            navBetweenAnalysisScreens(1, global_last_analysis_screen, '', '', '');
        }
        else
        {
            TransitionToSubscreen(global_Analysis_Pages[global_last_analysis_screen], 'none');
        }
    
        // Open local database so we can save this most recently chosen cycle
        db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
        global_db_ios_fail_userPickCyc_2 = DB_IOS_RETRY_LIMIT;
        db.transaction(     function(tx) 
                            {
                                global_db_ios_fail_userPickCyc_2 = -1;
                                userPickedCycle(state+1, tx, '', '');
                            },
                            errorCB,
                            function(tx)
                            {
                                // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                if (global_db_ios_fail_userPickCyc_2 > 0)
                                {
                                    global_db_ios_fail_userPickCyc_2 = global_db_ios_fail_userPickCyc_2 - 1;
                                    printDebug('iOS db.transaction failed userPickedCycle state 2. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_userPickCyc_2));
                                    userPickedCycle(state, param_1, param_2, param_3);
                                }
                                else if (global_db_ios_fail_userPickCyc_2 == 0)
                                {
                                    printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                }
                                else
                                {
                                    successCB();
                                }
                            }
                       );
    
        break;
        
    case 3:
        // Save the chosen cycle
        var tx = param_1;
        var strSql = 'UPDATE User_Info_DB SET selected_cycle=' + global_selected_cycle_as_number + ', sel_cycle_end='
        strSql += global_selected_cycle_end_as_number + ';';
        suspend_scrolling(true, '');
        tx.executeSql(  strSql, 
                        [], 
                        function(tx, results) 
                        {
                            suspend_scrolling(false, 0);
                            successCB();
                        },
                        errorCB
                     );
        break;
    }
}
function NavigateDirectToPicker()
{
    printDebug('called NavigateDirectToPicker()');
    TransitionToSubscreen('analysis_picker', 'none');
}
function NavigateToAnalysisSubscreen(target_url)
{
    var i;
    var target_url_index = 0;
    var page_suffix = GetCurrentPage();
    var strSql;
    
    // Find the index of the page we are going to and save it as the last selected page (the cycle picker needs to keep track of this to know which subpage to kick off)
    for (i=0; i<global_Analysis_Pages.length; i++)
    {
        if (global_Analysis_Pages[i] == target_url)
        {
            target_url_index = i;
        }
    }
    global_last_analysis_screen = target_url_index;
    
    // Save selection in database
    strSql = 'UPDATE User_Info_DB SET last_cycle_screen=' + global_last_analysis_screen + ';';
    open_database_and_execute(strSql, '');
    
    // Make sure a cycle has previously been selected.  If not, we need to show the picker first
    if (global_selected_cycle_as_number == 0)
    {
        // Load the requested page
        NavigateDirectToPicker();
    }
    else
    {
        // Load the requested page
        TransitionToSubscreen(target_url, 'none');
    }
}

function RenderAnalysisScreensFromLocalDatabase(state, callback, param_1, param_2, param_3, final_call, cycle_start, cycle_end, param_4, param_5)
{
    var ANALYSIS_PAGES_CHART_URL;
    if (BUILD_TARGET == BUILD_4_CCL)
    {
        ANALYSIS_PAGES_CHART_URL = "analysis_ccl_chart";
    }
    else
    {
        ANALYSIS_PAGES_CHART_URL = "analysis_chart";
    }
    const ANALYSIS_PAGES_CCL_CYCHIST_URL = "analysis_ccl_cychist";
    const ANALYSIS_PAGES_CCL_SEL_URL = "analysis_ccl_selection";
    const ANALYSIS_PAGES_GRAPH_URL = "analysis_graph";
    const ANALYSIS_PAGES_OVDATES_URL = "analysis_ovdates";
    const ANALYSIS_PAGES_WINCONF_URL = "analysis_winconf";
    const ANALYSIS_PAGES_CSTATS_URL = "analysis_cstats";
    var fallthrough_no_op = false;
    var tx = param_1;
    var results = param_2;
    var strSql = '';  
    var ChartColumnsWithData = cycle_end - cycle_start + 1;
    if (ChartColumnsWithData > MAX_NUMBER_OF_CHART_COLUMNS) 
    {
        ChartColumnsWithData = MAX_NUMBER_OF_CHART_COLUMNS;
    }

    // Callback State Machine
    var currTime = new Date();
    printDebug("State #" + state + " of RenderAnalysisScreensFromLocalDatabase " + appendTimeStamp(currTime));
    switch(state)
    {
    case 1:  
LogCall('h1'); 

        // Query cycles next - since all pages show the cycle at the top, all pages need to execute this
        if (true)  //((global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_OVDATES_URL) || (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_WINCONF_URL) || (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CSTATS_URL) || (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART) || (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_GRAPH_URL))
        {
            strSql = 'SELECT * FROM Cycles_DB ORDER BY cyc_started DESC;';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                RenderAnalysisScreensFromLocalDatabase(state+1, callback, tx, results, decoded, final_call, cycle_start, cycle_end, '', '');
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local DataRecs database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
        }
        else
        {
            // If any page did not need this, it could skip processing of the results (but all pages need it)
            state = 2;
            fallthrough_no_op = true;
            // Intentional fall through to next state
        }

    case 2:
LogCall('h2'); 
        if (fallthrough_no_op == false)     // all pages need to consider this query
        {
           // Retrieve results of query
            var chartSettings;
            var len = results.rows.length;
            var given_cyc_start;
            var given_cyc_start_formatted;
            var tempStr = '';
            var cycHistoryStr = '';
            var tempVal;
            var j;
            
            if ((global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL) || (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_GRAPH_URL))
            {
                // Decide on appropriate number of rows and columns
                chartSettings = DetermineChartSettings(ChartColumnsWithData);
                
                // Set page width
                var EXTRA_PAGE_WIDTH;
                if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL)
                {
                    EXTRA_PAGE_WIDTH = 100;
                }
                else
                {
                    EXTRA_PAGE_WIDTH = 115;
                }
                var new_html_width = chartSettings.chart_num_of_cols * chartSettings.chart_col_width + EXTRA_PAGE_WIDTH;
                if (new_html_width < html_designed_px_width)
                {
                    new_html_width = html_designed_px_width;
                }
                $("#" + global_Analysis_Pages[global_last_analysis_screen]).width(new_html_width);
            }
                
            // Set cycle length
            if ((global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CSTATS_URL) && (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CCL_CYCHIST_URL))
            {
                document.getElementById('CyStat_CycCount_Div').innerHTML = len;
            }
            
            // Loop through cycles
            if ((global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CSTATS_URL) && (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CCL_CYCHIST_URL))
            {
                cycHistoryStr = '<table border=1 align="center"><tr><td><b>Cycle Start</b></td><td><b>Cycle Length</b></td><td><b>Luteal Length</b></td></tr>';
            }
            for (var i=0; i<len; i++)
            {
                given_cyc_start = results.rows.item(i)['cyc_started'];
                var date_str = NumberToDate(given_cyc_start);
                given_cyc_start_formatted = PrintDate(date_str);
                // See if this cycle matches the loaded one
                if (given_cyc_start == cycle_start)
                {
                    // Identify the selected cycle
                    var sel_date = new Date(date_str);
                    var tempStr = months[sel_date.getMonth()] + ' ' + sel_date.getDate() + ', ' + sel_date.getFullYear();
                    document.getElementById('SelCyc_' + GetCurrentPage()).innerHTML = tempStr;
                    if (BUILD_TARGET == BUILD_4_CCL)
                    {
                        var cyc_id = results.rows.item(i)['id_txt'];
                        if (cyc_id == 0)
                        {
                            document.getElementById('CycId_' + GetCurrentPage()).innerHTML = '';
                        }
                        else
                        {
                            document.getElementById('CycId_' + GetCurrentPage()).innerHTML = ' [Cht ' + results.rows.item(i)['id_txt'] + ']';
                        }
                    }
                    // Pick on drop down
                    if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL)
                    {
                        var prefixStr = 'Charted Cycle: ';
                        if (BUILD_TARGET == BUILD_4_CCL)
                        {
                            prefixStr = 'Cycle: ';
                        }
                        $('#Chart_CycStartDate_Btn').parent().find('.ui-btn-text').text(prefixStr + given_cyc_start_formatted);
                    }
                    if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_GRAPH_URL)
                    {
                        $('#Graph_CycStartDate_Btn').parent().find('.ui-btn-text').text('Graphed Cycle: ' + given_cyc_start_formatted);
                    }
                    if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_WINCONF_URL)
                    {
                        $('#WinConf_CycStartDate_Btn').parent().find('.ui-btn-text').text('Analyzed Cycle: ' + given_cyc_start_formatted);
                    }
                    if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CCL_SEL_URL)
                    {
                        $('#CCLSel_CycStartDate_Btn').parent().find('.ui-btn-text').text('Cycle: ' + given_cyc_start_formatted);
                    }                        
                    if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CCL_CYCHIST_URL)
                    {
                        $('#CCLHistory_CycStartDate_Btn').parent().find('.ui-btn-text').text('Cycle: ' + given_cyc_start_formatted);
                    }                        
                    if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_OVDATES_URL)
                    {
                        $('#OvDate_CycStartDate_Btn').parent().find('.ui-btn-text').text('Analyzed Cycle: ' + given_cyc_start_formatted);
                        if (global_active_subscription == 0)  
                        {
                            // Enable/disable controls
                            document.getElementById('CMOvMeth_Disabled').style.display = 'block';
                            document.getElementById('CMOvMeth_Enabled').style.display = 'none';
                            document.getElementById('BBTOvMeth_Disabled').style.display = 'block';
                            document.getElementById('BBTOvMeth_Enabled').style.display = 'none';
                        }
                        else  // Active subscription
                        {
                            // Enable/disable controls
                            document.getElementById('CMOvMeth_Disabled').style.display = 'none';
                            document.getElementById('CMOvMeth_Enabled').style.display = 'block';
                            document.getElementById('BBTOvMeth_Disabled').style.display = 'none';
                            document.getElementById('BBTOvMeth_Enabled').style.display = 'block';
                        }
                    }
                    if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_WINCONF_URL)
                    {
                        if (global_active_subscription == 0)  
                        {
                            // Confidence Scores
                            document.getElementById('WinConf_CycConfComplete_Div').innerHTML = getDisabledMessageForNoSub();
                            document.getElementById('WinConf_CycConfCertain_Div').innerHTML =  getDisabledMessageForNoSub();
                            document.getElementById('WinConf_CycConfQuality_Div').innerHTML =  getDisabledMessageForNoSub();
                            // Fertility Window
                            document.getElementById('WinConf_CycFWinStart_Div').innerHTML = getDisabledMessageForNoSub();
                            document.getElementById('WinConf_CycFWinEnd_Div').innerHTML = getDisabledMessageForNoSub();
                            document.getElementById('WinConf_CycFWinWhy_Div').innerHTML =  getDisabledMessageForNoSub();
                        }
                        else  // Active subscription
                        {
                            // Confidence Scores
                            document.getElementById('WinConf_CycConfComplete_Div').innerHTML = ConvertNumToStars(results.rows.item(i)['complete']);
                            document.getElementById('WinConf_CycConfCertain_Div').innerHTML =  ConvertNumToStars(results.rows.item(i)['certain']);
                            document.getElementById('WinConf_CycConfQuality_Div').innerHTML =  ConvertNumToStars(results.rows.item(i)['quality']);
                            // Fertility Window
                            document.getElementById('WinConf_CycFWinStart_Div').innerHTML = PrintFertWindow(results.rows.item(i)['fwin_beg'], results.rows.item(i)['fwin_beg_final']);
                            document.getElementById('WinConf_CycFWinEnd_Div').innerHTML = PrintFertWindow(results.rows.item(i)['fwin_end'], results.rows.item(i)['fwin_end_final']);
                            document.getElementById('WinConf_CycFWinWhy_Div').innerHTML =  ReplaceQuotes(results.rows.item(i)['fwin_why'], false);
                        }
                    }
                    if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_OVDATES_URL)
                    {
                        // Ovulation Dates
                        if (results.rows.item(i)['anov'] != 0)
                        {
                            $("input[id='anovCheckbox']").attr("checked",true);
                            document.getElementById('OvDate_ManualButton1_Div').style.display = 'none';
                            document.getElementById('OvDate_ManualButton2_Div').style.display = 'none';
                            document.getElementById('OvDate_ShowAutomatic_Div').style.display = 'none';
                            document.getElementById('OvDate_AutoManualConfig_Div').style.display = 'none';
                            document.getElementById('OvDate_OverallOv_Div').innerHTML = 'n/a (user marked anovulatory)';
                        }
                        else
                        {
                            $("input[id='anovCheckbox']").attr("checked",false);
                            document.getElementById('OvDate_AutoManualConfig_Div').style.display = 'block';
                            if (results.rows.item(i)['all_ov_type'] == 1)  // Auto
                            {
                                document.getElementById('OvDate_ManualButton1_Div').style.display = 'block';
                                document.getElementById('OvDate_ManualButton2_Div').style.display = 'block';
                                document.getElementById('OvDate_ShowAutomatic_Div').style.display = 'none';
                                document.getElementById('OvDate_OverallOv_Div').innerHTML = PrintDateOrUnknown(results.rows.item(i)['all_ov_auto']);
                                document.getElementById('OvOverrideDateTextbox').value = '';
                            }
                            else // Manual
                            {
                                document.getElementById('OvDate_ManualButton1_Div').style.display = 'none';
                                document.getElementById('OvDate_ManualButton2_Div').style.display = 'none'; 
                                document.getElementById('OvDate_ShowAutomatic_Div').style.display = 'block';
                                document.getElementById('OvDate_OverallOv_Div').innerHTML = PrintDateOrUnknown(results.rows.item(i)['all_ov_manual']);
                                document.getElementById('OvDate_AutoOv_Div').innerHTML = PrintDateOrUnknown(results.rows.item(i)['all_ov_auto']);
                            }
                        }
                        var myselect = $("select#BBTOvMethodSelect");
                        myselect[0].selectedIndex = results.rows.item(i)['bbt_meth'];
                        var myselect = $("select#CMOvMethodSelect");
                        myselect[0].selectedIndex = results.rows.item(i)['cm_meth'];
                        // Conditionally refresh controls 
                        $("input[id='anovCheckbox']").checkboxradio("refresh");
                        myselect.selectmenu("refresh");
                        myselect.selectmenu("refresh");
                        RefreshCycleDayStartDropDownIfVisible();
                        // Load values from database
                        document.getElementById('OvDate_BBTOv_Div').innerHTML =  PrintDateOrUnknown(results.rows.item(i)['bbt_ov']);
                        document.getElementById('OvDate_BBTOvAvg_Div').innerHTML =  PrintDateOrUnknown(results.rows.item(i)['bbt_ave_ov']);
                        document.getElementById('OvDate_BBTOvOver6_Div').innerHTML =  PrintDateOrUnknown(results.rows.item(i)['bbt_36_ov']);
                        document.getElementById('OvDate_BBTOvTrad_Div').innerHTML =  PrintDateOrUnknown(results.rows.item(i)['bbt_orig_ov']);
                        document.getElementById('OvDate_BBTOvCov_Div').innerHTML =  PrintDateOrUnknown(results.rows.item(i)['bbt_cv_ov']);
                        document.getElementById('OvDate_BBTOvSMC_Div').innerHTML =  PrintDateOrUnknown(results.rows.item(i)['bbt_smc_ov']);
                        document.getElementById('OvDate_CMOv_Div').innerHTML =  PrintDateOrUnknown(results.rows.item(i)['cm_ov']);
                        document.getElementById('OvDate_CMOvTrad_Div').innerHTML =  PrintDateOrUnknown(results.rows.item(i)['cm_trad_ov']);
                        document.getElementById('OvDate_CMOvAlt_Div').innerHTML =  PrintDateOrUnknown(results.rows.item(i)['cm_alt_ov']);
                        document.getElementById('OvDate_FertMonOv_Div').innerHTML =  PrintDateOrUnknown(results.rows.item(i)['mon_ov']);
                        document.getElementById('OvDate_LHOv_Div').innerHTML =  PrintDateOrUnknown(results.rows.item(i)['lh_ov']);
                        document.getElementById('OvDate_SalivaOv_Div').innerHTML =  PrintDateOrUnknown(results.rows.item(i)['saliva_ov']);
                        document.getElementById('OvDate_RhyOv_Div').innerHTML =  PrintDateOrUnknown(results.rows.item(i)['rhy_ov']);
                    }
 
                    // CCL constants used by next two sections
                    const PHASE_1_56 = 3;
                    const PHASE_1_DOERING = 7;
                    const PHASE_1_LASTDRYDAYS = 9;
                    const PHASE_1_MANUAL = 1;
                    const PHASE_3_ST = 2;
                    const PHASE_3_POSTHORM = 8;
                    const PHASE_3_TEMPONLY = 4;
                    const PHASE_3_MUCUSONLY = 5;
                    const PHASE_3_MANUAL = 1;
                    var phase_i_fwin_beg_val_str = results.rows.item(i)['fwb_vals'];
                    // Store settings needed to render chart in a later call (relayed to later call using chartSettings argument)
                    if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL)
                    {
                        // Log other analyzed parameters needed for fertility chart rendering
                        if (BUILD_TARGET == BUILD_4_CCL)
                        {
                            if (results.rows.item(i)['fwe_st'] == PHASE_3_TEMPONLY)
                            {
                                chartSettings.phase_iii_use_st = false;
                            }
                            else
                            {
                                chartSettings.phase_iii_use_st = true;
                            }                            
                        }
                    }
                    if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CCL_CYCHIST_URL)
                    {
                        document.getElementById('CCLHistDetails').style.display = 'block';
                        document.getElementById('CCLHistDetails_Off').style.display = 'none';
                        
                        // Day 5/6 Rule
                        tempVal = getFertWinValueFromString(phase_i_fwin_beg_val_str, PHASE_1_56, true);
                        if (tempVal == 1)
                        {
                            document.getElementById('divCCLRule5or6').innerHTML = "<b>n/a</b> (rule not available)";
                        }
                        else if (tempVal == 6)
                        {
                            document.getElementById('divCCLRule5or6').innerHTML = "<b>(5)</b> 6";
                        }
                        else if (tempVal == 7)
                        {
                            document.getElementById('divCCLRule5or6').innerHTML = "5 <b>(6)</b>";
                        }
                        else if (tempVal == 0)
                        {
                            // If empty, this is a sign that the cycle must have been marked for non-analysis (using CCL startup wizard)
                            document.getElementById('CCLHistDetails').style.display = 'none';
                            document.getElementById('CCLHistDetails_Off').style.display = 'block';
                        }
                        else
                        {
                            document.getElementById('divCCLRule5or6').innerHTML = "<b>" + (tempVal-1) + " (due to mucus)</b>";
                        }
                        
                        // Doering Rule
                        tempVal = getFertWinValueFromString(phase_i_fwin_beg_val_str, PHASE_1_DOERING, true);
                        if (results.rows.item(i)['pc_num_tcyc'] < 6)
                        {
                            document.getElementById('divCCLDoeringRule').innerHTML = 'n/a';
                        }
                        else
                        {
                            if (tempVal == 0)
                            {
                                document.getElementById('divCCLDoeringRule').innerHTML = 'n/a';
                            }
                            else
                            {
                                document.getElementById('divCCLDoeringRule').innerHTML = "<b>" + (tempVal-1) + "</b>";
                            }
                        }
                        if ((tempVal == getFertWinValueFromString(phase_i_fwin_beg_val_str, PHASE_1_LASTDRYDAYS, true)) && (tempVal > 0))
                        {
                            // When these are the same, assume it's because of mucus overriding the Doering rule.  It may also be that they agree too though (Doering = Last Dry Day)
                            document.getElementById('divCCLDoeringRule').innerHTML += ' <b>(due to mucus)</b>';
                        }
 
                        // Load CCL Cycle History Stats
                        document.getElementById('divCCLPrevCycShort').innerHTML = results.rows.item(i)['pc_short'];
                        document.getElementById('divCCLPrevCycLong').innerHTML = results.rows.item(i)['pc_long'];
                        document.getElementById('divCCLCycVarCount').innerHTML = results.rows.item(i)['pc_num_cyc'];
                        document.getElementById('divCCLFirstDayOfRise').innerHTML = results.rows.item(i)['pc_early_trise'];
                        document.getElementById('divCCLNumLastCycles').innerHTML = results.rows.item(i)['pc_num_tcyc'];
                        
                        // Load specified cycle weight
                        var wt_units;
                        var ht_units;
                        if (global_t_units == 'F') 
                        {
                            wt_units = 'lbs';
                            ht_units = 'inches';
                        }
                        else
                        {
                            wt_units = 'kg';
                            ht_units = 'cm';
                        }
                        document.getElementById('divCyStat_Wt').innerHTML = results.rows.item(i)['cweight']/100 + ' ' + wt_units;
                        document.getElementById('divCyStat_Ht').innerHTML = global_user_height + ' ' + ht_units;
                        document.getElementById('divCyStat_BMI').innerHTML = calcBMI(global_t_units, results.rows.item(i)['cweight']/100, global_user_height);
                    }
                    if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CCL_SEL_URL)
                    {
                        var i_notes = '';
                        var tempVal;
                        var phase_i_notes = '';
                        var phase_iii_notes = '';
                        var phase_i_fwin_beg_val_str = results.rows.item(i)['fwb_vals'];
                        var phase_iii_fwin_end_val_str = results.rows.item(i)['fwe_vals'];
                        var show_manual_instr_override;
                        var Phase1RadioEnumeration = {};
                        Phase1RadioEnumeration[PHASE_1_56] = 'Phase1Radio_Day56';
                        Phase1RadioEnumeration[PHASE_1_DOERING] = 'Phase1Radio_Doering';
                        Phase1RadioEnumeration[PHASE_1_LASTDRYDAYS] = 'Phase1Radio_LastDryDay';
                        var Phase3RadioEnumeration = {};
                        Phase3RadioEnumeration[PHASE_3_ST] = 'Phase3Radio_ST';
                        Phase3RadioEnumeration[PHASE_3_POSTHORM] = 'Phase3Radio_PostHorm';
                        Phase3RadioEnumeration[PHASE_3_TEMPONLY] = 'Phase3Radio_TempOnly';
                        Phase3RadioEnumeration[PHASE_3_MUCUSONLY] = 'Phase3Radio_MucusOnly';
                        document.getElementById('CCLAnalysisSelDetails').style.display = 'block';
                        document.getElementById('CCLAnalysisSelDetails_Off').style.display = 'none';
                        
                        // Set cycle and instructor notes
                        document.getElementById('cycleNotesTextArea').value = ReplaceQuotes(results.rows.item(i)['cyc_notes'], 0);
                        $('#cycleNotesTextArea').trigger('keyup');
                        i_notes = ReplaceQuotes(results.rows.item(i)['inst_notes'], 0);
                        if (i_notes == '')
                        {
                            i_notes = '(<i>none</i>)';
                        }
                        document.getElementById('CCL_Sel_Instr_Notes').innerHTML = i_notes;
                        
                        // Set Phase I/III selections and then populate calculated values for each
                        var phase_db_vals;
                        phase_db_vals = [3,7,9]; // Excluding "manual" [3,7,9,1]
                        for (tindex=0; tindex<phase_db_vals.length; tindex++)
                        {
                            if (results.rows.item(i)['fwb_st'] == phase_db_vals[tindex])
                            {
                                $("input[id='" + Phase1RadioEnumeration[phase_db_vals[tindex]] + "']").attr("checked",true).checkboxradio("refresh");
                            }
                            else
                            {
                                $("input[id='" + Phase1RadioEnumeration[phase_db_vals[tindex]] + "']").attr("checked",false).checkboxradio("refresh");
                            }
                        }
                        phase_db_vals = [2,8,4,5]; // Excluding "manual" [2,8,4,5,1]
                        for (tindex=0; tindex<phase_db_vals.length; tindex++)
                        {
                            if (results.rows.item(i)['fwe_st'] == phase_db_vals[tindex])
                            {
                                $("input[id='" + Phase3RadioEnumeration[phase_db_vals[tindex]] + "']").attr("checked",true).checkboxradio("refresh");
                            }
                            else
                            {
                                $("input[id='" + Phase3RadioEnumeration[phase_db_vals[tindex]] + "']").attr("checked",false).checkboxradio("refresh");
                            }
                        }

                        // Note any manual overrides if they were performed on the web
                        if (results.rows.item(i)['fwb_st'] == 1)
                        {
                            document.getElementById('CCL_Sel_Manual_Phase_I_Choice').innerHTML = '<li>A manual override was specified on CycleProGo.com and is being used.  Phase I ends on cycle day ' + results.rows.item(i)['fwb_man_st'] + '</li>';
                        }
                        else
                        {
                            document.getElementById('CCL_Sel_Manual_Phase_I_Choice').innerHTML = '';
                        }
                        if (results.rows.item(i)['fwe_st'] == 1)
                        {
                            document.getElementById('CCL_Sel_Manual_Phase_III_Choice').innerHTML = '<li>A manual override was specified on CycleProGo.com and is being used.  Phase III starts on the evening of cycle day ' + results.rows.item(i)['fwe_man_st'] + '</li>';
                        }
                        else
                        {
                            document.getElementById('CCL_Sel_Manual_Phase_III_Choice').innerHTML = '';
                        }
                        
                        // Day 5/6 Rule
                        tempVal = getFertWinValueFromString(phase_i_fwin_beg_val_str, PHASE_1_56, true);
                        document.getElementById('divPhase1Radio_Day56').innerHTML = convertFertWinValToDisplayString(tempVal, true);
                        if (tempVal == 1)
                        {
                            // Ensure that this isn't due to a Last Dry Day override for Day 5/6 before claiming no cycle history
                            tempVal = getFertWinValueFromString(phase_i_fwin_beg_val_str, PHASE_1_LASTDRYDAYS, true);
                            if (tempVal != 1)
                            {
                                phase_i_notes += " <li><b>Day 5/6 Rule Adjusted for No Cycle History</b>: Since this is your first cycle, Phase II starts immediately (unless you indicate using the website that you have prior charting experience).</li>"
                            }
                        }
                        else if (tempVal == 0)
                        {
                            // If empty, this is a sign that the cycle must have been marked for non-analysis (using CCL startup wizard)
                            document.getElementById('CCLAnalysisSelDetails').style.display = 'none';
                            document.getElementById('CCLAnalysisSelDetails_Off').style.display = 'block';
                        }

                        // Doering Rule
                        tempVal = getFertWinValueFromString(phase_i_fwin_beg_val_str, PHASE_1_DOERING, true);
                        document.getElementById('divPhase1Radio_Doering').innerHTML = convertFertWinValToDisplayString(tempVal, true);
                        if (results.rows.item(i)['pc_num_tcyc'] < 6)
                        {
                            phase_i_notes += "<li><b>Doering Rule Not Available</b> until you have 6 or more cycles of temperature history</li>";
                            $("input[id='Phase1Radio_Doering']").checkboxradio('disable');
                        }
                        else
                        {
                            $("input[id='Phase1Radio_Doering']").checkboxradio('enable');
                        }

                        // Last Dry Day Rule
                        tempVal = getFertWinValueFromString(phase_i_fwin_beg_val_str, PHASE_1_LASTDRYDAYS, true);
                        document.getElementById('divPhase1Radio_LastDryDay').innerHTML = convertFertWinValToDisplayString(tempVal, true);
                        if (results.rows.item(i)['pc_num_cyc'] < 6)
                        {
                            phase_i_notes += "<li><b>Last Dry Day Rule Not Available</b> until you have 6 or more cycles of experience</li>";
                            $("input[id='Phase1Radio_LastDryDay']").checkboxradio('disable');
                        }
                        else if (results.rows.item(i)['pc_l_mucpat'] < 6)
                        {
                            phase_i_notes += "<li><b>Last Dry Day Rule Not Available</b> because fewer than 4 of the last 6 cycles have six or more days of mucus from onset through peak day.</li>";
                            $("input[id='Phase1Radio_LastDryDay']").checkboxradio('disable');
                        }
                        else
                        {
                            $("input[id='Phase1Radio_LastDryDay']").checkboxradio('enable');
                        }

                        // Phase III Rules (Symptothermal, Post Hormonal, Temp-Only, and Mucus-Only)
                        tempVal = getFertWinValueFromString(phase_iii_fwin_end_val_str, PHASE_3_ST, false);
                        document.getElementById('divPhase3Radio_ST').innerHTML = convertFertWinValToDisplayString(tempVal, false);
                        tempVal = getFertWinValueFromString(phase_iii_fwin_end_val_str, PHASE_3_POSTHORM, false);
                        document.getElementById('divPhase3Radio_PostHorm').innerHTML = convertFertWinValToDisplayString(tempVal, false);
                        tempVal = getFertWinValueFromString(phase_iii_fwin_end_val_str, PHASE_3_TEMPONLY, false);
                        document.getElementById('divPhase3Radio_TempOnly').innerHTML = convertFertWinValToDisplayString(tempVal, false);
                        tempVal = getFertWinValueFromString(phase_iii_fwin_end_val_str, PHASE_3_MUCUSONLY, false);
                        document.getElementById('divPhase3Radio_MucusOnly').innerHTML = convertFertWinValToDisplayString(tempVal, false);

                        // Check for instructor differences - Phase I
                        show_manual_instr_override = false;
                        if (results.rows.item(i)['fwb_st'] != results.rows.item(i)['fwb_in'])
                        {
                            tempVal = getFertWinValueFromString(phase_i_fwin_beg_val_str, results.rows.item(i)['fwb_in'], true);
                            switch(results.rows.item(i)['fwb_in'])
                            {
                                case PHASE_1_56:
                                    phase_i_notes += '<li>Please check with your instructor. He/she chose the Day 5/6 Rule (Phase I ending on cycle day ' + (tempVal-1) + ')</li>';
                                    break;
                                case PHASE_1_DOERING:
                                    phase_i_notes += '<li>Please check with your instructor. He/she chose the Doering Rule (Phase I ending on cycle day ' + (tempVal-1) + ')</li>';
                                    break;
                                case PHASE_1_LASTDRYDAYS:
                                    phase_i_notes += '<li>Please check with your instructor. He/she chose the Last Dry Day Rule (Phase I ending on cycle day ' + (tempVal-1) + ')</li>';
                                    break;
                                case PHASE_1_MANUAL:
                                    show_manual_instr_override = true;
                                    break;
                            }
                        }
                        else if ((results.rows.item(i)['fwb_st'] == PHASE_1_MANUAL) && (results.rows.item(i)['fwb_man_st'] != results.rows.item(i)['fwb_man_in']))
                        {
                            show_manual_instr_override = true;
                        }
                        if ((show_manual_instr_override) && (results.rows.item(i)['fwb_man_in'] > 0))
                        {
                            phase_i_notes += '<li>Please check with your instructor. He/she manually overrode the estimates and specified Phase I to end on Cycle Day ' + (results.rows.item(i)['fwb_man_in']-1) + '</li>';
                        }
                        // Check for instructor differences - Phase III
                        show_manual_instr_override = false;
                        if (results.rows.item(i)['fwe_st'] != results.rows.item(i)['fwe_in'])
                        {
                            tempVal = getFertWinValueFromString(phase_iii_fwin_end_val_str, results.rows.item(i)['fwe_in'], false);
                            switch(results.rows.item(i)['fwe_in'])
                            {
                                case PHASE_3_ST:
                                    phase_iii_notes += '<li>Please check with your instructor. He/she chose the Symptothermal (Phase III starts on the evening of cycle day ' + tempVal + ')</li>';
                                    break;
                                case PHASE_3_POSTHORM:
                                    phase_iii_notes += '<li>Please check with your instructor. He/she chose the Post Hormonal (Phase III starts on the evening of cycle day ' + tempVal + ')</li>';
                                    break;
                                case PHASE_3_TEMPONLY:
                                    phase_iii_notes += '<li>Please check with your instructor. He/she chose the Temperature Only Rule (Phase III starts on the evening of cycle day ' + tempVal + ')</li>';
                                    break;
                                case PHASE_3_MUCUSONLY:
                                    phase_iii_notes += '<li>Please check with your instructor. He/she chose the Mucus Only Rule (Phase III starts on the evening of cycle day ' + tempVal + ')</li>';
                                    break;
                                case PHASE_3_MANUAL:
                                    show_manual_instr_override = true;
                                    break;
                            }
                        }
                        else if ((results.rows.item(i)['fwe_st'] == PHASE_3_MANUAL) && (results.rows.item(i)['fwe_man_st'] != results.rows.item(i)['fwe_man_in']))
                        {
                            show_manual_instr_override = true;
                        }
                        if ((show_manual_instr_override) && (results.rows.item(i)['fwe_man_in'] > 0))
                        {
                            phase_iii_notes += '<li>Please check with your instructor. He/she manually overrode the estimates and specified Phase I to end on Cycle Day ' + results.rows.item(i)['fwe_man_in'] + '</li>';
                        }
                        document.getElementById('CCL_Sel_Phase_I_Notes').innerHTML = phase_i_notes;
                        document.getElementById('CCL_Sel_Phase_III_Notes').innerHTML = phase_iii_notes;
                    }
                }
                // Build up Cycle History for all cycles
                if ((global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CSTATS_URL) || (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CCL_CYCHIST_URL))
                {
                    cycHistoryStr += '<tr><td>' + given_cyc_start_formatted + '</td>';
                    tempVal = results.rows.item(i)['cyc_len'];
                    if (tempVal == 0)
                    {
                        cycHistoryStr += '<td>In Progress</td>';
                    }
                    else if (tempVal == 100)
                    {
                        cycHistoryStr += '<td>100 days or more</td>';
                    } 
                    else
                    {
                        cycHistoryStr += '<td>' + tempVal + ' days</td>';
                    }
                    if (results.rows.item(i)['anov'] == 1)
                    {
                        cycHistoryStr += '<td>Anovulatory</td></tr>';
                    }
                    else
                    {
                        tempVal = results.rows.item(i)['cyc_lut_len'];
                        if (tempVal == 0)
                        {
                            cycHistoryStr += '<td>Unknown</td></tr>';
                        }
                        else if (tempVal == -1)
                        {
                            cycHistoryStr += '<td>n/a</td></tr>';
                        }
                        else
                        {
                            cycHistoryStr += '<td>' + tempVal + '</td></tr>';
                        }
                    }
                }
                
            }
            if ((global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CSTATS_URL) && (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CCL_CYCHIST_URL))
            {
                cycHistoryStr += '</table>';
                document.getElementById('OvDate_CycleHistory_Div').innerHTML = cycHistoryStr;
            }
        }
        
        if ((global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL) || (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_GRAPH_URL))
        {
            // Retrieve interpretted values from local database
            strSql = 'SELECT * FROM Interp_DB WHERE record_date >= ' + cycle_start
            strSql += ' AND record_date <= ' + cycle_end + ';';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                RenderAnalysisScreensFromLocalDatabase(state+1, callback, tx, results, '', final_call, cycle_start, cycle_end, chartSettings, '');
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local Interp database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
        }
        else
        {
            // Events are needed for chart only, so we can skip this step
            state = 3;
            fallthrough_no_op = true;
            // Intentional fall through to next state
        }
    
    case 3:
LogCall('h3');  
        var chartSettings = param_4;
        
        if ((fallthrough_no_op == false) && ((global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL) || (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_GRAPH_URL))) 
        {
            var fpct_all = new Array();
            var fpct_cm = new Array();
            var fpct_saliva = new Array();
            var fpct_mon = new Array();
            var fpct_bbt = new Array();
            var fpct_rhy = new Array();
            var fpct_lh = new Array();
            var fpct_cervix = new Array();
            var cyc_day = new Array();
            var dpo_day = new Array();
            var all_ov = new Array();
            var fwin = new Array();
            var cm_ov = new Array();
            var mon_ov = new Array();
            var cclst_cov = new Array();
            var bill_itp_mucus_peak = new Array();
            var bbt_cov = new Array();
            var caldates_chart = new Array();
            var caldates_graph = new Array();
            var year;
        
            // Initialize
            var larger_col_count = chartSettings.graph_num_of_cols;
            if (larger_col_count < chartSettings.chart_num_of_cols)
            {
                larger_col_count = chartSettings.chart_num_of_cols;
            }
            for (var i=0; i<larger_col_count; i++)
            {
                fpct_all[i] = 0;
                fpct_cm[i] = 0;
                fpct_saliva[i] = 0;
                fpct_mon[i] = 0;
                fpct_bbt[i] = 0;
                fpct_rhy[i] = 0;
                fpct_lh[i] = 0;
                fpct_cervix[i] = 0;
                all_ov[i] = 0;
                fwin[i] = 0;
                cm_ov[i] = 0;
                mon_ov[i] = 0;
                cclst_cov[i] = 0;
                bill_itp_mucus_peak[i] = 0;
                bbt_cov[i] = 0;
                caldates_chart[i] = '';
                caldates_graph[i] = '';
                dpo_day[i] = '';
                if (i < ChartColumnsWithData)
                {
                    cyc_day[i] = (i+1) + global_selected_cycle_offset;
                }
                else
                {
                    // Blank out if there is no data for this date
                    cyc_day[i] = '';
                }
            }
            
            // Get data
            var rec_date_index;
            var len = results.rows.length;
            for (var i=0; i<len; i++)
            {
                rec_date_index = results.rows.item(i).record_date - cycle_start;
                if ((rec_date_index >= 0) && (rec_date_index < larger_col_count))
                {
                    if (BUILD_TARGET == BUILD_4_CCL)
                    {
                        var fpct_ccl = results.rows.item(i)['fpct_all'];
                        fpct_all[rec_date_index] = fpct_ccl;
                        fpct_cm[rec_date_index] = fpct_ccl;
                        fpct_saliva[rec_date_index] = fpct_ccl;
                        fpct_mon[rec_date_index] = fpct_ccl;
                        fpct_bbt[rec_date_index] = fpct_ccl;
                        fpct_rhy[rec_date_index] = fpct_ccl;
                        fpct_lh[rec_date_index] = fpct_ccl;
                        fpct_cervix[rec_date_index] = fpct_ccl;
                        
                        cclst_cov[rec_date_index] = results.rows.item(i)['cclst_cov'];
                        bill_itp_mucus_peak[rec_date_index] = results.rows.item(i)['bill_itp'];
                    }
                    else
                    {
                        fpct_all[rec_date_index] = results.rows.item(i)['fpct_all'];
                        fpct_cm[rec_date_index] = results.rows.item(i)['fpct_cm'];
                        fpct_saliva[rec_date_index] = results.rows.item(i)['fpct_saliva'];
                        fpct_mon[rec_date_index] = results.rows.item(i)['fpct_mon'];
                        fpct_bbt[rec_date_index] = results.rows.item(i)['fpct_bbt'];
                        fpct_rhy[rec_date_index] = results.rows.item(i)['fpct_rhy'];
                        fpct_lh[rec_date_index] = results.rows.item(i)['fpct_lh'];
                        fpct_cervix[rec_date_index] = results.rows.item(i)['fpct_cervix'];
                    }
                    // Note cycle or preg day
                    var POSTPARTUM_OFFSET=320;
                    if (results.rows.item(i)['preg_cnt'] >= POSTPARTUM_OFFSET)
                    {
                        cyc_day[rec_date_index] = results.rows.item(i)['preg_cnt']-POSTPARTUM_OFFSET+1;
                        if (i < (global_selected_cycle_offset+5))
                        {
                            chartSettings.pregnancy = POSTPARTUM_TYPE;
                        }
                    }
                    else if (results.rows.item(i)['preg_cnt'] > 0)
                    {
                        cyc_day[rec_date_index] = results.rows.item(i)['preg_cnt']+1;
                        if (i < (global_selected_cycle_offset+5))
                        {
                            chartSettings.pregnancy = PREG_TYPE;
                        }
                    }
                    else if (results.rows.item(i)['cd'] > 0)
                    {
                        cyc_day[rec_date_index] = results.rows.item(i)['cd'];
                        if ((results.rows.item(i)['dpo'] > 0) && (BUILD_TARGET != BUILD_4_CCL))
                        {
                            dpo_day[rec_date_index] = results.rows.item(i)['dpo'];
                        }
                    }   
                    all_ov[rec_date_index] = results.rows.item(i)['all_ov'];
                    fwin[rec_date_index] = results.rows.item(i)['fwin'];
                    cm_ov[rec_date_index] = results.rows.item(i)['cm_ov'];
                    mon_ov[rec_date_index] = results.rows.item(i)['mon_ov'];
                    bbt_cov[rec_date_index] = results.rows.item(i)['bbt_ov_cl'];
                }
                // CCL Support for PreShift 6 Numbering
                if (BUILD_TARGET == BUILD_4_CCL)
                {
                    // Also consider 6 points past the end of the chart so we can find PreShift 6 that need numbered
                    if ((rec_date_index >= 0) && (rec_date_index < (larger_col_count + 6)))
                    {
                        var ccl_st_cov;
                        var ccl_temponly_cov;
                        var back_counter;
                        
                        ccl_st_cov = results.rows.item(i)['cclst_cov'];        // ST Rule Shift
                        if (ccl_st_cov > 0) 
                        {
                            // Go back and number preshift 6.  Results in 2-6 and day 1 having a temperature shift value (>> 6)
                            for (back_counter=2; back_counter<=6; back_counter++)
                            {
                                if (rec_date_index-back_counter >= 0)
                                {
                                    cclst_cov[rec_date_index-back_counter+1] = back_counter;
                                }
                            }
                            cclst_cov[rec_date_index] = ccl_st_cov;
                        }
                        ccl_temponly_cov = results.rows.item(i)['bbt_ov_cl'];     // Temp-Only Rule Shift
                        if (ccl_temponly_cov > 0) 
                        {
                            // Go back and number preshift 6.  Results in 2-6 and day 1 having a temperature shift value (>> 6)
                            for (back_counter=2; back_counter<=6; back_counter++)
                            {
                                if (rec_date_index-back_counter >= 0)
                                {
                                    bbt_cov[rec_date_index-back_counter+1] = back_counter;
                                }
                            }
                            bbt_cov[rec_date_index] = ccl_temponly_cov;
                        }
                    }
                }
            }
            // Label the dates
            for (var i=0; i<larger_col_count; i++)
            {
                if (i < ChartColumnsWithData)
                {
                    var date_obj = NumberToDate(cycle_start + i);
                    if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL)
                    {
                        caldates_chart[i] = PrintDateForChart(date_obj, true);
                    }
                    if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_GRAPH_URL)
                    {
                        caldates_graph[i] = PrintDateForChart(date_obj, false);
                    }
                }
                else
                {
                    // Blank out if there is no data for this date
                    caldates_chart[i] = '';
                    caldates_graph[i] = '';
                }
            }
            year = NumberToDate(cycle_start).getFullYear();

            // Load chart with interp info
            if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL)
            {
                PopulateChart_Interp(fpct_all, fpct_cm, fpct_saliva, fpct_mon, fpct_bbt, fpct_rhy, fpct_lh, fpct_cervix, cyc_day, dpo_day, caldates_chart, year, all_ov, fwin, cm_ov, mon_ov, bill_itp_mucus_peak, cycle_start, chartSettings);
            }
            
            // Load graph
            if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_GRAPH_URL)
            {
                switch (document.getElementById('FertGraphPctTypeSelect').value)
                {
                    case "all":
                        printGraph( fpct_all, cyc_day, caldates_graph, chartSettings );
                        break;
                    case "cm":
                        printGraph( fpct_cm, cyc_day, caldates_graph, chartSettings );
                        break;
                    case "saliva":
                        printGraph( fpct_saliva, cyc_day, caldates_graph, chartSettings );
                        break;
                    case "mon":
                        printGraph( fpct_mon, cyc_day, caldates_graph, chartSettings );
                        break;
                    case "bbt":
                        printGraph( fpct_bbt, cyc_day, caldates_graph, chartSettings );
                        break;
                    case "rhy":
                        printGraph( fpct_rhy, cyc_day, caldates_graph, chartSettings );
                        break;
                    case "lh":
                        printGraph( fpct_lh, cyc_day, caldates_graph, chartSettings );
                        break;
                    case "cervix":
                        printGraph( fpct_cervix, cyc_day, caldates_graph, chartSettings );
                        break;
                    default:
                        printGraph( fpct_all, cyc_day, caldates_graph, chartSettings );
                        break;
                }
            }
            
            // Add the bbt_cov to the chart settings field so it can also get passed to subsequent calls
            chartSettings.bbt_cov = bbt_cov;
            chartSettings.cclst_cov = cclst_cov;
            chartSettings.bill_itp_mucus_peak = bill_itp_mucus_peak;
            
            // Re-Populate available lengths the user can select
            var cyc_len = cycle_end - cycle_start + 1 + global_selected_cycle_offset;
            var optionsList;
            var cycleSelect
            var drop_down = '';
            if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL)
            {
                drop_down = '#chartStartDateSelect';
            }
            if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_GRAPH_URL)
            {
                drop_down = '#graphStartDateSelect';
            }
            if (drop_down != '')
            {
                cycleSelect = $(drop_down); 
                if(cycleSelect.prop) 
                {
                    optionsList = cycleSelect.prop('options');
                }
                else 
                {
                    optionsList = cycleSelect.attr('options');
                }
                $('option', cycleSelect).remove();
                
                if (chartSettings.pregnancy > 0) 
                {
                    var preg_len = parseInt(cyc_len / 7) + 1;
                    var start_week;
                    if (chartSettings.pregnancy == PREG_TYPE)
                    {
                        optionsList[optionsList.length] = new Option('Pregnancy Start', 0);
                        start_week = 3;
                    }
                    else
                    {
                        optionsList[optionsList.length] = new Option('Postpartum Start', 0);
                        start_week = 1;
                    }
                    for (var i=start_week; i<=preg_len; i++)
                    {
                        optionsList[optionsList.length] = new Option('Week ' + i, (i-start_week)*7+1);
                    }
                }
                else
                {
                    for (var i=1; i<=cyc_len; i++)
                    {
                        optionsList[optionsList.length] = new Option('Cycle Day ' + i, i-1);
                    }
                }
                // Search for match and refresh
                found_index = convertOptionsListVal2Index(optionsList, global_selected_cycle_offset);
                if (found_index >= 0)
                {
                    cycleSelect[0].selectedIndex = found_index;
                }
                cycleSelect.selectmenu("refresh");
            }
            
            // Update special considerations if the user is not an Active Subscriber
            if ((global_active_subscription == 0) && (BUILD_TARGET != BUILD_4_CCL))
            {
                if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL)
                {
                    if (global_is_ios)
                    {
                        document.getElementById('shaded_chart_legend_nosub_ios').style.display = 'block';
                        document.getElementById('shaded_chart_legend_nosub').style.display = 'none';
                    }
                    else
                    {
                        document.getElementById('shaded_chart_legend_nosub_ios').style.display = 'none';
                        document.getElementById('shaded_chart_legend_nosub').style.display = 'block';
                    }
                    document.getElementById('shaded_chart_legend').style.display = 'none';
                }
                if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_GRAPH_URL)
                {
                    if (global_is_ios)
                    {
                        document.getElementById('shaded_graph_legend_nosub_ios').style.display = 'block';
                        document.getElementById('shaded_graph_legend_nosub').style.display = 'none';
                    }
                    else
                    {
                        document.getElementById('shaded_graph_legend_nosub_ios').style.display = 'block';
                        document.getElementById('shaded_graph_legend_nosub').style.display = 'none';
                    }
                    document.getElementById('shaded_graph_legend').style.display = 'none';
                }
            }
            else if (global_EnableRemoteAnalysis == 1)
            {
                // Must be an active subscriber.  We can clear this since this box is used to indicate subscription status issues or remote connectivity issues
                if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL)
                {
                    document.getElementById('shaded_chart_legend_nosub').style.display = 'none';
                    document.getElementById('shaded_chart_legend_nosub_ios').style.display = 'none';
                    document.getElementById('shaded_chart_legend').style.display = 'block';
                }
                if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_GRAPH_URL)
                {
                    document.getElementById('shaded_graph_legend_nosub').style.display = 'none';
                    document.getElementById('shaded_graph_legend_nosub_ios').style.display = 'none';
                    document.getElementById('shaded_graph_legend').style.display = 'block';
                }
            }
        }

        if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL)
        {
            // Query list of enabled events 
            strSql = 'SELECT * FROM Event_Settings_DB WHERE 1;';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                RenderAnalysisScreensFromLocalDatabase(state+1, callback, tx, results, '', final_call, cycle_start, cycle_end, chartSettings, '');
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local DataRecs database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
        }
        else
        {
            // Events are needed for chart only, so we can skip this step
            state = 4;
            fallthrough_no_op = true;
            // Intentional fall through to next state
        }
    
    case 4:
LogCall('h4'); 
        // Only run this if this is not a fallthrough case trying to skip this state
        if ((fallthrough_no_op == false) && (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL))
        {
            var rec_date_index;
            var len = results.rows.length;
            var encoded = new Array();
            var decoded = new Array();
            var chartSettings = param_4;
            var i;
            
            if (len > 0)
            {
                // Determine which events should be visible
                for (i=1; i<=NUMBER_OF_EVENT_WORDS; i++)
                {
                    // Get values from database
                    encoded[i-1] = results.rows.item(0)['ev_show_word' + i];
                }
                // Convert from encoded to decoded values
                decoded = DecompressEventBits(encoded);
                // Hide spotting as possibility for CCL
                if (BUILD_TARGET == BUILD_4_CCL)
                {
                    encoded[SPOTTING_EVENT_INDEX] = 0;
                }
                // Populate event names for placement below on demand
                eventInfo = BuildEventArray(results, false);
            }
        }
    
        // Query fertility records 
        if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL)
        {
            strSql = 'SELECT * FROM Data_Recs_DB WHERE record_date >= ' + cycle_start 
            strSql += ' AND record_date <= ' + cycle_end + ';';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                RenderAnalysisScreensFromLocalDatabase(state+1, callback, tx, results, decoded, final_call, cycle_start, cycle_end, chartSettings, eventInfo);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local DataRecs database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
        }
        else
        {
            // Fertility data is needed for chart only, so we can skip this step
            state = 5;
            fallthrough_no_op = true;
            // Intentional fall through to next state
        }

    case 5:
LogCall('h5');
        var new_cycle_starting = 0;
        
        // Only run this if this is not a fallthrough case trying to skip this state
        if ((fallthrough_no_op == false) && (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL))
        {
            var temp = new Array();
            var mucus = new Array();
            var mens = new Array();
            var ovtest_am = new Array();
            var ovtest_pm = new Array();
            var monitor = new Array();
            var cervix = new Array();
            var saliva = new Array();
            var intdays = new Array();
            var bcontrol = new Array();
            var discard = new Array();
            var unsure = new Array();
            var chartSettings = param_4;
            var tempRange = new Object();
            var mflow = new Array();
            var fweight = new Array();
            var cerv_cons = new Array();
            var cerv_dia = new Array();
            var muc_sens = new Array();
            var muc_acons = new Array();
            var evRec = new Array(NUMBER_OF_EVENTS); // SIZE: days_in_cyc x NUMBER_OF_EVENTS
            var evUsed = new Array();  // Size NUMBER_OF_EVENTS
            
            tempRange.MaxTemp = 0;
            tempRange.MinTemp = 999;

            var visible_events = param_3;
            var eventInfo = param_5;
            
            var encoded = new Array();
            var decoded = new Array();

            // Initialize
            var larger_col_count = chartSettings.graph_num_of_cols;
            if (larger_col_count < chartSettings.chart_num_of_cols)
            {
                larger_col_count = chartSettings.chart_num_of_cols;
            }
            for (var i=0; i<larger_col_count; i++)
            {
                temp[i] = 0;
                mens[i] = 0;
                discard[i] = 0;
                unsure[i] = 0;
                if (i < ChartColumnsWithData)
                {
                    mucus[i] = 'na';
                    ovtest_am[i] = 'na';
                    ovtest_pm[i] = 'na';
                    monitor[i] = 'na';
                    cervix[i] = 'na';
                    saliva[i] = 'na';
                }
                else
                {
                    mucus[i] = '';
                    ovtest_am[i] = '';
                    ovtest_pm[i] = '';
                    monitor[i] = '';
                    cervix[i] = '';
                    saliva[i] = '';
                }
            }
        
            // Retrieve results of query
            var len = results.rows.length;
            if (len == 0)
            {
                // Only display this if we aren't going to call this again after attempting to download data from server
                if (final_call)
                {
                    // See if any data at all (beyond just myopically looking at this cycle) has been recorded before we display messages
                    strSql = 'SELECT * FROM Data_Recs_DB WHERE 1;';
                    suspend_scrolling(true, '');
                    tx.executeSql(  strSql, 
                                    [], 
                                    function(tx, results) 
                                    {
                                        suspend_scrolling(false, 0);
                                        if (results.rows.length == 0)
                                        {
                                        
                                        
                                            if (BUILD_TARGET == BUILD_4_CCL)
                                            {
                                                ShowPopupMessage("You have not recorded any data yet.  To get started, go back to the Calendar, click on the first date of your cycle, expand the 'Other Info/Notes' section and check the 'This day should start a new cycle' box.  You can also record temperature and other symptoms and events there.", 'Welcome', '');
                                            }
                                            else
                                            {
                                                ShowPopupMessage("You have not recorded any data yet.  To get started, go back to the Calendar, click on the days of your period, and record menstruation (under the 'Basic Symptoms' section).  You can also record temperature and other symptoms and events after clicking on calendar dates too.", 'Welcome', '');
                                            }
                                        }
                                    },
                                    []
                                 );
                }
            }
            else
            {
                // Get data
                var rec_date_index;
                var this_temp_val;
                var this_discard_val;
                var days_in_cyc = cycle_end-cycle_start+1;
                var mens_break_count = 0;
 
                // Initialization
                for (var i=0; i<NUMBER_OF_EVENTS; i++)
                {
                    evRec[i] = new Array(days_in_cyc+1);
                }

                for (var i=0; i<len; i++)
                {
                    // Find min and max temps over the entire cycle
                    this_temp_val = parseFloat(results.rows.item(i)['temp']);
                    this_discard_val = assign_if_not_na(results.rows.item(i)['discard']);
                    if ((this_temp_val > tempRange.MaxTemp) && (this_discard_val == 0)) 
                    {
                        tempRange.MaxTemp = this_temp_val;
                    }
                    if (((this_temp_val > 0) && (this_temp_val < tempRange.MinTemp)) && (this_discard_val == 0))
                    {
                        tempRange.MinTemp = this_temp_val;
                    }

                    // Only package up data values that will actually need plotted
                    rec_date_index = results.rows.item(i).record_date - cycle_start;
                    if ((rec_date_index >= 0) && (rec_date_index < larger_col_count))
                    {
                        // Fertility Data Records
                        temp[rec_date_index] = this_temp_val;
                        mens[rec_date_index] = assign_if_not_na(results.rows.item(i)['mens']);
                        if (mens[rec_date_index] != 0)
                        {
                            if ((mens_break_count > 6) && (new_cycle_starting == 0))
                            {
                                // There appears to be the start of a new cycle
                                new_cycle_starting = results.rows.item(i).record_date;
                            }
                            mens_break_count = 0;
                        }
                        else
                        {
                            mens_break_count += 1;
                        }
                        if (mucus[rec_date_index] == 'F')   
                        {
                            mucus[rec_date_index] = 'S';        // Swap the letter "F" for "S" since that's the new app default to display
                        }
                        ovtest_am[rec_date_index] = assign_if_not_na(results.rows.item(i)['ovtest_am']);
                        ovtest_pm[rec_date_index] = assign_if_not_na(results.rows.item(i)['ovtest_pm']);
                        monitor[rec_date_index] = assign_if_not_na(results.rows.item(i)['monitor']) ;
                        discard[rec_date_index] = this_discard_val;
                        unsure[rec_date_index] = assign_if_not_na(results.rows.item(i)['unsure']);
                        mucus[rec_date_index] = assign_if_not_na(results.rows.item(i)['mucus']);
                        if (BUILD_TARGET == BUILD_4_CCL)
                        {
                            mflow[rec_date_index] = results.rows.item(i)['mflow'];
                            fweight[rec_date_index] = results.rows.item(i)['fweight'];
                            cerv_cons[rec_date_index] = results.rows.item(i)['cerv_cons'];
                            cerv_dia[rec_date_index] = results.rows.item(i)['cerv_dia'];
                            muc_sens[rec_date_index] = results.rows.item(i)['muc_sens'];
                            muc_acons[rec_date_index] = results.rows.item(i)['muc_acons'];
                        }
                        else
                        {
                            saliva[rec_date_index] = assign_if_not_na(results.rows.item(i)['saliva']);
                            cervix[rec_date_index] = assign_if_not_na(results.rows.item(i)['cervix']);
                        }
                        // Events - Get event words and convert them to an array
                        for (var j=1; j<=NUMBER_OF_EVENT_WORDS; j++)
                        {
                            // Get values from database
                            encoded[j-1] = results.rows.item(i)['ev' + j + 'nt'];
                        }
                        // Convert from encoded to decoded values
                        decoded = DecompressEventBits(encoded);

                        // Note incidents of recorded events
                        for (var j=0; j<visible_events.length; j++)
                        {
                            // Only ones actually recorded and enabled
                            if ((decoded[j] != 0) && (visible_events[j] != 0))
                            {
                                evRec[rec_date_index+1][j] = 1;    // SIZE: days_in_cyc x NUMBER_OF_EVENTS
                                evUsed[j] = 1;                  // Size NUMBER_OF_EVENTS
                            }
                        }
                        // Save off events that need specially depicted on the graph too (e.g. intercourse days)
                        intdays[rec_date_index] = decoded[INTERCOURSE_EVENT_INDEX];
                        bcontrol[rec_date_index] = decoded[PROTECTED_INTERCOURSE_EVENT_INDEX];
                    }
                }
            }
            // Convert min/max temps to be on a 0.1 degree scale if temperature values even exist 
            if (tempRange.MinTemp <= tempRange.MaxTemp)
            {
                tempRange.MinTemp = Math.floor(tempRange.MinTemp * 10) / 10;
                tempRange.MaxTemp = Math.ceil(tempRange.MaxTemp * 10) / 10;
            }

            // Figure out how many events were used and map them to locations
            var numEvUsed = 0;
            var assigned_event = new Array();       // Indexed by row 1-25 (0 is reserved for spotting)
            assigned_event[0] = -1;                 // Assume "Spotting" is not used
            for (var i=0; i<evUsed.length; i++)
            {
                if (evUsed[i] == 1)
                {
                    switch (i)
                    {
                    case INTERCOURSE_EVENT_INDEX:
                        break;  // do not count special case events
                    case PROTECTED_INTERCOURSE_EVENT_INDEX:
                        break;  // do not count special case events
                    case SPOTTING_EVENT_INDEX:
                        assigned_event[0] = i;
                        break;
                    default:
                        numEvUsed = numEvUsed + 1;
                        assigned_event[numEvUsed] = i;
                        break;
                    }
                }
            }
            // Loop through and place data on chart (all that will fit)
            var NUM_EV_ROWS_ON_CHART = 25;
            if (numEvUsed > NUM_EV_ROWS_ON_CHART)
            {
                numEvUsed = NUM_EV_ROWS_ON_CHART;   // Can't have more than will fit
            }
            for (var i=0; i<=NUM_EV_ROWS_ON_CHART; i++)
            {
                // Stop when out of room
                if (i > numEvUsed)
                {
                    // Hide remaining rows and quit
                    for (var j=i; j<=NUM_EV_ROWS_ON_CHART; j++)
                    {
                        document.getElementById('ChtEvN' + j).style.display = 'none';
                        document.getElementById('ChtEv' + j).style.display = 'none';
                    }
                    break;
                }
                // Place name and turn on visibility
                if (assigned_event[i] >= 0)
                {
                    document.getElementById('ChtEvN' + i).innerHTML = eventInfo[assigned_event[i]].name; 
                    document.getElementById('ChtEvN' + i).style.display = 'block';
                    document.getElementById('ChtEv' + i).style.display = 'block';
                    // Populate data
                    for (var j=1; j<=chartSettings.chart_num_of_cols; j++)
                    {
                        document.getElementById('ChtEv' + i + '_C' + j).style.display = 'block';
                        if (evRec[j][assigned_event[i]] == 1)
                        {
                            document.getElementById('ChtEv' + i + '_C' + j).innerHTML = 'X';
                        }
                        else
                        {
                            document.getElementById('ChtEv' + i + '_C' + j).innerHTML = '';
                        }
                    }
                    for (var j=chartSettings.chart_num_of_cols+1; j<=MAX_NUMBER_OF_CHART_COLUMNS; j++)
                    {
                        document.getElementById('ChtEv' + i + '_C' + j).style.display = 'none';
                    }
                }
                else
                {
                    document.getElementById('ChtEvN' + i).style.display = 'none';
                    document.getElementById('ChtEv' + i).style.display = 'none';
                }
            }

            // Re-render chart
            if (BUILD_TARGET == BUILD_4_CCL)
            {
                numEvUsed += 1;      // For CCL, coitus is always visible
            }
            if (assigned_event[0] < 0)
            {
                numEvUsed -= 1;     // Spotting counted separately
            }
            global_num_ev_rows = numEvUsed;
            fixChartDivHeight(ChartColumnsWithData);
            
            // Build chart with data
            PopulateChart_Data( temp, mucus, mens, monitor, ovtest_am, ovtest_pm, cervix, saliva, intdays, bcontrol, discard, unsure, tempRange, mflow, fweight, cerv_cons, cerv_dia, muc_sens, muc_acons, chartSettings.bbt_cov, chartSettings );
        }
    
        if (new_cycle_starting)
        {
            // Suggest to use cycle picker since new cycle is starting
            if (final_call)
            {
                ShowPopupMessage('It appears a new cycle started on ' + PrintDate(NumberToDate(new_cycle_starting)) + '.  It is recommended you view this cycle on its own chart by selecting "Charts" > "Pick Another Cycle" and picking the start date for this later cycle.', 'Changing Cycles', '');
            }
        }
        else if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CSTATS_URL)
        {
            // Query user info database to get stats 
            strSql = 'SELECT * FROM User_Info_DB WHERE 1;';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                RenderAnalysisScreensFromLocalDatabase(state+1, callback, tx, results, decoded, final_call, cycle_start, cycle_end, '', '');
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local DataRecs database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
        }
        else
        {
            // Fertility data is needed for chart only, so we can skip this step
            state = 6;
            fallthrough_no_op = true;
            // Intentional fall through to next state
        }

    case 6:
LogCall('h6');  
        if ((fallthrough_no_op == false) && (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CSTATS_URL))
        {
            // Retrieve results of query
            var len = results.rows.length;
            var i=0;
            
            // Extract fields of interest
            if (len > 0)
            {
                if (global_active_subscription == 0)
                {
                    document.getElementById('CyStat_CycAvgLen_Div').innerHTML = getShortDisabledMessageForNoSub();
                    document.getElementById('CyStat_CycStdDev_Div').innerHTML = getShortDisabledMessageForNoSub();
                    document.getElementById('CyStat_LutAvgLen_Div').innerHTML = getShortDisabledMessageForNoSub();
                    document.getElementById('CyStat_LutStdDev_Div').innerHTML = getShortDisabledMessageForNoSub();
                    document.getElementById('CyStat_CycShort_Div').innerHTML = getShortDisabledMessageForNoSub();
                    document.getElementById('CyStat_CycLong_Div').innerHTML = getShortDisabledMessageForNoSub();
                    document.getElementById('CyStat_LutShort_Div').innerHTML = getShortDisabledMessageForNoSub();
                    document.getElementById('CyStat_LutLong_Div').innerHTML = getShortDisabledMessageForNoSub();
                    
                    document.getElementById('CyStat_EarlyOv_Div').innerHTML = getShortDisabledMessageForNoSub();
                    document.getElementById('CyStat_LateOv_Div').innerHTML = getShortDisabledMessageForNoSub();
                    document.getElementById('CyStat_EarlyPeakF_Div').innerHTML = getShortDisabledMessageForNoSub();
                    document.getElementById('CyStat_EarlyPeakMon_Div').innerHTML = getShortDisabledMessageForNoSub();
                    document.getElementById('CyStat_LatePeakMon_Div').innerHTML = getShortDisabledMessageForNoSub();
                    document.getElementById('CyStat_EarlyAnyOv_Div').innerHTML = getShortDisabledMessageForNoSub();
                    document.getElementById('CyStat_EarlyTempShift_Div').innerHTML = getShortDisabledMessageForNoSub();
                }
                else  // Active subscription
                {
                    document.getElementById('CyStat_CycAvgLen_Div').innerHTML = PrintValueOrUnknown(results.rows.item(i)['cyc_avg']) + ' days';
                    document.getElementById('CyStat_CycStdDev_Div').innerHTML = PrintValueOrUnknown(results.rows.item(i)['cyc_sd']);
                    document.getElementById('CyStat_LutAvgLen_Div').innerHTML = PrintValueOrUnknown(results.rows.item(i)['lut_avg']) + ' days';
                    document.getElementById('CyStat_LutStdDev_Div').innerHTML = PrintValueOrUnknown(results.rows.item(i)['lut_sd']);
                    document.getElementById('CyStat_CycShort_Div').innerHTML = PrintValueOrUnknown(results.rows.item(i)['cyc_short']) + ' days';
                    document.getElementById('CyStat_CycLong_Div').innerHTML = PrintValueOrUnknown(results.rows.item(i)['cyc_long']) + ' days';
                    document.getElementById('CyStat_LutShort_Div').innerHTML = PrintValueOrUnknown(results.rows.item(i)['lut_short']) + ' days';
                    document.getElementById('CyStat_LutLong_Div').innerHTML = PrintValueOrUnknown(results.rows.item(i)['lut_long']) + ' days';
                    
                    document.getElementById('CyStat_EarlyOv_Div').innerHTML = 'Day ' + PrintValueOrUnknown(results.rows.item(i)['early_ov']);
                    document.getElementById('CyStat_LateOv_Div').innerHTML = 'Day ' + PrintValueOrUnknown(results.rows.item(i)['late_ov']);
                    document.getElementById('CyStat_EarlyPeakF_Div').innerHTML = 'Day ' + PrintValueOrUnknown(results.rows.item(i)['early_cm_f']);
                    document.getElementById('CyStat_EarlyPeakMon_Div').innerHTML = 'Day ' + PrintValueOrUnknown(results.rows.item(i)['early_mon_p']);
                    document.getElementById('CyStat_LatePeakMon_Div').innerHTML = 'Day ' + PrintValueOrUnknown(results.rows.item(i)['late_mon_p']);
                    document.getElementById('CyStat_EarlyAnyOv_Div').innerHTML = 'Day ' + PrintValueOrUnknown(results.rows.item(i)['early_any_ov']);
                    document.getElementById('CyStat_EarlyTempShift_Div').innerHTML = 'Day ' + PrintValueOrUnknown(results.rows.item(i)['early_bbt_ov']);
                }
            }
            else
            {
                printDebug('ERROR - Error accessing local User_Info_DB database!');
            }
        }
        // All done!  Execute callback if one exists
        if (callback != '')
        {
            callback(tx);
        }
        else
        {
            HideAct();
            printStatus('');
        }
        break;
    }
}

function PrintFertWindow(window, isFinal)
{
    var tempStr = '';
    
    if (window == '?')
    {
        tempStr = 'Unknown';
    }
    else
    {
        tempStr = window;
    }
    if (isFinal != 0)
    {
        tempStr += ' (official)';
    }
    else
    {
        tempStr += ' (pending estimate)';
    }
    return tempStr;
}

function ConvertNumToStars(value)
{
    // If the value is special, then assume it is because they do not have an active subscription.
    if (value == -1)
    {
        return getDisabledMessageForNoSub();
    }
    // Handle normally
    var tempStr = '';
    for (var j=0; j<value; j++)
    {
        tempStr += '<img src="images/star.gif">';
    }
    return tempStr;
}

function PrintValueOrUnknown(value)
{
    if ((value >= 0) && (value < 999))
    {
        return value;
    }
    else
    {
        return 'Unknown';
    }
}
function PrintDateOrUnknown(value)
{
    // If the value is blank, then assume it is because they do not have an active subscription.
    if (value == '')
    {
        return getDisabledMessageForNoSub();
    }
    // Otherwise figure out what the date is
    date_value = myDateParser(value);
    if (date_value.getFullYear() == 1990)
    {
        return 'Unknown';
    }
    else
    {
        return PrintDate(date_value);
    }
}
function getShortDisabledMessageForNoSub()
{
    return 'Disabled';
}
function getDisabledMessageForNoSub()
{
    return '<span onclick="NavToSubscriptionInfo();">Disabled <sup>(requires Premium Subscription)</sup></span>';
}
function myDateParser(yyyy_mm_dd_value)
{
LogCall('1i');
    var date_value;
    var pos;
    var d_year;
    var d_month;
    var d_date;

    // If the database is empty because we never downloaded the values yet, this might get 
    // passed null.  We need to return a default "unknown" date.
    if (yyyy_mm_dd_value == null)
    {
        return new Date(1990, 0, 1, 0, 0, 0, 0);
    }
    
    pos = yyyy_mm_dd_value.search("-");
    if ((pos > 0) && (pos < yyyy_mm_dd_value.length))
    {
        d_year = yyyy_mm_dd_value.substring(0, pos);
        yyyy_mm_dd_value = yyyy_mm_dd_value.substring(pos+1, yyyy_mm_dd_value.length);
    }
    pos = yyyy_mm_dd_value.search("-");
    if ((pos > 0) && (pos < yyyy_mm_dd_value.length))
    {
        d_month = yyyy_mm_dd_value.substring(0, pos);
        d_date = yyyy_mm_dd_value.substring(pos+1, yyyy_mm_dd_value.length);
    }
    date_value = new Date(d_year, d_month-1, d_date, 0, 0, 0, 0);
    return date_value; 
}
function PrintDateForChart(date_obj, vert_OR_horz_NOT)
{
    var months_vert = ['J<br>a<BR>n<BR>&nbsp;<BR>', 'F<br>e<BR>b<BR>&nbsp;<BR>', 'M<br>a<BR>r<BR>&nbsp;<BR>', 'A<br>p<BR>r<BR>&nbsp;<BR>', 'M<br>a<BR>y<BR>&nbsp;<BR>', 'J<br>u<BR>n<BR>&nbsp;<BR>', 'J<br>u<BR>l<BR>&nbsp;<BR>', 'A<br>u<BR>g<BR>&nbsp;<BR>', 'S<br>e<BR>p<BR>&nbsp;<BR>', 'O<br>c<BR>t<BR>&nbsp;<BR>', 'N<br>o<BR>v<BR>&nbsp;<BR>', 'D<br>e<BR>c<BR>&nbsp;<BR>'];
    var months_horz = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
    if (vert_OR_horz_NOT)
    {
        return months_vert[date_obj.getMonth()] + ' ' + date_obj.getDate();
    }
    else
    {
        return months_horz[date_obj.getMonth()] + ' ' + date_obj.getDate();
    }
}

function assign_if_not_na(value)
{
    if (value == 'na')
    {
        return '';
    }
    else
    {
        return value;
    }
}
function yesno2plusminus(value)
{
    if (value == 'y')
    {
        return '+';
    }
    else if (value == 'n')
    {
        return '-';
    }
    return value;
}

function ToggleAnovState()
{
LogCall('1j');
    updateLocalDb_Cycles(global_selected_cycle_as_number, 'anovCheckbox', TYPE_CHECKBOX, 'anov', -1, 'cdata_chg', 0);
    if (document.getElementById('anovCheckbox').checked)
    {
        document.getElementById('OvDate_AutoManualConfig_Div').style.display = 'none';
        // Remove server only acknowledges "Anov" when setting is also switched to "Manual"
        document.getElementById('OvOverrideDateTextbox').value = '1990-01-01';
        // Call is delayed to ensure we avoid a race condition to create a database entry if one doesn't already exist
        setTimeout("SwitchToManualOvDate()", 250); 
    }
    else
    {
        document.getElementById('OvDate_AutoManualConfig_Div').style.display = 'block';
        // Call is delayed to ensure we avoid a race condition to create a database entry if one doesn't already exist
        setTimeout("SwitchBackToAutoOvDate()", 250); 
    }
    return false;
}

function SwitchBackToAutoOvDate()
{
    // Update local database
    updateLocalDb_Cycles(global_selected_cycle_as_number, '1', PASSED_VALUE, 'all_ov_type', -1, 'cdata_chg', 2);
    // Swap fields so we don't have to reload everything
    document.getElementById('OvDate_OverallOv_Div').innerHTML = document.getElementById('OvDate_AutoOv_Div').innerHTML;
    document.getElementById('OvOverrideDateTextbox').value = '';
    document.getElementById('OvDate_ManualButton1_Div').style.display = 'block';
    document.getElementById('OvDate_ManualButton2_Div').style.display = 'block';
    document.getElementById('OvDate_ShowAutomatic_Div').style.display = 'none';
    return false;
}

function SwitchToManualOvDate()
{
    var date_str;
    var abort_because_of_error = false;
    
    // Validate input first
    date_str = Date.parse(document.getElementById('OvOverrideDateTextbox').value + ' 1:00:00');
    var override_date = new Date(date_str);
    if (isNaN(override_date))
    {
        ShowPopupMessage('The manually specified ovulation date is invalid.  Please enter a date in yyyy-mm-dd format and try again.', 'Invalid Date', '');
        printDebug('Invalid date: ' + date_str);
        abort_because_of_error = true;
    }
    else 
    {
        // Convert date to number
        var override_date_val = DateToNumber(override_date);
        if (((override_date_val <= global_selected_cycle_as_number) || (override_date_val  >= global_selected_cycle_end_as_number)) && (override_date_val != 0))
        {
            ShowPopupMessage('The manually specified ovulation date is invalid.  It must be a date later than the start of the cycle (later than ' + PrintDate(NumberToDate(global_selected_cycle_as_number)) + ') and earlier than the end of the cycle (earlier than ' + PrintDate(NumberToDate(global_selected_cycle_end_as_number)) + ').  Please correct specify a date that falls within this cycle and try again.', 'Invalid Date', '');
            printDebug('Invalid date ' + override_date_val + ' is not between ' + global_selected_cycle_as_number + ' and ' + global_selected_cycle_end_as_number);
            abort_because_of_error = true;
        }
    }

    if (abort_because_of_error == false)
    {
        // Update local database (second call is delayed to avoid race condition if both calls try to create a database record)
        updateLocalDb_Cycles(global_selected_cycle_as_number, '2', PASSED_VALUE, 'all_ov_type', -1, 'cdata_chg', 2);
        setTimeout("updateLocalDb_Cycles(" + global_selected_cycle_as_number + ", 'OvOverrideDateTextbox', " + TYPE_TEXTBOX + ", 'all_ov_manual', -1, 'cdata_chg', 1);", 250);
        // Swap fields so we don't have to reload anything
        document.getElementById('OvDate_OverallOv_Div').innerHTML = document.getElementById('OvOverrideDateTextbox').value; 
        document.getElementById('OvDate_ManualButton1_Div').style.display = 'none';
        document.getElementById('OvDate_ManualButton2_Div').style.display = 'none';
        document.getElementById('OvDate_ShowAutomatic_Div').style.display = 'block'; 
    }
    return false;
}

function replotGraphChart(state, param_1, direction_to_advance, absolute_start_slider)
{
    var tx = param_1;
    
    printDebug("State " + state + " of replotGraphChart");
    switch(state)
    {
    case 1:
LogCall('i1');  
        // First must open local database
        db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
        global_db_ios_fail_replotGraphCht = DB_IOS_RETRY_LIMIT;
        db.transaction(     function(tx) 
                            {
                                global_db_ios_fail_replotGraphCht = -1;
                                replotGraphChart(state+1, tx, direction_to_advance, absolute_start_slider);
                            },
                            errorCB,
                            function(tx)
                            {
                                // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                if (global_db_ios_fail_replotGraphCht > 0)
                                {
                                    global_db_ios_fail_replotGraphCht = global_db_ios_fail_replotGraphCht - 1;
                                    printDebug('iOS db.transaction replotGraphCht state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_replotGraphCht));
                                    replotGraphChart(state, param_1, direction_to_advance, absolute_start_slider);
                                }
                                else if (global_db_ios_fail_replotGraphCht == 0)
                                {
                                    printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                }
                                else
                                {
                                    successCB();
                                }
                            }
                       );
        break;

    case 2:
LogCall('i2'); 
        var NUMBER_OF_DAYS_TO_ADVANCE;
        var SIZE_OF_CHART_GRAPH = 20;
        var start_date;
        var end_date;
        var length_of_cycle = global_selected_cycle_end_as_number - global_selected_cycle_as_number + 1;
        
        // Handle a relative or absolute shift
        if (absolute_start_slider == '')
        {
            // Relative shift of the chart/graph
            NUMBER_OF_DAYS_TO_ADVANCE = 21 * direction_to_advance; 
        }
        else
        {
            // Absolute shift of the chart/graph
            NUMBER_OF_DAYS_TO_ADVANCE = 0;
            global_selected_cycle_offset = parseInt(document.getElementById(absolute_start_slider).value);
        }
        
        // Determine new dates.  Don't allow user to walk beyond the currently selected cycle though since we may not
        // have downloaded data from the remote server for other cycles.
        if ((global_selected_cycle_offset + NUMBER_OF_DAYS_TO_ADVANCE) >= length_of_cycle)
        {
            ShowPopupMessage("You cannot advance past the end of the selected cycle.  To select another cycle, push the <i>Chart & Analysis</i> button again and make another cycle selection.", 'Past End of Cycle', '');
        }
        else
        {
            global_selected_cycle_offset += NUMBER_OF_DAYS_TO_ADVANCE;
        }
        start_date = global_selected_cycle_as_number + global_selected_cycle_offset;
        end_date = global_selected_cycle_end_as_number + global_selected_cycle_offset;
        if (end_date > global_selected_cycle_end_as_number)
        {
            end_date = global_selected_cycle_end_as_number;
        }
        if (start_date < global_selected_cycle_as_number)
        {
            start_date = global_selected_cycle_as_number;
            end_date = start_date + SIZE_OF_CHART_GRAPH;
            ShowPopupMessage("You cannot go back before the start of the selected cycle. <br>To select another cycle, push the <i>Chart & Analysis</i> button again and make another cycle selection.", 'Past Start of Cycle', '');
            global_selected_cycle_offset = start_date - global_selected_cycle_as_number;
            HideAct();
            break;
        }
        global_selected_cycle_offset = start_date - global_selected_cycle_as_number;

        // Update sliders with this chosen values
        var cycleSelect;
        var ANALYSIS_PAGES_GRAPH_URL = "analysis_graph";
        var ANALYSIS_PAGES_CHART_URL = "analysis_chart";
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            ANALYSIS_PAGES_CHART_URL = "analysis_ccl_chart";
        }
        if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_GRAPH_URL)
        {
            cycleSelect = $("select#graphStartDateSelect");
        }
        if (global_Analysis_Pages[global_last_analysis_screen] == ANALYSIS_PAGES_CHART_URL)
        {
            cycleSelect = $("select#chartStartDateSelect");
        }

        // Search for match and refresh
        var j;
        var found_index = -1;
        if(cycleSelect.prop) 
        {
            optionsList = cycleSelect.prop('options');
        }
        else 
        {
            optionsList = cycleSelect.attr('options');
        }
        found_index = convertOptionsListVal2Index(optionsList, global_selected_cycle_offset);
        if (found_index >= 0)
        {
            cycleSelect[0].selectedIndex = found_index;
        }
        cycleSelect.selectmenu("refresh");

        // Make call to reload data from local database.  Passes a null callback as an indicator that the 
        // state machine can abort early.
        RenderAnalysisScreensFromLocalDatabase(1, '', tx, '', '', true, start_date, end_date, '', '');
        break;
    default:
        printDebug('default case should not happen');
        break;
    }
}
function RefreshCycleDayStartDropDownIfVisible()
{
    var CHART_ANALYSIS_PAGE = 0;
    var GRAPH_ANALYSIS_PAGE = 1;
    if (GetCurrentPage() == global_Analysis_Pages[GRAPH_ANALYSIS_PAGE])
    {
        $('#graphStartDateSelect').selectmenu("refresh");
    }
    if (GetCurrentPage() == global_Analysis_Pages[CHART_ANALYSIS_PAGE])
    {
        $('#chartStartDateSelect').selectmenu("refresh");
    }
}
function DetermineChartSettings(ChartColumnsWithData)
{
    var chartSettings = new Object();
    var deviceWidth = $('body').width();
    var deviceHeight = $('body').height();
    var columns;
    
    var CHART_CELL_WIDTH_SMALL = 17;
    var CHART_DAY_1_X_OFFSET = 72;
    var CHART_MARGINS = 20;
    var CHART_CELL_HEIGHT = 17;
    var CHART_EV_CELL_HEIGHT = 14;
    
    var GRAPH_CELL_WIDTH_SMALL = 19;
    var GRAPH_MARGINS = 30;
    
    // Determine size for the Chart
    if (false)
    {
        // Calculate what fits within fixed width
        columns = Math.floor((deviceWidth - CHART_DAY_1_X_OFFSET - CHART_MARGINS) / CHART_CELL_WIDTH_SMALL);  
        if (columns > 40)
        {
            columns = 40;
        }
    }
    else
    {
        // Plot as much as will fit
        columns = ChartColumnsWithData;
    }
    chartSettings.chart_col_width = CHART_CELL_WIDTH_SMALL;
    chartSettings.chart_num_of_cols = columns;
    chartSettings.pregnancy = 0;
    
    // Determine size for the Graph
    if (false)
    {
        // Calculate what fits within fixed width
        columns = Math.floor((deviceWidth - GRAPH_MARGINS) / GRAPH_CELL_WIDTH_SMALL);  
        if (columns > 40)
        {
            columns = 40;
        }
    }
    else
    {
        // Plot as much as will fit
        columns = ChartColumnsWithData;
    }
    chartSettings.graph_num_of_cols = columns;
    chartSettings.graph_col_width = GRAPH_CELL_WIDTH_SMALL;

    // Chart Parameters
    chartSettings.chart_day1_x_offset = CHART_DAY_1_X_OFFSET;
    chartSettings.chart_row_height = CHART_CELL_HEIGHT;
    chartSettings.chart_ev_row_height = CHART_EV_CELL_HEIGHT;
    chartSettings.chart_bottom_y_axis = CHART_BOTTOM_Y_AXIS;

    return chartSettings;
}

function fixChartDivHeight(ChartColumnsWithData)
{
    var offset_value = 0;
    
    // Position buttons below the chart.  Uses a global because this is only successful when the chart page is selected and
    // its div's can be manipulated.  When it is not, this needs executed again so we need to save the num_ev_rows as a global
    // parameter that we can reference again.
    var HEIGHT_OF_ChartingYear_CLASS = 68;
    var chartSettings = DetermineChartSettings(ChartColumnsWithData);

    // Allowance for temperature rows and the upper symptom rows
    offset_value += (NUMBER_OF_TEMP_ROWS + NUMBER_OF_LOWER_SYMPTOMS) * (chartSettings.chart_row_height);
    // Allowance for the date row
    offset_value += HEIGHT_OF_ChartingYear_CLASS;
    if (BUILD_TARGET == BUILD_4_CCL)
    {
        // Allowance for larger Cervix and Sensation rows
        offset_value += 35;
    }
    
    // Only apply if the number of event rows is known
    if (global_num_ev_rows >= 0)
    {
        // Allowance for the events
        offset_value += global_num_ev_rows * (chartSettings.chart_ev_row_height + 1);
    }
    
    // Set height to match that of the chart so content below the chart is properly spaced
    document.getElementById('ChartingDiv').style.height = offset_value + 'px';
}
function getFertWinValueFromString(fwin_vals_str, choice_index, beg_OR_end_NOT)
{
    var bytes_per_val = 2;
    var pos = -1;
    var retVal = 0;

    // The bits aren't mapped numerically in order, so we have to translate from the index to the position
    if (beg_OR_end_NOT)
    {
        // Phase I Fert Window Last Day
        switch(choice_index)
        {
        case 3:
            // Day 5/6 Rule
            pos = 0;
            break;
        case 7:
            // Doering
            pos = 10;
            break;
        case 9:
            // Last Dry Day
            pos = 14;
            break;
        case 1:
            // Manual, but that is not indexed here
            return 0;
        default:
            printDebug('ERROR - invalid case=' + choice_index + ' for Phase I in getFertWinValueFromString');
            break;
        }
    }
    else
    {
        // Phase III Fert Window Beginning
        switch(choice_index)
        {
        case 2:
            // ST Rule
            pos = 8;
            break;
        case 8:
            // Post Hormonal
            pos = 10;
            break;
        case 4:
            // Temp Only
            pos = 0;
            break;
        case 5:
            // Mucus Only
            pos = 4;
            break;
        case 1:
            // Manual, but that is not indexed here
            return 0;
        default:
            printDebug('ERROR - invalid case=' + choice_index + ' for Phase III in getFertWinValueFromString');
            break;
        }
    }

    // Get string
    if (fwin_vals_str == null)
    {
        printDebug('ERROR: getFertWinValueFromString passed null string');
        retVal = 0;
    }
    else
    {
        if ((pos >= 0) && (pos < (fwin_vals_str.length-1)))
        {
            retVal = fwin_vals_str.substring(pos, pos + bytes_per_val);
        }
        else if (fwin_vals_str != '')
        {
            printDebug('ERROR: Cannot index string "' + fwin_vals_str + '" to specified location');
            retVal = 0;
        }
    }
    
    return retVal;
}
function convertFertWinValToDisplayString(tempVal, beg_OR_end_NOT)
{
    // Format a value to display
    if (tempVal <= 0)
    {
        return '(<i>TBD</i>)';
    }
    else if (tempVal >= 99)
    {
        return '(<i>unknown</i>)';
    }
    else
    {
        if (beg_OR_end_NOT)
        {
            // Stored as Fertile Window Start Date, but they report last day of Phase I so need to subtract 1 before displaying
            tempVal = tempVal - 1;
        }
        return '<b>' + tempVal + '</b>';
    }
}
function calcBMI(t_units, cyc_weight, usr_height)
{
    var retBMI;
    if (t_units == 'F')
    {
        retBMI = 703;
    }
    else
    {
        retBMI = 10000;
    }
    if ((cyc_weight > 0) && (usr_height > 0))
    {
        return (Math.round((cyc_weight / (Math.pow(usr_height,2))) * retBMI * 10) / 10);
    }
    else
    {
        return 'na';
    }
}
function convertOptionsListVal2Index(optionsList, soughtIndex)
{
    var j;
    var found_index = -1;
    for (var j=0; j<optionsList.length; j++)
    {
        if (optionsList[j].value == global_selected_cycle_offset)
        {
            found_index = j;
            break;
        }
    }
    return found_index;
}
