///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// FUNCTIONS FOR CALENDAR SCREENS
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    // Declare global variables that need retained between calls to state machine
    var calendar_start_date = new Date();
    var calendar_last_date = new Date();
    var calendar_loaded_date = new Date();
    var global_calendar_start_int = -1;
    var global_calendar_last_int = -1;
    var global_selected_date = new Date();
    var global_calendar_index;
    var mens_days = new Array();
    var recorded_data = new Array();
    var global_t_units = 'F';
    var global_CalShadeFert = 0;
    var global_Debug_Enabled = 0;
    var global_CalOv = 1;
    var global_active_subscription = 0;
    var db;

    // Globals to help coordinate tasks running in parallel
    var UploadSyncToServer_DataRecsDB = 0;
    var UploadSyncToServer_EventSettingsDB = 0;
    var UploadSyncToServer_CyclesDB = 0;
    var UploadSyncToServer_PregDB = 0;
    var LoadCalScreen_InterpDB = 0;
    var LoadCalScreen_DataRecsDB = 0;
    var LoadCalScreen_EventSettingsDB = 0;
    var LoadCalScreen_CyclesDB = 0;
    var LoadCalScreen_UserInfoDB = 0;
    var LoadCalScreen_PregDB = 0;
    
    var COLOR_RGB_MENS = '#FF0000';
    var COLOR_RGB_NOTHING = '#FFFFFF';
    var AUTONUM_CYCLE_DELIMETER = 98765;
    
    // Function runs to draw the calendar.  The month should be 1-12 and not 0-11.
    function populate_calendar(date_type, y, m, d)
    {
LogCall('4b');  
        calendar_loaded_date = new Date();
        var days_in_month = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
        var day_counter;
        var prior_month;
        var prior_year;
        var calendar_start_m;
        var calendar_start_d;
        var calendar_start_y;
        var calendar_last_m;
        var calendar_last_d;
        var calendar_last_y;
        var i;

        // Use a pre-programmed date if supplied.  Otherwise will use global datecurrent date.
        if (date_type == 'today')
        {
            d = calendar_loaded_date.getDate();
            m = calendar_loaded_date.getMonth() + 1;
            y = calendar_loaded_date.getFullYear();
        }
        else if (date_type == 'global')
        {
            d = global_selected_date.getDate();
            m = global_selected_date.getMonth() + 1;
            y = global_selected_date.getFullYear();
        }
        calendar_loaded_date.setDate(d);
        calendar_loaded_date.setMonth(m-1);
        calendar_loaded_date.setFullYear(y);
        prior_year = y;
                        
        // Adjustment for leap year
        if ((y % 4) == 0)
        {
            days_in_month[1] = days_in_month[1] + 1;
        }
        
        // Determine where calendar starts
        var firstDayOfMonth = new Date(calendar_loaded_date.getFullYear(), calendar_loaded_date.getMonth(), 1, 0, 0, 0, 0);
        var dow = firstDayOfMonth.getDay();
        
        // Determine the prior month and display the current one
        prior_month = m - 1;
        if (prior_month == 0)
        {
            prior_month = 12;
            prior_year = y - 1;
        }
        document.getElementById('divCal_Header_Date').innerHTML = months[m-1] + ' ' + y;
        
        // Look ahead to days early in the next month
        calendar_last_m = m + 1;
        if (calendar_last_m > 12)
        {
            calendar_last_m = 1;
            calendar_last_y = y + 1;
        }
        else
        {
            calendar_last_y = y;
        }             
        
        // Loop through days at the end of last month
        day_counter = days_in_month[prior_month-1];
        for (i=dow-1; i>=0; i--)
        {
            document.getElementById('CalendarDateDay_' + (i+1)).innerHTML = day_counter;
            day_counter = day_counter - 1;
        }
        
        // Loop through the days of this month
        day_counter = 1;
        for (i=0; i<days_in_month[m-1]; i++)
        {
            document.getElementById('CalendarDateDay_' + (i+dow+1)).innerHTML = day_counter;
            day_counter = day_counter + 1;
        }
        
        // Loop through the days at the start of next month
        day_counter = 1;
        for (i=dow+days_in_month[m-1]+1; i<=42; i++)
        {
            document.getElementById('CalendarDateDay_' + i).innerHTML = day_counter;
            day_counter = day_counter + 1;
        }
        
        // Save dates into global variables
        calendar_last_d = day_counter - 1;
        if (dow > 0)
        {
            calendar_start_d = days_in_month[prior_month-1] - (dow - 1);
            calendar_start_m = prior_month;
            calendar_start_y = prior_year;
        }
        else
        {
            calendar_start_d = 1;
            calendar_start_m = m;
            calendar_start_y = y;
        }
        calendar_start_date = new Date(calendar_start_y, calendar_start_m-1, calendar_start_d, 0, 0, 0, 0); 
        calendar_last_date = new Date(calendar_last_y, calendar_last_m-1, calendar_last_d, 0, 0, 0, 0); 
        global_calendar_start_int = DateToNumber(calendar_start_date);
        global_calendar_last_int = DateToNumber(calendar_last_date);
        
        return; 
    }
    // Function refreshes only visible controls on the data entry subscreens
    function refreshCalendarSubscreenControls()
    {
        var myselect;
LogCall('4d'); 

        // Refresh all data input controls 
        $("input[id='mensCheckbox']").checkboxradio("refresh");
        $("input[id='eventCheckbox_30']").checkboxradio("refresh");     // spotting
        $("input[id='eventCheckbox_38']").checkboxradio("refresh");     // intercourse
        $("input[id='eventCheckbox_42']").checkboxradio("refresh");     // birth control
        // Events - it is assumed that other event checkboxes are refreshed as updated
        $("input[id='tempUnsureCheckbox']").checkboxradio("refresh");
        $("input[id='tempDiscardCheckbox']").checkboxradio("refresh");
        $("input[name='OvTestAmRadio']").checkboxradio("refresh");
        $("input[name='OvTestPmRadio']").checkboxradio("refresh");
        myselect = $("select#FertMonitorSelect");
        myselect.selectmenu("refresh");
        
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            myselect = $("select#MensFlow");
            myselect.selectmenu("refresh");
            myselect = $("select#MucusSense");
            myselect.selectmenu("refresh");
            myselect = $("select#MucusChar");
            myselect.selectmenu("refresh");
            myselect = $("select#CervixDia");
            myselect.selectmenu("refresh");
            myselect = $("select#CervixCons");
            myselect.selectmenu("refresh");    
        }
        else
        {
            myselect = $("select#MucusSelect");
            myselect.selectmenu("refresh");
            myselect = $("select#CervixSelect");
            myselect.selectmenu("refresh");
        }
    }
    // Function transitions from the calendar to a subscreen when a date is picked
    // This is Part 1 of 2 that 
    function jump_to_calendar_date(state, calendar_index)
    { 
printDebug('jump_to_calendar_date(' + calendar_index + ')');
        switch(state)
        {
        case 1:     // Step 1 executes when the calendar is visible and switches pages.  It relies on Part 2 to load the data.
LogCall('4e');
            // Populate the data values for all calendar subscreens. 
            printStatus('Loading');
            
            // Set the global variables so that Part 2 which will run when this subpage is loaded knows what to display
            global_calendar_index = calendar_index;

            // Show the calendar subscreen
            TransitionToSubscreen(global_Calendar_Pages[0], "slide");
            
            // State 2 executes on its own after the calendar subscreen is loaded (caused by transition above)
            break;
        
        case 2:  // Step 2 executes when the calendar data subscreen is loaded.  It relies on the global_calendar_index to know the desired date (calendar_index argument is ignored)
            var tempStr;
            var days_of_week = ['Sun','Mon','Tue','Wed','Thu','Fri','Sat'];
            var abbrev_months = ['Jan','Feb','Mar','Apr','May','June','July','Aug','Sept','Oct','Nov','Dec'];
            var i;
LogCall('4f');

            // CCL does not permit data entry without a valid subscription. Decrements down counter each time a date is loaded.
            if (BUILD_TARGET == BUILD_4_CCL)
            {
                if (global_active_subscription != 0)
                {
                    global_active_subscription = global_active_subscription - 1;
                    updateSubscriptionCounter(global_active_subscription);
                }
            }

            // Note the date selection and update display.  Relies on Part 1 of this function setting global_calendar_index.
            global_selected_date = new Date(calendar_start_date);
            global_selected_date.setDate(calendar_start_date.getDate() + (global_calendar_index-1));
            tempStr = days_of_week[global_selected_date.getDay()] + ' ' + abbrev_months[global_selected_date.getMonth()] + ' ' + global_selected_date.getDate() + ', ' + global_selected_date.getFullYear();
            document.getElementById('divCal_Header_Date_' + global_Calendar_Pages[0]).innerHTML = tempStr;
            
            // Perform the loading of data for the programmed date
            loadCalendarSubscreens(1, '', '', '');
            
            break;
            
        default:
            ShowPopupMessage('Default state error 34912430. Please email support.', 'Error', '');
        }

        return;
    }
    function navToMainCalendar(state)
    {
        // Broken into 2 states.  One transitions to other page and the second refreshes that page after it is visible
        switch(state)
        {
        case 1:
LogCall('4k'); 
            // Load the calendar screen
            TransitionToSubscreen("calendar", "none");
            break;
            
        case 2:
LogCall('4j'); 
            // Set dynamic build content for loaded page
            setDynamicContentForAppInstance('calendar');

            // Solicit for review
            if (global_survey_id != 0)
            {
                if ((global_survey_id > 0) && (global_survey_id <= 2))
                {
                    // Show feedback form
                    SolicitFeedback(global_survey_id);
                    global_survey_id = 0;
                    updateLocalDb_UserInfo(global_survey_id, PASSED_VALUE, 'survey_id');
                }
            }
            else if (global_svr_info_msg_shown == 0) // Show server notification message if the one has not been displayed previously
            {
                if (global_svr_info_msg != '')
                {
                    ShowPopupMessage(global_svr_info_msg, 'Special Message', '');
                }
                updateLocalDb_UserInfo('1', PASSED_VALUE, 'svr_info_msg_shown');
            } 
            else if (global_svr_info_msg_shown == 10) 
            {
                // Eventually replace with survey link
                if (BUILD_TARGET != BUILD_4_CCL)
                {
                    // Show ad to ask user to leave positive review
                    if (global_is_ios)
                    {
                        ShowPopupMessage('Please consider leaving a review for this app in the app store!  Thanks for your time!', 'App Review', '<a href="' + get_app_store_url() + '" target="_blank" onclick="return go2url(this);"><span class="divPopLink">Go to App Store</span></a>');
                    }
                    else
                    {
                        ShowPopupMessage('Do you like this app? Leave a review and email us about it and get a 15 day free premium subscription extension!<br><br><u><b>Details</b></u>: Leave us a 5 star review with comments on why you like the app and then email support@myfertilitycharts.com with your username. We will then credit your account. It is our way of thanking you for your time.', 'Special Feedback Offer', '<a href="' + get_app_store_url() + '" target="_blank" onclick="return go2url(this);"><span class="divPopLink">Go to App Store</span></a>');                
                    }
                }
                updateLocalDb_UserInfo('11', PASSED_VALUE, 'svr_info_msg_shown');
            }
            else if (global_svr_info_msg_shown == 20) 
            {
                // Eventually replace with survey link
                if (BUILD_TARGET != BUILD_4_CCL)
                {
                    // Show ad to ask user to leave positive review
                    ShowPopupMessage('Do you like this app?  Please consider taking time to leave a review in the app store!  As always, if you have questions or problems, email us at support@myfertilitycharts.com.', 'Review this app', '<a href="' + get_app_store_url() + '" target="_blank" onclick="return go2url(this);"><span class="divPopLink">Go to App Store</span></a>');
                    updateLocalDb_UserInfo('21', PASSED_VALUE, 'svr_info_msg_shown');
                }
            }
            
            // Register the tap events needed to make the calendar clickable (needs done every time since this is now a separate "page" that is dismissed and recalled)
            register_calendar_taps();
            // Initialize the calendar
            populate_calendar('global');

            // Proceed to load data now that the calendar is known to have been properly drawn
            var m = calendar_loaded_date.getMonth();
            var y = calendar_loaded_date.getFullYear();
            
            // Make the header show the month
            document.getElementById('divCal_Header_Date').innerHTML = months[m] + ' ' + y;

            // Refresh the calendar colors to cancel out anything done during a previous select (Calendar Cell Selection Feedback)
            var calendar_days_len = 42;
            for (var day_val=1; day_val<=calendar_days_len; day_val++)
            {
                document.getElementById('CalendarDate_' + day_val).style.color = '#000000';
                document.getElementById('CalendarDate_' + day_val).style.backgroundColor = document.getElementById('CalendarCell_' + day_val).style.backgroundColor;
                document.getElementById('CalendarDateDay_' + day_val).style.fontSize = '20px';
            }
            
            // Since this separate calendar "page" was dismissed and reloaded, we need to at least re-render it from the local database
            data_load_fsm(1, true, global_calendar_start_int, global_calendar_last_int, '', '', '', '');

            break;
            
        default:
            ShowPopupMessage('Default state error 3241912. Please email support.', 'Error', '');
        }
    }
    function does_timestamp_say_to_reload(timestamp_nv_pair_index)
    {
LogCall('4h'); 
        var need_to_load = false;
        var timestamp = g_LoadTimestamps[timestamp_nv_pair_index];
        var SECONDS_BEFORE_PRIOR_SYNC_EXPIRES = global_SyncInterval;

        // If there is no timestamp, then we must reload because either it has never
        // been loaded before or something dumped the timestamp name value pair data
        // because something changed which necessitates that we reload data from server.
        if ((timestamp == undefined) || (timestamp == ''))
        {
            need_to_load = true;
        }
        else 
        {
            // Compare timestamps to decide how long ago we last loaded the page.
            // If not too long ago, there is no need to load again.
            var currentTime = new Date();
            var diff_in_milliseconds = currentTime.getTime() - timestamp;
            if (diff_in_milliseconds > (SECONDS_BEFORE_PRIOR_SYNC_EXPIRES * 1000))
            {
                need_to_load = true;
            }
        }
printDebug('need_to_load = ' + need_to_load);
        return need_to_load;
    }
    function clearCalendarSubscreens() 
    {
LogCall('4i'); 
        var myselect;
        // Initially clear all fields
        $("input[id='mensCheckbox']").attr("checked", false);
        $("input[id='eventCheckbox_30']").attr("checked", false);       // spotting
        $("input[id='eventCheckbox_38']").attr("checked", false);       // intercourse
        $("input[id='eventCheckbox_42']").checkboxradio("refresh");     // birth control
        // Other events are created dynamically as needed and don't need cleared in advance
        document.getElementById('personalNotesTextArea').value = '';
        document.getElementById('intercourseNotesTextArea').value = '';
        document.getElementById('tempTextbox').value = '';
        $("input[id='tempUnsureCheckbox']").attr("checked", false);
        $("input[id='tempDiscardCheckbox']").attr("checked", false);
        document.getElementById('tempNotesTextArea').value = '';
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            document.getElementById('weightTextbox').value = '';
            document.getElementById('heightTextbox').value = '';
            if (global_t_units == 'F')
            {
                document.getElementById('weightUnits').innerHTML = 'lbs';
                document.getElementById('heightUnits').innerHTML = 'inches';
            }
            else
            {
                document.getElementById('weightUnits').innerHTML = 'kg';
                document.getElementById('heightUnits').innerHTML = 'cm';
            }
            myselect = $("select#MensFlow");
            myselect[0].selectedIndex = 0;
            myselect = $("select#MucusSense");
            myselect[0].selectedIndex = 0;
            myselect = $("select#MucusChar");
            myselect[0].selectedIndex = 0;
            myselect = $("select#CervixDia");
            myselect[0].selectedIndex = 0;
            myselect = $("select#CervixCons");
            myselect[0].selectedIndex = 0;
        }
        else
        {
            myselect = $("select#MucusSelect");
            myselect[0].selectedIndex = 0;
            myselect = $("select#CervixSelect");
            myselect[0].selectedIndex = 0;
        }
        myselect = $("select#FertMonitorSelect");
        myselect[0].selectedIndex = 0;
        $("input[name='OvTestAmRadio']").attr("checked",false);
        $("input[name='OvTestPmRadio']").attr("checked",false);
        // Disable the adjust temp pop-up
        document.getElementById('div_LateTempAdjustment').style.display = 'none';
        document.getElementById('div_LateTempAdjustButton').style.display = 'block';
    }
    function loadCalendarSubscreens(state, tx, results, param_1) 
    {
        printDebug("State #" + state + " of loadCalSubScrns");

        switch(state)
        {
        ////////////////////////////////
        // STEP 1 - Initialize Screen //
        ////////////////////////////////
        case 1:
LogCall('m1');
            // Clear user interface so we can start with a blank slate and populate from there
            clearCalendarSubscreens();
        
            // Open database
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_loadCalSubscreens_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_loadCalSubscreens_1 = -1;
                                    loadCalendarSubscreens(state+1, tx, '', '');
                                },
                                function(tx, err)
                                {
                                    crash_and_burn(err, 'Could not load data from local database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                                },
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_loadCalSubscreens_1 > 0)
                                    {
                                        global_db_ios_fail_loadCalSubscreens_1 = global_db_ios_fail_loadCalSubscreens_1 - 1;
                                        printDebug('iOS db.transaction failed loadCalSubscreens state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_loadCalSubscreens_1));
                                        loadCalendarSubscreens(state, tx, results, param_1);
                                    }
                                    else if (global_db_ios_fail_loadCalSubscreens_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            // Set dynamic build content
            setDynamicContentForAppInstance(global_Calendar_Pages[0]);
            
            break;

        case 2:
LogCall('m2');

            // Query custom event names from local database and also which are to be shown.  There is no need to do a remote query because the calendar
            // page does that for the entire month in view. 
            strSql = 'SELECT * FROM Event_Settings_DB;';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                loadCalendarSubscreens(state+1, tx, results, '');
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local DataRecs database for event settings.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
        
        case 3:
LogCall('m3');
            var i;
            var encoded = new Array();
            var decoded = new Array();
            var eventInfo = new Array();
            
            // Populate event names for placement below on demand
            eventInfo = BuildEventArray(results, true);

            // Determine which events should be visible 
            for (i=1; i<=NUMBER_OF_EVENT_WORDS; i++)
            {
                // Get values from database
                encoded[i-1] = results.rows.item(0)['ev_show_word' + i];
            }
            // Convert from encoded to decoded values
            decoded = DecompressEventBits(encoded);
            // Loop through and drop in HTML to create checkboxes for each as appropriate
            for (i=0; i<decoded.length; i++)
            {
                if (eventInfo[i].bit < 0)
                {
                    // Ignore alternatively represented events that don't need a checkbox dynamically created for them
                }
                else if (decoded[i] == 0)
                {
                    document.getElementById('divForEventCheckbox_' + i).innerHTML = '';
                }
                else
                {
                    document.getElementById('divForEventCheckbox_' + i).innerHTML = '<input type="checkbox" name="eventCheckbox_' + i + '" onchange="javascript:updateLocalDb_DataRecs(global_selected_date, \'eventCheckbox_' + i + '\', TYPE_CHECKBOX, \'' + eventInfo[i].field + '\', ' + eventInfo[i].bit + ', \'' + eventInfo[i].field + '_chg\', ' + eventInfo[i].bit + ');" id="eventCheckbox_' + i + '" class="custom" /><label for="eventCheckbox_' + i + '" >' + eventInfo[i].name + '</label>';
                }
            }
            // Call the jQuery Mobile create function to stylize these checkboxes to be pretty
            $('#eventEntry').trigger('create');

            
            // Query recorded data values from local database.  
            strSql = 'SELECT * FROM Data_Recs_DB WHERE record_date = ' + DateToNumber(global_selected_date) + ';';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                loadCalendarSubscreens(state+1, tx, results, eventInfo);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local DataRecs database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
            
        case 4:
LogCall('m4');
            // Retrieve results of query
            var eventInfo = param_1;
            var myselect;
            var len = results.rows.length;
            var mens_val = 0;
            var pnotes_val = '';
            var inotes_val = '';
            var tnotes_val = '';
            var temp_val = 0;
            var unsure_val = 0;
            var discard_val = 0;
            var mucus_val = 'na';
            var cervix_val = 'na';
            var monitor_val = 'na';
            var ovtest_am_val = 'na';
            var ovtest_pm_val = 'na';
            var weight_val = 0;
            var mFlow_val = 'na';
            var mucusSense_val = 'na';
            var mucusChar_val = 'na';
            var cervixDia_val = 'na';
            var cervixCons_val = 'na';
            var itxtreq_val = 0;
            var mucusEnumeration = {};
            mucusEnumeration['na'] = 0;
            mucusEnumeration['D'] = 1;
            mucusEnumeration['M'] = 2;
            mucusEnumeration['F'] = 3;
            var cervixEnumeration = {};
            cervixEnumeration['na'] = 0;
            cervixEnumeration['L'] = 1;
            cervixEnumeration['M'] = 2;
            cervixEnumeration['H'] = 3;
            var mFlowEnumeration = {};
            mFlowEnumeration['na'] = 0;
            mFlowEnumeration['Sp'] = 1;
            mFlowEnumeration['Li'] = 2;
            mFlowEnumeration['He'] = 3;
            var mucusSenseEnumeration = {};
            mucusSenseEnumeration['na'] = 0;
            mucusSenseEnumeration['D'] = 1;
            mucusSenseEnumeration['M-'] = 2;
            mucusSenseEnumeration['M+'] = 3;
            mucusSenseEnumeration['F'] = 4;
            mucusSenseEnumeration['MF'] = 5;
            var mucusCharEnumeration = {};
            mucusCharEnumeration['na'] = 0;
            mucusCharEnumeration['D'] = 1;
            mucusCharEnumeration['M+'] = 2;
            mucusCharEnumeration['F'] = 3;
            var cervixDiaEnumeration = {};
            cervixDiaEnumeration['na'] = 0;
            cervixDiaEnumeration['L'] = 1;
            cervixDiaEnumeration['M'] = 2;
            cervixDiaEnumeration['H'] = 3;
            cervixDiaEnumeration['P'] = 4;
            var cervixConsEnumeration = {};
            cervixConsEnumeration['na'] = 0;
            cervixConsEnumeration['L'] = 1;
            cervixConsEnumeration['H'] = 2;
            var monitorEnumeration = {};
            monitorEnumeration['na'] = 0;
            monitorEnumeration['L'] = 1;
            monitorEnumeration['H'] = 2;
            monitorEnumeration['P'] = 3;
            var ovTestAmEnumeration = {};
            ovTestAmEnumeration['na'] = 'OvTestAmRadio_None';
            ovTestAmEnumeration['y'] = 'OvTestAmRadio_Positive';
            ovTestAmEnumeration['n'] = 'OvTestAmRadio_Negative';
            var ovTestPmEnumeration = {};
            ovTestPmEnumeration['na'] = 'OvTestPmRadio_None';
            ovTestPmEnumeration['y'] = 'OvTestPmRadio_Positive';
            ovTestPmEnumeration['n'] = 'OvTestPmRadio_Negative';
            var encoded = new Array();
            var decoded = new Array();
            
            if (len == 0)
            {
                // Assumes that clearCalendarSubscreens() would have been called before this so we only need
                // to handle fields that need reset differently than how clearCalendarSubscreens does it
                $("input[id='OvTestAmRadio_None']").attr("checked",true).checkboxradio("refresh");
                $("input[id='OvTestPmRadio_None']").attr("checked",true).checkboxradio("refresh"); 
            }
            else
            {
                // Get values
                mens_val = results.rows.item(0)['mens'];
                pnotes_val = ReplaceQuotes(results.rows.item(0)['p_notes'], 0);
                inotes_val = ReplaceQuotes(results.rows.item(0)['i_notes'], 0);
                tnotes_val = ReplaceQuotes(results.rows.item(0)['t_notes'], 0);
                temp_val = results.rows.item(0)['temp'];
                unsure_val = results.rows.item(0)['unsure'];
                discard_val = results.rows.item(0)['discard'];
                monitor_val = results.rows.item(0)['monitor'];
                ovtest_am_val = results.rows.item(0)['ovtest_am'];
                ovtest_pm_val = results.rows.item(0)['ovtest_pm'];
                if (BUILD_TARGET == BUILD_4_CCL)
                {
                    weight_val = results.rows.item(0)['fweight'];
                    mFlow_val = results.rows.item(0)['mflow'];
                    mucusSense_val = results.rows.item(0)['muc_sens'];
                    mucusChar_val = results.rows.item(0)['muc_acons'];
                    cervixDia_val = results.rows.item(0)['cerv_dia'];
                    cervixCons_val = results.rows.item(0)['cerv_cons'];
                    itxtreq_val = results.rows.item(0)['itxtreq'];
                }
                else
                {
                    mucus_val = results.rows.item(0)['mucus'];
                    cervix_val = results.rows.item(0)['cervix'];
                }
                
                // Convert values if necessary
                if (mens_val == 0) 
                {
                    mens_val = false; 
                }
                else 
                {
                    mens_value = true;
                }
                if (discard_val == 0) 
                {
                    discard_val = false; 
                }
                else 
                {
                    discard_val = true;
                }
                if (unsure_val == 0) 
                {
                    unsure_val = false; 
                }
                else 
                {
                    unsure_val = true;
                }
                if (temp_val == 0)
                {
                    temp_val = '';
                }
                if (weight_val == 0)
                {
                    weight_val = '';
                }
                
                // Populate values in user interface
                $("input[id='mensCheckbox']").attr("checked", mens_val);
                document.getElementById('mensCheckbox').checked = mens_val;
                document.getElementById('personalNotesTextArea').value = pnotes_val;
                $('#personalNotesTextArea').trigger('keyup');  
                document.getElementById('intercourseNotesTextArea').value = inotes_val;
                $('#intercourseNotesTextArea').trigger('keyup');  
                document.getElementById('tempNotesTextArea').value = tnotes_val;
                $('#tempNotesTextArea').trigger('keyup');  
                document.getElementById('tempTextbox').value = temp_val;
                document.getElementById('normalTempTimeAdjustTextbox').value = global_NormalTempTime;
                $("input[id='tempUnsureCheckbox']").attr("checked", unsure_val);
                document.getElementById('tempUnsureCheckbox').checked = unsure_val;
                $("input[id='tempDiscardCheckbox']").attr("checked", discard_val);
                document.getElementById('tempDiscardCheckbox').checked = discard_val;
                myselect = $("select#FertMonitorSelect");
                myselect[0].selectedIndex = monitorEnumeration[monitor_val];
                $("input[id='" + ovTestAmEnumeration[ovtest_am_val] + "']").attr("checked",true);
                $("input[id='" + ovTestPmEnumeration[ovtest_pm_val] + "']").attr("checked",true); 
                if (BUILD_TARGET == BUILD_4_CCL)
                {
                    if (weight_val > 0)
                    {
                        document.getElementById('weightTextbox').value = weight_val / 100;
                    }
                    else
                    {
                        document.getElementById('weightTextbox').value = '';
                    }
                    if (global_user_height > 0)
                    {
                        document.getElementById('heightTextbox').value = global_user_height;
                    }
                    else
                    {
                        document.getElementById('heightTextbox').value = '';
                    }
                    myselect = $("select#MensFlow");
                    myselect[0].selectedIndex = mFlowEnumeration[mFlow_val];
                    myselect = $("select#MucusSense");
                    myselect[0].selectedIndex = mucusSenseEnumeration[mucusSense_val];
                    myselect = $("select#MucusChar");
                    myselect[0].selectedIndex = mucusCharEnumeration[mucusChar_val];
                    myselect = $("select#CervixDia");
                    myselect[0].selectedIndex = cervixDiaEnumeration[cervixDia_val];
                    myselect = $("select#CervixCons");
                    myselect[0].selectedIndex = cervixConsEnumeration[cervixCons_val];
                    if (itxtreq_val == 0)
                    {
                        document.getElementById('numManuallyTextbox').value = '';
                        $("input[id='autoNumCheckbox']").attr("checked", false).checkboxradio("refresh");
                    }
                    else if (itxtreq_val == AUTONUM_CYCLE_DELIMETER)
                    {
                        document.getElementById('numManuallyTextbox').value = '';
                        $("input[id='autoNumCheckbox']").attr("checked", true).checkboxradio("refresh");
                    }
                    else
                    {
                        document.getElementById('numManuallyTextbox').value = itxtreq_val;
                        $("input[id='autoNumCheckbox']").attr("checked", false).checkboxradio("refresh");
                    }
                    initCCLAutoNum();
                }
                else
                {
                    myselect = $("select#MucusSelect");
                    myselect[0].selectedIndex = mucusEnumeration[mucus_val];
                    myselect = $("select#CervixSelect");
                    myselect[0].selectedIndex = cervixEnumeration[cervix_val];
                }  

                // Get event words and convert them to an array
                for (var i=1; i<=NUMBER_OF_EVENT_WORDS; i++)
                {
                    // Get values from database
                    encoded[i-1] = results.rows.item(0)['ev' + i + 'nt'];
                }
                // Convert from encoded to decoded values
                decoded = DecompressEventBits(encoded);
                for (var i=0; i<decoded.length; i++)
                {
                    if (decoded[i] == 0)
                    {
                        event_val = false;
                    }
                    else
                    {
                        event_val = true;
                    }
                    // Populate value in checkbox and refresh control so it gets updated on the UI
                    $("input[id='eventCheckbox_" + i + "']").attr("checked", event_val);
                    chkbox = document.getElementById("eventCheckbox_" + i);
                    if (chkbox != null)
                    {
                        chkbox.checked = event_val;
                    }
                    $("input[id='eventCheckbox_" + i + "']").checkboxradio("refresh");
                }
            }
            
            // Refresh controls
            refreshCalendarSubscreenControls();
            
            // Query analyzed data values from local database to dig up Cycle Day number if available.  
            strSql = 'SELECT cd,preg_cnt FROM Interp_DB WHERE record_date=' + DateToNumber(global_selected_date) + ';';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                loadCalendarSubscreens(state+1, tx, results, eventInfo);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local DataRecs database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
        
        case 5:
LogCall('m5');
            // Retrieve results of query
            var len = results.rows.length;
            var cycle_day_str = '&nbsp;';
            if (len != 0)
            {
                // Get Cycle Day from database and display by the date
                var cycle_day = results.rows.item(0)['cd'];
                var preg_day = results.rows.item(0)['preg_cnt'];
                if (preg_day > 0)
                {
                    var POSTPARTUM_OFFSET=320;
                    if (preg_day >= POSTPARTUM_OFFSET)
                    {
                        preg_day = preg_day - POSTPARTUM_OFFSET + 1;
                        if (preg_day < 7)
                        {
                            cycle_day_str = preg_day + ' days Postpartum';
                        }
                        else
                        {
                            cycle_day_str = parseInt((preg_day)/7) + ' weeks Postpartum';
                        }
                    }
                    else
                    {
                        cycle_day_str = 'Pregnancy Week #' + (parseInt((preg_day-2)/7)+1);;
                    }
                }
                else if (cycle_day > 0)
                {
                    cycle_day_str = 'Cycle Day ' + cycle_day;
                }
            }
            document.getElementById('divCal_Header_Date_' + global_Calendar_Pages[0]).innerHTML += '<div style="font-size:12px;font-weight:normal;">' + cycle_day_str + '</div>';
            
            // Dismiss the "Please Wait Action Pending" pop-up
            HideAct_Legacy();

            // All done
            printStatus('');
            HideAct_Legacy();
            HideAct();
            break;
        }
        return;
    }  
    function update_last_calendar_screen_in_db(state, tx, new_value)
    {
        switch(state)
        {
        case 1:
LogCall('n1');
            // Open database
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_updateLastCalScreen_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_updateLastCalScreen_1 = -1;
                                    update_last_calendar_screen_in_db(state+1, tx, new_value);
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_updateLastCalScreen_1 > 0)
                                    {
                                        global_db_ios_fail_updateLastCalScreen_1 = global_db_ios_fail_updateLastCalScreen_1 - 1;
                                        printDebug('iOS db.transaction failed update_last_cal_screen state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_updateLastCalScreen_1));
                                        update_last_calendar_screen_in_db(state, tx, new_value);
                                    }
                                    else if (global_db_ios_fail_updateLastCalScreen_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            break; 
            
        case 2:
LogCall('n2');
            // Perform query
            strSql = 'UPDATE User_Info_DB SET last_calendar_screen=' + new_value + ' WHERE 1';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                successCB();
                            },
                            errorCB
                         );
            break;
        }
        return;
    }
    
    function crash_and_burn(err, status_msg) 
    {
LogCall('4z');
        printDebug('<span style="color:Red;">C&B ERROR: ' + status_msg);
        // Display info message
        printInfoMessage(status_msg);
        // Print debug information
        if (err != undefined)
        {
            printDebug("<font color='Red'>Database Error</font>: " + err.message);
        }
        printStatus('Error');
        
        // Turn back on scrolling.  Terrible things happened, so hopefully the user can navigate back to something useful
        suspend_scrolling(false, 0);
        
        return false;
    }         
    
    function advance_calendar(month_adjustment, reload_data_now_too)
    {
LogCall('4g');
        printDebug('advance_calendar called to adjust by ' + month_adjustment);
        var d;
        var y;
        var m;
        
        // Show loading indicators as we transition to another month
        ShowAct();
        
        // Change date
        d = global_selected_date.getDate();
        m = global_selected_date.getMonth() + month_adjustment;
        y = global_selected_date.getFullYear();
        if (m >= 12)
        {
            m = 0;
            y = y + 1;
        }
        if (m < 0)
        {
            m = 11;
            y = y - 1;
        }
        global_selected_date = new Date(y, m, d, 0, 0, 0, 0);

        if (reload_data_now_too) 
        {
            // Reload the calendar itself
            populate_calendar('global');
            // Reload calendar's data
            data_load_fsm(1, true, global_calendar_start_int, global_calendar_last_int, '', '', '', '');
        }
    }
    
    // Function that helps build the SQL string needed to update the local database using information downloaded from server.  Returns QueryDetails
    function loopThruRelevantIndicesAndStoreLocally(relevantIndices, respParamsStr, dbFieldObj, results, local_db_counter, QueryDetails)
    {    
        var given_index;
        var last_read_dirty_prefix = '';
        var last_read_chg = '';
        var last_read_pnd = '';
LogCall('4h');
        // Loop through this assembled list and consider each
        for (var j=0; j<relevantIndices.length; j++)
        {
            given_index = relevantIndices[j];
            ///////////////////////////////////////
            // SIMPLE CASE - ONE VALUE PER FIELD //
            ///////////////////////////////////////
            // First handle the simple case where there is only 1 value represented within the DB Field (the dirty bits could be encoded, but the field is not)
            if (dbFieldObj[given_index].numberEncodedBits == 1)
            {
                // Need to check "_chg" flag before we try to update it.  We can only update it if it is marked "No Change"
                var safe_to_change = 0;
                if (dbFieldObj[given_index].localDirtyDBName == '')
                {
                    // This database field doesn't have a change flag (one way updatable) so we always just overwrite it
                    safe_to_change = 1;
                }
                else
                {
                    // Only re-read database fields if necessary (because parsing SQLite responses is so slow)
                    if (last_read_dirty_prefix != dbFieldObj[given_index].localDirtyDBName)
                    {
                        last_read_dirty_prefix = dbFieldObj[given_index].localDirtyDBName;
                        last_read_chg = results.rows.item(local_db_counter)[dbFieldObj[given_index].localDirtyDBName + '_chg'];
                        last_read_pnd = results.rows.item(local_db_counter)[dbFieldObj[given_index].localDirtyDBName + '_pnd'];
                    }
                    
                    // The database has a '_chg' and '_pnd' flag and they use encoded bits
                    if (((last_read_chg & Math.pow(2, dbFieldObj[given_index].localDBEncodedBitIndex)) == 0) && ((last_read_pnd & Math.pow(2, dbFieldObj[given_index].localDBEncodedBitIndex)) == 0)) 
                    {
                        safe_to_change = 1;
                    }
                }

                // Update the database for this simple case
                if (safe_to_change != 0)
                {
                    // Only make the change if it is even necessary
                    var str_without_quotes = ReplaceQuotes(respParamsStr[given_index], 1);
                    if (results.rows.item(local_db_counter)[dbFieldObj[given_index].localDBName] != str_without_quotes)
                    {
                        // Append to SQL string
                        if (QueryDetails.execute_strSql != 0)
                        {
                            QueryDetails.strSql += ', ';
                        }
                        QueryDetails.strSql += dbFieldObj[given_index].localDBName + '="' + str_without_quotes + '"';
                        QueryDetails.execute_strSql = 1;
                    }
                }
            }
            else
            {
                ///////////////////////////////////////////////////////
                // ADVANCED CASE - MULTIPLE ENCODED VALUES PER FIELD //
                ///////////////////////////////////////////////////////
                var encoded_bits_to_set = 0;
                var encoded_bits_to_clear = 0;
                if (dbFieldObj[given_index].localDirtyDBName == '')
                {
                    // This field does not have any dirty change/pending bits.  Fake it out as having some that are never set for simplicity for remainder of algorithm
                    last_read_chg = 0;
                    last_read_pnd = 0;
                }
                else
                {
                    last_read_chg = results.rows.item(local_db_counter)[dbFieldObj[given_index].localDirtyDBName + '_chg'];
                    last_read_pnd = results.rows.item(local_db_counter)[dbFieldObj[given_index].localDirtyDBName + '_pnd'];
                }
                
                // Loop through all encodings
                for (var k=0; k<dbFieldObj[given_index].numberEncodedBits; k++)
                {
                    // The database has a '_chg' and '_pnd' flag and they use encoded bits
                    if (((last_read_chg & Math.pow(2, k)) == 0) && ((last_read_pnd & Math.pow(2, k)) == 0)) 
                    {
                        // Safe to change, so go ahead and queue up bit to get set or cleared
                        if ((respParamsStr[given_index] & Math.pow(2, k)) == 0)
                        {
                            encoded_bits_to_clear = encoded_bits_to_clear | Math.pow(2, k);
                        }
                        else
                        {
                            encoded_bits_to_set = encoded_bits_to_set | Math.pow(2, k);
                        } 
                    } 
                }
                
                // Append values to SQL string if there is anything marked as allowed to change from above
                if ((encoded_bits_to_set != 0) || (encoded_bits_to_clear != 0))
                {
                    // Make sure it doesn't already match what is in the database
                    if (encoded_bits_to_set != results.rows.item(local_db_counter)[dbFieldObj[given_index].localDBName])
                    {
                        if (QueryDetails.execute_strSql != 0)
                        {
                            QueryDetails.strSql += ', ';
                        }
                        QueryDetails.strSql += dbFieldObj[given_index].localDBName + '=((' + dbFieldObj[given_index].localDBName + ' | ' + encoded_bits_to_set + ') & ~(' + encoded_bits_to_clear + ')) ';
                        QueryDetails.execute_strSql = 1;
                    }
                }
            }
        }
        return QueryDetails;
    }
    
    // Function looks up data in the local database and updates the display
    function RenderCalendarFromLocalDatabase(state, callback, param_1, param_2, final_call)
    {
        var tx = param_1;
        var results = param_2;
        var strSql = '';            
        
        // Make sure we're still even displaying the calendar screen
        if (GetCurrentPage() != "calendar")
        {
            // Quit function immediately
            callback(tx);
            return;
        }
        
        // Callback State Machine
        var currTime = new Date();
        printDebug("State #" + state + " of RenderCalFromLocalDb " + appendTimeStamp(currTime));
        switch(state)
        {
        case 1:
LogCall('p1');
            // Suspend scrolling on iOS because of a bug with database accesses not working sometimes when scrolling occurs (specifically tx.executSql; I handle db.transaction already)
            suspend_scrolling(true, '');
            
            // Display appropriate legend
            if (BUILD_TARGET == BUILD_4_CCL)
            {
                if (global_active_subscription == 0)
                {
                    if (global_is_ios)
                    {
                        if (global_username.toLowerCase() == ("sync" + "low"))
                        {
                            document.getElementById('ccl_legend_nosub_ios').style.display = 'none';
                        }
                        else
                        {
                            document.getElementById('ccl_legend_nosub_ios').style.display = 'block';
                        }
                        document.getElementById('ccl_legend_nosub').style.display = 'none';
                    }
                    else
                    {
                        document.getElementById('ccl_legend_nosub').style.display = 'block';
                        document.getElementById('ccl_legend_nosub_ios').style.display = 'none';
                    }
                }
                else
                {
                    document.getElementById('ccl_legend_nosub').style.display = 'none';
                    document.getElementById('ccl_legend_nosub_ios').style.display = 'none';
                }
            }
            else
            {
                document.getElementById('nosub_cal_legend').style.display = 'none';
                document.getElementById('ccl_legend_nosub').style.display = 'none';
                document.getElementById('nosub_cal_legend_ios').style.display = 'none';
                if (global_active_subscription == 0)
                {
                    // Do not show a legend - not a subscriber
                    document.getElementById('trad_cal_legend').style.display = 'none';
                    document.getElementById('shaded_cal_legend').style.display = 'none';
                    if (global_is_ios)
                    {
                        document.getElementById('nosub_cal_legend_ios').style.display = 'block';
                    }
                    else
                    {
                        document.getElementById('nosub_cal_legend').style.display = 'block';
                    }
                }
                else if (global_CalShadeFert == 0)
                {
                    // Show traditional legend
                    document.getElementById('trad_cal_legend').style.display = 'block';
                    document.getElementById('shaded_cal_legend').style.display = 'none';
                }
                else
                {
                    // Show Shading legend
                    document.getElementById('trad_cal_legend').style.display = 'none';
                    document.getElementById('shaded_cal_legend').style.display = 'block';
                }
            }

            // See if there are any fertility records that have been recorded
            strSql = 'SELECT * FROM Data_Recs_DB WHERE record_date >= ' + DateToNumber(calendar_start_date) 
            strSql += ' AND record_date <= ' + DateToNumber(calendar_last_date) + ';';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                RenderCalendarFromLocalDatabase(state+1, callback, tx, results, final_call);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local DataRecs database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
        case 2:
LogCall('p2');
            // Retrieve results of query
            var len = results.rows.length;
            if (len == 0)
            {
                // Only display this if we aren't going to call this again after attempting to download data from server
                if (final_call)
                {
                    // See if any data at all (beyond just myopically looking at this cycle) has been recorded before we display messages
                    strSql = 'SELECT * FROM Data_Recs_DB WHERE 1;';
                    suspend_scrolling(true, '');
                    tx.executeSql(  strSql, 
                                    [], 
                                    function(tx, results) 
                                    {
                                        suspend_scrolling(false, 0);
                                        if (results.rows.length == 0)
                                        {
                                            ShowPopupMessage("You have not recorded any data yet.  To get started, click on the days of your period and record menstruation.  You can also record temperature and other symptoms and events after clicking on a date on the <i>Data Calendar</i> screen.", 'Welcome', '');
                                        }
                                    },
                                    []
                                 );
                }
            }
            else
            {
                var rec_date_int;
                for (var i=0; i<len; i++)
                {
                    rec_date_int = results.rows.item(i).record_date - global_calendar_start_int;
                    if ((rec_date_int >= 0) && (rec_date_int <= 42))
                    {
                        // Note if menstruation was recorded or if any records are recorded for the given date
                        mens_days[rec_date_int] = results.rows.item(i).mens;
                        if (mens_days[rec_date_int] != 0)
                        {
                            recorded_data[rec_date_int] = 1;
                        }
                        else 
                        {
                            for (var j=1; j<=NUMBER_OF_EVENT_WORDS; j++)
                            {
                                // We want to know if any event was set, so we can just check the entire coded word at once 
                                if (results.rows.item(i)['ev' + j + 'nt'] != 0)
                                {
                                    recorded_data[rec_date_int] = 1; 
                                    break;
                                }
                            }
                        }
                        // Keep searching if we haven't found anything yet
                        if (recorded_data[rec_date_int] != 1)
                        {
                            if (results.rows.item(i).temp > 0)
                            {
                                recorded_data[rec_date_int] = 1;
                            }
                            else if (results.rows.item(i).mucus != "na")
                            {
                                recorded_data[rec_date_int] = 1;
                            }
                            else if (results.rows.item(i).monitor != "na")
                            {
                                recorded_data[rec_date_int] = 1;
                            }
                            else if (results.rows.item(i).ovtest_am != "na")
                            {
                                recorded_data[rec_date_int] = 1;
                            }
                            else if (results.rows.item(i).ovtest_pm != "na")
                            {
                                recorded_data[rec_date_int] = 1;
                            }
                            else if (results.rows.item(i).cervix != "na")
                            {
                                recorded_data[rec_date_int] = 1;
                            }
                            else if (results.rows.item(i).p_notes != "")
                            {
                                recorded_data[rec_date_int] = 1;
                            }
                            else if (results.rows.item(i).i_notes != "")
                            {
                                recorded_data[rec_date_int] = 1;
                            }
                            else if (results.rows.item(i).t_notes != "")
                            {
                                recorded_data[rec_date_int] = 1;
                            }
                            else if (results.rows.item(i).saliva != "na")
                            {
                                recorded_data[rec_date_int] = 1;
                            }
                            // Intentionally skipped checking Unsure and Discard since
                            // it doesn't make sense to record that without a temp anyway.
                            // This is to help keep this as efficient as possible since
                            // SQLite field searching is slow.
                        }
                    }
                }
            }
            
            // Retrieve interpretted values from local database
            strSql = 'SELECT * FROM Interp_DB WHERE record_date >= ' + DateToNumber(calendar_start_date) 
            strSql += ' AND record_date <= ' + DateToNumber(calendar_last_date) + ';';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                RenderCalendarFromLocalDatabase(state+1, callback, tx, results, final_call);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local Interp database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
            
        case 3:
LogCall('p3');
            // Retrieve results of query
            var len = results.rows.length;
            var calendar_days_len = 42;
            var rec_date_int;
            var interp_avail = new Array();
            var cd_num = new Array();
            var UNKNOWN_FPCT_COLOR = '#999999';
            var todays_date = new Date();
            var todays_date_i = DateToNumber(todays_date) - global_calendar_start_int;
            document.getElementById('invisMensColor').style.backgroundColor = COLOR_RGB_MENS;
            // Initialize
            document.getElementById('divCal_PregStatus').style.display = 'none'; 
            for (var i=0; i<calendar_days_len; i++)
            {
                interp_avail[i] = 0;
                cd_num[i] = 0;
            }
            // Loop through results
            for (var i=0; i<len; i++)
            {
                rec_date_int = results.rows.item(i).record_date - global_calendar_start_int;
                if ((rec_date_int < 0) || (rec_date_int >= 42))
                {
                    // This will only happen if the user has navigated to another calendar and the 
                    // query we ran is now stale because global_calendar_start_int was changed.
                    // We should just abandon what we are working on it this case since the new
                    // calendar view will execute and load its own data.
                    printDebug('Abandoning in RenderCalendarFromLocalDatabase because of a perceived global_calendar_start_int shift ' + rec_date_int);
                    calendar_days_len = -1;
                    suspend_scrolling(false, 0);
                    break;
                }
                interp_avail[rec_date_int] = 1;
                // Color the date
                if (global_CalShadeFert == 0)
                {
                    // Traditional Mode that shows Mens and Ov dates only
                    if (results.rows.item(i).color != "")
                    {
                        document.getElementById('CalendarDate_' + (rec_date_int+1)).style.backgroundColor = GetCalendarColor(results.rows.item(i).color);
                    }
                }
                else
                {
                    // Alternate mode that shows fertility percentages
                    if (((BUILD_TARGET == BUILD_4_CCL) && (results.rows.item(i).color == "m")) && (results.rows.item(i).fpct_all < 100))
                    {
                        // CCL to show future mens
                        document.getElementById('CalendarDate_' + (rec_date_int+1)).style.backgroundColor = '#FF80FF';
                    }
                    else if ((BUILD_TARGET != BUILD_4_CCL) && ((results.rows.item(i).color == "M") || (results.rows.item(i).color == "m")))
                    {
                        // Mens is always highlighted
                        document.getElementById('CalendarDate_' + (rec_date_int+1)).style.backgroundColor = GetCalendarColor(results.rows.item(i).color);
                    }
                    else if (results.rows.item(i).color == "P")
                    {
                        // Pregnancy 
                        if (BUILD_TARGET == BUILD_4_CCL)
                        {
                            document.getElementById('CalendarDate_' + (rec_date_int+1)).style.backgroundColor = '#9FB0EE';
                        }
                        else
                        {
                            document.getElementById('CalendarDate_' + (rec_date_int+1)).style.backgroundColor = '#FFFF60';
                        }
                    }
                    else
                    {
                        if (results.rows.item(i).fpct_all != -1)
                        {  
                            // Shade the fertility percentage
                            applyShadingToDiv('CalendarDate_' + (rec_date_int+1), results.rows.item(i).fpct_all);
                        }
                        else
                        {
                            if ((recorded_data[rec_date_int] != 0) && (BUILD_TARGET != BUILD_4_CCL))
                            {
                                // They recorded data, but we don't have a fertility percentage from the server yet
                                document.getElementById('CalendarDate_' + (rec_date_int+1)).style.backgroundColor = UNKNOWN_FPCT_COLOR;
                            }
                            else
                            {
                                // Just color as empty
                                applyShadingToDiv('CalendarDate_' + (rec_date_int+1), 0);
                            }
                        }
                    }
                }
                // Highlight ovulation 
                if (global_CalOv != 0)
                {
                    switch (results.rows.item(i).all_ov)
                    {
                    case 0:
                    default:
                        // Not an ovulation
                        break;
                    case 1:
                        // Auto-calculated ovulation
                        document.getElementById('CalendarDateTest_' + (rec_date_int+1)).innerHTML = '<img src="images/ovulation.png" width="13" height="13">';
                        break;
                    case 2:
                        // Manually specified ovulation
                        document.getElementById('CalendarDateTest_' + (rec_date_int+1)).innerHTML = '<img src="images/ovulation_m.png" width="13" height="13">';
                        break;
                    case 3:
                        // Speculative rhythm/calendar method date
                        document.getElementById('CalendarDateTest_' + (rec_date_int+1)).innerHTML = '<img src="images/ovulation_q.png" width="13" height="13">';
                        break;
                    }
                }
                if (BUILD_TARGET == BUILD_4_CCL)
                {
                    // Show ov
                    //if (results.rows.item(i).color == "o")
                    //{
                    //    document.getElementById('CalendarDateTest_' + (rec_date_int+1)).innerHTML = '<img src="images/ovulation.png" width="13" height="13">';
                    //}
                    // Italic for future mens
                    if (results.rows.item(i).color == "m")
                    {
                        document.getElementById('CalendarDateDay_' + (i+1)).style.fontStyle='italic';
                        document.getElementById('CalendarDateDay_' + (i+1)).style.textShadow='2px 2px #FFFFFF';
                        document.getElementById('CalendarDateDay_' + (i+1)).style.fontSize='28px';
                    }
                }
                
                // Display the Recommended Ovulation Test indicator
                //if (results.rows.item(i).rec_test != 0)
                //{
                //    document.getElementById('CalendarDateTest_' + (rec_date_int+1)).innerHTML = '<img src="images/ov_test.png" width="13" height="13">';
                //}

                // Note cycle or preg day
                if (results.rows.item(i).preg_cnt > 0)
                {
                    var POSTPARTUM_OFFSET=320;
                    var pcnt = results.rows.item(i).preg_cnt;
                    if (pcnt >= POSTPARTUM_OFFSET)
                    {
                        var pp_date;
                        pcnt = pcnt - POSTPARTUM_OFFSET + 1;
                        if (pcnt == 1)
                        {
                            pp_date = 0;
                        }
                        else
                        {
                            pp_date = (parseInt((pcnt-2)/7)+1);
                        }
                        cd_num[i] = 'w' + pp_date;
                        if (todays_date_i == rec_date_int)
                        {
                            var preg_str;
                            document.getElementById('divCal_PregStatus').style.display = 'block';
                            preg_str = 'This is Postpartum Week #' + pp_date + ' (as of today ' + PrintDate(todays_date) + ')';
                            document.getElementById('divCal_PregStatus').innerHTML = preg_str;
                        }
                    }
                    else
                    {
                        pcnt = pcnt + 1;
                        cd_num[i] = 'w' + (parseInt((pcnt-2)/7)+1);
                        if (todays_date_i == rec_date_int)
                        {
                            var preg_str;
                            var week;
                            document.getElementById('divCal_PregStatus').style.display = 'block';
                            week = (parseInt((pcnt-2)/7)+1);
                            preg_str = '<u>Today is ' + PrintDate(todays_date);
                            preg_str += '</u><br>This is <i>week #' + week + '</i> of your pregnancy.';
                            preg_str += '<br>You have been pregnant for ' + parseInt((pcnt-1)/7) + ' week(s) and ' + ((pcnt-1) % 7) + ' day(s)<br>';
                            preg_str = getPregInfo(week, preg_str);
                            document.getElementById('divCal_PregStatus').innerHTML = preg_str;
                        }
                    }
                }
                else
                {
                    var db_cd = results.rows.item(i).cd;
                    if (db_cd > 0)
                    {
                        cd_num[i] = db_cd;
                    }
                }                
            }
            var check_size = 6;
            if (global_last_screen_width > 400)
            {
                check_size = 13;
            }
            // Loop through other parameters set during prior calls
            for (var i=0; i<calendar_days_len; i++)
            {
                var recorded_img = '';
                
                // Records with recorded data
                if (recorded_data[i] != 0)
                {   
                    if (BUILD_TARGET != BUILD_4_CCL)
                    {
                        recorded_img = '<img src="images/data.png" width=' + check_size + ' height=' + check_size + '>';
                    }
                    // If we recorded data, but don't have analysis info from the server, then gray that box to indicate uncertainty
                    if ((interp_avail[i] == 0) && (global_CalShadeFert != 0))
                    {
                        // They recorded data, but we don't have a fertility percentage from the server yet
                        document.getElementById('CalendarDate_' + (i+1)).style.backgroundColor = UNKNOWN_FPCT_COLOR;
                    }
                }
                // Print cycle day if available
                if (cd_num[i] != 0)
                {
                    document.getElementById('CalendarDateData_' + (i+1)).innerHTML = recorded_img + '(' + cd_num[i] + ')';
                }
                // Menstruation dates (that may not have been returned from server with its "interpretted" color
                if (mens_days[i] != 0)
                {
                    if (BUILD_TARGET == BUILD_4_CCL)
                    {
                        // For CCL, "mens" means the first day of a cycle
                        document.getElementById('CalendarDateDay_' + (i+1)).style.fontStyle='italic';
                        document.getElementById('CalendarDateDay_' + (i+1)).style.textShadow='2px 2px #FFFFFF';
                        document.getElementById('CalendarDateDay_' + (i+1)).style.fontSize='28px';
                    }
                    else
                    {
                        document.getElementById('CalendarDate_' + (i+1)).style.backgroundColor = COLOR_RGB_MENS;
                    }
                }
                else if (document.getElementById('invisMensColor').style.backgroundColor == document.getElementById('CalendarDate_' + (i+1)).style.backgroundColor)
                {
                    // Makes sure that un-recorded menstruations are cleared and not left colored until the server gets around to responding
                    if (BUILD_TARGET == BUILD_4_CCL)
                    {
                        // For CCL, "mens" means the first day of a cycle
                        document.getElementById('CalendarDateDay_' + (i+1)).style.fontStyle='normal';
                        document.getElementById('CalendarDateDay_' + (i+1)).style.textShadow='none';
                        document.getElementById('CalendarDateDay_' + (i+1)).style.fontSize='20px';
                    }
                    else
                    {
                        document.getElementById('CalendarDate_' + (i+1)).style.backgroundColor = COLOR_RGB_NOTHING;
                    }                 
                }
                
                // Save calendar colors for retrieval when recolored for a write (Calendar Cell Selection Feedback)
                document.getElementById('CalendarCell_' + (i+1)).style.backgroundColor = document.getElementById('CalendarDate_' + (i+1)).style.backgroundColor;
            }
            
            // Enable scrolling again
            suspend_scrolling(false, 0);
            
            // Execute callback
            callback(tx);
            break;
        
        default:
            // Should not happen
            printDebug('Error - RenderCalendarFromLocalDatabase State Machine calling default');
            printInfoMessage('Invalid FSM state in RenderLocal: ' + state);
        }
    }    
        
       
    function UploadSyncToServer(state, callback, param_1, param_2, param_3)
    {       
        var tx = param_1;
        var results = param_2;
        var newContent = param_2;
        var strSql = ''; 
        
        // Declare constants
        const NO_CHANGE=0;
        const CHANGED=1;
        const PENDING_UPDATE=2;
        
        // Declare database fields (all that have corresponding _chg flags and need checked - assumes xxyyzz has an xxyyzz_chg field that is 0 or 1)
        var DataRecsDB_FieldObj = new Array();
        DataRecsDB_FieldObj[0] = dbDataDBField_Mens;
        DataRecsDB_FieldObj[1] = dbDataDBField_Temp;
        DataRecsDB_FieldObj[2] = dbDataDBField_Unsure;
        DataRecsDB_FieldObj[3] = dbDataDBField_Discard;
        DataRecsDB_FieldObj[4] = dbDataDBField_Monitor;
        DataRecsDB_FieldObj[5] = dbDataDBField_OvTestAm;
        DataRecsDB_FieldObj[6] = dbDataDBField_OvTestPm;
        DataRecsDB_FieldObj[7] = dbDataDBField_INotes;
        DataRecsDB_FieldObj[8] = dbDataDBField_PNotes;
        DataRecsDB_FieldObj[9] = dbDataDBField_TNotes;
        DataRecsDB_FieldObj[10] = dbDataDBField_Events_1;
        DataRecsDB_FieldObj[11] = dbDataDBField_Events_2;
        DataRecsDB_FieldObj[12] = dbDataDBField_Events_3;
        DataRecsDB_FieldObj[13] = dbDataDBField_Events_4;
        DataRecsDB_FieldObj[14] = dbDataDBField_Weight;
        DataRecsDB_FieldObj[15] = dbDataDBField_Mucus;
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            DataRecsDB_FieldObj[16] = dbDataDBField_MFlow;
            DataRecsDB_FieldObj[17] = dbDataDBField_CervCons;
            DataRecsDB_FieldObj[18] = dbDataDBField_CervDia;
            DataRecsDB_FieldObj[19] = dbDataDBField_MucusSense;
            DataRecsDB_FieldObj[20] = dbDataDBField_MucusAcons;
            DataRecsDB_FieldObj[21] = dbDataDBField_IdTxtReq;
        }
        else
        {
            DataRecsDB_FieldObj[16] = dbDataDBField_Saliva;
            DataRecsDB_FieldObj[17] = dbDataDBField_Cervix;
        }

        var EvSetDB_FieldObj = new Array();
        EvSetDB_FieldObj[0] = dbEvSetDBField_EvName_1;
        EvSetDB_FieldObj[1] = dbEvSetDBField_EvName_2;
        EvSetDB_FieldObj[2] = dbEvSetDBField_EvName_3;
        EvSetDB_FieldObj[3] = dbEvSetDBField_EvName_4;
        EvSetDB_FieldObj[4] = dbEvSetDBField_EvName_5;
        EvSetDB_FieldObj[5] = dbEvSetDBField_EvName_6;
        EvSetDB_FieldObj[6] = dbEvSetDBField_EvName_7;
        EvSetDB_FieldObj[7] = dbEvSetDBField_EvName_8;
        EvSetDB_FieldObj[8] = dbEvSetDBField_EvName_9;
        EvSetDB_FieldObj[9] = dbEvSetDBField_EvName_10;
        EvSetDB_FieldObj[10] = dbEvSetDBField_EvName_11;
        EvSetDB_FieldObj[11] = dbEvSetDBField_EvName_12;
        EvSetDB_FieldObj[12] = dbEvSetDBField_EvName_13;
        EvSetDB_FieldObj[13] = dbEvSetDBField_EvName_14;
        EvSetDB_FieldObj[14] = dbEvSetDBField_EvName_15;
        EvSetDB_FieldObj[15] = dbEvSetDBField_EvName_16;
        EvSetDB_FieldObj[16] = dbEvSetDBField_EvName_17;
        EvSetDB_FieldObj[17] = dbEvSetDBField_EvName_18;
        EvSetDB_FieldObj[18] = dbEvSetDBField_EvName_19;
        EvSetDB_FieldObj[19] = dbEvSetDBField_EvName_20;
        
        var CyclesDB_FieldObj = new Array();
        CyclesDB_FieldObj[0] = dbCyclesBField_Anov;
        CyclesDB_FieldObj[1] = dbCyclesBField_AllOvManual;
        CyclesDB_FieldObj[2] = dbCyclesBField_AllOvType;
        CyclesDB_FieldObj[3] = dbCyclesBField_BbtMeth;
        CyclesDB_FieldObj[4] = dbCyclesBField_CmMeth;
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            CyclesDB_FieldObj[5] = dbCyclesBField_FweSt;
            CyclesDB_FieldObj[6] = dbCyclesBField_FwbSt;
            CyclesDB_FieldObj[7] = dbCyclesBField_CycNotes;
        }
        
        var PregDB_FieldObj = new Array();
        PregDB_FieldObj[0] = dbPregDBField_PregLen;
        PregDB_FieldObj[1] = dbPregDBField_PregStatus;
        
        var PART_1_START_STATE_2 = 2;
        var PART_1_EVAL_STATE_5 = 5;
        var PART_2_START_STATE_7 = 7;
        var PART_2_EVAL_STATE_10 = 10;
        var PART_3_START_STATE_12 = 12;
        var PART_3_EVAL_STATE_15 = 15;
        var PART_4_START_STATE_17 = 17;
        var PART_4_EVAL_STATE_20 = 20;
    
        // Callback State Machine
        var currTime = new Date();
        printDebug("State #" + state + " of UploadSyToServ " + appendTimeStamp(currTime));
        switch(state)
        {
        ///////////////////////////
        // PART 1 - DATA_RECS_DB //
        ///////////////////////////
        case 1: 
LogCall('q1');
            var last_read_dirty_prefix ;
            var appended_something;
            printStatus('Updating');

            ////////////////////////////////////////
            // First Parallel Path - Data_Recs_DB //
            ////////////////////////////////////////
            UploadSyncToServer_DataRecsDB = 0;
            
            // Search for flags marked CHG that need updated with remote server
            last_read_dirty_prefix = '';
            appended_something = false;
            strSql = 'SELECT * FROM Data_Recs_DB WHERE ';
            for (var i=0; i<DataRecsDB_FieldObj.length; i++)
            {
                // Only include in the query if we didn't already just deal with this one
                if (last_read_dirty_prefix != DataRecsDB_FieldObj[i].localDirtyDBName)
                {
                    if (appended_something == true)
                    {
                        strSql += ' OR ';
                    }
                    strSql += '(' + DataRecsDB_FieldObj[i].localDirtyDBName + '_chg != 0)';
                    strSql += ' OR (' + DataRecsDB_FieldObj[i].localDirtyDBName + '_pnd != 0)';
                    last_read_dirty_prefix = DataRecsDB_FieldObj[i].localDirtyDBName;
                    appended_something = true;
                }
            }
            strSql += ';';
            
            // Execute search
            var scroll_disable_id_1 = suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, scroll_disable_id_1);
                                UploadSyncToServer(PART_1_START_STATE_2, callback, tx, results, 0);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error synchronizing local DataRecs database with server.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            
            
            /////////////////////////////////////
            // Third Parallel Path - Cycles_DB //
            /////////////////////////////////////
            UploadSyncToServer_CyclesDB = 0;

            // Search for flags marked CHG that need updated with remote server
            last_read_dirty_prefix = '';
            appended_something = false;
            strSql = 'SELECT * FROM Cycles_DB WHERE ';
            for (var i=0; i<CyclesDB_FieldObj.length; i++)
            {
                // Only include in the query if we didn't already just deal with this one
                if (last_read_dirty_prefix != CyclesDB_FieldObj[i].localDirtyDBName)
                {
                    if (appended_something == true)
                    {
                        strSql += ' OR ';
                    }
                    strSql += '(' + CyclesDB_FieldObj[i].localDirtyDBName + '_chg != 0)';
                    strSql += ' OR (' + CyclesDB_FieldObj[i].localDirtyDBName + '_pnd != 0)';
                    last_read_dirty_prefix = CyclesDB_FieldObj[i].localDirtyDBName;
                    appended_something = true;
                }
            }
            strSql += ';';

            // Execute search
            var scroll_disable_id_3 = suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, scroll_disable_id_3);
                                UploadSyncToServer(PART_3_START_STATE_12, callback, tx, results, 0);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error synchronizing local Cycles database with server.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         ); 
            
            
            //////////////////////////////////////////////
            // Second Parallel Path - Event_Settings_DB //
            //////////////////////////////////////////////
            UploadSyncToServer_EventSettingsDB = 0;

            // Search for flags marked CHG that need updated with remote server
            last_read_dirty_prefix = '';
            appended_something = false;
            strSql = 'SELECT * FROM Event_Settings_DB WHERE ';
            for (var i=0; i<EvSetDB_FieldObj.length; i++)
            {
                // Only include in the query if we didn't already just deal with this one
                if (last_read_dirty_prefix != EvSetDB_FieldObj[i].localDirtyDBName)
                {
                    if (appended_something == true)
                    {
                        strSql += ' OR ';
                    }
                    strSql += '(' + EvSetDB_FieldObj[i].localDirtyDBName + '_chg != 0)';
                    strSql += ' OR (' + EvSetDB_FieldObj[i].localDirtyDBName + '_pnd != 0)';
                    last_read_dirty_prefix = EvSetDB_FieldObj[i].localDirtyDBName;
                    appended_something = true;
                }
            }
            strSql += ';';
            
            // Execute search
            var scroll_disable_id_2 = suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, scroll_disable_id_2);
                                UploadSyncToServer(PART_2_START_STATE_7, callback, tx, results, 0);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error synchronizing local EventSettings database with server.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
                         
            ////////////////////////////////////
            // Fourth Parallel Path - Preg_DB //
            ////////////////////////////////////
            UploadSyncToServer_PregDB = 0;

            // Search for flags marked CHG that need updated with remote server
            last_read_dirty_prefix = '';
            appended_something = false;
            strSql = 'SELECT * FROM Preg_DB WHERE ';
            for (var i=0; i<PregDB_FieldObj.length; i++)
            {
                // Only include in the query if we didn't already just deal with this one
                if (last_read_dirty_prefix != PregDB_FieldObj[i].localDirtyDBName)
                {
                    if (appended_something == true)
                    {
                        strSql += ' OR ';
                    }
                    strSql += '(' + PregDB_FieldObj[i].localDirtyDBName + '_chg != 0)';
                    strSql += ' OR (' + PregDB_FieldObj[i].localDirtyDBName + '_pnd != 0)';
                    last_read_dirty_prefix = PregDB_FieldObj[i].localDirtyDBName;
                    appended_something = true;
                }
            }
            strSql += ';';
            
            // Execute search
            var scroll_disable_id_4 = suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, scroll_disable_id_4);
                                UploadSyncToServer(PART_4_START_STATE_17, callback, tx, results, 0);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error synchronizing local EventSettings database with server.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
                         
            break;
        
        case PART_1_START_STATE_2:
LogCall('q2');
            // Retrieve results of query
            var rec_date_id;
            var rec_date = new Date();
            var len = results.rows.length;
            var first_to_upload = 0;
            var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
            var upload_date_counter = 1;
            var last_read_dirty_prefix = '';
            var last_read_chg = '';
            var last_read_pnd = '';
            var encoded_bits_to_upload = 0;

            // Loop through results
            for (var local_db_counter=0; local_db_counter<len; local_db_counter++)
            {
                rec_date_id = results.rows.item(local_db_counter)['record_date'];
                rec_date = NumberToDate(rec_date_id);
                first_to_upload = 0;
                strSql = '';
                last_read_dirty_prefix = '';
                // Loop through fields
                for (var i=0; i<DataRecsDB_FieldObj.length; i++)
                {
                    // Add to the SQL query if we are switching fields (relative to prior iteration of loop)
                    if ((last_read_dirty_prefix != DataRecsDB_FieldObj[i].localDirtyDBName) && (encoded_bits_to_upload != 0))
                    {
                        if (first_to_upload == 0)
                        {
                            first_to_upload = 1;
                            strSql += 'UPDATE Data_Recs_DB SET '; 
                        }
                        else
                        {
                            strSql += ', ';
                        }
                        strSql += last_read_dirty_prefix + '_pnd=' + encoded_bits_to_upload;
                        encoded_bits_to_upload = 0;
                    }

                    ///////////////////////////////////////
                    // SIMPLE CASE - ONE VALUE PER FIELD //
                    ///////////////////////////////////////
                    // First handle the simple case where there is only 1 value represented within the DB Field (the dirty bits could be encoded, but the field is not)
                    if (DataRecsDB_FieldObj[i].numberEncodedBits == 1)
                    {
                        // Only re-read database fields if necessary (because parsing SQLite responses is so slow)
                        if (last_read_dirty_prefix != DataRecsDB_FieldObj[i].localDirtyDBName)
                        {
                            last_read_dirty_prefix = DataRecsDB_FieldObj[i].localDirtyDBName;
                            last_read_chg = results.rows.item(local_db_counter)[DataRecsDB_FieldObj[i].localDirtyDBName + '_chg'];
                            last_read_pnd = results.rows.item(local_db_counter)[DataRecsDB_FieldObj[i].localDirtyDBName + '_pnd'];
                        }
                        // Check the database for the '_chg' and '_pnd' flag which each use encoded bits
                        if (((last_read_chg & Math.pow(2, DataRecsDB_FieldObj[i].localDBEncodedBitIndex)) != 0) || ((last_read_pnd & Math.pow(2, DataRecsDB_FieldObj[i].localDBEncodedBitIndex)) != 0)) 
                        {
                            // This value needs uploaded to the server.  Log it as a Name Value Pair to upload shortly
                            uploadParameters[DataRecsDB_FieldObj[i].localDBName + upload_date_counter] = ReplaceQuotes(results.rows.item(local_db_counter)[DataRecsDB_FieldObj[i].localDBName], 0);
                            encoded_bits_to_upload = encoded_bits_to_upload | Math.pow(2, DataRecsDB_FieldObj[i].localDBEncodedBitIndex);       
                        }
                    }
                    else
                    {
                        ///////////////////////////////////////////////////////
                        // ADVANCED CASE - MULTIPLE ENCODED VALUES PER FIELD //
                        ///////////////////////////////////////////////////////  
                        last_read_dirty_prefix = DataRecsDB_FieldObj[i].localDirtyDBName;
                        encoded_bits_to_upload = 0;
                        last_read_chg = results.rows.item(local_db_counter)[DataRecsDB_FieldObj[i].localDirtyDBName + '_chg'];
                        last_read_pnd = results.rows.item(local_db_counter)[DataRecsDB_FieldObj[i].localDirtyDBName + '_pnd'];
                        
                        // Loop through all encodings
                        for (var k=0; k<DataRecsDB_FieldObj[i].numberEncodedBits; k++)
                        {
                            // The database has a '_chg' and '_pnd' flag and they use encoded bits
                            if (((last_read_chg & Math.pow(2, k)) != 0) || ((last_read_pnd & Math.pow(2, k)) != 0)) 
                            {
                                // This value needs uploaded to the server.  
                                encoded_bits_to_upload = encoded_bits_to_upload | Math.pow(2, k);                         
                            } 
                        }
                        // Append values to SQL string and send to remote server if there is anything marked as allowed to change from above
                        if (encoded_bits_to_upload != 0) 
                        {     
                            // Upload value and indicate which bits should be considered
                            uploadParameters[DataRecsDB_FieldObj[i].localDBName + upload_date_counter] = results.rows.item(local_db_counter)[DataRecsDB_FieldObj[i].localDBName];
                            uploadParameters[DataRecsDB_FieldObj[i].localDBName + '_chg' + upload_date_counter] = encoded_bits_to_upload;
                            
                            // Build SQL string to mark bits as pending
                            if (first_to_upload == 0)
                            {
                                first_to_upload = 1;
                                strSql += 'UPDATE Data_Recs_DB SET '; 
                            }
                            else
                            {
                                strSql += ', ';
                            }
                            strSql += DataRecsDB_FieldObj[i].localDirtyDBName + '_pnd=(' + DataRecsDB_FieldObj[i].localDirtyDBName 
                            strSql += '_pnd | ' + encoded_bits_to_upload + ')';
                            first_to_upload = 1;
                            encoded_bits_to_upload = 0;
                        }
                    }
                }
                // Catch any final additions to the SQL query that were not appended yet
                if (encoded_bits_to_upload != 0)
                {
                    if (first_to_upload == 0)
                    {
                        first_to_upload = 1;
                        strSql += 'UPDATE Data_Recs_DB SET '; 
                    }
                    else
                    {
                        strSql += ', ';
                    }
                    strSql += last_read_dirty_prefix + '_pnd=' + encoded_bits_to_upload;
                    encoded_bits_to_upload = 0;
                }
                // Prepare upload and database update
                if (first_to_upload != 0)
                {
                    // There is something to upload here, so specify the date as a Name Value Pair and increment to the next record index for the next pass
                    uploadParameters['date' + upload_date_counter] = PrintDate(rec_date);
                    uploadParameters['local_id' + upload_date_counter] = rec_date_id;
                    upload_date_counter += 1;
                    // Finish the SQL string and execute it
                    strSql += ' WHERE record_date=' + rec_date_id + '; ';
                    var scroll_disable_id = suspend_scrolling(true, '');
                    tx.executeSql(  strSql, 
                                    [], 
                                    function(tx, results) 
                                    {
                                        suspend_scrolling(false, scroll_disable_id);
                                        successCB();
                                    },
                                    errorCB
                                 ); 
                }
            }
            
            // Upload values to the server if there are any to upload
            if (upload_date_counter > 1)
            {
                var url_str = global_server_prefix + 'apps_set_data.aspx?' + new Date().getTime();
                
                // Add additional Name Value Pairs to upload
                uploadParameters['un'] = global_username;
                uploadParameters['pw'] = global_password;
                uploadParameters['debug'] = global_Debug_Enabled;
                uploadParameters['app_ver'] = global_app_ver_str;
                uploadParameters['device_id'] = global_device_id_str;
                if (global_user_height_dirty == true)
                {
                    // Piggy back user height change to this sync attempt. Works assuming height is entered when a fdata rec is (e.g. enter height AND weight)
                    uploadParameters['uht'] = global_user_height;
                }

                // Use jQuery to upload the data to the server
                $.ajax({
                    type: 'POST',
                    // The URL of the request
                    url: url_str,
                    // Values to upload
                    data: uploadParameters,
                    // The success callback with result from server
                    success: function(newContent) {
                        // Handles response this function and advance to the next state.  Notice that the tx
                        // cannot be passed to this legitimately because it is not being created as a call
                        // to this registered function (it only has a newContent argument) because this 
                        // callback has nothing to do with databases.  Therefore we will have to re-establish
                        // the tx variable when we want to resume database operations.
                        UploadSyncToServer(state+1, callback, '', newContent, upload_date_counter-1);
                    },
                    dataType: 'html'
                });
                break;
            }
            else
            {
                // Skip states (using intentional fall through paths) because because no data needs uploaded...
                state = PART_1_EVAL_STATE_5;
            }
            // Intentional fall through for Else case
        
        case 3:
LogCall('q3');
            // Re-generate the tx variable so we can continue to perform database operations.  It was lost
            // in the prior state because the last callback into the state machine involved a remote server
            // transfer and not a local database access.  Therefore the local database parameter was not
            // carried forward and needs to be regenerated.
            if (state <= 3)
            {
                global_db_ios_fail_UploadSyncToServ_3 = DB_IOS_RETRY_LIMIT;
                db.transaction(     function(tx) 
                                    {
                                        global_db_ios_fail_UploadSyncToServ_3 = -1;
                                        UploadSyncToServer(state+1, callback, tx, param_2, param_3);
                                    },
                                    function(tx, err)
                                    {
                                        crash_and_burn(err, 'Could not open local database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                                    },
                                    function(tx)
                                    {
                                        // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                        if (global_db_ios_fail_UploadSyncToServ_3 > 0)
                                        {
                                            global_db_ios_fail_UploadSyncToServ_3 = global_db_ios_fail_UploadSyncToServ_3 - 1;
                                            printDebug('iOS db.transaction failed UploadSyncToServ state 3. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_UploadSyncToServ_3));
                                            UploadSyncToServer(state, callback, param_1, param_2, param_3);
                                        }
                                        else if (global_db_ios_fail_UploadSyncToServ_3 == 0)
                                        {
                                            printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                        }
                                        else
                                        {
                                            successCB();
                                        }
                                    }
                               );
                break;
            }
            // Intentional fall through for Else case
        
        case 4:
LogCall('q4');        
            var upload_count = param_3;
            var desiredStrStart=new Array();
            var desiredStrEnd=new Array();
            var respParamsStr=new Array();
            var ev_fdata_ok_Index;
            var preg_err_Index;
            var continue_execution;
                
            if (state <= 4)
            {
                var error_or_warning = CheckForStandardErrors(newContent);
                continue_execution = HandleServerErrorOrWarning(error_or_warning);
                if (continue_execution == 0)
                {
                    // Stop execution because of a fatal error
                    printDebug('Halting execution due to server returned error.');
                    printStatus('Server Offline?');
                    hideStatusSpinner();
                    break;
                }
                else
                {
                    global_user_height_dirty = false;
                }
            }
            if (state <= 4)
            {     
                // Prepare variables to extract from response
                for (var i=1; i<=upload_count; i++)
                {
                    desiredStrStart[desiredStrStart.length]='EV_FDATA_OK' + i + '=';
                    desiredStrEnd[desiredStrEnd.length]=" ";
                    desiredStrStart[desiredStrStart.length]='PREG_ERR' + i;
                    desiredStrEnd[desiredStrEnd.length]="";
                }
               
                // Parse the response to find the desired values
                respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);

                // Scan the responses
                var strSql_1_needs_executed = 0;
                var strSql_2_needs_executed = 0;
                var strSql_1 = '';
                var strSql_2 = 'UPDATE Data_Recs_DB SET mens=0 WHERE';
                for (var i=0; i<desiredStrStart.length; i++)
                {
                    // Look for success notifications
                    if ((desiredStrStart[i].search('EV_FDATA_OK') >= 0) && (respParamsStr[i] > 0))
                    {
                        last_read_dirty_prefix = '';
                        for (var j=0; j<DataRecsDB_FieldObj.length; j++)
                        {
                            // No need to update something twice if we just did so
                            if (last_read_dirty_prefix != DataRecsDB_FieldObj[j].localDirtyDBName)
                            {
                                // See if this is the very first thing appended to the string
                                if (strSql_1_needs_executed == 0)
                                {
                                    strSql_1 = 'UPDATE Data_Recs_DB SET ';
                                    strSql_1_needs_executed = 1;
                                }
                                else
                                {
                                    strSql_1 += ', ';
                                }
                                // Build a query to clear the applicable "_pnd" pending bits and mark them as no longer being "_chg" changed
                                strSql_1 += DataRecsDB_FieldObj[j].localDirtyDBName + '_chg=(' + DataRecsDB_FieldObj[j].localDirtyDBName + '_chg & ~(';
                                strSql_1 += DataRecsDB_FieldObj[j].localDirtyDBName + '_pnd))';
                                strSql_1 += ', ' + DataRecsDB_FieldObj[j].localDirtyDBName + '_pnd=0';
                                last_read_dirty_prefix = DataRecsDB_FieldObj[j].localDirtyDBName;
                            }
                        }
                        // Knock down pending/changed bits 
                        if (strSql_1_needs_executed != 0)
                        {
                            strSql_1 += ' WHERE record_date=' + respParamsStr[i] + ';';
                            var scroll_disable_id = suspend_scrolling(true, '');
                            tx.executeSql(  strSql_1, 
                                            [], 
                                            function(tx, results) 
                                            {
                                                suspend_scrolling(false, scroll_disable_id);
                                                successCB();
                                            },
                                            errorCB
                                         ); 
                            strSql_1_needs_executed = 0;
                        }
                    }
                    // Look for errors
                    if ((desiredStrStart[i].search('PREG_ERR') >= 0) && (respParamsStr[i] > 0))
                    {
                        if (strSql_2_needs_executed != 0)
                        {
                            strSql_2 += ' OR';
                        }
                        strSql_2 += ' (record_date=' + respParamsStr[i] + ')';
                        strSql_2_needs_executed = 1;
                    }
                }
                // Menstruations conflicted with pregnancy.  Report error and null it out in database
                if (strSql_2_needs_executed != 0)
                {
                    printInfoMessage('One or more recorded menstruations overlapped a pregnancy.  This is not allowed.  The menstruations were removed as a result.  Please login to you MyFertilityCharts.com account and adjust the pregnancy term if necessary to avoid the conflict in the future.');
                    strSql_2 += ';';
                    var scroll_disable_id = suspend_scrolling(true, '');
                    tx.executeSql(  strSql_2, 
                                    [], 
                                    function(tx, results) 
                                    {
                                        suspend_scrolling(false, scroll_disable_id);
                                        successCB();
                                    },
                                    errorCB
                                 ); 
                }
            }
            // Intentional fall through for all cases
            state = PART_1_EVAL_STATE_5;
       
        case PART_1_EVAL_STATE_5: 
LogCall('q5');
            // Mark that Part 1 is finished
            UploadSyncToServer_DataRecsDB = 1;
        
            // Check if all 4 parallel parts are complete.  If so, complete by executing the callback
            if ((UploadSyncToServer_DataRecsDB == 1) && (UploadSyncToServer_EventSettingsDB == 1) && (UploadSyncToServer_CyclesDB == 1) && (UploadSyncToServer_PregDB == 1))
            {
                // Indicate that this will take ownership of executing the callback.  Part 1 has highest priority, followed by Part 2 and part 3 respectively 
                UploadSyncToServer_DataRecsDB = 0;

                // Double check that another parallel task (of higher priority) didn't take ownership by clearing its flag.  We don't want to have more than
                // one parallel thread executing the callback.
                // NOTE: Part 1 always has priority and doesn't need to check for ties.  It always wins if there is a conflict (the later "parts" defer to it)
                
                // Timestamp callback
                var currTime = new Date();
                printDebug("State #" + state + " of UploadSyToServ parallelism done " + appendTimeStamp(currTime));
                
                // Return to caller by executing a callback now that this is complete
                callback(tx);
            }
            break;
        
        
        ////////////////////////////////
        // PART 2 - EVENT_SETTINGS_DB //
        ////////////////////////////////        
        case PART_2_START_STATE_7:
LogCall('q7');
            // Retrieve results of query
            var rec_date_id;
            var rec_date = new Date();
            var len = results.rows.length;
            var first_to_upload = 0;
            var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
            var upload_date_counter = 1;
            var upload_date_counter_NA = '';
            var last_read_dirty_prefix = '';
            var last_read_chg = '';
            var last_read_pnd = '';
            var encoded_bits_to_upload = 0;

            // Loop at result (there is only 1 row)
            if (len > 0)
            {
                var local_db_counter = 0;
                rec_id = results.rows.item(local_db_counter)['id'];
                first_to_upload = 0;
                strSql = '';
                last_read_dirty_prefix = '';
                // Loop through fields
                for (var i=0; i<EvSetDB_FieldObj.length; i++)
                {
                    // Add to the SQL query if we are switching fields (relative to prior iteration of loop)
                    if ((last_read_dirty_prefix != EvSetDB_FieldObj[i].localDirtyDBName) && (encoded_bits_to_upload != 0))
                    {
                        if (first_to_upload == 0)
                        {
                            first_to_upload = 1;
                            strSql += 'UPDATE Event_Settings_DB SET '; 
                        }
                        else
                        {
                            strSql += ', ';
                        }
                        strSql += last_read_dirty_prefix + '_pnd=' + encoded_bits_to_upload;
                        encoded_bits_to_upload = 0;
                    }

                    ///////////////////////////////////////
                    // SIMPLE CASE - ONE VALUE PER FIELD //
                    ///////////////////////////////////////
                    // First handle the simple case where there is only 1 value represented within the DB Field (the dirty bits could be encoded, but the field is not)
                    if (EvSetDB_FieldObj[i].numberEncodedBits == 1)
                    {
                        // Only re-read database fields if necessary (because parsing SQLite responses is so slow)
                        if (last_read_dirty_prefix != EvSetDB_FieldObj[i].localDirtyDBName)
                        {
                            last_read_dirty_prefix = EvSetDB_FieldObj[i].localDirtyDBName;
                            last_read_chg = results.rows.item(local_db_counter)[EvSetDB_FieldObj[i].localDirtyDBName + '_chg'];
                            last_read_pnd = results.rows.item(local_db_counter)[EvSetDB_FieldObj[i].localDirtyDBName + '_pnd'];
                        }
                        // Check the database for the '_chg' and '_pnd' flag which each use encoded bits
                        if (((last_read_chg & Math.pow(2, EvSetDB_FieldObj[i].localDBEncodedBitIndex)) != 0) || ((last_read_pnd & Math.pow(2, EvSetDB_FieldObj[i].localDBEncodedBitIndex)) != 0)) 
                        {
                            // This value needs uploaded to the server.  Log it as a Name Value Pair to upload shortly
                            uploadParameters[EvSetDB_FieldObj[i].localDBName + upload_date_counter_NA] = ReplaceQuotes(results.rows.item(local_db_counter)[EvSetDB_FieldObj[i].localDBName], 0);
                            encoded_bits_to_upload = encoded_bits_to_upload | Math.pow(2, EvSetDB_FieldObj[i].localDBEncodedBitIndex);                         
                        }
                    }
                    else
                    {
                        ///////////////////////////////////////////////////////
                        // ADVANCED CASE - MULTIPLE ENCODED VALUES PER FIELD //
                        ///////////////////////////////////////////////////////  
                        last_read_dirty_prefix = EvSetDB_FieldObj[i].localDirtyDBName;
                        encoded_bits_to_upload = 0;
                        last_read_chg = results.rows.item(local_db_counter)[EvSetDB_FieldObj[i].localDirtyDBName + '_chg'];
                        last_read_pnd = results.rows.item(local_db_counter)[EvSetDB_FieldObj[i].localDirtyDBName + '_pnd'];
                        
                        // Loop through all encodings
                        for (var k=0; k<EvSetDB_FieldObj[i].numberEncodedBits; k++)
                        {
                            // The database has a '_chg' and '_pnd' flag and they use encoded bits
                            if (((last_read_chg & Math.pow(2, k)) != 0) || ((last_read_pnd & Math.pow(2, k)) != 0)) 
                            {
                                // This value needs uploaded to the server.  
                                encoded_bits_to_upload = encoded_bits_to_upload | Math.pow(2, k);                         
                            } 
                        }
                        // Append values to SQL string and send to remote server if there is anything marked as allowed to change from above
                        if (encoded_bits_to_upload != 0) 
                        {     
                            // Upload value and indicate which bits should be considered
                            uploadParameters[EvSetDB_FieldObj[i].localDBName + upload_date_counter_NA] = results.rows.item(local_db_counter)[EvSetDB_FieldObj[i].localDBName];
                            uploadParameters[EvSetDB_FieldObj[i].localDBName + '_chg' + upload_date_counter_NA] = encoded_bits_to_upload;
                            
                            // Build SQL string to mark bits as pending
                            if (first_to_upload == 0)
                            {
                                first_to_upload = 1;
                                strSql += 'UPDATE Event_Settings_DB SET '; 
                            }
                            else
                            {
                                strSql += ', ';
                            }
                            strSql += EvSetDB_FieldObj[i].localDirtyDBName + '_pnd=(' + EvSetDB_FieldObj[i].localDirtyDBName 
                            strSql += '_pnd | ' + encoded_bits_to_upload + ')';
                            first_to_upload = 1;
                            encoded_bits_to_upload = 0;
                        }
                    }
                }
                // Catch any final additions to the SQL query that were not appended yet
                if (encoded_bits_to_upload != 0)
                {
                    if (first_to_upload == 0)
                    {
                        first_to_upload = 1;
                        strSql += 'UPDATE Event_Settings_DB SET '; 
                    }
                    else
                    {
                        strSql += ', ';
                    }
                    strSql += last_read_dirty_prefix + '_pnd=' + encoded_bits_to_upload;
                    encoded_bits_to_upload = 0;
                }
                // Prepare upload and database update
                if (first_to_upload != 0)
                {
                    // There is something to upload here, but nothing addition we need to specify as a Name Value Pair
                    upload_date_counter += 1;
                    // Finish the SQL string and execute it
                    strSql += ' WHERE id=' + rec_id + '; ';
                    var scroll_disable_id = suspend_scrolling(true, '');
                    tx.executeSql(  strSql, 
                                    [], 
                                    function(tx, results) 
                                    {
                                        suspend_scrolling(false, scroll_disable_id);
                                        successCB();
                                    },
                                    errorCB
                                 ); 
                }
            }
            
            // Upload values to the server if there are any to upload
            if (upload_date_counter > 1)
            {
                var url_str = global_server_prefix + 'apps_set_data.aspx?' + new Date().getTime();
                
                // Add additional Name Value Pairs to upload
                uploadParameters['un'] = global_username;
                uploadParameters['pw'] = global_password;
                uploadParameters['debug'] = global_Debug_Enabled;
                uploadParameters['app_ver'] = global_app_ver_str;
                uploadParameters['device_id'] = global_device_id_str;
   
                // Use jQuery to upload the data to the server
                $.ajax({
                    type: 'POST',
                    // The URL of the request
                    url: url_str,
                    // Values to upload
                    data: uploadParameters,
                    // The success callback with result from server
                    success: function(newContent) {
                        // Handles response this function and advance to the next state.  Notice that the tx
                        // cannot be passed to this legitimately because it is not being created as a call
                        // to this registered function (it only has a newContent argument) because this 
                        // callback has nothing to do with databases.  Therefore we will have to re-establish
                        // the tx variable when we want to resume database operations.
                        UploadSyncToServer(state+1, callback, '', newContent, upload_date_counter-1);
                    },
                    dataType: 'html'
                });
                break;
            }
            else
            {
                // Skip states (using intentional fall through paths) because because no data needs uploaded...
                state = PART_2_EVAL_STATE_10;
            }
            // Intentional fall through for Else case

        case 8:
LogCall('q8');
            // Re-generate the tx variable so we can continue to perform database operations.  It was lost
            // in the prior state because the last callback into the state machine involved a remote server
            // transfer and not a local database access.  Therefore the local database parameter was not
            // carried forward and needs to be regenerated.
            if (state <= 8)
            {
                global_db_ios_fail_UploadSyncToServ_8 = DB_IOS_RETRY_LIMIT;
                db.transaction(     function(tx) 
                                    {
                                        global_db_ios_fail_UploadSyncToServ_8 = -1;
                                        UploadSyncToServer(state+1, callback, tx, param_2, param_3);
                                    },
                                    function(tx, err)
                                    {
                                        crash_and_burn(err, 'Could not open local database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                                    },
                                    function(tx)
                                    {
                                        // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                        if (global_db_ios_fail_UploadSyncToServ_8 > 0)
                                        {
                                            global_db_ios_fail_UploadSyncToServ_8 = global_db_ios_fail_UploadSyncToServ_8 - 1;
                                            printDebug('iOS db.transaction failed UploadSyncToServ state 8. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_UploadSyncToServ_8));
                                            UploadSyncToServer(state, callback, param_1, param_2, param_3);
                                        }
                                        else if (global_db_ios_fail_UploadSyncToServ_8 == 0)
                                        {
                                            printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                        }
                                        else
                                        {
                                            successCB();
                                        }
                                    }
                               );
                break;
            }
            // Intentional fall through for Else case
        
        case 9: 
LogCall('q9');        
            var upload_count = param_3;
            var desiredStrStart=new Array();
            var desiredStrEnd=new Array();
            var respParamsStr=new Array();
            var ev_fdata_ok_Index;
            var continue_execution = 0;
                
            if (state <= 9)
            {
                var error_or_warning = CheckForStandardErrors(newContent);
                continue_execution = HandleServerErrorOrWarning(error_or_warning);
                if (continue_execution == 0)
                {
                    // Stop execution because of a fatal error
                    printDebug('Halting execution due to server returned error.');
                    printStatus('Server Offline?');
                    hideStatusSpinner();
                    break;
                }
            }
            if (state <= 9)
            {    
                // Prepare variables to extract from response
                desiredStrStart[0]="CUST_EVENT_NAMES_OK";
                desiredStrEnd[0]="";
                               
                // Parse the response to find the desired values
                respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
                
                // Scan the responses
                var strSql_1_needs_executed = 0;
                var strSql_1 = '';
                for (var i=0; i<desiredStrStart.length; i++)
                {
                    // Look for success notifications
                    if ((desiredStrStart[i].search('CUST_EVENT_NAMES_OK') >= 0) && (respParamsStr[i] > 0))
                    {
                        last_read_dirty_prefix = '';
                        for (var j=0; j<EvSetDB_FieldObj.length; j++)
                        {
                            // No need to update something twice if we just did so
                            if (last_read_dirty_prefix != EvSetDB_FieldObj[j].localDirtyDBName)
                            {
                                // See if this is the very first thing appended to the string
                                if (strSql_1_needs_executed == 0)
                                {
                                    strSql_1 = 'UPDATE Event_Settings_DB SET ';
                                    strSql_1_needs_executed = 1;
                                }
                                else
                                {
                                    strSql_1 += ', ';
                                }
                                // Build a query to clear the applicable "_pnd" pending bits and mark them as no longer being "_chg" changed
                                strSql_1 += EvSetDB_FieldObj[j].localDirtyDBName + '_chg=(' + EvSetDB_FieldObj[j].localDirtyDBName + '_chg & ~(';
                                strSql_1 += EvSetDB_FieldObj[j].localDirtyDBName + '_pnd))';
                                strSql_1 += ', ' + EvSetDB_FieldObj[j].localDirtyDBName + '_pnd=0';
                                last_read_dirty_prefix = EvSetDB_FieldObj[j].localDirtyDBName;
                            }
                        }
                        // Knock down pending/changed bits 
                        if (strSql_1_needs_executed != 0)
                        {
                            strSql_1 += ' WHERE 1';  // there is only 1 row in this database
                            var scroll_disable_id = suspend_scrolling(true, '');
                            tx.executeSql(  strSql_1, 
                                            [], 
                                            function(tx, results) 
                                            {
                                                suspend_scrolling(false, scroll_disable_id);
                                                successCB();
                                            },
                                            errorCB
                                         ); 
                            strSql_1_needs_executed = 0;
                        }
                    }
                }
            }
            // Intentional fall through for all cases
            state = PART_2_EVAL_STATE_10;
       
        case PART_2_EVAL_STATE_10: 
LogCall('qa');
            // Mark that Part 2 is finished
            UploadSyncToServer_EventSettingsDB = 1;
        
            // Check if all 4 parallel parts are complete.  If so, complete by executing the callback
            if ((UploadSyncToServer_DataRecsDB == 1) && (UploadSyncToServer_EventSettingsDB == 1) && (UploadSyncToServer_CyclesDB == 1) && (UploadSyncToServer_PregDB == 1))
            {
                // Indicate that this will take ownership of executing the callback.  Part 1 has highest priority, followed by Part 2 and part 3 respectively
                UploadSyncToServer_EventSettingsDB = 0;
                
                // Delay for a moment and check again that a higher priority parallel path didn't already declare ownership of doing the callback
                for (var x=0; x<5; x++)
                {
                    var i=x+2;
                }
                
                // Double check that another parallel task (of higher priority) didn't take ownership by clearing its flag.  We don't want to have more than
                // one parallel thread executing the callback.
                if (UploadSyncToServer_DataRecsDB == 1)
                {
                    // Timestamp callback
                    var currTime = new Date();
                    printDebug("State #" + state + " of UploadSyToServ parallelism done " + appendTimeStamp(currTime));
                
                    // Return to caller by executing a callback now that this is complete
                    callback(tx);
                }              
            }
            break;

            
        //////////////////////////////////
        // PART 3 - CyclesDB_FieldObj //
        //////////////////////////////////
        case PART_3_START_STATE_12:
LogCall('qc');
            // Retrieve results of query
            var rec_date_id;
            var rec_date = new Date();
            var len = results.rows.length;
            var first_to_upload = 0;
            var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
            var upload_date_counter = 1;
            var last_read_dirty_prefix = '';
            var last_read_chg = '';
            var last_read_pnd = '';
            var encoded_bits_to_upload = 0;
            
            // Loop through results
            for (var local_db_counter=0; local_db_counter<len; local_db_counter++)
            {
                rec_date_id = results.rows.item(local_db_counter)['cyc_started'];
                rec_date = NumberToDate(rec_date_id);
                first_to_upload = 0;
                strSql = '';
                last_read_dirty_prefix = '';
                // Loop through fields
                for (var i=0; i<CyclesDB_FieldObj.length; i++)
                {
                    // Add to the SQL query if we are switching fields (relative to prior iteration of loop)
                    if ((last_read_dirty_prefix != CyclesDB_FieldObj[i].localDirtyDBName) && (encoded_bits_to_upload != 0))
                    {
                        if (first_to_upload == 0)
                        {
                            first_to_upload = 1;
                            strSql += 'UPDATE Cycles_DB SET '; 
                        }
                        else
                        {
                            strSql += ', ';
                        }
                        strSql += last_read_dirty_prefix + '_pnd=' + encoded_bits_to_upload;
                        encoded_bits_to_upload = 0;
                    }

                    ///////////////////////////////////////
                    // SIMPLE CASE - ONE VALUE PER FIELD //
                    ///////////////////////////////////////
                    // First handle the simple case where there is only 1 value represented within the DB Field (the dirty bits could be encoded, but the field is not)
                    if (CyclesDB_FieldObj[i].numberEncodedBits == 1)
                    {
                        // Only re-read database fields if necessary (because parsing SQLite responses is so slow)
                        if (last_read_dirty_prefix != CyclesDB_FieldObj[i].localDirtyDBName)
                        {
                            last_read_dirty_prefix = CyclesDB_FieldObj[i].localDirtyDBName;
                            last_read_chg = results.rows.item(local_db_counter)[CyclesDB_FieldObj[i].localDirtyDBName + '_chg'];
                            last_read_pnd = results.rows.item(local_db_counter)[CyclesDB_FieldObj[i].localDirtyDBName + '_pnd'];
                        }
                        // Check the database for the '_chg' and '_pnd' flag which each use encoded bits
                        if (((last_read_chg & Math.pow(2, CyclesDB_FieldObj[i].localDBEncodedBitIndex)) != 0) || ((last_read_pnd & Math.pow(2, CyclesDB_FieldObj[i].localDBEncodedBitIndex)) != 0)) 
                        {
                            // This value needs uploaded to the server.  Log it as a Name Value Pair to upload shortly
                            uploadParameters[CyclesDB_FieldObj[i].localDBName + upload_date_counter] = ReplaceQuotes(results.rows.item(local_db_counter)[CyclesDB_FieldObj[i].localDBName], 0);
                            encoded_bits_to_upload = encoded_bits_to_upload | Math.pow(2, CyclesDB_FieldObj[i].localDBEncodedBitIndex);                         
                        }
                    }
                    else
                    {
                        ///////////////////////////////////////////////////////
                        // ADVANCED CASE - MULTIPLE ENCODED VALUES PER FIELD //
                        ///////////////////////////////////////////////////////  
                        last_read_dirty_prefix = CyclesDB_FieldObj[i].localDirtyDBName;
                        encoded_bits_to_upload = 0;
                        last_read_chg = results.rows.item(local_db_counter)[CyclesDB_FieldObj[i].localDirtyDBName + '_chg'];
                        last_read_pnd = results.rows.item(local_db_counter)[CyclesDB_FieldObj[i].localDirtyDBName + '_pnd'];
                        
                        // Loop through all encodings
                        for (var k=0; k<CyclesDB_FieldObj[i].numberEncodedBits; k++)
                        {
                            // The database has a '_chg' and '_pnd' flag and they use encoded bits
                            if (((last_read_chg & Math.pow(2, k)) != 0) || ((last_read_pnd & Math.pow(2, k)) != 0)) 
                            {
                                // This value needs uploaded to the server.  
                                encoded_bits_to_upload = encoded_bits_to_upload | Math.pow(2, k);                         
                            } 
                        }
                        // Append values to SQL string and send to remote server if there is anything marked as allowed to change from above
                        if (encoded_bits_to_upload != 0) 
                        {     
                            // Upload value and indicate which bits should be considered
                            uploadParameters[CyclesDB_FieldObj[i].localDBName + upload_date_counter] = results.rows.item(local_db_counter)[CyclesDB_FieldObj[i].localDBName];
                            uploadParameters[CyclesDB_FieldObj[i].localDBName + '_chg' + upload_date_counter] = encoded_bits_to_upload;
                            
                            // Build SQL string to mark bits as pending
                            if (first_to_upload == 0)
                            {
                                first_to_upload = 1;
                                strSql += 'UPDATE Cycles_DB SET '; 
                            }
                            else
                            {
                                strSql += ', ';
                            }
                            strSql += CyclesDB_FieldObj[i].localDirtyDBName + '_pnd=(' + CyclesDB_FieldObj[i].localDirtyDBName 
                            strSql += '_pnd | ' + encoded_bits_to_upload + ')';
                            first_to_upload = 1;
                            encoded_bits_to_upload = 0;
                        }
                    }
                }
                // Catch any final additions to the SQL query that were not appended yet
                if (encoded_bits_to_upload != 0)
                {
                    if (first_to_upload == 0)
                    {
                        first_to_upload = 1;
                        strSql += 'UPDATE Cycles_DB SET '; 
                    }
                    else
                    {
                        strSql += ', ';
                    }
                    strSql += last_read_dirty_prefix + '_pnd=' + encoded_bits_to_upload;
                    encoded_bits_to_upload = 0;
                }
                // Prepare upload and database update
                if (first_to_upload != 0)
                {
                    // There is something to upload here, so specify the date as a Name Value Pair and increment to the next record index for the next pass
                    uploadParameters['cyc_started' + upload_date_counter] = PrintDate(rec_date);
                    uploadParameters['local_cid' + upload_date_counter] = rec_date_id;
                    upload_date_counter += 1;
                    // Finish the SQL string and execute it
                    strSql += ' WHERE cyc_started=' + rec_date_id + '; ';
                    var scroll_disable_id = suspend_scrolling(true, '');
                    tx.executeSql(  strSql, 
                                    [], 
                                    function(tx, results) 
                                    {
                                        suspend_scrolling(false, scroll_disable_id);
                                        successCB();
                                    },
                                    errorCB
                                 ); 
                }
            }
            // Upload values to the server if there are any to upload
            if (upload_date_counter > 1)
            {
                var url_str = global_server_prefix + 'apps_set_data.aspx?' + new Date().getTime();
                
                // Add additional Name Value Pairs to upload
                uploadParameters['un'] = global_username;
                uploadParameters['pw'] = global_password;
                uploadParameters['debug'] = global_Debug_Enabled;
                uploadParameters['app_ver'] = global_app_ver_str;
                uploadParameters['device_id'] = global_device_id_str;
   
                // Use jQuery to upload the data to the server
                $.ajax({
                    type: 'POST',
                    // The URL of the request
                    url: url_str,
                    // Values to upload
                    data: uploadParameters,
                    // The success callback with result from server
                    success: function(newContent) {
                        // Handles response this function and advance to the next state.  Notice that the tx
                        // cannot be passed to this legitimately because it is not being created as a call
                        // to this registered function (it only has a newContent argument) because this 
                        // callback has nothing to do with databases.  Therefore we will have to re-establish
                        // the tx variable when we want to resume database operations.
                        UploadSyncToServer(state+1, callback, '', newContent, upload_date_counter-1);
                    },
                    dataType: 'html'
                });
                break;
            }
            else
            {
                // Skip states (using intentional fall through paths) because because no data needs uploaded...
                state = PART_3_EVAL_STATE_15;
            }
            // Intentional fall through for Else case

        case 13:
LogCall('qd');
            // Re-generate the tx variable so we can continue to perform database operations.  It was lost
            // in the prior state because the last callback into the state machine involved a remote server
            // transfer and not a local database access.  Therefore the local database parameter was not
            // carried forward and needs to be regenerated.
            if (state <= 13)
            {
                global_db_ios_fail_UploadSyncToServ_13 = DB_IOS_RETRY_LIMIT;
                db.transaction(     function(tx) 
                                    {
                                        global_db_ios_fail_UploadSyncToServ_13 = -1;
                                        UploadSyncToServer(state+1, callback, tx, param_2, param_3);
                                    },
                                    function(tx, err)
                                    {
                                        crash_and_burn(err, 'Could not open local database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                                    },
                                    function(tx)
                                    {
                                        // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                        if (global_db_ios_fail_UploadSyncToServ_13 > 0)
                                        {
                                            global_db_ios_fail_UploadSyncToServ_13 = global_db_ios_fail_UploadSyncToServ_13 - 1;
                                            printDebug('iOS db.transaction failed UploadSyncToServ state 13. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_UploadSyncToServ_13));
                                            UploadSyncToServer(state, callback, param_1, param_2, param_3);
                                        }
                                        else if (global_db_ios_fail_UploadSyncToServ_13 == 0)
                                        {
                                            printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                        }
                                        else
                                        {
                                            successCB();
                                        }
                                    }
                               );
                break;
            }
            // Intentional fall through for Else case
        
        case 14:  
LogCall('qe');        
            var upload_count = param_3;
            var desiredStrStart=new Array();
            var desiredStrEnd=new Array();
            var respParamsStr=new Array();
            var ev_fdata_ok_Index;
            var preg_err_Index;
            var continue_execution = 0;
                
            if (state <= 14)
            {
                var error_or_warning = CheckForStandardErrors(newContent);
                continue_execution = HandleServerErrorOrWarning(error_or_warning);
                if (continue_execution == 0)
                {
                    // Stop execution because of a fatal error
                    printDebug('Halting execution due to server returned error.');
                    printStatus('Server Offline?');
                    hideStatusSpinner();
                    break;
                }
            }
            if (state <= 14) 
            {    
                // Prepare variables to extract from response
                for (var i=1; i<=upload_count; i++)
                {
                    desiredStrStart[desiredStrStart.length]='CYCLES_UPDATED' + i + '=';
                    desiredStrEnd[desiredStrEnd.length]=" ";
                }
               
                // Parse the response to find the desired values
                respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
                
                // Scan the responses
                var strSql_1_needs_executed = 0;
                var strSql_1 = '';
                for (var i=0; i<desiredStrStart.length; i++)
                {
                    // Look for success notifications
                    if ((desiredStrStart[i].search('CYCLES_UPDATED') >= 0) && (respParamsStr[i] > 0))
                    {
                        last_read_dirty_prefix = '';
                        for (var j=0; j<CyclesDB_FieldObj.length; j++)
                        {
                            // No need to update something twice if we just did so
                            if (last_read_dirty_prefix != CyclesDB_FieldObj[j].localDirtyDBName)
                            {
                                // See if this is the very first thing appended to the string
                                if (strSql_1_needs_executed == 0)
                                {
                                    strSql_1 = 'UPDATE Cycles_DB SET ';
                                    strSql_1_needs_executed = 1;
                                }
                                else
                                {
                                    strSql_1 += ', ';
                                }
                                // Build a query to clear the applicable "_pnd" pending bits and mark them as no longer being "_chg" changed
                                strSql_1 += CyclesDB_FieldObj[j].localDirtyDBName + '_chg=(' + CyclesDB_FieldObj[j].localDirtyDBName + '_chg & ~(';
                                strSql_1 += CyclesDB_FieldObj[j].localDirtyDBName + '_pnd))';
                                strSql_1 += ', ' + CyclesDB_FieldObj[j].localDirtyDBName + '_pnd=0';
                                last_read_dirty_prefix = CyclesDB_FieldObj[j].localDirtyDBName;
                            }
                        }
                        // Knock down pending/changed bits 
                        if (strSql_1_needs_executed != 0)
                        {
                            strSql_1 += ' WHERE cyc_started=' + respParamsStr[i] + ';';
                            var scroll_disable_id = suspend_scrolling(true, '');
                            tx.executeSql(  strSql_1, 
                                            [], 
                                            function(tx, results) 
                                            {
                                                suspend_scrolling(false, scroll_disable_id);
                                                successCB();
                                            },
                                            errorCB
                                         ); 
                            strSql_1_needs_executed = 0;
                        }
                    }
                }
            }
            // Intentional fall through for all cases
            state = PART_3_EVAL_STATE_15;
       
        case PART_3_EVAL_STATE_15: 
LogCall('qf');
            // Mark that Part 1 is finished
            UploadSyncToServer_CyclesDB = 1;
        
            // Check if all 4 parallel parts are complete.  If so, complete by executing the callback
            if ((UploadSyncToServer_DataRecsDB == 1) && (UploadSyncToServer_EventSettingsDB == 1) && (UploadSyncToServer_CyclesDB == 1) && (UploadSyncToServer_PregDB == 1))
            {
                // Indicate that this will take ownership of executing the callback.  Part 1 has highest priority, followed by Part 2 and part 3 respectively
                UploadSyncToServer_CyclesDB = 0;
                
                // Delay for a moment and check again that a higher priority parallel path didn't already declare ownership of doing the callback
                for (var x=0; x<12; x++)
                {
                    var i=x+2;
                }
                
                // Double check that another parallel task (of higher priority) didn't take ownership by clearing its flag.  We don't want to have more than
                // one parallel thread executing the callback.
                if ((UploadSyncToServer_DataRecsDB == 1) && (UploadSyncToServer_EventSettingsDB == 1))
                {
                    // Timestamp callback
                    var currTime = new Date();
                    printDebug("State #" + state + " of UploadSyToServ parallelism done " + appendTimeStamp(currTime));
                
                    // Return to caller by executing a callback now that this is complete
                    callback(tx);
                }              
            }
            break;
            
        //////////////////////////////////
        // PART 4 - PregDB_FieldObj //
        //////////////////////////////////
        case PART_4_START_STATE_17:
LogCall('qc');
            // Retrieve results of query
            var rec_date_id;
            var rec_date = new Date();
            var len = results.rows.length;
            var first_to_upload = 0;
            var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
            var upload_date_counter = 1;
            var last_read_dirty_prefix = '';
            var last_read_chg = '';
            var last_read_pnd = '';
            var encoded_bits_to_upload = 0;
            
            // Loop through results
            for (var local_db_counter=0; local_db_counter<len; local_db_counter++)
            {
                rec_date_id = results.rows.item(local_db_counter)['preg_started'];
                rec_date = NumberToDate(rec_date_id);
                first_to_upload = 0;
                strSql = '';
                last_read_dirty_prefix = '';
                // Loop through fields
                for (var i=0; i<PregDB_FieldObj.length; i++)
                {
                    // Add to the SQL query if we are switching fields (relative to prior iteration of loop)
                    if ((last_read_dirty_prefix != PregDB_FieldObj[i].localDirtyDBName) && (encoded_bits_to_upload != 0))
                    {
                        if (first_to_upload == 0)
                        {
                            first_to_upload = 1;
                            strSql += 'UPDATE Preg_DB SET '; 
                        }
                        else
                        {
                            strSql += ', ';
                        }
                        strSql += last_read_dirty_prefix + '_pnd=' + encoded_bits_to_upload;
                        encoded_bits_to_upload = 0;
                    }

                    ///////////////////////////////////////
                    // SIMPLE CASE - ONE VALUE PER FIELD //
                    ///////////////////////////////////////
                    // First handle the simple case where there is only 1 value represented within the DB Field (the dirty bits could be encoded, but the field is not)
                    if (PregDB_FieldObj[i].numberEncodedBits == 1)
                    {
                        // Only re-read database fields if necessary (because parsing SQLite responses is so slow)
                        if (last_read_dirty_prefix != PregDB_FieldObj[i].localDirtyDBName)
                        {
                            last_read_dirty_prefix = PregDB_FieldObj[i].localDirtyDBName;
                            last_read_chg = results.rows.item(local_db_counter)[PregDB_FieldObj[i].localDirtyDBName + '_chg'];
                            last_read_pnd = results.rows.item(local_db_counter)[PregDB_FieldObj[i].localDirtyDBName + '_pnd'];
                        }
                        // Check the database for the '_chg' and '_pnd' flag which each use encoded bits
                        if (((last_read_chg & Math.pow(2, PregDB_FieldObj[i].localDBEncodedBitIndex)) != 0) || ((last_read_pnd & Math.pow(2, PregDB_FieldObj[i].localDBEncodedBitIndex)) != 0)) 
                        {
                            // This value needs uploaded to the server.  Log it as a Name Value Pair to upload shortly
                            uploadParameters[PregDB_FieldObj[i].localDBName + upload_date_counter] = ReplaceQuotes(results.rows.item(local_db_counter)[PregDB_FieldObj[i].localDBName], 0);
                            encoded_bits_to_upload = encoded_bits_to_upload | Math.pow(2, PregDB_FieldObj[i].localDBEncodedBitIndex);
                        }
                    }
                    else
                    {
                        ///////////////////////////////////////////////////////
                        // ADVANCED CASE - MULTIPLE ENCODED VALUES PER FIELD //
                        ///////////////////////////////////////////////////////  
                        last_read_dirty_prefix = PregDB_FieldObj[i].localDirtyDBName;
                        encoded_bits_to_upload = 0;
                        last_read_chg = results.rows.item(local_db_counter)[PregDB_FieldObj[i].localDirtyDBName + '_chg'];
                        last_read_pnd = results.rows.item(local_db_counter)[PregDB_FieldObj[i].localDirtyDBName + '_pnd'];
                        
                        // Loop through all encodings
                        for (var k=0; k<PregDB_FieldObj[i].numberEncodedBits; k++)
                        {
                            // The database has a '_chg' and '_pnd' flag and they use encoded bits
                            if (((last_read_chg & Math.pow(2, k)) != 0) || ((last_read_pnd & Math.pow(2, k)) != 0)) 
                            {
                                // This value needs uploaded to the server.  
                                encoded_bits_to_upload = encoded_bits_to_upload | Math.pow(2, k);                         
                            } 
                        }
                        // Append values to SQL string and send to remote server if there is anything marked as allowed to change from above
                        if (encoded_bits_to_upload != 0) 
                        {     
                            // Upload value and indicate which bits should be considered
                            uploadParameters[PregDB_FieldObj[i].localDBName + upload_date_counter] = results.rows.item(local_db_counter)[PregDB_FieldObj[i].localDBName];
                            uploadParameters[PregDB_FieldObj[i].localDBName + '_chg' + upload_date_counter] = encoded_bits_to_upload;
                            
                            // Build SQL string to mark bits as pending
                            if (first_to_upload == 0)
                            {
                                first_to_upload = 1;
                                strSql += 'UPDATE Preg_DB SET '; 
                            }
                            else
                            {
                                strSql += ', ';
                            }
                            strSql += PregDB_FieldObj[i].localDirtyDBName + '_pnd=(' + PregDB_FieldObj[i].localDirtyDBName 
                            strSql += '_pnd | ' + encoded_bits_to_upload + ')';
                            first_to_upload = 1;
                            encoded_bits_to_upload = 0;
                        }
                    }
                }
                // Catch any final additions to the SQL query that were not appended yet
                if (encoded_bits_to_upload != 0)
                {
                    if (first_to_upload == 0)
                    {
                        first_to_upload = 1;
                        strSql += 'UPDATE Preg_DB SET '; 
                    }
                    else
                    {
                        strSql += ', ';
                    }
                    strSql += last_read_dirty_prefix + '_pnd=' + encoded_bits_to_upload;
                    encoded_bits_to_upload = 0;
                }
                // Prepare upload and database update
                if (first_to_upload != 0)
                {
                    // There is something to upload here, so specify the date as a Name Value Pair and increment to the next record index for the next pass
                    uploadParameters['preg_started' + upload_date_counter] = PrintDate(rec_date);
                    uploadParameters['local_cid' + upload_date_counter] = rec_date_id;
                    upload_date_counter += 1;
                    // Finish the SQL string and execute it
                    strSql += ' WHERE preg_started=' + rec_date_id + '; ';
                    var scroll_disable_id = suspend_scrolling(true, '');
                    tx.executeSql(  strSql, 
                                    [], 
                                    function(tx, results) 
                                    {
                                        suspend_scrolling(false, scroll_disable_id);
                                        successCB();
                                    },
                                    errorCB
                                 ); 
                }
            }
            // Upload values to the server if there are any to upload
            if (upload_date_counter > 1)
            {
                var url_str = global_server_prefix + 'apps_set_data.aspx?' + new Date().getTime();
                
                // Add additional Name Value Pairs to upload
                uploadParameters['un'] = global_username;
                uploadParameters['pw'] = global_password;
                uploadParameters['debug'] = global_Debug_Enabled;
                uploadParameters['app_ver'] = global_app_ver_str;
                uploadParameters['device_id'] = global_device_id_str;
                // Use jQuery to upload the data to the server
                $.ajax({
                    type: 'POST',
                    // The URL of the request
                    url: url_str,
                    // Values to upload
                    data: uploadParameters,
                    // The success callback with result from server
                    success: function(newContent) {
                        // Handles response this function and advance to the next state.  Notice that the tx
                        // cannot be passed to this legitimately because it is not being created as a call
                        // to this registered function (it only has a newContent argument) because this 
                        // callback has nothing to do with databases.  Therefore we will have to re-establish
                        // the tx variable when we want to resume database operations.
                        UploadSyncToServer(state+1, callback, '', newContent, upload_date_counter-1);
                    },
                    dataType: 'html'
                });
                break;
            }
            else
            {
                // Skip states (using intentional fall through paths) because because no data needs uploaded...
                state = PART_4_EVAL_STATE_20;
            }
            // Intentional fall through for Else case

        case 18:
LogCall('qd');
            // Re-generate the tx variable so we can continue to perform database operations.  It was lost
            // in the prior state because the last callback into the state machine involved a remote server
            // transfer and not a local database access.  Therefore the local database parameter was not
            // carried forward and needs to be regenerated.
            if (state <= 18)
            {
                global_db_ios_fail_UploadSyncToServ_18 = DB_IOS_RETRY_LIMIT;
                db.transaction(     function(tx) 
                                    {
                                        global_db_ios_fail_UploadSyncToServ_18 = -1;
                                        UploadSyncToServer(state+1, callback, tx, param_2, param_3);
                                    },
                                    function(tx, err)
                                    {
                                        crash_and_burn(err, 'Could not open local database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                                    },
                                    function(tx)
                                    {
                                        // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                        if (global_db_ios_fail_UploadSyncToServ_18 > 0)
                                        {
                                            global_db_ios_fail_UploadSyncToServ_18 = global_db_ios_fail_UploadSyncToServ_18 - 1;
                                            printDebug('iOS db.transaction failed UploadSyncToServ state 13. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_UploadSyncToServ_18));
                                            UploadSyncToServer(state, callback, param_1, param_2, param_3);
                                        }
                                        else if (global_db_ios_fail_UploadSyncToServ_18 == 0)
                                        {
                                            printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                        }
                                        else
                                        {
                                            successCB();
                                        }
                                    }
                               );
                break;
            }
            // Intentional fall through for Else case
        
        case 19:  
LogCall('qe');
            var upload_count = param_3;
            var desiredStrStart=new Array();
            var desiredStrEnd=new Array();
            var respParamsStr=new Array();
            var ev_fdata_ok_Index;
            var preg_err_Index;
            var continue_execution = 0;
                
            if (state <= 19)
            {
                var error_or_warning = CheckForStandardErrors(newContent);
                continue_execution = HandleServerErrorOrWarning(error_or_warning);
                if (continue_execution == 0)
                {
                    // Stop execution because of a fatal error
                    printDebug('Halting execution due to server returned error.');
                    printStatus('Server Offline?');
                    hideStatusSpinner();
                    break;
                }
            }
            if (state <= 19) 
            {    
                // Prepare variables to extract from response
                for (var i=1; i<=upload_count; i++)
                {
                    desiredStrStart[desiredStrStart.length]='PREG_UPDATED' + i + '=';
                    desiredStrEnd[desiredStrEnd.length]=" ";
                    desiredStrStart[desiredStrStart.length]='PREG_DELETED' + i + '=';
                    desiredStrEnd[desiredStrEnd.length]=" ";
                }
               
                // Parse the response to find the desired values
                respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);

                // Scan the responses
                var strSql_1_needs_executed = 0;
                var strSql_1 = '';
                for (var i=0; i<desiredStrStart.length; i++)
                {
                    // Look for success notifications
                    if (respParamsStr[i] > 0)
                    {
                        // First consider if this was to be deleted
                        if (desiredStrStart[i].search('PREG_DELETED') >= 0)
                        {
                            strSql_1 = 'DELETE FROM Preg_DB ';
                            strSql_1_needs_executed = 1;
                        }
                        else
                        {
                            // Updating an existing record
                            last_read_dirty_prefix = '';
                            for (var j=0; j<PregDB_FieldObj.length; j++)
                            {
                                // No need to update something twice if we just did so
                                if (last_read_dirty_prefix != PregDB_FieldObj[j].localDirtyDBName)
                                {
                                    // See if this is the very first thing appended to the string
                                    if (strSql_1_needs_executed == 0)
                                    {
                                        strSql_1 = 'UPDATE Preg_DB SET ';
                                        strSql_1_needs_executed = 1;
                                    }
                                    else
                                    {
                                        strSql_1 += ', ';
                                    }
                                    // Build a query to clear the applicable "_pnd" pending bits and mark them as no longer being "_chg" changed
                                    strSql_1 += PregDB_FieldObj[j].localDirtyDBName + '_chg=(' + PregDB_FieldObj[j].localDirtyDBName + '_chg & ~(';
                                    strSql_1 += PregDB_FieldObj[j].localDirtyDBName + '_pnd))';
                                    strSql_1 += ', ' + PregDB_FieldObj[j].localDirtyDBName + '_pnd=0';
                                    last_read_dirty_prefix = PregDB_FieldObj[j].localDirtyDBName;
                                }
                            }
                        }
                        
                        // Knock down pending/changed bits or delete record if needed 
                        if (strSql_1_needs_executed != 0)
                        {
                            strSql_1 += ' WHERE preg_started=' + respParamsStr[i] + ';';
                            var scroll_disable_id = suspend_scrolling(true, '');
                            tx.executeSql(  strSql_1, 
                                            [], 
                                            function(tx, results) 
                                            {
                                                suspend_scrolling(false, scroll_disable_id);
                                                successCB();
                                            },
                                            errorCB
                                         ); 
                            strSql_1_needs_executed = 0;
                        }
                    }
                }
            }
            // Intentional fall through for all cases
            state = PART_4_EVAL_STATE_20;
       
        case PART_4_EVAL_STATE_20: 
LogCall('qf');
            // Mark that Part 4 is finished
            UploadSyncToServer_PregDB = 1;
        
            // Check if all 4 parallel parts are complete.  If so, complete by executing the callback
            if ((UploadSyncToServer_DataRecsDB == 1) && (UploadSyncToServer_EventSettingsDB == 1) && (UploadSyncToServer_CyclesDB == 1) && (UploadSyncToServer_PregDB == 1))
            {
                // Indicate that this will take ownership of executing the callback.  Part 1 has highest priority, followed by Part 2 and part 3 respectively
                UploadSyncToServer_PregDB = 0;
                
                // Delay for a moment and check again that a higher priority parallel path didn't already declare ownership of doing the callback
                for (var x=0; x<12; x++)
                {
                    var i=x+2;
                }
                
                // Double check that another parallel task (of higher priority) didn't take ownership by clearing its flag.  We don't want to have more than
                // one parallel thread executing the callback.
                if ((UploadSyncToServer_DataRecsDB == 1) && (UploadSyncToServer_EventSettingsDB == 1) && (UploadSyncToServer_CyclesDB == 1))
                {
                    // Timestamp callback
                    var currTime = new Date();
                    printDebug("State #" + state + " of UploadSyToServ parallelism done " + appendTimeStamp(currTime));
                
                    // Return to caller by executing a callback now that this is complete
                    callback(tx);
                }              
            }
            break;
             
        default:
            // Should not happen
            printDebug('Error - UploadSyncToServer State Machine calling default');
        }
        
    }    
    
    function showTempAdjustment()
    {
LogCall('4m');
        var pos;
        var normal_time_MIN;
        var normal_time_HR;
        var late_time_HR;
        var late_time_MIN;
        
        // Validate inputs first
        var normal_time = document.getElementById('normalTempTimeAdjustTextbox').value;
        var late_time = document.getElementById('tempTimeForAdjustTextbox').value;
        var late_temp_taken = document.getElementById('tempToAdjustTextbox').value;
        pos = normal_time.search(":");
        if ((pos > 0) && (pos < normal_time.length))
        {
            normal_time_HR = normal_time.substring(0, pos);
            normal_time_MIN = normal_time.substring(pos+1, normal_time.length);
            pos = normal_time_MIN.search(" ");
            if (pos > 0)
            {
                normal_time_MIN = normal_time_MIN.substring(0, pos);
            }
        }
        pos = late_time.search(":");
        if ((pos > 0) && (pos < late_time.length))
        {
            late_time_HR = late_time.substring(0, pos);
            late_time_MIN = late_time.substring(pos+1, late_time.length);
            pos = late_time_MIN.search(" ");
            if (pos > 0)
            {
                late_time_MIN = late_time_MIN.substring(0, pos);
            }
        }
        if (((late_temp_taken == '') || (late_temp_taken < 30)) || (late_temp_taken > 110))
        {
            ShowPopupMessage("The actual temperature taken that you specified ('" + late_temp_taken + "') is invalid.  Please enter a valid temp to adjust and try again.", 'Invalid Temperature', '');
        }
        else if ((IsNumeric(late_time_HR) == false) || (IsNumeric(late_time_MIN) == false))
        {
            ShowPopupMessage("The actual temperature time you specified is invalid.  Please enter in mm:ss format and try again.", 'Invalid Time', '');
        }
        else if ((IsNumeric(normal_time_HR) == false) || (IsNumeric(normal_time_MIN) == false))
        {
            ShowPopupMessage("The actual temperature time you specified is invalid.  Please enter in mm:ss format and try again.", 'Invalid Time', '');
        }
        else
        {
            normal_time_MIN = Number(normal_time_MIN);
            normal_time_HR = Number(normal_time_HR);
            late_time_MIN = Number(late_time_MIN);
            late_time_HR = Number(late_time_HR);
            
            // Perform Calculation
            var normal_as_min = normal_time_HR * 60 + normal_time_MIN;
            var late_as_min = late_time_HR * 60 + late_time_MIN;
            var min_diff = late_as_min - normal_as_min;
            var calculated_temp = Math.round(100 * (late_temp_taken - (min_diff/30) * 0.1)) / 100;

            if (isNaN(calculated_temp))
            {
                ShowPopupMessage("The calculated temperature is invalid.  Please check all input fields and try again.", 'Invalid Temp', '');
            }
            else
            {
                // Store temperature result
                document.getElementById('tempTextbox').value = calculated_temp;
                updateLocalDb_DataRecs(global_selected_date, 'tempTextbox', TYPE_TEXTBOX, 'temp', -1, 'fdata_chg', 1);
                
                // Add mention of adjustment to the temp notes field 
                document.getElementById('tempNotesTextArea').value = document.getElementById('tempNotesTextArea').value + ' Taken at ' + late_time + ' and adjusted from ' + late_temp_taken + ' to ' + calculated_temp;
                setTimeout("updateLocalDb_DataRecs(global_selected_date, 'tempNotesTextArea', TYPE_TEXTBOX, 't_notes', -1, 'fdata_chg', 12);", 250);  // Call is delayed to ensure we avoid a race condition to create a database entry if one doesn't already exist
                
                // Save the normal temp time
                global_NormalTempTime = normal_time;
                
                // Hide input fields
                document.getElementById('div_LateTempAdjustment').style.display = 'none';
                document.getElementById('div_LateTempAdjustButton').style.display = 'block';
            }
        }
 
        return;
    }
    function validateNumericEntry(control_name, popup_msg, popup_title, min_allowed, max_allowed, special_temp_adjust)
    {
        var valid_temp = false;
        var number_entered = document.getElementById(control_name).value;
        
        // Validate input first
        if (number_entered == '')
        {
            valid_temp = true;
        }
        else
        {
            number_entered = parseFloat(number_entered);
            if (isNaN(number_entered) == false)
            {
				// Bounds checking
				if ((number_entered >= min_allowed) && (number_entered <= max_allowed))
				{
					valid_temp = true;
					// Adjust temp if needed for missing decimal point
					if (special_temp_adjust == true)
					{
						if ((number_entered >= 350) && (number_entered <= 1059))
						{
							number_entered = number_entered / 10;
						}
						else if ((number_entered >= 3500) && (number_entered <= 10590)) 
						{
							number_entered = number_entered / 100;
						}
					}
					// Update the value shown in case the parsing removed spaces or other unnecessary characters
					document.getElementById(control_name).value = number_entered;
				}
            }
        }
        // Either prompt with an error or save it to the database
        if (valid_temp == false)
        {
            document.getElementById(control_name).value = '';
            ShowPopupMessage(popup_msg, popup_title, '');
            printDebug('Invalid numeric input: ' + number_entered);
            abort_because_of_error = true;
        }
        return valid_temp;
    }
    function validateTemperatureEntry()
    {
        var valid_temp = validateNumericEntry('tempTextbox', 'The temperature value entered is invalid.  Please enter a numeric value and try again.', 'Invalid Temperature',35,10500,true);
        if (valid_temp == true)
        {
            updateLocalDb_DataRecs(global_selected_date, 'tempTextbox', TYPE_TEXTBOX, dbDataDBField_Temp.localDBName, -1, 'fdata_chg', dbDataDBField_Temp.localDBEncodedBitIndex);
        }
    }
    function validateWeightEntry()
    {
        var valid_temp = validateNumericEntry('weightTextbox', 'The weight value entered is invalid.  Please enter a numeric value and try again.', 'Invalid Weight',0,999,false);
        if (valid_temp == true)
        {
            var value = document.getElementById('weightTextbox').value;
            value = value * 100;
            updateLocalDb_DataRecs(global_selected_date, value, PASSED_INTEGER, dbDataDBField_Weight.localDBName, -1, 'fdata_chg', dbDataDBField_Weight.localDBEncodedBitIndex);
        }
    }
    function validateHeightEntry()
    {
        var valid_temp = validateNumericEntry('heightTextbox', 'The height value entered is invalid.  Please enter a numeric value and try again.', 'Invalid Height',0,120,false);
        if (valid_temp == true)
        {
            updateLocalDb_UserInfo('heightTextbox', TYPE_TEXTBOX, 'height');
            global_user_height = document.getElementById('heightTextbox').value;
            global_user_height_dirty = true;
        }
    }
    function BindCollapsibles()
    {
        // Want to call function to redraw textareas when visible from within collapsible regions. 
        // The "keyup" event forces them to be redrawn in case they are overflowing with pre-loaded text
        $('#collapsible_1').bind('expand', function() { $('#intercourseNotesTextArea').trigger('keyup'); $('#personalNotesTextArea').trigger('keyup'); });
        $('#collapsible_2').bind('expand', function() { $('#tempNotesTextArea').trigger('keyup'); });
    }
    function BuildEventArray(results, forDataEntry_or_forChartNOT)
    {
        var eventInfo = new Array(NUMBER_OF_EVENTS);
        var ev_index = '';
        var i;
    
        eventInfo[0] = {field: 'ev1nt', bit: 0, name: 'Anxiety'};
        eventInfo[1] = {field: 'ev1nt', bit: 1, name: 'Depression'};
        eventInfo[2] = {field: 'ev1nt', bit: 2, name: 'Happiness'};
        eventInfo[3] = {field: 'ev1nt', bit: 3, name: 'Energetic'};
        eventInfo[4] = {field: 'ev1nt', bit: 4, name: 'Stress'};
        eventInfo[5] = {field: 'ev1nt', bit: 5, name: 'Irritable'};
        eventInfo[6] = {field: 'ev1nt', bit: 6, name: 'Sadness'};
        eventInfo[7] = {field: 'ev1nt', bit: 7, name: 'Mood Swings'};
        eventInfo[8] = {field: 'ev1nt', bit: 8, name: 'Acne'};
        eventInfo[9] = {field: 'ev1nt', bit: 9, name: 'Backache'};
        eventInfo[10] = {field: 'ev1nt', bit: 10, name: 'Bloating'};
        eventInfo[11] = {field: 'ev1nt', bit: 11, name: 'Breast Tenderness'};
        eventInfo[12] = {field: 'ev1nt', bit: 12, name: 'Constipation'};
        eventInfo[13] = {field: 'ev1nt', bit: 13, name: 'Cramping'};
        eventInfo[14] = {field: 'ev1nt', bit: 14, name: 'Decreased Appetite'};
        eventInfo[15] = {field: 'ev1nt', bit: 15, name: 'Decreased Libido'};
        eventInfo[16] = {field: 'ev1nt', bit: 16, name: 'Diarrhea'};
        eventInfo[17] = {field: 'ev1nt', bit: 17, name: 'Dizziness'};
        eventInfo[18] = {field: 'ev1nt', bit: 18, name: 'Fatigue'};
        eventInfo[19] = {field: 'ev1nt', bit: 19, name: 'Fever'};
        eventInfo[20] = {field: 'ev1nt', bit: 20, name: 'Frequent Urination'};
        eventInfo[21] = {field: 'ev1nt', bit: 21, name: 'Gassy'};
        eventInfo[22] = {field: 'ev1nt', bit: 22, name: 'Headache'};
        eventInfo[23] = {field: 'ev1nt', bit: 23, name: 'Heartburn'};
        eventInfo[24] = {field: 'ev1nt', bit: 24, name: 'Increased Appetite'};
        eventInfo[25] = {field: 'ev1nt', bit: 25, name: 'Increased Libido'};
        eventInfo[26] = {field: 'ev1nt', bit: 26, name: 'Migraine'};
        eventInfo[27] = {field: 'ev1nt', bit: 27, name: 'Nausea'};
        eventInfo[28] = {field: 'ev1nt', bit: 28, name: 'Ovulation Pain'};
        eventInfo[29] = {field: 'ev1nt', bit: 29, name: 'PMS'};
        if (forDataEntry_or_forChartNOT)
        {
            eventInfo[30] = {field: '', bit: -1, name: ''};                  // Spotting (displayed separate from other events)
        }
        else
        {
            eventInfo[30] = {field: 'ev1nt', bit: 30, name: 'Spotting'};                  // Spotting (displayed separate from other events)
        }
        eventInfo[31] = {field: 'ev2nt', bit: 0, name: 'Alcohol Consumption'};
        eventInfo[32] = {field: 'ev2nt', bit: 1, name: 'Breast Self Exam'};
        eventInfo[33] = {field: 'ev2nt', bit: 2, name: 'Exercise'};
        eventInfo[34] = {field: 'ev2nt', bit: 3, name: 'Illness'};
        eventInfo[35] = {field: 'ev2nt', bit: 4, name: 'Insemination'};
        eventInfo[36] = {field: 'ev2nt', bit: 5, name: 'Insomnia'};
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            eventInfo[37] = {field: 'ev2nt', bit: 6, name: 'Expectorant'};
        }
        else
        {
            eventInfo[37] = {field: 'ev2nt', bit: 6, name: 'Intense Dreams'};
        }    
        eventInfo[37] = {field: 'ev2nt', bit: 6, name: 'Intense Dreams'};
        if (forDataEntry_or_forChartNOT)
        {
            eventInfo[38] = {field: '', bit: -1, name: ''};                  // Intercourse (displayed separate from other events)
        }
        else
        {
            eventInfo[38] = {field: 'ev2nt', bit: 7, name: 'Intercourse'};                  // Intercourse (displayed separate from other events)
        }
        eventInfo[39] = {field: 'ev2nt', bit: 8, name: 'IVF Transfer'};
        eventInfo[40] = {field: 'ev2nt', bit: 9, name: 'Mucus Obscurred'};
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            eventInfo[41] = {field: 'ev2nt', bit: 10, name: 'Steroids (oral)'};
        }
        else
        {
            eventInfo[41] = {field: 'ev2nt', bit: 10, name: 'Faintness'};
        }   
        if (forDataEntry_or_forChartNOT)
        {
            eventInfo[42] = {field: '', bit: -1, name: ''};                  // Birth Control (displayed separate from other events)
        }
        else
        {
            eventInfo[42] = {field: 'ev2nt', bit: 11, name: 'Protection'};                  // Birth Control (displayed separate from other events)
        }
        eventInfo[43] = {field: 'ev2nt', bit: 12, name: 'Restless Night'};
        eventInfo[44] = {field: 'ev2nt', bit: 13, name: 'Traveling'};
        eventInfo[45] = {field: 'ev2nt', bit: 14, name: 'Yeast Infection'};
        eventInfo[46] = {field: 'ev2nt', bit: 15, name: 'Clomid'};
        eventInfo[47] = {field: 'ev2nt', bit: 16, name: 'Estrogen'};
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            eventInfo[48] = {field: 'ev2nt', bit: 17, name: 'Antibiotic'};
            eventInfo[49] = {field: 'ev2nt', bit: 18, name: 'Thyroid Medication'};
            eventInfo[50] = {field: 'ev2nt', bit: 19, name: 'Antidepressant'};
            eventInfo[51] = {field: 'ev2nt', bit: 20, name: 'Antihistamine'};
        }
        else
        {
            eventInfo[48] = {field: 'ev2nt', bit: 17, name: 'Femara/Letrozole'};
            eventInfo[49] = {field: 'ev2nt', bit: 18, name: 'FSH'};
            eventInfo[50] = {field: 'ev2nt', bit: 19, name: 'HCG'};
            eventInfo[51] = {field: 'ev2nt', bit: 20, name: 'Metformin'};
        }            
        eventInfo[52] = {field: 'ev2nt', bit: 21, name: 'Other Medications'};
        eventInfo[53] = {field: 'ev2nt', bit: 22, name: 'Progesterone'};
        eventInfo[54] = {field: 'ev2nt', bit: 23, name: 'Vitamins'};
        eventInfo[55] = {field: 'ev2nt', bit: 24, name: 'Bleeding Gums'};
        eventInfo[56] = {field: 'ev2nt', bit: 25, name: 'Blurred Vision'};
        eventInfo[57] = {field: 'ev2nt', bit: 26, name: 'Braxton Hicks Contractions'};
        eventInfo[58] = {field: 'ev2nt', bit: 27, name: 'Cravings'};
        eventInfo[59] = {field: 'ev2nt', bit: 28, name: 'Dry Eyes'};
        eventInfo[60] = {field: 'ev2nt', bit: 29, name: 'Enlarged Breasts'};
        eventInfo[61] = {field: 'ev2nt', bit: 30, name: 'Excess Saliva'};
        eventInfo[62] = {field: 'ev3nt', bit: 0, name: 'Pregnancy Test Positive'};
        eventInfo[63] = {field: 'ev3nt', bit: 1, name: 'Fetal Movement'};
        eventInfo[64] = {field: 'ev3nt', bit: 2, name: 'Fluid Retention'};
        eventInfo[65] = {field: 'ev3nt', bit: 3, name: 'Food Aversions'};
        eventInfo[66] = {field: 'ev3nt', bit: 4, name: 'Hemorrhoids'};
        eventInfo[67] = {field: 'ev3nt', bit: 5, name: 'Itchiness'};
        eventInfo[68] = {field: 'ev3nt', bit: 6, name: 'Leaking Colustrum'};
        eventInfo[69] = {field: 'ev3nt', bit: 7, name: 'Leaking Urine'};
        eventInfo[70] = {field: 'ev3nt', bit: 8, name: 'Leg cramps'};
        eventInfo[71] = {field: 'ev3nt', bit: 9, name: 'Leukorrhea'};
        eventInfo[72] = {field: 'ev3nt', bit: 10, name: 'Linea nigra'};
        eventInfo[73] = {field: 'ev3nt', bit: 11, name: 'Mask of Pregnancy'};
        eventInfo[74] = {field: 'ev3nt', bit: 12, name: 'Morning Sickness'};
        eventInfo[75] = {field: 'ev3nt', bit: 13, name: 'Pubic Bone Pain'};
        eventInfo[76] = {field: 'ev3nt', bit: 14, name: 'Rash'};
        eventInfo[77] = {field: 'ev3nt', bit: 15, name: 'Round Ligament Pain'};
        eventInfo[78] = {field: 'ev3nt', bit: 16, name: 'Sciatica'};
        eventInfo[79] = {field: 'ev3nt', bit: 17, name: 'Shortness of Breath'};
        eventInfo[80] = {field: 'ev3nt', bit: 18, name: 'Skin Changes'};
        eventInfo[81] = {field: 'ev3nt', bit: 19, name: 'Sore bellybutton'};
        eventInfo[82] = {field: 'ev3nt', bit: 20, name: 'Sore hips'};
        eventInfo[83] = {field: 'ev3nt', bit: 21, name: 'Sore perineum'};
        eventInfo[84] = {field: 'ev3nt', bit: 22, name: 'Stretch Marks'};
        eventInfo[85] = {field: 'ev3nt', bit: 23, name: 'Stuffy nose'};
        eventInfo[86] = {field: 'ev3nt', bit: 24, name: 'Sweating'};
        eventInfo[87] = {field: 'ev3nt', bit: 25, name: 'Swelling (Edema)'};
        eventInfo[88] = {field: 'ev3nt', bit: 26, name: 'Thirsty'};
        eventInfo[89] = {field: 'ev3nt', bit: 27, name: 'Tingling Hands'};
        eventInfo[90] = {field: 'ev3nt', bit: 28, name: 'Varicose Veins'};
        eventInfo[91] = {field: 'ev3nt', bit: 29, name: 'Weepiness'};
        eventInfo[92] = {field: 'ev3nt', bit: 30, name: '1_Custom'};
        eventInfo[93] = {field: 'ev4nt', bit: 0, name: '2_Custom'};
        eventInfo[94] = {field: 'ev4nt', bit: 1, name: '3_Custom'};
        eventInfo[95] = {field: 'ev4nt', bit: 2, name: '4_Custom'};
        eventInfo[96] = {field: 'ev4nt', bit: 3, name: '5_Custom'};
        eventInfo[97] = {field: 'ev4nt', bit: 4, name: '6_Custom'};
        eventInfo[98] = {field: 'ev4nt', bit: 5, name: '7_Custom'};
        eventInfo[99] = {field: 'ev4nt', bit: 6, name: '8_Custom'};
        eventInfo[100] = {field: 'ev4nt', bit: 7, name: '9_Custom'};
        eventInfo[101] = {field: 'ev4nt', bit: 8, name: '10_Custom'};
        eventInfo[102] = {field: 'ev4nt', bit: 9, name: '11_Custom'};
        eventInfo[103] = {field: 'ev4nt', bit: 10, name: '12_Custom'};
        eventInfo[104] = {field: 'ev4nt', bit: 11, name: '13_Custom'};
        eventInfo[105] = {field: 'ev4nt', bit: 12, name: '14_Custom'};
        eventInfo[106] = {field: 'ev4nt', bit: 13, name: '15_Custom'};                        
        eventInfo[107] = {field: 'ev4nt', bit: 14, name: '16_Custom'};
        eventInfo[108] = {field: 'ev4nt', bit: 15, name: '17_Custom'};
        eventInfo[109] = {field: 'ev4nt', bit: 16, name: '18_Custom'};                        
        eventInfo[110] = {field: 'ev4nt', bit: 17, name: '19_Custom'};
        eventInfo[111] = {field: 'ev4nt', bit: 18, name: '20_Custom'};
        eventInfo[112] = {field: 'ev4nt', bit: 19, name: 'Pregnancy Test Negative'};
        
        // Load custom event names
        for (i=1; i<=NUMBER_OF_CUSTOM_EVENTS; i++)
        {
            ev_index = (i-1) + CUSTOM_EVENT_OFFSET;
            eventInfo[ev_index].name = results.rows.item(0)['cev_name_' + i];
        }
        
        return eventInfo;
    }

    function initCCLAutoNum()
    {
        /* Since this is a request field that auto-clears, hide the prior value set
        // unconditionally to discourage expectations that it is storing what they asked
        // for. Once value is set, the request goes to server, and value gets cleared.
        if (document.getElementById('mensCheckbox').checked == true)
        {
            if (document.getElementById('autoNumCheckbox').checked == true) 
            {
                document.getElementById('divNumManuallyTextbox').style.display = 'none';
            }
            else
            {
                document.getElementById('divNumManuallyTextbox').style.display = 'block';
            }
            document.getElementById('divAutoNumCheckbox').style.display = 'block';
        }
        else
        {
        */
            document.getElementById('divNumManuallyTextbox').style.display = 'none';
            document.getElementById('divAutoNumCheckbox').style.display = 'none';
            document.getElementById('divNumManuallyTextbox').style.display = 'none';
        //}
    }
    function cclNewCycleCheckbox()
    {
        if (document.getElementById('mensCheckbox').checked == true) 
        {
            document.getElementById('divAutoNumCheckbox').style.display = 'block';
            $("input[id='autoNumCheckbox']").attr("checked",true).checkboxradio("refresh");
            document.getElementById('divNumManuallyTextbox').style.display = 'none';
        }
        else
        {
            document.getElementById('divAutoNumCheckbox').style.display = 'none';
            document.getElementById('divNumManuallyTextbox').style.display = 'none';
        }
    }
    function manuallyIDCycle()
    {
        if (document.getElementById('autoNumCheckbox').checked == true)  
        {
            document.getElementById('divNumManuallyTextbox').style.display = 'none';
        }
        else
        {
            document.getElementById('divNumManuallyTextbox').style.display = 'block';
        }
    }
    function cclCycleIDSave()
    {
        if (document.getElementById('mensCheckbox').checked == true) 
        {
            if (document.getElementById('autoNumCheckbox').checked == true) 
            {
                updateLocalDb_DataRecs(global_selected_date, AUTONUM_CYCLE_DELIMETER, PASSED_INTEGER, 'itxtreq', -1, 'fdata_chg', 19);
            }
            else
            {
                var input_integer = parseInt(document.getElementById('numManuallyTextbox').value);
                if (isNaN(input_integer))
                {
                    input_integer = 0;
                }
                updateLocalDb_DataRecs(global_selected_date, input_integer, PASSED_INTEGER, 'itxtreq', -1, 'fdata_chg', 19);
            }
        }
        else
        {
            updateLocalDb_DataRecs(global_selected_date, 0, PASSED_INTEGER, 'itxtreq', -1, 'fdata_chg', 19);
        }
    }
    function SolicitFeedback(type_id)
    {
        if (type_id == 1)
        {
            // Solicit initial feedback
            document.getElementById('divFdbk1').style.display = 'block';
            document.getElementById('divFdbk2').style.display = 'none';
        }
        else if (type_id == 2)
        {
            // Solicit review
            document.getElementById('divFdbk1').style.display = 'none';
            document.getElementById('divFdbk2').style.display = 'block';
        }
        // Show Popup
        setTimeout("$('#divFdbkPop').popup('open');", 300);
    }
    function AppFeedback(action)
    {
        var feedback_value = 0;
        var uploadParameters = {};  // Declare name value pair list to specify values to upload to server

        switch (action)
        {
            case 1:     // Don't like app
            case 2:     // App is ok
            case 3:     // Like app
                global_survey_id = 0;
                updateLocalDb_UserInfo(global_survey_id, PASSED_VALUE, 'survey_id');
                feedback_value = action;
                uploadParameters['suggest'] = document.getElementById('feedbackTextArea').value;
                break;
                
            case 10:    // Won't leave review
            case 11:    // Will leave review
                global_survey_id = 0;
                updateLocalDb_UserInfo(global_survey_id, PASSED_VALUE, 'survey_id');
                feedback_value = action;
                break;
        }
        
        // Close
        $('#divFdbkPop').popup('close');
        
        // Notify server
        if (feedback_value > 0)
        {
            var url_str = global_server_prefix + 'apps_set_data.aspx?' + new Date().getTime();
                        
            // Specify values to upload
            uploadParameters['un'] = global_username;
            uploadParameters['pw'] = global_password;
            uploadParameters['debug'] = global_Debug_Enabled;
            uploadParameters['app_ver'] = global_app_ver_str;
            uploadParameters['device_id'] = global_device_id_str;
            uploadParameters['fdbk'] = feedback_value;
            
            // Use jQuery to upload the data to the server
            $.ajax({
                type: 'POST',
                // The URL of the request
                url: url_str,
                // Values to upload
                data: uploadParameters,
                // The success callback with result from server
                success: function(newContent) { },
                dataType: 'html'
            });
        }
    }
    function LeaveFeedback()
    {
        AppFeedback(11);
        return go2url(this);        
    }
    function getPregInfo(which_week, introStr)
    {
        var weburl;
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            weburl = 'CycleProGo';
        }
        else
        {
            weburl = 'MyFertilityChart';
        }
        var retStr = '<div class="PregImg"><img src="http://myfertilitycharts.com/webedition/20/images/pregweeks/week' + which_week + '.png"><br>' + weburl + '.com/PhotoCredit</div><div class="PregWeeks">' + introStr;
        switch (which_week)
        {
        case 1:
        case 2:
        case 3:
            retStr += '<div class="PregWeeks">' + introStr + '</div>';
            break;
        case 4:
            retStr += '<b>Baby Size</b>: Poppy seed<br>';
            retStr += '<b>Symptoms</b>: Nausea, Vomiting, Tired, Swollen Breasts<br>';
            retStr += '<b>Tips</b>: Take a prenatal vitamin. Eat small and frequent meals.</div>';
            break;
        case 5:
            retStr += '<b>Baby Size</b>: Apple seed<br>';
            retStr += '<b>Development</b>: Heart begins to beat<br>';
            retStr += '<b>Symptoms</b>: Tired<br>';
            break;
        case 6:
            retStr += '<b>Baby Size</b>: Pea<br>';
            retStr += '<b>Development</b>: Head bigger than body.  Limbs starting to form.<br>';
            retStr += '<b>Symptoms</b>: Moodiness. Tired.<br>';
            retStr += '<b>Tips</b>: First doctor appointment</div>';
            break;
        case 7:
            retStr += '<b>Baby Size</b>: Cranberry<br>';
            retStr += '<b>Development</b>: Skeleton formed.<br>';
            retStr += '<b>Symptoms</b>: Nausea. Cravings.<br>';
            retStr += '<b>Tips</b>: Eat nutritiously</div>';
            break;
        case 8:
            retStr += '<b>Baby Size</b>: Blackberry<br>';
            retStr += '<b>Development</b>: Face developing.<br>';
            retStr += '<b>Symptoms</b>: Increased sense of smell. Sore belly. Cramps.<br>';
            retStr += '<b>Tips</b>: Visit your doctor if you have not already</div>';
            break;
        case 9:
            retStr += '<b>Baby Size</b>: Olive<br>';
            retStr += '<b>Development</b>: Eyes developing. Can hear heartbeat.<br>';
            retStr += '<b>Symptoms</b>: Tired.<br>';
            retStr += '<b>Tips</b>: Eat mini meals.</div>';
            break;
        case 10:
            retStr += '<b>Baby Size</b>: Prune<br>';
            retStr += '<b>Development</b>: Upper lip forms. Baby tail is gone.<br>';
            retStr += '<b>Symptoms</b>: Abdominal aches and pains. Increase vaginal discharge.<br>';
            retStr += '<b>Tips</b>: Shop for maternity clothes</div>';
            break;
        case 11:
            retStr += '<b>Baby Size</b>: Lime<br>';
            retStr += '<b>Development</b>: Fingernails almost fully formed.<br>';
            retStr += '<b>Symptoms</b>: Linea nigra may appear.<br>';
            break;
        case 12:
            retStr += '<b>Baby Size</b>: Clementine<br>';
            retStr += '<b>Development</b>: Wrists and elbows bend.<br>';
            retStr += '<b>Symptoms</b>: Emotional.<br>';
            retStr += '<b>Tips</b>: Hear the baby heartbeat at doctor appointment</div>';
            break;
        case 13:
            retStr += '<b>Baby Size</b>: Peach<br>';
            retStr += '<b>Development</b>: All teeth formed.  Second trimester starts.<br>';
            retStr += '<b>Symptoms</b>: Increased sex drive.<br>';
            retStr += '<b>Tips</b>: Exercise.  Plan for maternity leave.</div>';
            break;
        case 14:
            retStr += '<b>Baby Size</b>: Lemon<br>';
            retStr += '<b>Development</b>: Thumb sucking.<br>';
            retStr += '<b>Symptoms</b>: Aches and pains as the baby grows.<br>';
            retStr += '<b>Tips</b>: Begin monthly doctor appointments.</div>';
            break;
        case 15:
            retStr += '<b>Baby Size</b>: Orange<br>';
            retStr += '<b>Development</b>: Can move all limbs.<br>';
            retStr += '<b>Symptoms</b>: Heartburn. Swollen gums.<br>';
            retStr += '<b>Tips</b>: Think about baby names.</div>';
            break;
        case 16:
            retStr += '<b>Baby Size</b>: Avocado<br>';
            retStr += '<b>Development</b>: Ears forming.<br>';
            retStr += '<b>Symptoms</b>: May start to feel baby move.<br>';
            retStr += '<b>Tips</b>: Talk to baby.</div>';
            break;
        case 17:
            retStr += '<b>Baby Size</b>: Onion<br>';
            retStr += '<b>Development</b>: Cartilage has turned to bone.<br>';
            retStr += '<b>Symptoms</b>: Vaginal discharge.<br>';
            retStr += '<b>Tips</b>: Decide if you wish to learn the gender.</div>';
            break;
        case 18:
            retStr += '<b>Baby Size</b>: Sweet Potato<br>';
            retStr += '<b>Development</b>: Baby rolling around.<br>';
            retStr += '<b>Symptoms</b>: Can feel baby kicking.<br>';
            retStr += '<b>Tips</b>: Schedule ultrasound to find out gender if desired.</div>';
            break;
        case 19:
            retStr += '<b>Baby Size</b>: Tomato<br>';
            retStr += '<b>Development</b>: Develops protective coating over skin called vernix caseosa.<br>';
            retStr += '<b>Symptoms</b>: Leg cramps.<br>';
            retStr += '<b>Tips</b>: Look into birthing classes.</div>';
            break;
        case 20:
            retStr += '<b>Baby Size</b>: Mango<br>';
            retStr += '<b>Development</b>: Producing meconium.<br>';
            retStr += '<b>Symptoms</b>: Hair and nails growing faster.<br>';
            retStr += '<b>Tips</b>: Schedule infant CPR and first aid classes.</div>';
            break;
        case 21:
            retStr += '<b>Baby Size</b>: Pomegranate<br>';
            retStr += '<b>Development</b>: Eyebrows and lids are developed.<br>';
            retStr += '<b>Symptoms</b>: Braxton hicks contractions.<br>';
            retStr += '<b>Tips</b>: Exercise daily.</div>';
            break;
        case 22:
            retStr += '<b>Baby Size</b>: Spaghetti Squash<br>';
            retStr += '<b>Development</b>: Developing sleep and wake periods.<br>';
            retStr += '<b>Symptoms</b>: swollen feet.<br>';
            retStr += '<b>Tips</b>: Sing to baby.</div>';
            break;
        case 23:
            retStr += '<b>Baby Size</b>: Papaya<br>';
            retStr += '<b>Development</b>: Pancreas developing.<br>';
            retStr += '<b>Symptoms</b>: Forgetfulness.<br>';
            retStr += '<b>Tips</b>: Take breaks to rest.</div>';
            break;
        case 24:
            retStr += '<b>Baby Size</b>: Ear of Corn<br>';
            retStr += '<b>Development</b>: Consider viable. If born, baby could survive.<br>';
            retStr += '<b>Symptoms</b>: Should have gained at least 10 pounds. Be careful not to fall because your center of gravity has changed.<br>';
            retStr += '<b>Tips</b>: Start baby proofing your home.</div>';
            break;
        case 25:
            retStr += '<b>Baby Size</b>: Cauliflower<br>';
            retStr += '<b>Development</b>: Baby developing tastes.<br>';
            retStr += '<b>Symptoms</b>: Constipation.<br>';
            retStr += '<b>Tips</b>: Think about decorating the nursery.</div>';
            break;
        case 26:
            retStr += '<b>Baby Size</b>: Lettuce<br>';
            retStr += '<b>Development</b>: Breathing movements begin.<br>';
            retStr += '<b>Symptoms</b>: Hot flashes.<br>';
            retStr += '<b>Tips</b>: Start to create your birth plan.</div>';
            break;
        case 27:
            retStr += '<b>Baby Size</b>: Passion Fruit<br>';
            retStr += '<b>Development</b>: Lungs and brain are maturing.<br>';
            retStr += '<b>Symptoms</b>: Weight gain and leg cramps.<br>';
            retStr += '<b>Tips</b>: Take birthing classes.</div>';
            break;
        case 28:
            retStr += '<b>Baby Size</b>: Cabbage<br>';
            retStr += '<b>Development</b>: Baby can see light. Eyelids open.<br>';
            retStr += '<b>Symptoms</b>: Varicose veins.<br>';
            retStr += '<b>Tips</b>: Glucose testing<br>';
            break;
        case 29:
            retStr += '<b>Baby Size</b>: Cauliflower<br>';
            retStr += '<b>Development</b>: Permanent teeth are forming<br>';
            retStr += '<b>Symptoms</b>: Constipation. Hemorrhoids.<br>';
            retStr += '<b>Tips</b>: Eat high protein, Vitamin C, and Calcium in your diet.</div>';
            break;
        case 30:
            retStr += '<b>Baby Size</b>: Squash<br>';
            retStr += '<b>Development</b>: Brain getting bigger.<br>';
            retStr += '<b>Symptoms</b>: Shortness of breath (due to baby leaving less room for the lungs)<br>';
            retStr += '<b>Tips</b>: Ensure regularity of the baby kicking</div>';
            break;
        case 31:
            retStr += '<b>Baby Size</b>: Coconut<br>';
            retStr += '<b>Development</b>: Five senses are developed.<br>';
            retStr += '<b>Symptoms</b>: May start Braxton Hicks contractions<br>';
            retStr += '<b>Tips</b>: Start a list of items to pack in your hospital bag</div>';
            break;
        case 32:
            retStr += '<b>Baby Size</b>: Jicama<br>';
            retStr += '<b>Development</b>: Baby likely getting into a head down position.<br>';
            retStr += '<b>Symptoms</b>: Vaginal discharge<br>';
            retStr += '<b>Tips</b>: Try to get some rest.</div>';
            break;
        case 33:
            retStr += '<b>Baby Size</b>: Durian<br>';
            retStr += '<b>Development</b>: Establishing an immune system<br>';
            retStr += '<b>Symptoms</b>: Headaches.  Feeling hot.<br>';
            retStr += '<b>Tips</b>: Stay hydrated.</div>';
            break;
        case 34:
            retStr += '<b>Baby Size</b>: Honeydew<br>';
            retStr += '<b>Development</b>: Skin is becoming smooth<br>';
            retStr += '<b>Symptoms</b>: Baby descends lower into pelvis.<br>';
            retStr += '<b>Tips</b>: Install the car seat</div>';
            break;
        case 35:
            retStr += '<b>Baby Size</b>: Pineapple<br>';
            retStr += '<b>Development</b>: Kidneys and liver develop<br>';
            retStr += '<b>Symptoms</b>: Frequent urination.<br>';
            retStr += '<b>Tips</b>: Last minute prep for baby.</div>';
            break;
        case 36:
            retStr += '<b>Baby Size</b>: Canary Melon<br>';
            retStr += '<b>Development</b>: Almost able to breathe on own.<br>';
            retStr += '<b>Symptoms</b>: Maybe may have dropped down into pelvis.<br>';
            retStr += '<b>Tips</b>: Make a list of who to notify after the birth.</div>';
            break;
        case 37:
            retStr += '<b>Baby Size</b>: Winter melon<br>';
            retStr += '<b>Development</b>: Full term<br>';
            retStr += '<b>Symptoms</b>: Nesting<br>';
            retStr += '<b>Tips</b>: Continue with weekly doctor appointments</div>';
            break;
        case 38:
            retStr += '<b>Baby Size</b>: Pumpkin<br>';
            retStr += '<b>Development</b>: Shedding vernix caseosa<br>';
            retStr += '<b>Symptoms</b>: Swelling ankles<br>';
            retStr += '<b>Tips</b>: Enjoy final days before the baby is born</div>';
            break;
        case 39:
            retStr += '<b>Baby Size</b>: Mini watermelon<br>';
            retStr += '<b>Development</b>: Brain developing more and more<br>';
            retStr += '<b>Symptoms</b>: Possible labor<br>';
            retStr += '<b>Tips</b>: Know signs of false labor versus true labor.</div>';
            break;
        case 40:
        case 41:
        case 42:
            retStr += '<b>Baby Size</b>: Pumpkin<br>';
            retStr += '<b>Development</b>: Ready to be born<br>';
            retStr += '<b>Symptoms</b>: Anxious<br>';
            retStr += '<b>Tips</b>: Watch for signs of labor.</div>';
            break;   
        default:
            break;
        }
        retStr += '<br>';
        return retStr;
    }
