///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// FUNCTIONS FOR COMMUNITY/RESOURCE SCREENS
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

var global_last_comm_screen;
var COMMUNITY_POST_PAGE_STATE_3 = 3;
var COMMUNITY_BOARDS_PAGE_STATE_4 = 4;
var COMMUNITY_RESOURCE_PAGE_STATE_5 = 5;
var COMMUNITY_LIBRARY_PAGE_STATE_6 = 6;
var COMM_BOARDS_SCREEN = 0;
var COMM_POST_SCREEN = 1;
var global_moffset_counter = 0;

function navBetweenCommScreens(state, target_screen, param_1, param_2, use_offset)
{
    var strSql = '';
    var tx = param_1;

    printDebug("State " + state + " of navBetweenCommScreens");
    switch(state)
    {
    case 1:
LogCall('c1');
        // Open local database
        db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
        global_db_ios_fail_navBtCommScreens_1 = DB_IOS_RETRY_LIMIT;
        db.transaction(     function(tx) 
                            {
                                global_db_ios_fail_navBtCommScreens_1 = -1;
                                navBetweenCommScreens(state+1, target_screen, tx, use_offset);
                            },
                            errorCB,
                            function(tx)
                            {
                                // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                if (global_db_ios_fail_navBtCommScreens_1 > 0)
                                {
                                    global_db_ios_fail_navBtCommScreens_1 = global_db_ios_fail_navBtCommScreens_1 - 1;
                                    printDebug('iOS db.transaction failed navBtCommScreens state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_navBtCommScreens_1));
                                    navBetweenCommScreens(state, target_screen, param_1, param_2, use_offset);
                                }
                                else if (global_db_ios_fail_navBtCommScreens_1 == 0)
                                {
                                    printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                }
                                else
                                {
                                    successCB();
                                }
                            }
                       );
        // Set dynamic build content for loaded page
        setDynamicContentForAppInstance(global_Comm_Pages[target_screen]);
        
        break;
    
    case 2:   
LogCall('c2');
        var next_state = -1;
        var uploadParameters = {};
        var url_str;
        var requires_server_query = false;
    
        // See what page is being targeted and react accordingly
        switch(target_screen)               // see global_Comm_Pages[]
        {
        case COMM_BOARDS_SCREEN:   // Community Boards screen
        case COMM_POST_SCREEN:  // Message board post page
        
            next_state = COMMUNITY_POST_PAGE_STATE_3;
            // Query values from local database.
            strSql = 'SELECT * FROM Groups_DB WHERE 1;';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                navBetweenCommScreens(next_state, target_screen, tx, results, use_offset);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local Preg database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;

        case 2:   // Resource Links screen

            // Formerly used to test to see if content needed redownloaded, but now must always redownload since page is being reloaded.  Was:  if (does_timestamp_say_to_reload('resources') == true) 
            if (true)
            {
                printDebug('Need to download resource links');
                next_state = COMMUNITY_RESOURCE_PAGE_STATE_5;
                url_str = global_server_prefix + 'apps_get_data.aspx?' + new Date().getTime();

                // Query server
                printStatus('Connecting');
                uploadParameters['resources'] = '1';
                uploadParameters['un'] = global_username;
                uploadParameters['pw'] = global_password;
                uploadParameters['debug'] = global_Debug_Enabled;
                uploadParameters['app_ver'] = global_app_ver_str;
                uploadParameters['device_id'] = global_device_id_str;
                requires_server_query = true;
            }
            else
            {
                printDebug('No need to reload resource links.');
                next_state = -1;
            } 
            // Check if offline
            if (global_online_status == false)
            {
                // No network access
                printOfflineStatus(); 
                document.getElementById('Resources_Links_div').innerHTML = 'The server could not be reached to download a list of resources.  Your device may not have internet access or the server may be down.  Please try again later.';
                next_state = -1;
            }                
            break;
            
        case 3:   // Chart Library
            requires_server_query = true;
            
            printDebug('Need to download friends');
            next_state = COMMUNITY_LIBRARY_PAGE_STATE_6;
            url_str = global_server_prefix + 'apps_forums.aspx?' + new Date().getTime();

            // Display cycle
            if (global_selected_cycle_as_number > 0)
            {
                document.getElementById('CommLibChartStart').innerHTML = PrintDate(NumberToDate(global_selected_cycle_as_number));
            }
            else
            {
                document.getElementById('CommLibChartStart').innerHTML = 'No chart selected';
            }
            
            // Query server for more cycle start dates
            printStatus('Connecting');
            uploadParameters['friends'] = '1';
            uploadParameters['un'] = global_username;
            uploadParameters['pw'] = global_password;
            uploadParameters['debug'] = global_Debug_Enabled;
            uploadParameters['app_ver'] = global_app_ver_str;
            uploadParameters['device_id'] = global_device_id_str;
            requires_server_query = true;
            break;
           
        case 4:   // Share Chart screen
        
            // No loading is necessary.  Page is completely static content.
            next_state = -1;
            break;
            
        case 5:  // Daughters "Body" Page
        
            // No loading is necessary.  Page is completely static content.
            next_state = -1;
            break;
            
        case 6:  // Daughters "Woman" Page
        
            // No loading is necessary.  Page is completely static content.
            next_state = -1;
            break;
		
		case 7:  // Daughters "Prayer" Page
        
            // No loading is necessary.  Page is completely static content.
            next_state = -1;
            break;
     
        // Should not happen
        default:
            printDebug('ERROR: Executing default case in navBetweenCommScreens looking up target_screen');
        }

        if ((next_state >= 0) && (requires_server_query == true))
        {
            // Use jQuery to upload the data to the server
            $.ajax({
                type: 'POST',
                // The URL of the request
                url: url_str,
                // Values to upload
                data: uploadParameters,
                // The success callback with result from server
                success: function(newContent) {
                    // Handles response this function and advance to the next state.  Notice that the tx
                    // cannot be passed to this legitimately because it is not being created as a call
                    // to this registered function (it only has a newContent argument) because this 
                    // callback has nothing to do with databases.  Therefore we will have to re-establish
                    // the tx variable when we want to resume database operations.
                    navBetweenCommScreens(next_state, target_screen, tx, newContent, use_offset);
                },
                dataType: 'html'
            });
        }
        else
        {
            HideAct();
        }
        HideAct_Legacy();
        break;
    
    case COMMUNITY_POST_PAGE_STATE_3:
LogCall('c3');

        var ctrlPag;
        var defVal;
        
        // Get drop down control control
        if (target_screen == COMM_POST_SCREEN)
        {
            ctrlPag = 'Post';
            defVal = 'No Target Group (public post)';
            if (global_active_subscription == 0)
            {
                document.getElementById("PostBodyTextArea").disabled = true;
                document.getElementById("PostTitleTextbox").disabled = true;
                document.getElementById("Post_Button").disabled = true;
                document.getElementById('postSubWarn').innerHTML = '<b>Warning</b>: New posts require an active subscription.  Please check your account and try again.  If you feel you have received this message in error, push the "Sync" button to ensure synchronization with the server and try again.';
            }
            else
            {
                document.getElementById("PostBodyTextArea").disabled = false;
                document.getElementById("PostTitleTextbox").disabled = false;
                document.getElementById("Post_Button").disabled = false;
                document.getElementById('postSubWarn').innerHTML = '';
            }
        }
        else
        {
            ctrlPag = 'Board';
            defVal = 'Show All (no filter)';
            if (global_active_subscription == 0)
            {
                document.getElementById('replySubWarn').innerHTML = '<b>Warning</b>: You cannot post messages without an active subscription.  It appears as though your subscription expired.  Please check your account and try again.';
            }
            else
            {
                document.getElementById('replySubWarn').innerHTML = '';
            }
        }
        if (global_selected_cycle_as_number > 0)
        {
            document.getElementById('Comm' + ctrlPag + 'ChartStart').innerHTML = PrintDate(NumberToDate(global_selected_cycle_as_number));
            document.getElementById('Comm' + ctrlPag + 'ShareDiv').style.display = 'block';
        }
        else
        {
            document.getElementById('Comm' + ctrlPag + 'ChartStart').innerHTML = 'No chart selected';
            document.getElementById('Comm' + ctrlPag + 'ShareDiv').style.display = 'none';
        }

        var optionsList;
        var cycleSelect = $('#Comm' + ctrlPag + '_GroupsSelect');
        if(cycleSelect.prop) 
        {
            optionsList = cycleSelect.prop('options');
        }
        else 
        {
            optionsList = cycleSelect.attr('options');
        }

        // Only load results if called with them passed
        if (param_2 != '')
        {
            var results = param_2;
            var len = results.rows.length;
            
            // Clear list
            $('option', cycleSelect).remove();
            optionsList[optionsList.length] = new Option(defVal, 0);   
            if (len > 0)
            {
                var gCode;
                var gDesc;
                // Loop through results and populate pregs
                for (var i=0; i<len; i++)
                {
                    gCode = results.rows.item(i)['gcode'];
                    gDesc = results.rows.item(i)['desc'];
                    optionsList[optionsList.length] = new Option(gDesc + ' (' + gCode + ')', gCode); 
                }
            }
            
            // Refresh control after update and make a default selection
            cycleSelect[0].selectedIndex = 0;
            cycleSelect.selectmenu("refresh");      
        }

        if (target_screen == COMM_POST_SCREEN)
        {
            // Post page is done
            HideAct();
        }
        else
        {
            // Group page needs to go on to load messages.
            var uploadParameters = {};
            printDebug('Need to download message board posts');
            next_state = COMMUNITY_BOARDS_PAGE_STATE_4;
            url_str = global_server_prefix + 'apps_forums.aspx?app=1&' + new Date().getTime();

            // Query server
            printStatus('Connecting');
            uploadParameters['get_posts'] = '1';
            uploadParameters['un'] = global_username;
            uploadParameters['pw'] = global_password;
            uploadParameters['app_ver'] = global_app_ver_str;
            uploadParameters['device_id'] = global_device_id_str;
            if (use_offset == 1)
            {
                uploadParameters['moffset'] = global_moffset_counter;
            }
            else
            {
                uploadParameters['moffset'] = 0;
                global_moffset_counter = 0;
            }   
            if (cycleSelect[0].selectedIndex == 0)
            { 
                uploadParameters['showpub'] = 1;
            }
            else
            {
                uploadParameters['gcode1'] = ReplaceQuotes(document.getElementById('CommBoard_GroupsSelect').value); 
            }
                
            // Check if offline
            if (global_online_status == false)
            {
                // No network access
                printOfflineStatus(); 
                document.getElementById('Boards_Msg_div').innerHTML = 'The server could not be reached to download a list of message board posts.  Your device may not have internet access or the server may be down.  Please try again later.';
                next_state = -1;
            }    
            else
            {
                // Use jQuery to upload the data to the server
                $.ajax({
                    type: 'POST',
                    // The URL of the request
                    url: url_str,
                    // Values to upload
                    data: uploadParameters,
                    // The success callback with result from server
                    success: function(newContent) {
                        // Handles response this function and advance to the next state.  Notice that the tx
                        // cannot be passed to this legitimately because it is not being created as a call
                        // to this registered function (it only has a newContent argument) because this 
                        // callback has nothing to do with databases.  Therefore we will have to re-establish
                        // the tx variable when we want to resume database operations.
                        navBetweenCommScreens(next_state, target_screen, tx, newContent, use_offset);
                    },
                    dataType: 'html'
                });
            }
        }
        break;
    
    case COMMUNITY_BOARDS_PAGE_STATE_4:
LogCall('c4');
        var desiredStrStart=new Array();
        var desiredStrEnd=new Array();
        var respParamsStr=new Array();
        var index2_Time_field = new Array();
        var index2_Title_field = new Array();
        var index2_AuthUn_field = new Array();
        var index2_AuthName_field = new Array();
        var index2_AuthRole_field = new Array();
        var index2_AuthPic_field = new Array();
        var index2_AuthMsg_field = new Array();
        var index2_ChUrl_field = new Array();
        var index2_PID_field = new Array();
        var tempStr = '';
        var newContent = param_2;
        var num_posts = -1;
        var topic_count = 0;
        var last_pid = -1;
        var i;

        desiredStrStart[desiredStrStart.length]='POSTCNT=';
        desiredStrEnd[desiredStrEnd.length]=" ";

        // Initially parse the response to find the number of posts
        respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
        if (respParamsStr[0] != '')
        {
            num_posts = parseInt(respParamsStr[0]);
        }

        // Prepare variables to extract from response for all returned cycles
        desiredStrStart.length = 0;
        desiredStrEnd.length = 0;
        
        index2_server_time = desiredStrStart.length;
        desiredStrStart[desiredStrStart.length]='CURR_TIME=';
        desiredStrEnd[desiredStrEnd.length]="@!@.";
        
        for (i=1; i<=num_posts; i++)
        {
            index2_Time_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='TIME_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]="@!@.";
            
            index2_Title_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='TIT_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]="@!@.";
            
            index2_AuthUn_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='AUN_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]="@!@.";
            
            index2_AuthName_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='ANAME_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]="@!@.";
            
            index2_AuthRole_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='AROLE_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]=" ";
            
            index2_AuthPic_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='APIC_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]=" ";
            
            index2_AuthMsg_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='MSG_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]="@!@.";
            
            index2_ChUrl_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='CHURL_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]=" ";
            
            index2_PID_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='PID_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]=" ";
        }

        // Parse the response 
        respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);

        // Determine time offset b/t server and device        
        var currTime = new Date();
        var serverTime = new Date();
        var msgTime = new Date();
        var server_sec_diff;
        var sec_diff;
        var lapsedStr;
        if (respParamsStr[index2_server_time] != '')
        {
            serverTime = new Date(respParamsStr[index2_server_time]);
            server_sec_diff = (currTime.getTime() - serverTime.getTime())/1000;
            printDebug('server time adjust by ' + server_sec_diff + ' secs');
        }
        else
        {
            printDebug('Error - Could not determine server time');
            serverTime = currTime;
            server_sec_diff = 0;
        }
        g_LoadTimestamps['messages'] = currTime.getTime();
        
        // Load values on to the screen
        for (i=0; i<num_posts; i++)
        {
            if ((respParamsStr[index2_Title_field[i]] != '') || (respParamsStr[index2_AuthMsg_field[i]] != ''))
            {
                if (last_pid != respParamsStr[index2_PID_field[i]])
                {
                    topic_count += 1;
                    if (last_pid >= 0)
                    {
                        tempStr += '</div><br>';
                    }
                    tempStr += '<div id="fmsg_' + topic_count + '_' + respParamsStr[index2_PID_field[i]] + '" style="background-color:#181818;padding:5px;">';
                    if (respParamsStr[index2_Title_field[i]] != '')
                    {
                        tempStr += '<b><span style="font-variant:small-caps;font-size:18px;">' + respParamsStr[index2_Title_field[i]] + '</span></b><br>';
                    }
                    last_pid = respParamsStr[index2_PID_field[i]];
                }
                else
                {
                    tempStr += '<hr>';
                }
                tempStr += '<img src="http://' + respParamsStr[index2_AuthPic_field[i]] + '" align="left">'; 
                switch (respParamsStr[index2_AuthRole_field[i]])
                {
                case 'tea':
                    tempStr += '<b>' + respParamsStr[index2_AuthName_field[i]] + '</b> (' + respParamsStr[index2_AuthUn_field[i]] + ')<br>';
                    tempStr += ' <img src="' + global_server_prefix + 'images/profiles/tc.png" align="left"> <div style="padding-top:8px;"> &nbsp;&nbsp; <i>Teaching Couple</i></div><br>';
                    break;
                case 'mbr':
                //    tempStr += '<b>' + respParamsStr[index2_AuthName_field[i]] + '</b> (' + respParamsStr[index2_AuthUn_field[i]] + ')<br>';
                //    tempStr += ' <img src="' + global_server_prefix + 'images/profiles/cclsupport.png" align="left"> <div style="padding-top:8px;"> &nbsp;&nbsp; <i>Active Supporter</i></div><br>';
                //    break;
                case 'na':
                default:
                    tempStr += '<div style="padding-top:15px;padding-bottom:10px;"><b>' + respParamsStr[index2_AuthName_field[i]] + '</b> (' + respParamsStr[index2_AuthUn_field[i]] + ')</div><br>';
                    break;
                }
                tempStr += respParamsStr[index2_AuthMsg_field[i]] + '<br>';
                tempStr += '<span style="float:right;"><a href="javascript:PostReply(' + respParamsStr[index2_PID_field[i]] + ',' + topic_count + ',' + i + ')">Reply</a></span>';

                if (respParamsStr[index2_ChUrl_field[i]] != '')
                {
                    tempStr += '<div style="text-align:center;margin:10px;"><a href="' + respParamsStr[index2_ChUrl_field[i]] + '" target="_blank" onclick="return go2chart(this,' + i + ',' + respParamsStr[index2_PID_field[i]] + ')"><img src="images/viewchart.jpg" id="chimg_' + i + '_' + respParamsStr[index2_PID_field[i]] +'"></a><span id="chlink_' + i + '_' + respParamsStr[index2_PID_field[i]] +'"</span></div>';
                }
                
                msgTime = new Date(respParamsStr[index2_Time_field[i]]);
                msgTime.setSeconds(msgTime.getSeconds() + server_sec_diff);
                sec_diff = (currTime.getTime() - msgTime.getTime())/1000;
                if (sec_diff < 60)
                {
                    lapsedStr = Math.floor(sec_diff) + ' second(s) ago';
                }
                else if (sec_diff < 3600)
                {
                    lapsedStr = Math.floor(sec_diff/60) + ' minute(s) ago';
                }
                else if (sec_diff < 86400)
                {
                    lapsedStr = Math.floor(sec_diff/3600) + ' hour(s) ago';
                }
                else if (sec_diff < 2592000)
                {
                    lapsedStr = Math.floor(sec_diff/86400) + ' day(s) ago';
                }
                else
                {
                    lapsedStr = Math.floor(sec_diff/2592000) + ' month(s) ago';
                }
                tempStr += '<font color=Gray>' + lapsedStr + ' on ' + PrintDate(msgTime) + ' at ' + PrintTime(msgTime) + '</font>';
            }
        }
        if (tempStr == '')
        {
            if (num_posts == -1)
            {
                // No internet access
                document.getElementById('Boards_Msg_div').innerHTML = 'The server could not be reached to download a list of message board posts.  Your device may not have internet access or the server may be down.  Please try again later.';
                printOfflineStatus();
            }
            else
            {
                // No posts
                if (global_moffset_counter > 0)
                {
                    // Requesting "MORE" so append to what exists
                    document.getElementById('Boards_Msg_div').innerHTML += '<p align="center"><i>No additional messages available</i>.</p>';
                }
                else
                {
                    document.getElementById('Boards_Msg_div').innerHTML = 'No posts match the group code you have selected.';
                }
                document.getElementById('Boards_More_div').style.display = 'none';
                printStatus('');
            }
        }
        else
        {
            tempStr += '</div>';
            if (global_moffset_counter > 0)
            {
                // Requesting "MORE" so append to what exists
                document.getElementById('Boards_Msg_div').innerHTML += '<p></p>' + tempStr;
            }
            else
            {
                document.getElementById('Boards_Msg_div').innerHTML = tempStr;
            }
            printStatus('');
            // Decide if we should prompt to query more
            var MIN_NUM_POSTS_TO_RETURN = 75;
            if (num_posts >= MIN_NUM_POSTS_TO_RETURN)
            {
                document.getElementById('Boards_More_div').style.display = 'block';
            }
            else
            {
                document.getElementById('Boards_More_div').style.display = 'none';
            }
            global_moffset_counter = num_posts + global_moffset_counter;
        }
        break;
        
    case COMMUNITY_RESOURCE_PAGE_STATE_5:
LogCall('c5');
        var desiredStrStart=new Array();
        var desiredStrEnd=new Array();
        var respParamsStr=new Array();
        var index2_Title_field = new Array();
        var index2_Link_field = new Array();
        var index2_URL_field = new Array();
        var tempStr = '';
        var newContent = param_2;
        var num_links;
        var i;
    
        // Prepare variables to extract from response
        desiredStrStart[desiredStrStart.length]='NUM_LINKS=';
        desiredStrEnd[desiredStrEnd.length]=" ";
        
        // Initially parse the response to find the number of links
        respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
        num_links = respParamsStr[0];
      
        // Prepare variables to extract from response for all returned cycles
        desiredStrStart.length = 0;
        desiredStrEnd.length = 0;
        for (i=1; i<=num_links; i++)
        {
            index2_Title_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='TITLE_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]="@!@.";
            
            index2_Link_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='LINK_DESC_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]="@!@.";
            
            index2_URL_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='RES_URL_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]=" ";
        }
        
        // Parse the response 
        respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
    
        // Load values on to the screen
        for (i=0; i<num_links; i++)
        {
            if ((respParamsStr[index2_Title_field[i]] != '') && (respParamsStr[index2_Link_field[i]] != '') && (respParamsStr[index2_URL_field[i]] != ''))
            {
                tempStr += '<li><a href="' + respParamsStr[index2_URL_field[i]] + '" target="_blank" onclick="return go2url(this);">' + respParamsStr[index2_Title_field[i]] + '</a><br>' + respParamsStr[index2_Link_field[i]] + '</li><br>';
            }
        }        
        if (tempStr == '')
        {
            // No internet access
            document.getElementById('Resources_Links_div').innerHTML = 'The server could not be reached to download a list of resources.  Your device may not have internet access or the server may be down.  Please try again later.';
            printOfflineStatus();
        }
        else
        {
            document.getElementById('Resources_Links_div').innerHTML = tempStr;
            printStatus('');
        }

        var currTime = new Date(); 
        g_LoadTimestamps['resources'] = currTime.getTime();
        
        HideAct();
        break;
        
    case COMMUNITY_LIBRARY_PAGE_STATE_6:
LogCall('c6');

        var desiredStrStart=new Array();
        var desiredStrEnd=new Array();
        var respParamsStr=new Array();
        var index2_User_field = new Array();
        var index2_FullName_field = new Array();
        var index2_Uid_field = new Array();
        var tempStr = '';
        var newContent = param_2;
        var num_friends;
        var i;
    
        // Prepare variables to extract from response
        desiredStrStart[desiredStrStart.length]='FRIENDCNT=';
        desiredStrEnd[desiredStrEnd.length]=" ";
        
        // Initially parse the response to find the number of links
        respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
        num_friends = respParamsStr[0];
        
        // Prepare variables to extract from response for all returned cycles
        desiredStrStart.length = 0;
        desiredStrEnd.length = 0;
        for (i=1; i<=num_friends; i++)
        {
            index2_User_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='FUN_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]="@!@.";
            
            index2_FullName_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='FNAME_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]="@!@.";
            
            index2_Uid_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='FID_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]=" ";
        }

        // Parse the response 
        respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
    
        // Get control
        var optionsList;
        var userSelect = $('#CommLib_UserSelect');
        if(userSelect.prop) 
        {
            optionsList = userSelect.prop('options');
        }
        else 
        {
            optionsList = userSelect.attr('options');
        }
        // Clear list
        $('option', userSelect).remove();
        
        // Load content
        if (len == 0)
        {
            optionsList[optionsList.length] = new Option('No users are sharing with you', 0);
        }
        else
        {
            optionsList[optionsList.length] = new Option('Please select a user', 0);
        }
    
        // Load values on to the screen
        for (i=0; i<num_friends; i++)
        {
            if ((respParamsStr[index2_User_field[i]] != '') && (respParamsStr[index2_Uid_field[i]] != ''))
            {
                if (respParamsStr[index2_FullName_field[i]] != '')
                {
                    dispName = respParamsStr[index2_FullName_field[i]] + ' (' + respParamsStr[index2_User_field[i]] + ')';
                }
                else
                {
                    dispName = '(' + respParamsStr[index2_User_field[i]] + ')';
                }
                optionsList[optionsList.length] = new Option(dispName, respParamsStr[index2_Uid_field[i]]);
            }
        }  
        
        // Refresh control after update and make a default selection
        userSelect[0].selectedIndex = 0;
        userSelect.selectmenu("refresh");
        
        printStatus(''); 
        HideAct();
        break;
    
    default:
        break;
    }
    return;
}

function requestPublicURL(state, param_1)
{
    printDebug("State " + state + " of requestPublicURL");
    switch(state)
    {
    case 1:
LogCall('y1');

        var url_str = global_server_prefix + 'apps_get_data.aspx?' + new Date().getTime();
        var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
        
        // Add additional Name Value Pairs to upload
        uploadParameters['un'] = global_username;
        uploadParameters['pw'] = global_password;
        uploadParameters['debug'] = global_Debug_Enabled;
        uploadParameters['app_ver'] = global_app_ver_str;
        uploadParameters['device_id'] = global_device_id_str;
        uploadParameters['pcht'] = '1';
        if (document.getElementById('publicUrlEvents').checked) 
        {
            uploadParameters['chtev'] = 1;
        }
        else
        {
            uploadParameters['chtev'] = 0;
        }
        var chart_len = (global_selected_cycle_end_as_number - global_selected_cycle_as_number + 7);  // leaves 1 week for chart to grow
        if (chart_len < 40)
        {
            chart_len = 40;
        }
        uploadParameters['chtlen'] = chart_len;
        uploadParameters['date'] = PrintDate(NumberToDate(global_selected_cycle_as_number));

        // Use jQuery to upload the data to the server
        $.ajax({
            type: 'POST',
            // The URL of the request
            url: url_str,
            // Values to upload
            data: uploadParameters,
            // The success callback with result from server
            success: function(newContent) {
                // Handles response this function and advance to the next state.  Notice that the tx
                // cannot be passed to this legitimately because it is not being created as a call
                // to this registered function (it only has a newContent argument) because this 
                // callback has nothing to do with databases.  Therefore we will have to re-establish
                // the tx variable when we want to resume database operations.
                requestPublicURL(state+1, newContent);
            },
            dataType: 'html'
        });
        
        break;
    
    case 2:  
LogCall('y2');
 
        var desiredStrStart=new Array();
        var desiredStrEnd=new Array();
        var respParamsStr=new Array();
        var continue_execution;
        var newContent = param_1;

        var error_or_warning = CheckForStandardErrors(newContent);
        continue_execution = HandleServerErrorOrWarning(error_or_warning);
        if (continue_execution == 0)
        {
            // Stop execution because of a fatal error
            printDebug('Halting execution due to server returned error.');
            printStatus('Server Offline?');
            hideStatusSpinner();
            break;
        }

        // Itemize fields to look for in server response
        var index_PublicURL = desiredStrStart.length;
        desiredStrStart[desiredStrStart.length]='PUBURL=';
        desiredStrEnd[desiredStrEnd.length]="@!@.";
        
        // Parse the response to find the desired values
        respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);

        if (respParamsStr[index_PublicURL] == '')
        {
            // Could not get URL
            printDebug('No URL returned');
            ShowPopupMessage("The server could not be reached to grant permission for this chart and create a public URL.  Please try again later or try creating it after logging into the website. If this problem continues, please contact support.", 'Operation Failed', '');
            document.getElementById('publicUrlResult').innerHTML = "Could not create link.  No url returned";
        }  
        else
        {
            document.getElementById('publicUrlResult').innerHTML = '<a href="' + respParamsStr[index_PublicURL] + '">' + respParamsStr[index_PublicURL] + '</a>';
            
            // Create share links
            if (global_is_ios)
            {
                document.getElementById('share_link_em').setAttribute('href', global_server_prefix + 'email.aspx?subj=' + encodeURIComponent('My Chart') + '&url=' + encodeURIComponent(respParamsStr[index_PublicURL]) + '"');
            }
            else
            {
                document.getElementById('share_link_em').setAttribute('href', 'mailto:?subject=' + encodeURIComponent('My Chart') + '&body=' + encodeURIComponent(respParamsStr[index_PublicURL]) + '"');
            }
            document.getElementById('share_link_fb').setAttribute('href', 'http://www.facebook.com/share.php?u=' + encodeURIComponent(respParamsStr[index_PublicURL]));
            document.getElementById('share_link_tw').setAttribute('href', 'http://twitter.com/home?status=' + encodeURIComponent(respParamsStr[index_PublicURL]));
            document.getElementById('comm_share_2b').style.display = 'none'; 
            document.getElementById('comm_share_2c').style.display = 'block'; 
        }
        
        break;
    }
}
function CommPostSelectGroup()
{
    // Conditionally show "public" checkbox
    var optionsList;
    var cycleSelect = $('#CommPost_GroupsSelect');
    if(cycleSelect.prop) 
    {
        optionsList = cycleSelect.prop('options');
    }
    else 
    {
        optionsList = cycleSelect.attr('options');
    }
    if (cycleSelect[0].selectedIndex == 0)
    {
        document.getElementById('commPostPublicDiv').style.display = 'none'; 
    }
    else
    {
        document.getElementById('commPostPublicDiv').style.display = 'block'; 
    }    
}
function PostMessage(state, param_1, param_2, New0_or_Reply1)
{
    var strSql = '';
    var tx = param_1;
    
    printDebug("State " + state + " of PostMessage");
    switch(state)
    {
    case 1:
        var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
        var url_str = global_server_prefix + 'apps_forums.aspx?app=1&' + new Date().getTime();
        var ctrl_id;

        // Post to server
        printStatus('Posting');
        uploadParameters['new_post'] = '1';
        uploadParameters['un'] = global_username;
        uploadParameters['pw'] = global_password;
        uploadParameters['app_ver'] = global_app_ver_str;
        uploadParameters['device_id'] = global_device_id_str;
        if (New0_or_Reply1 == 0)
        {
            if ((document.getElementById('PostTitleTextbox').value == '') || (document.getElementById('PostBodyTextArea').value == ''))
            {
                ShowPopupMessage('New posts must contain a headline and a message body before you can post it.', 'Post Failed', '');
                printStatus('');
                break;
            }
            ctrl_id = 'Post';
            if (document.getElementById('postPublicCheckbox').checked == true)
            {
                uploadParameters['showpub'] = 1;
            }
            else
            {
                uploadParameters['showpub'] = 0;
            }
            uploadParameters['title'] = ReplaceQuotes(document.getElementById('PostTitleTextbox').value);
            uploadParameters['msg'] = ReplaceQuotes(document.getElementById('PostBodyTextArea').value);
            
            // Check Group Code
            var optionsList;
            var cycleSelect = $('#CommPost_GroupsSelect');
            if(cycleSelect.prop) 
            {
                optionsList = cycleSelect.prop('options');
            }
            else 
            {
                optionsList = cycleSelect.attr('options');
            }
            if (cycleSelect[0].selectedIndex == 0)
            {
                uploadParameters['gcode'] = ''; 
            }
            else
            {
                uploadParameters['gcode'] = ReplaceQuotes(document.getElementById('CommPost_GroupsSelect').value); 
            }
            
            uploadParameters['pid'] = 0;
        }
        else
        {
            if (document.getElementById('ReplyBodyTextArea').value == '')
            {
                printStatus('Empty Post Failed');
                break;
            }
            ctrl_id = 'Board';
            // Reply to a message
            uploadParameters['showpub'] = 0;
            uploadParameters['title'] = '';
            uploadParameters['msg'] = ReplaceQuotes(document.getElementById('ReplyBodyTextArea').value);
            uploadParameters['pid'] = document.getElementById('ReplyPID').innerHTML;
            $('#divPopUpReply').popup('close');
        }
        if (document.getElementById('Comm' + ctrl_id + 'ChartCheck').checked)
        {
            ch_date = document.getElementById('Comm' + ctrl_id + 'ChartStart').innerHTML;
            if (ch_date.indexOf("No chart") <= -1)
            {
                uploadParameters['chdate'] = ch_date;     
            }
            if (document.getElementById(ctrl_id + 'EventsCheckbox').checked)
            {
                uploadParameters['chev'] = 1;
            }
            else
            {
                uploadParameters['chev'] = 0;
            }
        }
        if (document.getElementById(ctrl_id + 'AnonCheckbox').checked)
        {
            uploadParameters['anon'] = 1;
        }

        // Use jQuery to upload the data to the server
        $.ajax({
            type: 'POST',
            // The URL of the request
            url: url_str,
            // Values to upload
            data: uploadParameters,
            // The success callback with result from server
            success: function(newContent) {
                // Handles response this function and advance to the next state.  Notice that the tx
                // cannot be passed to this legitimately because it is not being created as a call
                // to this registered function (it only has a newContent argument) because this 
                // callback has nothing to do with databases.  Therefore we will have to re-establish
                // the tx variable when we want to resume database operations.
                PostMessage(state+1, tx, newContent, New0_or_Reply1);
            },
            dataType: 'html'
        });
        break;
        
    case 2:
        var newContent = param_2;
        var desiredStrStart=new Array();
        var desiredStrEnd=new Array();
        var respParamsStr=new Array();
        
        // Check for success
        desiredStrStart[desiredStrStart.length]='POST_SUCCESSFUL=';
        desiredStrEnd[desiredStrEnd.length]=" ";
        
        desiredStrStart[desiredStrStart.length]='CANT_POST_WO_SUB=';
        desiredStrEnd[desiredStrEnd.length]=" ";        
        
        // Parse the response to find the desired values
        respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
        
        // Notify of success
        if (respParamsStr[0] == 1)
        {
            // Clear
            if (New0_or_Reply1 == 0)
            {
                document.getElementById('PostTitleTextbox').value = '';
                document.getElementById('PostBodyTextArea').value = '';
                // Show message boards
                TransitionToSubscreen('comm_board','none');
            }
            else
            {
                document.getElementById('ReplyBodyTextArea').value = '';
                // Reload posts
                navBetweenCommScreens(1, COMM_BOARDS_SCREEN, '', '', 0); // "#comm_board"
            } 
        }
        else if (respParamsStr[1] == 1)
        {
            ShowPopupMessage('Posting to the online message boards requires an active subscription.  Please check your account and try again.', 'Post Failed', '');
        }
        else
        {
            ShowPopupMessage('There was a problem posting your message.  Please confirm you are connected to the internet and try again.', 'Post Failed', '');
        }

        printStatus(''); 
        break;
    }
}
function PostReply(pid, top_cnt, index)
{
    var prior_msg = document.getElementById('fmsg_' + top_cnt + '_' + pid).innerHTML;
    var pos1;
    var pos2;
    // Remove browser link
    var rem_str = '<a href="javascript:PostReply(' + pid + ',' + top_cnt + ',';
    var rem_str_2 = ')">Reply</a>';
    var before_replace = '';
    var temp_str;
    while (before_replace != prior_msg)
    {
        before_replace = prior_msg;
        pos1 = prior_msg.indexOf(rem_str);
        if (pos1 > 0)
        {
            temp_str = prior_msg.substring(pos1+rem_str.length, pos1+rem_str.length+20);
            pos2 = temp_str.indexOf(rem_str_2);
            if (pos2 > 0)
            {
                prior_msg = prior_msg.substring(0,pos1) + prior_msg.substring(pos1 + rem_str.length + pos2 + rem_str_2.length);
            }
        }
    }
    // Hide images not downloaded
    rem_str = '<img src="images/viewchart.jpg" id="chimg_' + index + '_' + pid +'">';
    before_replace = '';
    while (before_replace != prior_msg)
    {
        before_replace = prior_msg;
        prior_msg = prior_msg.replace(rem_str, '');
    }
    // Give downloaded images new IDs
    rem_str = 'id="chimg_';
    temp_str = 'id="repimg_';
    var before_replace = '';
    while (before_replace != prior_msg)
    {
        before_replace = prior_msg;
        prior_msg = prior_msg.replace(rem_str, temp_str);
    }    
    
    document.getElementById('ReplyDiv').innerHTML = prior_msg + '<br><hr><b>Your Response:</b><br>';
    document.getElementById('ReplyPID').innerHTML = pid;
    $('#divPopUpReply').popup('open');
}
function RetrieveCharts(state, search_type, param_1, param_2)
{
    var strSql = '';
    var tx = param_1;
    
    printDebug("State " + state + " of RetrieveCharts");
    switch(state)
    {
    case 1:
        var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
        var url_str = global_server_prefix + 'apps_forums.aspx?app=1&' + new Date().getTime();
        var ctrl_id;
        var error_execution = false;

        switch(search_type)
        {
        case 'u': // User
            uploadParameters['chartlist'] = '1';
            if (document.getElementById('CommLib_UserSelect').value > 0)
            {
                uploadParameters['frid'] = document.getElementById('CommLib_UserSelect').value;
            }
            else
            {
                error_execution = true;
            }
            break;
        case 'l': // Library
            uploadParameters['chartlib'] = '1';
            if (document.getElementById('ChLib_FindLikeMineCheck').checked)
            {
                var working_str = document.getElementById('CommLibChartStart').innerHTML;
                if ((working_str.indexOf('-') > 0) || (working_str.indexOf('//') > 0))
                {
                    uploadParameters['cycdate'] = working_str;
                }
                else
                {
                    ShowPopupMessage('No cycle is specified.  Please view the chart for the cycle you wish to search with and try again. (Charts &gt; Pick Another Cycle)', 'Cannot search', '');
                    error_execution = true;
                    break;
                }                    
            }
            else
            {
                if (document.getElementById('ChLib_CompletedCheck').checked)
                {
                    uploadParameters['find_comp'] = '1';
                }
                if (document.getElementById('ChLib_PregCheck').checked)
                {
                    uploadParameters['find_conceive'] = '1';
                }
                if (document.getElementById('ChLib_MucusCheck').checked)
                {
                    uploadParameters['find_muctrack'] = '1';
                }
                if (document.getElementById('ChLib_TempCheck').checked)
                {
                    uploadParameters['find_temptrack'] = '1';
                }
                if (document.getElementById('ChLib_CervixCheck').checked)
                {
                    uploadParameters['find_cervixtrack'] = '1';
                }
                if (document.getElementById('ChLib_LHTestCheck').checked)
                {
                    uploadParameters['find_lhtrack'] = '1';
                }
                if (document.getElementById('ChLib_MonCheck').checked)
                {
                    uploadParameters['find_montrack'] = '1';
                }
                if (document.getElementById('ChLib_EndoCheck').checked)
                {
                    uploadParameters['find_endo'] = '1';
                }
                if (document.getElementById('ChLib_PCOSCheck').checked)
                {
                    uploadParameters['find_pcos'] = '1';
                }
                if (document.getElementById('ChLib_ProDefCheck').checked)
                {
                    uploadParameters['find_prodef'] = '1';
                }
                if (document.getElementById('ChLib_LowSpermCheck').checked)
                {
                    uploadParameters['find_lowsperm'] = '1';
                }
                if (document.getElementById('ageMinTextbox').value != '')
                {
                    uploadParameters['find_minage'] = ReplaceQuotes(document.getElementById('ageMinTextbox').value);
                }
                if (document.getElementById('ageMaxTextbox').value != '')
                {
                    uploadParameters['find_maxage'] = ReplaceQuotes(document.getElementById('ageMaxTextbox').value);
                }
                if (document.getElementById('cycMinTextbox').value != '')
                {
                    uploadParameters['find_minclen'] = ReplaceQuotes(document.getElementById('cycMinTextbox').value);
                }
                if (document.getElementById('cycMaxTextbox').value != '')
                {
                    uploadParameters['find_maxclen'] = ReplaceQuotes(document.getElementById('cycMaxTextbox').value);
                }
            }
            break;
        }
        
        if (error_execution == false)
        {
            // Post to server
            printStatus('Connecting');
            
            uploadParameters['un'] = global_username;
            uploadParameters['pw'] = global_password;
            uploadParameters['app_ver'] = global_app_ver_str;
            uploadParameters['device_id'] = global_device_id_str;
            
            // Use jQuery to upload the data to the server
            $.ajax({
                type: 'POST',
                // The URL of the request
                url: url_str,
                // Values to upload
                data: uploadParameters,
                // The success callback with result from server
                success: function(newContent) {
                    // Handles response this function and advance to the next state.  Notice that the tx
                    // cannot be passed to this legitimately because it is not being created as a call
                    // to this registered function (it only has a newContent argument) because this 
                    // callback has nothing to do with databases.  Therefore we will have to re-establish
                    // the tx variable when we want to resume database operations.
                    RetrieveCharts(state+1, search_type, param_1, newContent)
                },
                dataType: 'html'
            });
        }
        break;
        
    case 2:
        var newContent = param_2;
        var desiredStrStart=new Array();
        var desiredStrEnd=new Array();
        var respParamsStr=new Array();
        var index2_ChUrl_field = new Array();
        var index2_ChType_field = new Array();
        var index2_ChId_field = new Array();
        var index2_ChDate_field = new Array();
        var num_charts = 0;
        var chart_date;
        var chart_date_str;
        var tempStr = '';
        
        // Check for success
        desiredStrStart[desiredStrStart.length]='CHARTCNT=';
        desiredStrEnd[desiredStrEnd.length]=" ";
        
        // Parse the response to find the desired values
        respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);

        if (respParamsStr[0] != '')
        {
            num_charts = parseInt(respParamsStr[0]);
        }

        // Prepare variables to extract from response for all returned cycles
        desiredStrStart.length = 0;
        desiredStrEnd.length = 0;
        
        for (i=1; i<=num_charts; i++)
        {
            index2_ChDate_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='CHDATE_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]=" ";
            
            index2_ChType_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='CHTYPE_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]=" ";
            
            index2_ChId_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='CHID_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]=" ";            
            
            index2_ChUrl_field[i-1] = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='CHURL_' + i + '=';
            desiredStrEnd[desiredStrEnd.length]=" ";
        }

        // Parse the response 
        respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);

        if (num_charts == 0)
        {
            tempStr += '<h2>No matching charts could be found</h2>';
        }
        for (i=0; i<num_charts; i++)
        {
            chart_date_str = Date.parse(respParamsStr[index2_ChDate_field[i]] + ' 1:00:00');
            chart_date = new Date(chart_date_str);
            tempStr += '<p></p><h2>';
            switch(respParamsStr[index2_ChType_field[i]])
            {
                case 'pp':
                    tempStr += 'Postpartum';
                    break;
                case 'cycle':
                    tempStr += 'Cycle';
                    break;
                default:
                    tempStr += 'Pregnancy';
                    break;
            }
            tempStr += ' starting on ' + PrintDate(chart_date);
            if ((respParamsStr[index2_ChId_field[i]] != '') && (respParamsStr[index2_ChId_field[i]] != 0))
            {
                tempStr += ' (' + respParamsStr[index2_ChId_field[i]] + ')';
            }
            tempStr += '</h2>';
            if (respParamsStr[index2_ChUrl_field[i]] != '')
            {
                tempStr += '<div style="text-align:center;margin:10px;"><a href="' + respParamsStr[index2_ChUrl_field[i]] + '" target="_blank" onclick="return go2chart(this,' + i + ',' + 99 + ')"><img src="images/viewchart.jpg" id="chimg_' + i + '_' + 99 +'"></a><span id="chlink_' + i + '_' + 99 +'"</span></div>';
            }
            tempStr += '<hr>';
        }
        
        // Display results
        document.getElementById('CommLib_ResultsSect').style.display = 'block';
        document.getElementById('CommLibSearchResults').innerHTML = tempStr;
        
        printStatus(''); 
        break;
    }
}
function ToggleDivViaCheckbox(checkbox_id, page_div_show, page_div_hide)
{
     if (document.getElementById(checkbox_id).checked)
     {
        document.getElementById(page_div_show).style.display = 'none';
        document.getElementById(page_div_hide).style.display = 'block';
     }
     else
     {
        document.getElementById(page_div_show).style.display = 'block';
        document.getElementById(page_div_hide).style.display = 'none';
     }
}

