///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Settings FUNCTIONS
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

    var enable_db_drop = false;

    function NavToSubscriptionInfo()
    {
        var curr_screen = 1;
        
        // Show that an action is in process
        ShowAct();
        
        // Find the settings page
        for (var i=0; i<global_Settings_Pages.length; i++)
        {
            if (global_Settings_Pages[i] == "settings_sub")
            {
                curr_screen = i;
                break;
            }
        }
        
        // Update the local database so it will take us to the Subscription page when we navigate to "Settings"
        var strSql = 'UPDATE User_Info_DB SET last_settings_screen=' + curr_screen + ' WHERE 1;';
        open_database_and_execute(strSql, '');
        
        // Call "Settings" navigation after a short delay to allow time for the last_settings_screen change to take effect
        ShowAct();
        TransitionToSubscreen("settings_sub", "slide");
    }
    
    function navBetweenSettings(state, target_screen, param_1, param_2)
    {
        var strSql = '';
        var tx = param_1;
        var TARGET_EVENTS_3 = 3;
        var TARGET_SETTINGS_4 = 4;
        var TARGET_SUBSCRIBE_5 = 5;
        var TARGET_PREG_7 = 7;
        var TARGET_GROUPS_8 = 8;

        printDebug("State " + state + " of navBetweenSettings");
        switch(state)
        {
        case 1:
LogCall('e1');
            // Open local database
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_NavBtSet_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_NavBtSet_1 = -1;
                                    navBetweenSettings(state+1, target_screen, tx, '');
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_NavBtSet_1 > 0)
                                    {
                                        global_db_ios_fail_NavBtSet_1 = global_db_ios_fail_NavBtSet_1 - 1;
                                        printDebug('iOS db.transaction failed NavBetweenSettings state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_NavBtSet_1));
                                        navBetweenSettings(state, target_screen, param_1, param_2);
                                    }
                                    else if (global_db_ios_fail_NavBtSet_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            // Set dynamic build content for loaded page
            setDynamicContentForAppInstance(global_Settings_Pages[target_screen]);
            
            break;

        case 2:
LogCall('e2');
            var target_state = TARGET_EVENTS_3;
            
            // Determine appropriate string
            switch(target_screen)
            {
            case 0:     
                // App Settings Screen
                strSql = 'SELECT * FROM User_Info_DB;';
                target_state = TARGET_SETTINGS_4;
                break;
            case 1:
                // Events Settings Screen
                strSql = 'SELECT * FROM Event_Settings_DB;';
                target_state = TARGET_EVENTS_3;
                break;
            case 2:
                // Subscription Settings Screen - No local database query is needed.  Just download from web by calling into that state
                strSql = '';
                target_state = -1;
                navBetweenSettings(TARGET_SUBSCRIBE_5, 0, '', '');
                break;
            case 3:
                // Pregnancy Setting Screen
                strSql = 'SELECT * FROM Preg_DB;';
                target_state = TARGET_PREG_7;
                break;
            case 4:
                // Message Group Settings
                strSql = 'SELECT * FROM Groups_DB;';
                target_state = TARGET_GROUPS_8;
                break;
            case 5:
            default:
                // About Settings Screen - No local database query is needed.  Uses static content
                document.getElementById('app_version_div').innerHTML = CURRENT_APP_VERSION;
                document.getElementById('app_info_resolution_div').innerHTML = $('body').width() + ' by ' + $('body').height();
                document.getElementById('app_info_scale_div').innerHTML = global_calculated_scale + '<br>' + global_app_ver_str;
                strSql = '';
                target_state = -1;
                break;
            }
            
            if (target_state > 0)
            {
                // Query values from local database. 
                suspend_scrolling(true, '');
                tx.executeSql(  strSql, 
                                [], 
                                function(tx, results) 
                                {
                                    suspend_scrolling(false, 0);
                                    navBetweenSettings(target_state, target_screen, tx, results);
                                },
                                function(tx, err)
                                {
                                    crash_and_burn(err, 'Error querying local DataRecs database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                                }
                             );
             }
             else
             {
                HideAct();
             }
             HideAct_Legacy();
            break;
            
        case TARGET_EVENTS_3:     // EVENTS Screen
LogCall('e3');
            // Retrieve results of query
            var results = param_2;
            var cev_name = '';
            var encoded = new Array();
            var decoded = new Array();
            var checked_value = false;
            var i;
            
            // Determine which events should be visible
            for (i=1; i<=NUMBER_OF_EVENT_WORDS; i++)
            {
                // Get values from database
                encoded[i-1] = results.rows.item(0)['ev_show_word' + i];
            }
            // Convert from encoded to decoded values
            decoded = DecompressEventBits(encoded);
            // Loop through and initialize values as appropriate
            for (i=0; i<decoded.length; i++)
            {
                if (decoded[i] == 0)
                {
                    checked_value = false; 
                }
                else
                {
                    checked_value = true;
                }
                $("input[id='evShowCheckbox_" + i + "']").attr("checked", checked_value).checkboxradio("refresh");
            }
            // Load custom event names
            for (i=1; i<=NUMBER_OF_CUSTOM_EVENTS; i++)
            {
                cev_name = results.rows.item(0)['cev_name_' + i];
                document.getElementById('evShowCustomText' + i).value = cev_name;
            }
            HideAct();
            break;
            
        case TARGET_SETTINGS_4:     // APP SETTINGS Screen
LogCall('e4');
            var results = param_2;
            // Load Fields
            document.getElementById('app_settings_username_span').innerHTML = results.rows.item(0)['un'].toLowerCase();
            $("input[id='appSettings_ReqLogin']").attr("checked", convert_01_to_TF(results.rows.item(0)['pw_prompt'])).checkboxradio("refresh");
            $("input[id='appSettings_ShowTips']").attr("checked", convert_01_to_TF(results.rows.item(0)['tip_of_day_enabled'])).checkboxradio("refresh");
            $("input[id='appSettings_CathMode']").attr("checked", convert_01_to_TF(results.rows.item(0)['catholic'])).checkboxradio("refresh");
            $("input[id='appSettings_EnabRemote']").attr("checked", convert_01_to_TF(results.rows.item(0)['enable_remote_analysis'])).checkboxradio("refresh");
            $("input[id='appSettings_EnDebug']").attr("checked", convert_01_to_TF(results.rows.item(0)['debug'])).checkboxradio("refresh");
            $("input[id='appSettings_CalShade']").attr("checked", convert_01_to_TF(results.rows.item(0)['cal_shade'])).checkboxradio("refresh");
            $("input[id='appSettings_CalOv']").attr("checked", convert_01_to_TF(results.rows.item(0)['cal_ov'])).checkboxradio("refresh");
            switch(results.rows.item(0)['t_units'])
            {
            case 'F':
            default:
                $("input[id='appSettings_tUnitsRadio_C']").attr("checked",false).checkboxradio("refresh");
                $("input[id='appSettings_tUnitsRadio_F']").attr("checked",true).checkboxradio("refresh");
                break;
            case 'C':
                $("input[id='appSettings_tUnitsRadio_C']").attr("checked",true).checkboxradio("refresh");
                $("input[id='appSettings_tUnitsRadio_F']").attr("checked",false).checkboxradio("refresh");
                break;
            }
            switch(results.rows.item(0)['sync_interval'])
            {
            case 60:
                $("input[id='appSettings_RemSync_1m']").attr("checked",true).checkboxradio("refresh");
                break;
            case 180:
            default:
                $("input[id='appSettings_RemSync_3m']").attr("checked",true).checkboxradio("refresh");
                break;
            case 300:
                $("input[id='appSettings_RemSync_5m']").attr("checked",true).checkboxradio("refresh");
                break;
            case 600:
                $("input[id='appSettings_RemSync_10m']").attr("checked",true).checkboxradio("refresh");
                break;
            }
            HideAct();
            break;
            
        case TARGET_SUBSCRIBE_5:     // SUBSCRIPTION Screen
LogCall('e5');
            var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
            var url_str = global_server_prefix + 'apps_get_data.aspx?' + new Date().getTime();
            
            // Display username
            document.getElementById('app_account_un_span').innerHTML = global_username.toLowerCase();
            document.getElementById('sub_bottom_webad').innerHTML = document.getElementById('sub_top_webad').innerHTML;
            
            // Validate the password with the online version.  Specify values to upload
            uploadParameters['un'] = global_username;
            uploadParameters['pw'] = global_password;
            uploadParameters['subhist'] = '1';
            uploadParameters['debug'] = global_Debug_Enabled;
            uploadParameters['app_ver'] = global_app_ver_str;
            uploadParameters['device_id'] = global_device_id_str;

            // Use jQuery to post data to the server
            $.ajax({
                type: 'POST',
                // The URL of the request
                url: url_str,
                // Values to upload
                data: uploadParameters,
                // The success callback with result from server
                success: function(newContent) {
                    // Handles response this function and advance to the next state.  Notice that the tx
                    // cannot be passed to this legitimately because it is not being created as a call
                    // to this registered function (it only has a newContent argument) because this 
                    // callback has nothing to do with databases.  Therefore we will have to re-establish
                    // the tx variable when we want to resume database operations.
                    navBetweenSettings(state+1, target_screen, newContent, '');
                },
                dataType: 'html'
            });  
            break;
            
        case 6:
LogCall('e6');
            var newContent = param_1;
            var offset;

            var new_pw = param_2;
            var c_LOGIN_OK = 0;
            var c_NUMBER_OF_ORDERS = 1;
            var c_PAY_URL = 2;
            var c_NO_SUB = 3;
            var c_FULL_SUB = 4;
            var c_SUB_EXP_DATE = 5;
            var c_PAY_OPT_DESC_BASE = 6;    // uses 6-8
            var c_PAY_OPT_URL_BASE = 7;     // uses 9-11
            var c_PAY_HISTORY_BASE = 12;     // uses 12 onward in groups of 4 (e.g. 12-15, etc)

            var desiredStrStart=new Array();        // Start delimeter to look for in server response
            var desiredStrEnd=new Array();          // End delimeter to look for in server response
            var respParamsStr=new Array();          // Placeholder for the parsed response found in the server returned content.
            
            desiredStrStart[c_LOGIN_OK]="LOGIN_OK";
            desiredStrEnd[c_LOGIN_OK]="";
            
            desiredStrStart[c_NUMBER_OF_ORDERS]="NUM_ORDERS=";
            desiredStrEnd[c_NUMBER_OF_ORDERS]=" ";
            
            // Do a preliminary parse to find how many orders we need to look up
            respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
            
            // Setup to extract payment info fields
            desiredStrStart[c_NO_SUB]="NO_SUB";
            desiredStrEnd[c_NO_SUB]="";
            desiredStrStart[c_FULL_SUB]="FULL_SUB";
            desiredStrEnd[c_FULL_SUB]="";          
            desiredStrStart[c_SUB_EXP_DATE]="SUB_EXP=";
            desiredStrEnd[c_SUB_EXP_DATE]=" "; 

            desiredStrStart[c_PAY_URL]="PAY_URL=";
            desiredStrEnd[c_PAY_URL]=" "; 
            for (var i=1; i<=3; i++)
            {
                offset = (i-1)*2;
                desiredStrStart[c_PAY_OPT_DESC_BASE + offset]="PAY_OPT" + i + "_DESC=";
                desiredStrEnd[c_PAY_OPT_DESC_BASE + offset]="@!@";
                
                desiredStrStart[c_PAY_OPT_URL_BASE + offset]="PAY_OPT" + i + "_URL=";
                desiredStrEnd[c_PAY_OPT_URL_BASE + offset]="@!@";                
            }

            // Loop through and extract the payment history or arbitrary length
            for (var i=1; i<=respParamsStr[c_NUMBER_OF_ORDERS]; i++)
            {
                offset = (i-1)*4; 
                
                desiredStrStart[c_PAY_HISTORY_BASE + 0 + offset]="PAY_DATE_" + i + "=";
                desiredStrEnd[c_PAY_HISTORY_BASE + 0 + offset]=" ";
                
                desiredStrStart[c_PAY_HISTORY_BASE + 1 + offset]="ORDER_ID_" + i + "=";
                desiredStrEnd[c_PAY_HISTORY_BASE + 1 + offset]=" ";

                desiredStrStart[c_PAY_HISTORY_BASE + 2 + offset]="AMOUNT_" + i + "=";
                desiredStrEnd[c_PAY_HISTORY_BASE + 2 + offset]=" ";      

                desiredStrStart[c_PAY_HISTORY_BASE + 3 + offset]="NEW_EXP_" + i + "=";
                desiredStrEnd[c_PAY_HISTORY_BASE + 3 + offset]=" "; 
            }

            // Re-Parse the response to find the desired values
            respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
            
            // Check the sought parameters
            if (respParamsStr[c_LOGIN_OK] == '1')
            {
                // Load subscription status
                document.getElementById('settingsSubStatus').innerHTML = 'Unknown - Could not check status';
                if (respParamsStr[c_NO_SUB] == 1)
                {
                    document.getElementById('settingsSubStatus').innerHTML = 'Subscription is Expired<br>Expired on: ' + respParamsStr[c_SUB_EXP_DATE];
                }
                if (respParamsStr[c_FULL_SUB] == 1)
                {
                    document.getElementById('settingsSubStatus').innerHTML = 'Subscription is Active<br>Active through: ' + respParamsStr[c_SUB_EXP_DATE];
                }
                document.getElementById('settingsSubStatusLink').innerHTML = '<a href="' + respParamsStr[c_PAY_URL] + '" target="_blank" onclick="return go2url(this);">Manage Subscriptions</a>';
                for (var i=1; i<=3; i++)
                {
                    offset = (i-1)*2;
                    document.getElementById('settingsOptionDesc_' + i).innerHTML = respParamsStr[c_PAY_OPT_DESC_BASE + offset];
                    document.getElementById('settingsOptionURL_' + i).innerHTML = respParamsStr[c_PAY_OPT_URL_BASE + offset];
                }
                var historyStr = '';
                for (var i=respParamsStr[c_NUMBER_OF_ORDERS]; i>0; i--)
                {
                    offset = (i-1)*4; 
                    
                    historyStr += "<u>Payment #" + i + "</u><br>";
                    historyStr += "Paid: " + respParamsStr[c_PAY_HISTORY_BASE + 2 + offset];
                    historyStr += " on " + respParamsStr[c_PAY_HISTORY_BASE + 0 + offset];
                    historyStr += "<BR>";
                    historyStr += "Order #" + respParamsStr[c_PAY_HISTORY_BASE + 1 + offset];
                    historyStr += ".  Expires on " + respParamsStr[c_PAY_HISTORY_BASE + 3 + offset] + '<BR><BR>';
                }
                document.getElementById('settingsPayHistoryDiv').innerHTML = historyStr;
            }
            HideAct();
            break;
           
        case TARGET_PREG_7:     // Pregnancy Screen
LogCall('e7');
            // Retrieve results of query
            var results = param_2;
            var len = results.rows.length;
            var record_date_val;
            var record_date_str;
            var preg_len;
            var i;
            
            // Get drop down control control for preg picker
            var optionsList;
            var cycleSelect = $('#Settings_PregPickerSelect');
            if(cycleSelect.prop) 
            {
                optionsList = cycleSelect.prop('options');
            }
            else 
            {
                optionsList = cycleSelect.attr('options');
            }
            
            // Clear list
            $('option', cycleSelect).remove();
            
            // Load content
            if (len == 0)
            {
                optionsList[optionsList.length] = new Option('No pregnancies recorded yet', 0);
                document.getElementById('Settings_PregHistory').innerHTML = 'You have not recorded any previous pregnancies.';
            }
            else
            {
                optionsList[optionsList.length] = new Option('Please select a pregnancy', 0);           
                document.getElementById('Settings_PregHistory').innerHTML = '';
                
                // Loop through results and populate pregs
                for (var i=0; i<len; i++)
                {
                    record_date_val = results.rows.item(i)['preg_started'];
                    record_date_str = PrintDate(NumberToDate(record_date_val));
                    preg_len = results.rows.item(i)['preg_len'];
                    if (preg_len > 0)
                    {
                        optionsList[optionsList.length] = new Option(record_date_str, record_date_val);
                        document.getElementById('Settings_PregHistory').innerHTML += '<u>Pregnancy ' + (i+1) + '</u>:<br>Started:<b> ' + record_date_str + '</b><br>Duration: <b>' + (preg_len+13) + ' days</b><br>Type: <b>' + ConvertPregOutcome(results.rows.item(i)['preg_status'],false,false,true,false) + '</b><br>End Date: <b>' + PrintDate(NumberToDate(record_date_val+preg_len-1)) + '</b><br><br>';
                    }
                    else
                    {
                        printDebug('DELETED PREG ' + record_date_val + ' IGNORED');
                    }
                }
                document.getElementById('Settings_PregHistory').innerHTML += '</ul>';
            }
            
            // Refresh control after update and make a default selection
            cycleSelect[0].selectedIndex = 0;
            cycleSelect.selectmenu("refresh");
            
            HideAct();
            break;
           
        case TARGET_GROUPS_8:     // Message Group Screen
LogCall('e8');
            // Retrieve results of query
            var results = param_2;
            var len = results.rows.length;
            var i;
            
            // Get drop down control control for preg picker
            var optionsList;
            var groupSelect = $('#Settings_GroupsSelect');
            if(groupSelect.prop) 
            {
                optionsList = groupSelect.prop('options');
            }
            else 
            {
                optionsList = groupSelect.attr('options');
            }
            
            // Clear list
            $('option', groupSelect).remove();
            
            // Load content
            if (len == 0)
            {
                optionsList[optionsList.length] = new Option('No groups defined', 0);
            }
            else
            {
                optionsList[optionsList.length] = new Option('Please select a group', 0);           
                
                // Loop through results and populate
                for (var i=0; i<len; i++)
                {
                    var code_desc = results.rows.item(i)['desc'] + ' (' + results.rows.item(i)['gcode'] + ')';
                    var db_id = results.rows.item(i)['id'];
                    optionsList[optionsList.length] = new Option(code_desc, db_id);
                }
            }
            
            // Refresh control after update and make a default selection
            groupSelect[0].selectedIndex = 0;
            groupSelect.selectmenu("refresh");
            
            HideAct();
            break;
           
        default:
            break;
        }
        return;
    }
    
    function switchDispShowCategory(which_suffix)
    {
        var NUMBER_OF_CATEGORIES = 6;
        
        // First hide all of them
        for (var i=1; i<=NUMBER_OF_CATEGORIES; i++)
        {
            document.getElementById('divEvShow_' + i).style.display = 'none';
        }
        
        // Then display only this selected one
        document.getElementById('divEvShow_' + which_suffix).style.display = 'block';
        
        return;
    }
    
    function changeUsername()
    {
LogCall('1c');
        // Prompt user with warnings and then drop all tables and restart app.  May not be necessary
        // if uninstalling the app also effectively drops the tables.
        if (enable_db_drop == true)
        {
            drop_databases();
            setTimeout("ClosePopupMessage();startup_app_navigation();",3500);
            g_LoadTimestamps = {};
            ShowPopupMessage("Your app has been reset.  You can now associate it with another account.  The app will restart in 3 seconds.", 'App Reset', '');
        }
        else
        {
            ShowPopupMessage("WARNING: This will delete all data on your device.  To change username, you must reset this app and delete all data stored within it.  Make sure you have synchronized with the remote server first if you want to preserve any data.  If you really want to delete all data and reset the app so you can associate with another account, press this same button again within 10 seconds of the first time you pushed it.", 'WARNING', '');
            setTimeout("changeUsernameTimeUp();",10000);
            $('#ChangeUsernameButton').parent().find('.ui-btn-text').text('Proceed to DELETE My App Data!');
            enable_db_drop = true;
        }
        return;
    }
    function changeUsernameTimeUp()
    {
        enable_db_drop=false;
        if (GetCurrentPage() == 'settings_app')
        {
            document.getElementById('ChangeUsernameButton').value = '';
            $('#ChangeUsernameButton').parent().find('.ui-btn-text').text('Change Account');
        }
    }
    
    function tryToChangePw(state, param_1, param_2)
    {
LogCall('1d');
        printDebug("State " + state + " of tryToChangePw");
        switch(state)
        {
        case 1:
            // Check if they have successfully entered enough information to change the password
            if (document.getElementById('appSettings_CurrPwTextbox').value == '')
            {
                // Apparently they are not trying to change the password
                document.getElementById('appSettings_PwChgStatus').innerHTML = '';
            }
            else if (document.getElementById('appSettings_NewPwTextbox').value == '')
            {
                // Apparently they are not trying to change the password
                document.getElementById('appSettings_PwChgStatus').innerHTML = '';
            }
            else if (document.getElementById('appSettings_NewPwTextbox').value != document.getElementById('appSettings_ConfirmPwTextbox').value)
            {
                // They must not be trying to change the password
                document.getElementById('appSettings_PwChgStatus').innerHTML = 'Passwords Do Not Match';
            }
            else
            {
                // Validate the password with the online version.  It will accept and change the password if the old or new
                // password they type in matches the current password associated with their web account
                var new_pw = ReplaceQuotes(document.getElementById('appSettings_NewPwTextbox').value, 1);
                var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
                var url_str = global_server_prefix + 'apps_set_data.aspx?' + new Date().getTime();
                
                // Validate the password with the online version.  Specify values to upload
                uploadParameters['un'] = global_username;
                uploadParameters['pw'] = ReplaceQuotes(document.getElementById('appSettings_CurrPwTextbox').value, 1);
                uploadParameters['chgd_pw'] = new_pw;
                uploadParameters['debug'] = global_Debug_Enabled;
                uploadParameters['app_ver'] = global_app_ver_str;
                uploadParameters['device_id'] = global_device_id_str;

                // Use jQuery to post data to the server
                $.ajax({
                    type: 'POST',
                    // The URL of the request
                    url: url_str,
                    // Values to upload
                    data: uploadParameters,
                    // The success callback with result from server
                    success: function(newContent) {
                        // Handles response this function and advance to the next state.  Notice that the tx
                        // cannot be passed to this legitimately because it is not being created as a call
                        // to this registered function (it only has a newContent argument) because this 
                        // callback has nothing to do with databases.  Therefore we will have to re-establish
                        // the tx variable when we want to resume database operations.
                        tryToChangePw(state+1, newContent, new_pw);
                    },
                    dataType: 'html'
                });
            }           
            break;
            
        case 2:
            var newContent = param_1;
            var new_pw = param_2;
            var c_LOGIN_OK = 0;
            var c_PW_CHG = 1;
            var c_PW_RESET = 2;
            var c_LOGIN_INVALID = 3;

            var desiredStrStart=new Array();        // Start delimeter to look for in server response
            var desiredStrEnd=new Array();          // End delimeter to look for in server response
            var respParamsStr=new Array();          // Placeholder for the parsed response found in the server returned content.
            
            desiredStrStart[c_LOGIN_OK]="LOGIN_OK";
            desiredStrEnd[c_LOGIN_OK]="";
            
            desiredStrStart[c_PW_CHG]="PW_CHANGED";
            desiredStrEnd[c_PW_CHG]="";
            
            desiredStrStart[c_PW_RESET]="PW_RESET";
            desiredStrEnd[c_PW_RESET]="";
            
            desiredStrStart[c_LOGIN_INVALID]="LOGIN_INVALID";
            desiredStrEnd[c_LOGIN_INVALID]="";

            // Parse the response to find the desired values
            respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
            
            // Check the sought parameters
            if (respParamsStr[c_LOGIN_OK] == '1')
            {
                if (respParamsStr[c_PW_CHG] == '1')
                {
                    // Success - update local database
                    strSql = 'UPDATE User_Info_DB SET pw="' + new_pw + '" WHERE 1;';
                    open_database_and_execute(strSql, '');
                    
                    // Update status
                    document.getElementById('appSettings_CurrPwTextbox').value = '';
                    document.getElementById('appSettings_NewPwTextbox').value = '';
                    document.getElementById('appSettings_ConfirmPwTextbox').value = '';
                    document.getElementById('appSettings_PwChgStatus').innerHTML = 'Password Changed';
                    
                    break;
                }
                else if (respParamsStr[c_PW_RESET] == '1')
                {
                    // Error because password was reset due to too many failed attempts
                    document.getElementById('appSettings_CurrPwTextbox').value = '';
                    document.getElementById('appSettings_PwChgStatus').innerHTML = 'Incorrect Password';
                    break;
                }
            }
            // If we made it here, then the password got rejected
            document.getElementById('appSettings_PwChgStatus').innerHTML = 'Incorrect Password';
            break;
        
        default:
            break;
        }
        return;
    }
    
    function setRequeryRate(new_rate)
    {
        var strSql = '';
        // Update global flag
        global_SyncInterval = new_rate;
        // Update in local database
        strSql = 'UPDATE User_Info_DB SET sync_interval=' + new_rate + ' WHERE 1;';
        open_database_and_execute(strSql, '');
        return;
    }
    
    function setRemoteFeatures()
    {
        var strSql = '';
        var new_val = true;
        
        if (document.getElementById('appSettings_EnabRemote').checked) 
        {
            new_val = 1;
        }
        else
        {
            new_val = 0;
        }
        // Update global flag
        global_EnableRemoteAnalysis = new_val;
        // Dump the timestamp table to force reloading of everything
        g_LoadTimestamps = {};
        // Update in local database
        strSql = 'UPDATE User_Info_DB SET enable_remote_analysis=' + new_val + ' WHERE 1;';
        open_database_and_execute(strSql, '');
        return;
    }
    
    function changeTempUnits()
    {
        var new_val;
        var strSql_1;
        var strSql_2;
        if (document.getElementById('appSettings_tUnitsRadio_C').checked)
        {
            new_val = 'C';
            strSql_2 = 'UPDATE Data_Recs_DB SET temp=(temp-32)*5/9 WHERE temp>60;';
        }
        else
        {
            new_val = 'F';
            strSql_2 = 'UPDATE Data_Recs_DB SET temp=(temp*9/5)+32 WHERE temp<60;';
        }
        strSql_1 = 'UPDATE User_Info_DB SET t_units="' + new_val + '" WHERE 1;';
        open_database_and_execute(strSql_1, strSql_2);
    }
    function toggleCatholicMode()
    {
        if (global_catholic_mode)
        {
            // Disable "IVF" and "Insemination" events
            updateLocalDb_EventSettings(0, PASSED_INTEGER, 'ev_show_word2', 8, '', 0);
            updateLocalDb_EventSettings(0, PASSED_INTEGER, 'ev_show_word2', 4, '', 0);
        }
    }
    function toggleCatholicModeSetting()
    {
        global_catholic_mode = document.getElementById('appSettings_CathMode').checked;
        toggleCatholicMode();    
    }
    
    function AddPregnancy(state, param_1, param_2, pregDetails, new1_or_chg0)
    {
        var strSql = '';
        var tx = param_1;
        
        printDebug("State " + state + " of AddPregnancy");
        switch(state)
        {
        case 1:
            var pregDetails = {};
            var PregLen = 267;
            
            if (new1_or_chg0 != 0)
            {
                // New pregnancy
                var date_str = Date.parse(iOS_Date_Convert(document.getElementById('pregStartText').value) + ' 1:00:00');
                var preg_date = new Date(date_str);
                if (isNaN(preg_date))
                {
                    ShowPopupMessage('The specified date is invalid.  Please enter a date in yyyy-mm-dd format and try again.', 'Invalid Date', '');
                    printDebug('Invalid date: ' + date_str);
                    break;
                }

                if (document.getElementById('DueDateMethRadio_Prem').checked)
                {
                    pregDetails['start'] = preg_date;
                    pregDetails['end'] = addDays(preg_date, PregLen);
                }
                else if (document.getElementById('DueDateMethRadio_Naegele').checked)
                {
                    pregDetails['start'] = addDays(preg_date, 14);
                    pregDetails['end'] = addDays(preg_date, PregLen-1);
                }
                else if (document.getElementById('DueDateMethRadio_Ov').checked)
                {
                    pregDetails['start'] = addDays(preg_date, 14);
                    pregDetails['end'] = addDays(preg_date, PregLen-1);
                }
                else if (document.getElementById('DueDateMethRadio_Manual').checked)
                {
                    var end_date_str = Date.parse(iOS_Date_Convert(document.getElementById('pregEndText').value) + ' 1:00:00');
                    var end_preg_date = new Date(end_date_str);
                    if (isNaN(end_preg_date))
                    {
                        ShowPopupMessage('The specified end date is invalid.  Please enter a date in yyyy-mm-dd format and try again.', 'Invalid Date', '');
                        printDebug('Invalid date: ' + end_date_str);
                        break;
                    }
                    pregDetails['start'] = preg_date;
                    pregDetails['end'] = end_preg_date;
                }
                pregDetails['prevstart'] = DateToNumber(pregDetails['start']);
            }
            else
            {
                // Modify existing pregnancy
                var date_str = Date.parse(iOS_Date_Convert(document.getElementById('UpdatePregStartTextbox').value) + ' 1:00:00');
                var preg_date = new Date(date_str);
                var prior_preg_date;
                if (isNaN(preg_date))
                {
                    ShowPopupMessage('The specified start date is invalid.  Please enter a date in yyyy-mm-dd format and try again.', 'Invalid Date', '');
                    printDebug('Invalid date: ' + date_str);
                    break;
                }
                date_str = Date.parse(iOS_Date_Convert(document.getElementById('UpdatePregEndTextbox').value) + ' 1:00:00');
                end_preg_date = new Date(date_str);
                if (isNaN(end_preg_date))
                {
                    ShowPopupMessage('The specified end date is invalid.  Please enter a date in yyyy-mm-dd format and try again.', 'Invalid Date', '');
                    printDebug('Invalid date: ' + date_str);
                    break;
                }
                pregDetails['start'] = preg_date;
                pregDetails['prevstart'] = document.getElementById('EditPregPrevStart').innerHTML;
                pregDetails['end'] = end_preg_date;
                // Force reselection of charted cycle
                global_selected_cycle_as_number = 0;
            }
            pregDetails['start_val'] = DateToNumber(pregDetails['start']);
            pregDetails['end_val'] = DateToNumber(pregDetails['end']);
            
            // Open local database
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_AddPreg_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_AddPreg_1 = -1;
                                    AddPregnancy(state+1, tx, '', pregDetails, new1_or_chg0);
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_AddPreg_1 > 0)
                                    {
                                        global_db_ios_fail_AddPreg_1 = global_db_ios_fail_AddPreg_1 - 1;
                                        printDebug('iOS db.transaction failed AddPregnancy state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_AddPreg_1));
                                        AddPregnancy(state, param_1, param_2, pregDetails, new1_or_chg0);
                                    }
                                    else if (global_db_ios_fail_AddPreg_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            break;

        case 2:
            // Query values from local database. 
            strSql = 'SELECT * FROM Preg_DB ORDER BY preg_started ASC;';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                AddPregnancy(state+1, tx, results, pregDetails, new1_or_chg0);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local Preg database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
            
        case 3:
            var results = param_2;
            var len = results.rows.length;
            var abort_case = false;
            var last_preg = -1;

            // Loop through results
            for (var i=0; i<len; i++)
            {
                var preg_start_val = results.rows.item(i)['preg_started'];
                var preg_end_val = preg_start_val + results.rows.item(i)['preg_len'] - 1;
printDebug('Found previous preg ' + PrintDate(NumberToDate(preg_start_val)) + ' to ' + PrintDate(NumberToDate(preg_end_val)));
printDebug(preg_start_val + '!=' + pregDetails['prevstart'] + ' with new1_or_chg0=' + new1_or_chg0);
                // Check overlap (exclude self if an update)
                if ((preg_start_val != pregDetails['prevstart']) || (new1_or_chg0 != 0))
                {
                    // Check for overlap
                    if (((preg_start_val >= pregDetails['start_val']) && (preg_start_val <= pregDetails['end_val'])) || ((preg_end_val >= pregDetails['start_val']) && (preg_end_val <= pregDetails['end_val'])))
                    {
                        // Conflict
                        ShowPopupMessage('The new pregnancy cannot be recorded because it overlaps a previously recorded pregnancy. The conflicting pregnancy started on ' + PrintDate(NumberToDate(preg_start_val)) + '.  Remove it or use the Manual Due Date entry option to specify the pregnancy duration to avoid this overlap.', 'Cannot Create Pregnancy', '');
                        printDebug('Cannot add pregnancy due to conflict with preg');
                        abort_case = true;
                        break;
                    }
                }
                if ((preg_start_val < pregDetails['start_val']) && (results.rows.item(i)['preg_len'] > 0))
                {
                    last_preg = preg_start_val;
                }
            }
            if (abort_case == false)
            {
                pregDetails['last_preg'] = last_preg;
                // Query values from local database. 
                strSql = 'SELECT * FROM Cycles_DB ORDER BY cyc_started ASC;';
                suspend_scrolling(true, '');
                tx.executeSql(  strSql, 
                                [], 
                                function(tx, results) 
                                {
                                    suspend_scrolling(false, 0);
                                    AddPregnancy(state+1, tx, results, pregDetails, new1_or_chg0);
                                },
                                function(tx, err)
                                {
                                    crash_and_burn(err, 'Error querying local Cycles database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                                }
                             );
            }
            break;

        case 4:
            var results = param_2;
            var len = results.rows.length;
            var potential_conflict = 0;
            var abort_case = false;
            var prior_cyc_val = -1;

            // Loop through results
            for (var i=0; i<len; i++)
            {
                var cyc_start_val = results.rows.item(i)['cyc_started'];
                var cyc_end_val = cyc_start_val + results.rows.item(i)['cyc_len'] - 1;
printDebug('Found previous cycle ' + PrintDate(NumberToDate(cyc_start_val)) + ' to ' + PrintDate(NumberToDate(cyc_end_val)));
                // Check for overlap
                if (((cyc_start_val >= pregDetails['start_val']) && (cyc_start_val <= pregDetails['end_val'])) || ((cyc_end_val >= pregDetails['start_val']) && (cyc_end_val <= pregDetails['end_val'])))
                {
                    if ((cyc_start_val <= pregDetails['start_val']) && (potential_conflict == 0))
                    {
                        potential_conflict = cyc_start_val;
                        printDebug('Exception for conception cycle ' + PrintDate(NumberToDate(cyc_start_val)) + ' to ' + PrintDate(NumberToDate(cyc_end_val)));
                    }
                    else
                    {
                        // Conflict
                        ShowPopupMessage('The new pregnancy cannot be recorded because it overlaps a previously recorded cycle.  The conflicting cycle started on ' + PrintDate(NumberToDate(cyc_start_val)) + '.  Remove it or use the Manual Due Date entry option to specify the pregnancy duration to avoid this overlap.', 'Cannot Create Pregnancy', '');
                        printDebug('Cannot add pregnancy due to conflict with cycle');
                        abort_case = true;
                        break;
                    }
                }
                if (cyc_start_val < pregDetails['start_val'])
                {
                    prior_cyc_val = cyc_start_val;
                }
            }
            pregErrHelp = ' If you believe another cycle exists and is not being recognized (likely because it was not recorded in the app), load the chart for that cycle first to force app synchronization for that cycle and try again.';
            if (prior_cyc_val < 0)
            {
                // Conflict
                ShowPopupMessage('Each pregnancy must have at least 1 cycle recorded before it starts.  The new pregnancy does not. Record the menstrual cycle prior to the start of this pregnancy and try again.' + pregErrHelp, 'Cannot Create Pregnancy', '');
                printDebug('Cannot add pregnancy due to absence of cycle');
                abort_case = true;
                break;
            }
            else
            {
                if (pregDetails['last_preg'] >= prior_cyc_val)
                {
                    // Can't tie 2 pregs to same cycle
                    ShowPopupMessage('Each pregnancy must have 1 unique cycle recorded before it starts. The cycle before this pregnancy already has another pregnancy recorded by it. Please record a new cycle between the pregnancies or delete the other pregnancy and try again.' + pregErrHelp, 'Cannot Create Pregnancy', '');
                    printDebug('Cannot add pregnancy due to absence of cycle');
                    abort_case = true;
                    break;
                }
                else if ((pregDetails['start_val'] - prior_cyc_val) >= 150)
                {
                    ShowPopupMessage('Each pregnancy must have 1 unique cycle recorded within 150 days of its start. This pregnancy (' + PrintDateDivider(NumberToDate(pregDetails['start_val']),false) + ') has a cycle too long before it (' + PrintDateDivider(NumberToDate(prior_cyc_val),false) + ').  These dates are ' + (pregDetails['start_val'] - prior_cyc_val) + ' days apart.  Record a cycle that is less than 150 days prior to the pregnancy start and try again.' + pregErrHelp, 'Cannot Create Pregnancy', '');
                    printDebug('Cannot add pregnancy without recent cycle');
                    abort_case = true;
                    break;
                }
            }
            if (abort_case == false)
            {
                // Go ahead and record the pregnancy
                var strSql_fields;
                var strSql_values;
                var PregLen = pregDetails['end_val'] - pregDetails['start_val'] + 1;
                var execute = false;
                
                if (new1_or_chg0 != 0)
                {
                    strSql_fields = 'INSERT INTO Preg_DB (preg_started, ';
                    strSql_values = 'VALUES (' + pregDetails['start_val'] + ', ';
                    
                    strSql_fields += 'pdata_chg, pdata_pnd, ';
                    strSql_values += '7, 0, ';

                    strSql_fields += 'preg_len, preg_status) ';
                    strSql_values += PregLen + ', "preg");';
                    execute = true;
                }
                else
                {
                    var chg_bits = 0;
                    strSql_fields = 'UPDATE Preg_DB SET ';
                    strSql_values = '';
                    
                    myselect = $("select#Settings_PregOutcomeSelect");
                    var PregOutcome = ConvertPregOutcome(myselect[0].selectedIndex, true, false, false, false);
                    
                    // See what changed
                    if (pregDetails['start_val'] != document.getElementById('EditPregPrevStart').innerHTML)
                    {
                        strSql_values += 'preg_started=' + pregDetails['start_val'] + ', ';
                        chg_bits = chg_bits | Math.pow(2, dbPregDBField_PregStart.localDBEncodedBitIndex);
                    }
                    if (PregLen != document.getElementById('EditPregPrevLen').innerHTML)
                    {
                        strSql_values += 'preg_len=' + PregLen + ', ';
                        chg_bits = chg_bits | Math.pow(2, dbPregDBField_PregLen.localDBEncodedBitIndex);
                    }
                    if (PregOutcome != document.getElementById('EditPregPrevOutcome').innerHTML)
                    {
                        strSql_values += 'preg_status="' + PregOutcome + '", ';
                        chg_bits = chg_bits | Math.pow(2, dbPregDBField_PregStatus.localDBEncodedBitIndex);
                    }
                    if (chg_bits != 0)
                    {
                        strSql_values += 'pdata_chg=' + chg_bits + ' WHERE preg_started=' + document.getElementById('EditPregPrevStart').innerHTML + ';';
                        execute = true;
                    }
                }
                
                if (execute)
                {
                    strSql = strSql_fields + strSql_values;
                    suspend_scrolling(true, '');
                    tx.executeSql(  strSql, 
                                    [], 
                                    function(tx, results) 
                                    {
                                        suspend_scrolling(false, 0);
                                        AddPregnancy(state+1, tx, results, pregDetails, new1_or_chg0);
                                    },
                                    function(tx, err)
                                    {
                                        crash_and_burn(err, 'Error querying local Cycles database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                                    }
                                 );
                 }
            }
            // Dump all load times to force everything to refresh
            g_LoadTimestamps = {};
            // Reload screen
            if (new1_or_chg0 == 0)
            {
                ShowPopupMessage("This pregnancy has been updated.", 'Success', ''); 
            }
            else
            {
                ShowPopupMessage("A new pregnancy was created.", 'Success', '');
            }
            reloadPregScreen();
            break;
        }
    }
    
    function reloadPregScreen()
    {
        // Force total resync
        g_LoadTimestamps = {};
        // Clear
        document.getElementById('chgPregDiv').style.display = 'none';
        document.getElementById('pregStartText').value = '';
        document.getElementById('pregEndText').value = '';
        // Reload
        navBetweenSettings(1, 3, '', '');
    }    
    function userPickedPreg(state, param_1, param_2)
    {
        var strSql = '';
        var tx = param_1;
        
        printDebug("State " + state + " of userPickedPreg");
        switch(state)
        {
        case 1:
            // Open local database
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_UserPickPreg_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_UserPickPreg_1 = -1;
                                    userPickedPreg(state+1, tx, '');
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_UserPickPreg_1 > 0)
                                    {
                                        global_db_ios_fail_UserPickPreg_1 = global_db_ios_fail_UserPickPreg_1 - 1;
                                        printDebug('iOS db.transaction failed userPickedPreg state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_UserPickPreg_1));
                                        userPickedPreg(state, param_1, param_2);
                                    }
                                    else if (global_db_ios_fail_UserPickPreg_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            break;

        case 2:
            // Get selection
            var global_selected_preg_as_number = Number(document.getElementById('Settings_PregPickerSelect').value);
            
            // Query values from local database. 
            strSql = 'SELECT * FROM Preg_DB WHERE preg_started=' + global_selected_preg_as_number + ';';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                userPickedPreg(state+1, tx, results);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local Preg database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
            
        case 3:
            var results = param_2;
            var len = results.rows.length;

            if (len <= 0)
            {
                document.getElementById('chgPregDiv').style.display = 'none';
                ShowPopupMessage("Could not find the selected pregnancy.  Please try resynchronizing by pressing the Sync button and try again.", 'Could not edit pregnancy', '');  
            }
            else
            {
                // Load results
                var i=0;
                var myselect;
                var pregStart = PrintDateDivider(NumberToDate(results.rows.item(i)['preg_started']),false);
                var pregEnd = PrintDateDivider(NumberToDate(results.rows.item(i)['preg_started'] + results.rows.item(i)['preg_len'] - 1),false);
                
                document.getElementById('EditPregPrevStart').innerHTML = results.rows.item(i)['preg_started'];
                document.getElementById('EditPregPrevLen').innerHTML = results.rows.item(i)['preg_len'];
                document.getElementById('EditPregPrevOutcome').innerHTML = results.rows.item(i)['preg_status'];
                
                document.getElementById('PregToEdit').innerHTML = pregStart;
                document.getElementById('UpdatePregStartTextbox').value = pregStart;
                document.getElementById('UpdatePregEndTextbox').value = pregEnd;
                myselect = $("select#Settings_PregOutcomeSelect");
                myselect[0].selectedIndex = ConvertPregOutcome(results.rows.item(i)['preg_status'], false, true, false, false);
                myselect.selectmenu("refresh");
                document.getElementById('chgPregDiv').style.display = 'block';
            }
            break;
        }
    }
    function DeletePreg()
    {
        var strSql = 'UPDATE Preg_DB SET preg_len=0,pdata_chg=' + Math.pow(2, dbPregDBField_PregLen.localDBEncodedBitIndex) + ' WHERE preg_started=' + document.getElementById('EditPregPrevStart').innerHTML + ';';
printDebug(strSql + '  ' + PrintDate(NumberToDate(document.getElementById('EditPregPrevStart').innerHTML)));
        open_database_and_execute(strSql, ''); 
        ShowPopupMessage("Pregnancy was deleted.", 'Success', '');
        reloadPregScreen();
        // Force reselection of charted cycle
        global_selected_cycle_as_number = 0;
        // Dump all load times to force everything to refresh
        g_LoadTimestamps = {};
    }

    function addDays(date, days) 
    {
        var result = new Date(date);
        result.setDate(date.getDate() + days);
        return result;
    }
    function ConvertPregOutcome(inputData, index2db, db2index, db2show, show2db)
    {
        var retval = 'ERROR91731';
        var mapping = {};
        var db_PREG_field = 'preg';
        var db_MIS_field = 'miscar';
        var db_BIRTH_field = 'birth';
        var show_PREG_text = 'Still Pregnant';
        var show_MIS_text = 'Miscarriage';
        var show_BIRTH_text = 'Gave Birth';

        if (index2db)
        {
            mapping[0] = db_PREG_field;
            mapping[1] = db_MIS_field;
            mapping[2] = db_BIRTH_field;
            retval = mapping[inputData];
        }
        else if (db2index)
        {
            mapping[db_PREG_field] = 0;
            mapping[db_MIS_field] = 1;
            mapping[db_BIRTH_field] = 2;
            retval = mapping[inputData];
        }
        else if (db2show)
        {
            mapping[db_PREG_field] = show_PREG_text;
            mapping[db_MIS_field] = show_MIS_text;
            mapping[db_BIRTH_field] = show_BIRTH_text;
            retval = mapping[inputData];
        }
        else if (show2db)
        {
            mapping[show_PREG_text] = db_PREG_field;
            mapping[show_MIS_text] = db_MIS_field;
            mapping[show_BIRTH_text] = db_BIRTH_field;
            retval = mapping[inputData];
        }
        else
        {
            printDebug('Error - hit ELSE in ConvertPregOutcome');
        }
        return retval;
    }
    function savePregMsg(showit)
    {
        if (showit)
        {
            document.getElementById("ChgWarnDiv").style.color = "yellow";
        }
        else
        {
            document.getElementById("ChgWarnDiv").style.color = "white";
        }
    }
    
    function DefineMsgGroup(state, param_1, new1_or_chg0)
    {
        var strSql = '';
        var tx = param_1;
        var gCodeStr;
        var ctrlName;
        if (new1_or_chg0 == 0)
        {
            ctrlName = 'Update';
        }
        else
        {
            ctrlName = 'New';
        }
        gCodeStr = document.getElementById(ctrlName + 'GroupCodeTextbox').value.toLowerCase();
        gCodeStr = gCodeStr.replace(/\s+/g, ''); // remove spaces
        
        printDebug("State " + state + " of DefineMsgGroup");
        switch(state)
        {
        case 1:
            // Validate inputs
            var descStr = document.getElementById(ctrlName + 'GroupDescTextbox').value;
            
            if (gCodeStr == '')
            {
                ShowPopupMessage("You must specify a group code.", 'Could not save group', '');
                break;
            }
        
        
            // Open local database
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_DefGroup_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_DefGroup_1 = -1;
                                    DefineMsgGroup(state+1, tx, new1_or_chg0);
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_DefGroup_1 > 0)
                                    {
                                        global_db_ios_fail_DefGroup_1 = global_db_ios_fail_DefGroup_1 - 1;
                                        printDebug('iOS db.transaction failed DefineMsgGroup state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_DefGroup_1));
                                        DefineMsgGroup(state, param_1, new1_or_chg0);
                                    }
                                    else if (global_db_ios_fail_DefGroup_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            break;

        case 2:       
            // Delete any previous record 
            var sql_byID = '';
            if (new1_or_chg0 == 0)
            {
                var sel_group = Number(document.getElementById('Settings_GroupsSelect').value);
                sql_byID = " OR id=" + sel_group;
            }
            
            strSql = "DELETE FROM Groups_DB WHERE gcode='" + gCodeStr + "'" + sql_byID + ";";
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                DefineMsgGroup(state+1, tx, new1_or_chg0);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local Preg database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;

        case 3:
            // Get group code
            var descStr = document.getElementById(ctrlName + 'GroupDescTextbox').value;
        
            // Delete any previous record 
            strSql = "INSERT INTO Groups_DB (gcode, desc) VALUES ('" + ReplaceQuotes(gCodeStr) + "', '" + ReplaceQuotes(descStr) + "');";
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                DefineMsgGroup(state+1, tx, new1_or_chg0);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local Preg database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;

        case 4:
            // Reload screen
            ShowPopupMessage("This group has been saved.", 'Success', '');
            reloadGroupScreen();
            break;
        }
    }
    function reloadGroupScreen()
    {
        // Clear
        document.getElementById('NewGroupCodeTextbox').value = '';
        document.getElementById('NewGroupDescTextbox').value = '';
        document.getElementById('UpdateGroupCodeTextbox').value = '';
        document.getElementById('UpdateGroupDescTextbox').value = '';
        document.getElementById('chgGroupDiv').style.display = 'none';
        // Reload
        navBetweenSettings(1, 4, '', '');
    }
    function userPickedGroup(state, param_1, param_2)
    {
        var strSql = '';
        var tx = param_1;
        
        printDebug("State " + state + " of userPickedGroup");
        switch(state)
        {
        case 1:
            // Open local database
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_UserPickGroup_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_UserPickGroup_1 = -1;
                                    userPickedGroup(state+1, tx, '');
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_UserPickGroup_1 > 0)
                                    {
                                        global_db_ios_fail_UserPickGroup_1 = global_db_ios_fail_UserPickGroup_1 - 1;
                                        printDebug('iOS db.transaction failed userPickedGroup state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_UserPickGroup_1));
                                        userPickedGroup(state, param_1, param_2);
                                    }
                                    else if (global_db_ios_fail_UserPickGroup_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            break;

        case 2:
            // Get selection
            var sel_group = Number(document.getElementById('Settings_GroupsSelect').value);

            // Query values from local database. 
            strSql = 'SELECT * FROM Groups_DB WHERE id=' + sel_group + ';';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                userPickedGroup(state+1, tx, results);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local Preg database for this date.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
            
        case 3:
            var results = param_2;
            var len = results.rows.length;

            if (len <= 0)
            {
                document.getElementById('chgPregDiv').style.display = 'none';
                ShowPopupMessage("Could not find the selected group.", 'Error', '');  
            }
            else
            {
                // Load results
                var myselect;
                var i = 0;
                var gCode = results.rows.item(i)['gcode'];
                document.getElementById('UpdateGroupCodeTextbox').value = gCode;
                document.getElementById('UpdateGroupDescTextbox').value = results.rows.item(i)['desc'];
                document.getElementById('GroupToEdit').innerHTML = gCode;
                document.getElementById('chgGroupDiv').style.display = 'block';
            }
            break;
        }
    }
    function DeleteGroup()
    {
        var sel_group = Number(document.getElementById('Settings_GroupsSelect').value);
        strSql = "DELETE FROM Groups_DB WHERE id='" + sel_group + "';";
        open_database_and_execute(strSql, ''); 
        ShowPopupMessage("Group was deleted.", 'Success', '');
        reloadGroupScreen();
    }
    function iOS_Date_Convert(date_str)
    {
        var retval;
        if (global_is_ios)
        {
            retval = ReplaceAllOccurrences(date_str, '-', '/');
        }
        else
        {
            retval = date_str;
        }
        return retval;
    }
    