///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// FUNCTIONS FOR STARTUP SCREENS
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
    var DROP_TABLE_TEST = 0;
    
    var INIT_STATE = 1;
    var STATE_FOR_USER_DB = 2;
    var STATE_FOR_USER_DB_INIT = 3;
    var STATE_FOR_DATA_RECS_DB = 4;
    var STATE_FOR_EVENT_SETTINGS_DB = 5;
    var STATE_FOR_EVENT_SETTINGS_DB_INIT = 6;
    var STATE_FOR_PREG_DB = 7;
    var STATE_FOR_GROUPS_DB = 8;
    var STATE_FOR_CYCLES_DB = 9;
    var STATE_FOR_INTERP_DB = 10;
    var STATE_FOR_RESOURCE_DB = 11;
    var STATE_FOR_RESOURCE_DB_INIT = 12;
    var LAST_DECISION_STATE = 13;
    
    var global_remember_username = true;
    var global_pw_prompt = true;
    var global_tip_of_day = false;
    var global_tip_of_day_index = 0;
    var global_catholic_mode = false;
    var global_username = '';
    var global_password = '';
    var global_user_height = 0;
    var global_user_height_dirty = false;
    
    function startup_app_navigation()
    {
        printDebug('starting to execute startup_app_navigation');     
        // Check database for existence
        initial_startup(1, '', 0, 0);
    }

    function drop_databases()
    {
        DROP_TABLE_TEST = 1;
        printDebug("WARNING: Dropping all databases");
        initial_startup(1, '', 0, 0);                
    }

    function initial_startup(state, param_1, param_2, param_3)
    {
        var tx = param_1;
        var create = param_3;
        var strSql = '';
        var strSql_fields = '';
        var strSql_values = '';
        
        // Skip states that do follow up insertions if we are not creating tables 
        if (create == 0)
        {
            if ((state == STATE_FOR_EVENT_SETTINGS_DB_INIT) || (state == STATE_FOR_RESOURCE_DB_INIT))
            {
                state = state + 1;
            }
        }                
        
        // Callback State Machine
        printDebug("State " + state + " of initial_startup");
        switch(state)
        {
        case INIT_STATE:
            global_MissingDatabases = 0;
            // Try to open database.  This is the first open that happens when the app runs, so error handling
			// is added here.  Specifically it's needed because iOS 5 returns a SECURITY_ERR: DOM Exception 18
			// when you re-install the app and try to access the existing database (you must delete the app 
		    // and reinstall it to get it to work).  PhoneGap 1.6.0 is promising to fix this.
			try
			{
				db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
			}
			catch(err)
			{
				// The app isn't going to load correctly, so display a special error.
				ShowPopupMessage('Permissions are preventing access to your database from the previous install.  You must uninstall the app and then reinstall it to fix this (tap and hold app icon and then click on the X that appears).  Detailed error: openDatabase - ' + err.message, 'Must Uninstall App First', '');
				printDebug('Error during window.openDatabase: ' + err.message);
			}
            global_db_ios_fail_InitStartup_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_InitStartup_1 = -1;
                                    initial_startup(state+1, tx, param_2, create);
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_InitStartup_1 > 0)
                                    {
                                        global_db_ios_fail_InitStartup_1 = global_db_ios_fail_InitStartup_1 - 1;
                                        printDebug('iOS db.transaction failed init_startup state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_InitStartup_1));
                                        initial_startup(state, param_1, param_2, param_3);
                                    }
                                    else if (global_db_ios_fail_InitStartup_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            break;
        case STATE_FOR_USER_DB:
        
            // HTML Initialization: Register taps for carousel
            register_carousel_taps();
        
            // Disable scrolling for the remainder of this state machine since it involves all local database accesses
            suspend_scrolling(true, '');
        
            // Debug case to drop the tables for testing purposes only
            if (DROP_TABLE_TEST == 1)
            {
                // Note: suspend_scrolling(true, '') already called above in a blanket call for States 2 thru 12 (basically all of initital_startup)
                tx.executeSql('DROP TABLE IF EXISTS User_Info_DB;');
                tx.executeSql('DROP TABLE IF EXISTS Data_Recs_DB;');
                tx.executeSql('DROP TABLE IF EXISTS Event_Settings_DB;');
                tx.executeSql('DROP TABLE IF EXISTS Preg_DB;');
                tx.executeSql('DROP TABLE IF EXISTS Groups_DB;');
                tx.executeSql('DROP TABLE IF EXISTS Cycles_DB;');
                tx.executeSql('DROP TABLE IF EXISTS Interp_DB;');
                tx.executeSql('DROP TABLE IF EXISTS Resource_DB;');
                DROP_TABLE_TEST = 0;
                break;
            }
            
            // Note: suspend_scrolling(true, '') already called above in a blanket call for States 2 thru 12 (basically all of initital_startup)
            tx.executeSql(  'SELECT * FROM User_Info_DB WHERE 1;', 
                            [], 
                            function(tx, results) 
                            {
								initial_startup(state+1, tx, results, create);
                            },
                            function(tx, err) 
                            {
                                table_does_not_exist(tx, err, state, create);
                            }
                         );
             
            // Tell jQuery to initialize some of the global controls that don't show up within any of the "page" data-type regions (and won't otherwise get initialized as pretty jQuery controls)
            $('#divPopupMsg').trigger('create');
            $('#divFdbkPop').trigger('create');
            $('#divPopUpReply').trigger('create');
            // Initialize popups that span all pages
            initNavMenuVisibility();
            $( '#navChartsPopup' ).popup();
            $( '#navSettingsPopup' ).popup();
            $( '#navConnectPopup' ).popup();
            $( '#divPopupMsg' ).popup();
            $( '#divFdbkPop' ).popup();
            $( '#divPopUpReply' ).popup();
            $('#navConnectClose').trigger('create');
            
            break;
        case STATE_FOR_USER_DB_INIT:
            if (create == 1)
            {
                strSql_fields = 'INSERT INTO User_Info_DB (un, pw, email, t_units, ';
                strSql_values = 'VALUES ("' + global_username + '", "' + global_password + '", "' + global_user_email + '", "' + global_t_units + '", ';
                
                strSql_fields += 'db_ver, disable_analysis, pw_prompt, remember_username, selected_date, ';
                strSql_values += '2.0, 0, ' + global_pw_prompt + ', 1, 1, ';
                
                strSql_fields += 'selected_cycle, sel_cycle_end, last_calendar_screen, last_cycle_screen, last_community_screen, ';
                strSql_values += '0, 0, 0, 0, 1, ';
                
                strSql_fields += 'last_settings_screen, server_prefix, enable_remote_analysis, sync_interval, tip_of_day_enabled, ';
                strSql_values += '1, "' + global_server_prefix + '", 1, 180, 1, ';
                
                strSql_fields += 'tip_of_day_index, saliva_ferning_enabled, survey_id, ';
                strSql_values += '1, 1, 0,';
                
                strSql_fields += 'catholic, ';
                if (BUILD_TARGET != BUILD_4_MFC)
                {
                    strSql_values += ' 1, ';       // Enable catholic mode by default
                    global_catholic_mode = true;
                }
                else
                {
                    strSql_values += ' 0, ';
                } 
                
                if (BUILD_TARGET == BUILD_4_CCL)
                {
                    strSql_fields += 'height, hw_units, sub_ctr, ';
                    strSql_values += '0, "us", 0, ';
                }
                
                strSql_fields += 'temp_time, svr_info_msg, svr_info_msg_shown, cyc_avg, ';
                strSql_values += '"7:00", "", 1, 28, ';
                
                strSql_fields += 'cyc_sd, lut_avg, lut_sd, cyc_short, cyc_long, lut_short, ';
                strSql_values += '-1, 14, -1, -1, -1, -1, ';
                
                strSql_fields += 'lut_long, early_ov, late_ov, early_any_ov, early_cm_f, ';
                strSql_values += '-1, -1, -1, -1, -1, ';
                
                strSql_fields += 'early_bbt_ov, early_mon_p, late_mon_p, cal_shade, '
                strSql_values += '-1, -1, -1, 1,';
                
                strSql_fields += 'cal_ov, debug) '
                if ((BUILD_TARGET == BUILD_4_BOS) || (BUILD_TARGET == BUILD_4_CCL))
                {
                    strSql_values += ' 0,';       // Disable showing ovulation by default
                }
                else
                {
                    strSql_values += ' 1,';
                } 
                strSql_values += ' 0);';
                // Note: suspend_scrolling(true, '') already called above in a blanket call for States 2 thru 12 (basically all of initital_startup)
                strSql = strSql_fields + strSql_values;
                tx.executeSql(  strSql, 
                                [], 
                                function(tx, results) 
                                {
                                    initial_startup(state+1, tx, results, create);
                                },
                                errorCB
                             );
				break;
			} 
			else
			{
				// Check Database version and upgrade if needed
                const CURRENT_DB_VERSION = 2;
                results = param_2;
                var len = results.rows.length;
                if (len == 0)
                {
                    printDebug("Error - Missing user settings table!");
                }
                else
                {
                    var db_version = parseInt(results.rows.item(0).db_ver);
                    if (CURRENT_DB_VERSION != db_version)
                    {
                        upgrade_db(db_version, tx);
                    }
                }

				//Intentional fall through to next state
            }
        case STATE_FOR_DATA_RECS_DB:
            // Note: suspend_scrolling(true, '') already called above in a blanket call for States 2 thru 12 (basically all of initital_startup)
            tx.executeSql(  'SELECT * FROM Data_Recs_DB WHERE 1;', 
                            [], 
                            function(tx, results) 
                            {
                                initial_startup(state+1, tx, results, create);
                            }, 
                            function(tx, err) 
                            {
                                table_does_not_exist(tx, err, state, create);
                            }
                         );
            break;
        case STATE_FOR_EVENT_SETTINGS_DB:
            // Note: suspend_scrolling(true, '') already called above in a blanket call for States 2 thru 12 (basically all of initital_startup)
            tx.executeSql(  'SELECT * FROM Event_Settings_DB WHERE 1;', 
                            [], 
                            function(tx, results) 
                            {
                                initial_startup(state+1, tx, results, create);
                            },
                            function(tx, err) 
                            {
                                table_does_not_exist(tx, err, state, create);
                            }
                         );            
            break;
        case STATE_FOR_EVENT_SETTINGS_DB_INIT:
            if (create == 1)
            {
                // Create desired initial records to show
                var events_to_show = new Array();
                var ev_show_words = new Array();
                for (var i=0; i<NUMBER_OF_EVENTS; i++)
                {
                    events_to_show[i] = 0;
                }
                // events_to_show[2] = 1;  Happiness
                events_to_show[8] = 1;
                events_to_show[31] = 1; 
                events_to_show[32] = 1;
                events_to_show[9] = 1;
                events_to_show[10] = 1;
                events_to_show[11] = 1;
                // events_to_show[46] = 1;  Clomid
                // events_to_show[12] = 1;  Constipation
                events_to_show[13] = 1;
                events_to_show[33] = 1;
                events_to_show[18] = 1;
                events_to_show[19] = 1;
                // events_to_show[20] = 1;  Frequent Urination
                events_to_show[21] = 1;
                events_to_show[2] = 1;
                events_to_show[22] = 1;
                events_to_show[34] = 1;
                // events_to_show[24] = 1;  Increased appetite
                // events_to_show[25] = 1;  Increased Libido
                events_to_show[5] = 1;
                // events_to_show[51] = 1;  Metformin
                // events_to_show[7] = 1; Mood Swings
                events_to_show[27] = 1;
                // events_to_show[28] = 1;  Ovulation Pain
                events_to_show[112] = 1;
                events_to_show[62] = 1;
                events_to_show[43] = 1;
                //events_to_show[4] = 1;  Stress
                events_to_show[54] = 1;
                //events_to_show[45] = 1; Yeast Infection
                if (BUILD_TARGET == BUILD_4_CCL)
                {
                    events_to_show[53] = 1; // Progesterone
                    events_to_show[52] = 1; // Other Medications / Antihistimine
                }
                events_to_show[30] = 1;     // Spotting is always on (can't turn it off)
                ev_show_words = CompressEventBits(events_to_show);

                // Insert into database
                strSql_fields = 'INSERT INTO Event_Settings_DB (cev_name_1, cev_name_2, cev_name_3, cev_name_4, cev_name_5, ';
                strSql_values = 'VALUES ("", "", "", "", "", ';

                strSql_fields += 'cev_name_6, cev_name_7, cev_name_8, cev_name_9, cev_name_10, ';
                strSql_values += '"", "", "", "", "", ';
                
                strSql_fields += 'cev_name_11, cev_name_12, cev_name_13, cev_name_14, cev_name_15, ';
                strSql_values += '"", "", "", "", "", ';
                
                strSql_fields += 'cev_name_16, cev_name_17, cev_name_18, cev_name_19, cev_name_20, ';
                strSql_values += '"", "", "", "", "", ';
                
                strSql_fields += 'names_chg, names_pnd, ';
                strSql_values += '0, 0, ';
                
                strSql_fields += 'ev_show_word1, ev_show_word2, ev_show_word3, ev_show_word4) ';
                strSql_values += ev_show_words[0] + ', ' + ev_show_words[1] + ', ' + ev_show_words[2] + ', ' + ev_show_words[3] + ');';

                // Note: suspend_scrolling(true, '') already called above in a blanket call for States 2 thru 12 (basically all of initital_startup)
                strSql = strSql_fields + strSql_values;
                tx.executeSql(  strSql, 
                                [], 
                                function(tx, results) 
                                {
                                    initial_startup(state+1, tx, results, create);
                                },
                                errorCB
                             );
            }
            break;
        case STATE_FOR_PREG_DB:
            tx.executeSql(  'SELECT * FROM Preg_DB WHERE 1;', 
                            [], 
                            function(tx, results) 
                            {
                                initial_startup(state+1, tx, results, create);
                            },
                            function(tx, err) 
                            {
                                table_does_not_exist(tx, err, state, create);
                            }
                         );
            break;
        case STATE_FOR_GROUPS_DB:
            tx.executeSql(  'SELECT * FROM Groups_DB WHERE 1;', 
                            [], 
                            function(tx, results) 
                            {
                                initial_startup(state+1, tx, results, create);
                            },
                            function(tx, err) 
                            {
                                table_does_not_exist(tx, err, state, create);
                            }
                         );
            break;
        case STATE_FOR_CYCLES_DB:
            // Note: suspend_scrolling(true, '') already called above in a blanket call for States 2 thru 12 (basically all of initital_startup)
            tx.executeSql(  'SELECT * FROM Cycles_DB WHERE 1;', 
                            [], 
                            function(tx, results) 
                            {
                                initial_startup(state+1, tx, results, create);
                            },
                            function(tx, err) 
                            {
                                table_does_not_exist(tx, err, state, create);
                            }
                         );
            break;
        case STATE_FOR_INTERP_DB:
            // Note: suspend_scrolling(true, '') already called above in a blanket call for States 2 thru 12 (basically all of initital_startup)
            tx.executeSql(  'SELECT * FROM Interp_DB WHERE 1;', 
                            [], 
                            function(tx, results) 
                            {
                                initial_startup(state+1, tx, results, create);
                            },
                            function(tx, err) 
                            {
                                table_does_not_exist(tx, err, state, create);
                            }
                         );
            break;
        case STATE_FOR_RESOURCE_DB:
            //tx.executeSql(  'SELECT * FROM Resource_DB WHERE 1;', 
            //                [], 
            //                function(tx, results) 
            //                {
            //                    initial_startup(state+1, tx, results, create);
                                  initial_startup(state+1, tx, 0, create);
            //                },
            //                function(tx, err) 
            //                {
            //                    table_does_not_exist(tx, err, state, create);
            //                }
            //             );
            break;
        case STATE_FOR_RESOURCE_DB_INIT:
            if (create == 1)
            {
                //strSql = 'INSERT INTO Resource_DB (title, link_desc, res_url) ';
                //strSql += 'VALUES ("My Fertility Charts", "Online version of the site", "http://www.myfertilitycharts.com"); ';
                //tx.executeSql(  strSql, 
                //                [], 
                //                function(tx, results) 
                //                {
                //                  initial_startup(state+1, tx, results, create);
                                    initial_startup(state+1, tx, 0, create);
                //                },
                //                errorCB
                //             );
                //// First insert includes call back.  Subsequent inserts don't require a separate callback
                //strSql = 'INSERT INTO Resource_DB (title, link_desc, res_url) ';
                //strSql += 'VALUES ("Fertility Instructor", "Explanation of fertility tracking", "http://www.fertilityinstructor.com"); ';
                //tx.executeSql( strSql );
            }
            break;
            
        case LAST_DECISION_STATE:
            // Turn back on scrolling (it was off in nearly all states in initial_startup)
            suspend_scrolling(false, 0);
        
            HideAct_Legacy();
            HideAct();
            // For test only case (no create) we do a final decision for what screen is next.
            if (create == 0)
            {
                printDebug("Last State: Done checking databases");
                if (global_MissingDatabases == 0)
                {
                    printDebug("SHOW FIG 40 - Splash Screen");
                    check_password(1, tx);
                }
                else
                {
                    // Prompt user to setup an account
                    printDebug("SHOW FIG 41 - Initial Sign Up Screen");
                    TransitionToSubscreen("startup_signup", "none");
                }
            }
            else
            {
                // Launch the app normally - first time shows tutorial
                if (BUILD_TARGET == BUILD_4_CCL)
                {
                    TransitionToSubscreen("startup_ccl_tutorial", "none");
                }
                else
                {
                    TransitionToSubscreen("startup_tutorial", "none");
                }
            }
            break;
            
        default:
            // Should not happen
            printDebug('Error - Callback State Machine calling default (state=' + state + ')');
        }
        printDebug('Exiting initial_startup');
        return false;
    }    
    
    function table_does_not_exist(tx, err, state, create) 
    {
        printDebug("entering table_does_not_exist");
        if (create == 0)
        {
            // Just note that at least one database didn't exist so we can skip ahead
            printDebug("table " + state + " does not exist: " + err.message);
            global_MissingDatabases = 1;
            
            // We have enough information to make a decision, so just jump to final state
            initial_startup(LAST_DECISION_STATE, tx, 0, 0);
        }
        else
        {       
            var strSql = '';                
            // Create Database Machine
            switch(state)
            {
            case STATE_FOR_USER_DB:
                strSql = 'CREATE TABLE IF NOT EXISTS User_Info_DB (id INTEGER NOT NULL PRIMARY KEY, un, pw, email, t_units,';
                strSql += 'db_ver, disable_analysis INTEGER, pw_prompt INTEGER, remember_username INTEGER, selected_date INTEGER, ';
                strSql += 'selected_cycle, sel_cycle_end, last_calendar_screen INTEGER, last_cycle_screen INTEGER, last_community_screen INTEGER, ';
                strSql += 'last_settings_screen INTEGER, server_prefix, enable_remote_analysis INTEGER, sync_interval INTEGER, tip_of_day_enabled INTEGER, ';
                strSql += 'tip_of_day_index INTEGER, saliva_ferning_enabled INTEGER, catholic INTEGER, ';
                strSql += 'temp_time, svr_info_msg, svr_info_msg_shown INTEGER, cyc_avg INTEGER, ';
                strSql += 'cyc_sd INTEGER, lut_avg INTEGER, lut_sd INTEGER, cyc_short INTEGER, cyc_long INTEGER, lut_short INTEGER, ';
                strSql += 'lut_long INTEGER, early_ov INTEGER, late_ov INTEGER, early_any_ov INTEGER, early_cm_f INTEGER, ';
                strSql += 'early_bbt_ov INTEGER, early_mon_p INTEGER, late_mon_p INTEGER, cal_shade INTEGER, cal_ov INTEGER, survey_id INTEGER,';
                if (BUILD_TARGET == BUILD_4_CCL)
                {
                    strSql += 'height INTEGER, hw_units, sub_ctr INTEGER, ';
                }
                strSql += 'debug INTEGER); ';
                // Note: suspend_scrolling(true, '') already called above in a blanket call for States 2 thru 12 (basically all of initital_startup)
                tx.executeSql (strSql);
                printDebug("User_Info_DB table created");
                break;
            case STATE_FOR_DATA_RECS_DB:
                strSql = 'CREATE TABLE IF NOT EXISTS Data_Recs_DB (record_date INTEGER NOT NULL PRIMARY KEY, ';
                strSql += 'fdata_chg INTEGER, fdata_pnd INTEGER, ';
                strSql += 'mens INTEGER, i_notes, t_notes, ';
                strSql += 'p_notes, temp, unsure INTEGER, discard INTEGER, ';
                strSql += 'monitor, ovtest_am, ovtest_pm, mucus';                        
                for (var i=1; i<=NUMBER_OF_EVENT_WORDS; i++)
                {
                    strSql += ', ev' + i + 'nt INTEGER, ev' + i + 'nt_chg INTEGER, ev' + i + 'nt_pnd INTEGER ';
                }
                if (BUILD_TARGET == BUILD_4_CCL)
                {
                    strSql += ', mflow, fweight INTEGER, cerv_cons, cerv_dia, muc_sens, muc_acons, itxtreq INTEGER, ';
                }
                else
                {
                    strSql += ', cervix, saliva, ';
                }
                strSql += 'mkr INTEGER);';
                // Note: suspend_scrolling(true, '') already called above in a blanket call for States 2 thru 12 (basically all of initital_startup)
                tx.executeSql (strSql);
                printDebug("Data_Recs_DB table created");
                break;                    
            case STATE_FOR_EVENT_SETTINGS_DB:
                strSql = 'CREATE TABLE IF NOT EXISTS Event_Settings_DB (id INTEGER NOT NULL PRIMARY KEY, ';
                strSql += 'cev_name_1, cev_name_2, cev_name_3, cev_name_4, cev_name_5, ';
                strSql += 'cev_name_6, cev_name_7, cev_name_8, cev_name_9, cev_name_10, ';
                strSql += 'cev_name_11, cev_name_12, cev_name_13, cev_name_14, cev_name_15, ';
                strSql += 'cev_name_16, cev_name_17, cev_name_18, cev_name_19, cev_name_20, ';
                strSql += 'names_chg INTEGER, names_pnd INTEGER, ';
                strSql += 'ev_show_word1 INTEGER, ev_show_word2 INTEGER, ev_show_word3 INTEGER, ev_show_word4 INTEGER);';
                // Note: suspend_scrolling(true, '') already called above in a blanket call for States 2 thru 12 (basically all of initital_startup)
                tx.executeSql (strSql);
                printDebug("Event_Settings_DB table created");
                break;
            case STATE_FOR_PREG_DB:
                strSql = getPregDbCreateStr();
                tx.executeSql (strSql);
                printDebug("Preg_DB table created");
                break;
            case STATE_FOR_GROUPS_DB:
                strSql = getGroupsDbCreateStr();
                tx.executeSql (strSql);
                printDebug("Groups_DB table created");
                // Initialize Groups Table
                initGroupsDbTable(tx);
                printDebug("Groups_DB table init");
                break;                
            case STATE_FOR_CYCLES_DB:
                strSql = 'CREATE TABLE IF NOT EXISTS Cycles_DB (cyc_started INTEGER NOT NULL PRIMARY KEY, ';
                strSql += 'cdata_chg INTEGER, cdata_pnd INTEGER, ';
                strSql += 'cyc_len INTEGER, cyc_lut_len INTEGER, anov INTEGER, all_ov_manual, ';
                strSql += 'all_ov_auto, cyc_ov_cd INTEGER, all_ov_type INTEGER, ';
                strSql += 'bbt_ov, bbt_cv_ov, bbt_ave_ov, bbt_smc_ov, ';
                strSql += 'bbt_orig_ov, bbt_36_ov, bbt_meth INTEGER, lh_ov, ';
                strSql += 'cm_ov, cm_trad_ov, cm_alt_ov, cm_meth INTEGER, ';
                strSql += 'mon_ov, rhy_ov, saliva_ov, certain INTEGER, quality INTEGER, complete INTEGER, ';
                if (BUILD_TARGET == BUILD_4_CCL)
                {
                    strSql += 'cweight INTEGER, cyc_notes, fwb_st INTEGER, fwe_st INTEGER, ';
                    strSql += 'fwb_in INTEGER, fwe_in INTEGER, fwb_man_in INTEGER, fwe_man_in INTEGER, ';
                    strSql += 'fwb_man_st INTEGER, fwe_man_st INTEGER, fwb_vals, fwe_vals, ';
                    strSql += 'pc_short INTEGER, pc_long INTEGER, pc_num_cyc INTEGER, pc_early_trise INTEGER, ';
                    strSql += 'pc_num_tcyc INTEGER, pc_l_mucpat INTEGER, inst_notes, id_txt INTEGER, ';
                }
                strSql += 'fwin_beg, fwin_end, fwin_beg_final INTEGER, fwin_end_final INTEGER, fwin_why, mkr INTEGER);';
                // Note: suspend_scrolling(true, '') already called above in a blanket call for States 2 thru 12 (basically all of initital_startup)
                tx.executeSql (strSql);
                printDebug("Cycles_DB table created");
                break;  
            case STATE_FOR_INTERP_DB:
                strSql = 'CREATE TABLE IF NOT EXISTS Interp_DB (record_date INTEGER NOT NULL PRIMARY KEY, color, cd INTEGER, ';
                strSql += 'dpo INTEGER, preg_cnt INTEGER, rec_test INTEGER, bbt_ov_cl INTEGER, mon_ov INTEGER, cm_ov INTEGER, ';
                strSql += 'all_ov INTEGER, fwin INTEGER, fpct_all INTEGER, fpct_cm INTEGER, fpct_saliva INTEGER, fpct_mon INTEGER, ';
                if (BUILD_TARGET == BUILD_4_CCL)
                {
                    strSql += 'bill_itp, cclst_cov INTEGER, ';
                }
                strSql += 'fpct_bbt INTEGER, fpct_rhy INTEGER, fpct_lh INTEGER, fpct_cervix INTEGER);';
                // Note: suspend_scrolling(true, '') already called above in a blanket call for States 2 thru 12 (basically all of initital_startup)
                tx.executeSql (strSql);
                printDebug("Interp_DB table created");
                break;  
            case STATE_FOR_RESOURCE_DB:
                //strSql = 'CREATE TABLE IF NOT EXISTS Resource_DB (id INTEGER NOT NULL PRIMARY KEY, title, link_desc, res_url);';
                //tx.executeSql (strSql);
                //printDebug("Resource_DB table created");
                break;  
                
            default:
                // Should not happen
                printDebug('Error - Create Database Machine calling default');
                break;
            }
                        
            // Advance to next state to check the next database
            initial_startup(state+1, tx, 0, create);
        }
        
        printDebug('Exiting table_does_not_exist');
        return false;
    }

    function promptForForgotPasswordURL()
    {
        if (global_is_android)
        {
            navigator.app.loadUrl(global_server_prefix + 'forgot.aspx', { openExternal:true } );
        }
        else
        {
            var site_url = 'MyFertilityCharts.com';
            if (BUILD_TARGET == BUILD_4_CCL)
            {
                site_url = 'CyclePro<i>Go</i>.com';
            }
            ShowPopupMessage("You can visit " + site_url + " to try to login or to recover your password. Click the 'Recover Password' link below to go to the password recovery screen.", 'Recover Password', '<a href="' + global_server_prefix + 'forgot.aspx" target="_blank" onclick="return go2url(this);"><span class="divPopLink">Recover Password</span></a>');
        }
        return;
    }
    
    function pw_prompt_try_login()
    {
        if ((document.getElementById('pw_prompt_pw').value == '') || (document.getElementById('pw_prompt_un').value == ''))
        {
            ShowPopupMessage("You must enter your username and password before trying to login.  One of these fields was left blank.  If you forgot your password, you can recover it online using the email address you registered under.", 'Missing Login', '<a href="' + global_server_prefix + 'forgot.aspx" target="_blank" onclick="return go2url(this);"><span class="divPopLink">Recover Password</span></a>');
        }
        else if ((document.getElementById('pw_prompt_pw').value == global_password) && (document.getElementById('pw_prompt_un').value == global_username))
        {
             // Password accepted - prevent future login prompts if disabled, otherwise just run the app
            check_if_disabling_future_pw_checks_and_launch_app(1, '');
        }
        else
        {
            // Login failed - check if password online happens to match instead
            check_password_with_remote_server(1, '');
        }
        return;
    }
    
    function check_if_disabling_future_pw_checks_and_launch_app(state, param_1)
    { 
        var strSql = '';
       
        printDebug("State " + state + " of check_if_disabling_future_pw_checks_and_launch_app");
        switch(state)
        {
        case 1:
           
            // Open database so we can update the local password since it was apparently changed online
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_CheckIfDis_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_CheckIfDis_1 = -1;
                                    check_if_disabling_future_pw_checks_and_launch_app(state+1, tx);
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_CheckIfDis_1 > 0)
                                    {
                                        global_db_ios_fail_CheckIfDis_1 = global_db_ios_fail_CheckIfDis_1 - 1;
                                        printDebug('iOS db.transaction failed check_if_disabling state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_CheckIfDis_1));
                                        check_if_disabling_future_pw_checks_and_launch_app(state, param_1);
                                    }
                                    else if (global_db_ios_fail_CheckIfDis_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            break;
            
        case 2:
            var tx = param_1;
            
            // If they want to disable password checking, then update local database to turn it off
            if (document.getElementById('pw_prompt_remember').checked)
            {
                strSql = 'UPDATE User_Info_DB SET pw_prompt=0 WHERE 1';
                suspend_scrolling(true, '');
                tx.executeSql(  strSql, 
                                [], 
                                function(tx, results) 
                                {
                                    suspend_scrolling(false, 0);
                                },
                                errorCB
                             ); 
            }
            
            // Launch the app or show tip of the day
            checkTipOfDayOrLaunchApp(tx);

            break;
            
        default:
            break;
        }
        return;
    }
    
    function check_password_with_remote_server(state, param_1)
    {
        var strSql = '';
        
        printDebug("State " + state + " of check_password_with_remote_server");
        switch(state)
        {
        case 1:
            // Check if we should even talk to the server
            if (document.getElementById('pw_prompt_un').value != global_username)
            {
                // The user is not allowed to change the username so there is no point in even checking with the remote server
                ShowPopupMessage("The login is incorrect.  Please re-enter it and try again.  If you want to link the app to a different account, uninstall and reinstall it first.", 'Invalid Login', '<a href="' + global_server_prefix + 'forgot.aspx" target="_blank" onclick="return go2url(this);"><span class="divPopLink">Recover Password</span></a>');
                break;
            }
            printStatus('Authenticating');
            
            // Determine device type     
            var url_str = global_server_prefix + 'apps_sign_up.aspx?' + new Date().getTime();
            var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
            
            // Add Name Value Pairs to upload
            uploadParameters['un'] = ReplaceQuotes(document.getElementById('pw_prompt_un').value, 1);
            uploadParameters['pw'] = ReplaceQuotes(document.getElementById('pw_prompt_pw').value, 1);
            uploadParameters['debug'] = global_Debug_Enabled;
            uploadParameters['app_ver'] = global_app_ver_str;
            uploadParameters['device_id'] = global_device_id_str;
            uploadParameters['device_type'] = determine_device_type();
            uploadParameters['create_new'] = '0';

            // Use jQuery to upload the data to the server
            $.ajax({
                type: 'POST',
                // The URL of the request
                url: url_str,
                // Values to upload
                data: uploadParameters,
                // The success callback with result from server
                success: function(newContent) {
                    // Handles response this function and advance to the next state.  Notice that the tx
                    // cannot be passed to this legitimately because it is not being created as a call
                    // to this registered function (it only has a newContent argument) because this 
                    // callback has nothing to do with databases.  Therefore we will have to re-establish
                    // the tx variable when we want to resume database operations.
                    check_password_with_remote_server(state+1, newContent);
                },
                dataType: 'html'
            });
            break;
            
        case 2:
            var newContent = param_1;
            var error_or_warning = CheckForStandardErrors(newContent);
            var desiredStrStart=new Array();
            var desiredStrEnd=new Array();
            var respParamsStr=new Array();
            var continue_execution = 1;

            // Check for server returned status errors
            if ((error_or_warning >= 0) && (error_or_warning != g_LOGIN_INVALID))
            {
                // Only display error if one is found
                continue_execution = HandleServerErrorOrWarning(error_or_warning);
            }
            if (continue_execution == 0)
            {
                // Stop execution because of a fatal error
                printDebug('Halting execution due to server returned error.');
                printStatus('Server Offline?');
                hideStatusSpinner();
                break;
            }
            
            // Itemize fields to look for in server response
            var index_Login_Invalid = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='LOGIN_INVALID';
            desiredStrEnd[desiredStrEnd.length]="";
            
            var index_Login_Ok = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='LOGIN_OK';
            desiredStrEnd[desiredStrEnd.length]="";
            
            // Parse the response to find the desired values
            respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);
            
            // Clear status (under expectation that remaining tasks will take insignificant time)
             printStatus('');
            
            // Check response
            if (respParamsStr[index_Login_Invalid] == '1')
            {
                // Invalid login
                printDebug('Invalid login');
                ShowPopupMessage("The login is incorrect.  Please re-enter it and try again.  If you forgot your password, you can recover it at MyFertilityCharts.com.", 'Invalid Login', '<a href="' + global_server_prefix + 'forgot.aspx" target="_blank" onclick="return go2url(this);"><span class="divPopLink">Recover Password</span></a>');
                break;
            }  
            if (respParamsStr[index_Login_Ok] == '1')
            {
                printDebug('Login okay on remote server only.  Updating local database password.');
                global_password = ReplaceQuotes(document.getElementById('pw_prompt_pw').value, 1);

                // Open database so we can update the local password since it was apparently changed online
                db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
                global_db_ios_checkPw_1 = DB_IOS_RETRY_LIMIT;
                db.transaction(     function(tx) 
                                    {
                                        global_db_ios_checkPw_1 = -1;
                                        check_password_with_remote_server(state+1, tx);
                                    },
                                    errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_checkPw_1 > 0)
                                    {
                                        global_db_ios_checkPw_1 = global_db_ios_checkPw_1 - 1;
                                        printDebug('iOS db.transaction failed check_pw_with_remote state 2. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_checkPw_1));
                                        check_password_with_remote_server(state, param_1);
                                    }
                                    else if (global_db_ios_checkPw_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                               );
                break;
            }  
            // Unexpected case
            ShowPopupMessage("The login could not be authenticated at this time.  Please try again later.", 'Validation Problem', '<a href="' + global_server_prefix + '" target="_blank" onclick="return go2url(this);"><span class="divPopLink">Access Account Online Instead</span></a>');
            break;
            
        case 3:
            var tx = param_1;
            
            // Login was a success.  The user changed their password online.  We need to update it in the local database
            strSql = 'UPDATE User_Info_DB SET pw="' + global_password + '" WHERE 1';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                            },
                            errorCB
                         ); 
            
            // See if we need to disable the password and do so.  Otherwise this just runs the app.
            check_if_disabling_future_pw_checks_and_launch_app(2, tx);

            break;
            
        default:
            break;
        }
    }
    
    function toggleConfirmPWVisible()
    {
        if (document.getElementById('new_user_AccType_New').checked)
        {
            // Need to confirm password so show second box to re-enter it
            document.getElementById('new_user_Confirm_Pw_Div').style.display = 'block';
            document.getElementById('new_user_Email_Div').style.display = 'block';
        }
        else
        {
            // No need to enter password twice if associating, so hide second box
            document.getElementById('new_user_Confirm_Pw_Div').style.display = 'none';
            document.getElementById('new_user_Email_Div').style.display = 'none';
        }
    }
  
    function check_password(state, param_1, param_2)
    {
        var tx = param_1;
        var results = param_2;
        var strSql = '';           

        // Callback State Machine
        printDebug("State " + state + " of check_password");
        switch(state)
        {
        case 1:
            // Check user settings in the User_Info_DB
            strSql = 'SELECT * FROM User_Info_DB;';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                check_password(state+1, tx, results);
                            },
                            function(tx, err)
                            {
                                crash_and_burn(err, 'Error querying local UserInfo database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                            }
                         );
            break;
        case 2:
            // Retrieve results of query
            var len = results.rows.length;
            if (len == 0)
            {
                printDebug("Error - Missing user settings table!");
                printInfoMessage('Error querying local UserInfo database.  Please try again.  If this problem persists, you may want to try going to the settings page and re-associating with your account.');
                break;
            }
            else
            {
                global_SyncInterval = results.rows.item(0)['sync_interval'];
                global_username = results.rows.item(0)['un'];
                global_password = results.rows.item(0)['pw'];
                global_server_prefix = results.rows.item(0)['server_prefix'];
                global_pw_prompt = results.rows.item(0)['pw_prompt'];
                global_remember_username = results.rows.item(0)['remember_username'];
                global_tip_of_day = results.rows.item(0)['tip_of_day_enabled'];
                global_tip_of_day_index = results.rows.item(0)['tip_of_day_index'];
                global_NormalTempTime = results.rows.item(0)['temp_time'];
                global_CalShadeFert = results.rows.item(0)['cal_shade'];
                global_Debug_Enabled = results.rows.item(0)['debug'];
                global_CalOv = results.rows.item(0)['cal_ov'];
                global_svr_info_msg = results.rows.item(0)['svr_info_msg'];
                global_svr_info_msg_shown = results.rows.item(0)['svr_info_msg_shown'];
                global_last_analysis_screen = results.rows.item(0)['last_cycle_screen'];
                global_selected_cycle_as_number = results.rows.item(0)['selected_cycle'];
                global_selected_cycle_end_as_number = results.rows.item(0)['sel_cycle_end'];
                global_EnableRemoteAnalysis = results.rows.item(0)['enable_remote_analysis'];
                if (BUILD_TARGET == BUILD_4_CCL)
                {
                    global_user_height = results.rows.item(0)['height'];
                    global_active_subscription = results.rows.item(0)['sub_ctr'];
                }
                // Disable fields if in catholic mode
                if (results.rows.item(0)['catholic'] == '1')
                {
                    global_catholic_mode = true;
                    toggleCatholicMode();
                }
                else
                {
                    global_catholic_mode = false;
                }
            }
            // Determine what screen to show next
            if (global_pw_prompt)
            {
                // Show the password prompt screen
                TransitionToSubscreen("startup_pw", "none");
            }
            else
            {
                // Run app
                checkTipOfDayOrLaunchApp(tx);
            }
            break;
        default:
            break;
        }
        return;
    }
    
    function new_user_TryLogin(state, param_1, param_2)
    {
        var newContent = param_1;           
		
        // Makes sure that focus returns to the top of the screen so they can see the status messages telling them
        // that authentication is being performed with the remote server.
        window.scrollTo(0,0);
        
        // Callback State Machine
        printDebug("State " + state + " of new_user_TryLogin");
        switch(state)
        {
        case 1:
            // Validate user input
            if ((document.getElementById('new_user_un').value == "") || (document.getElementById('new_user_pw').value == ""))
            {
                ShowPopupMessage("You must specify a username and password to secure your data entered within this app.", 'Missing Login', '');
                printDebug('missing username or password');
            }
            else if ((document.getElementById('new_user_email').value == "") && (document.getElementById('new_user_AccType_New').checked))
            {
                ShowPopupMessage("It is important that you specify a valid email address when creating your account. This is used to help recover your password in case you forget it.  We will never sell your email addresses or personal data.", 'Missing Email', '');
                printDebug('missing email');
            }
            else if ((document.getElementById('new_user_pw_confirm').value != document.getElementById('new_user_pw').value) && (document.getElementById('new_user_AccType_New').checked))
            {
                ShowPopupMessage("You must confirm your password by re-entering it.  The password you retyped does not match what you first entered.", 'Passwords Do Not Match', '');
                printDebug('Passwords do not match');
            }
            else if (global_online_status == false)
            {
                ShowPopupMessage("You must be online to create an account.  Please connect to the internet using wifi or a cellular network and try again.  If you are already connected and receive this message in error, please try closing the app and restarting it again.", 'Device is Offline', '');
                printDebug('Offline so cannot create account!');
            }
            else
            {
                printStatus('Authenticating');
                ShowAct();
                
                printDebug('Input data validated');
                var url_str = global_server_prefix + 'apps_sign_up.aspx?' + new Date().getTime();
                var uploadParameters = {};  // Declare name value pair list to specify values to upload to server
                
                // Add Name Value Pairs to upload
                uploadParameters['un'] = ReplaceQuotes(document.getElementById('new_user_un').value, 1);
                uploadParameters['pw'] = ReplaceQuotes(document.getElementById('new_user_pw').value, 1);
                uploadParameters['query_prefix'] = '1';
                uploadParameters['debug'] = global_Debug_Enabled;
                uploadParameters['app_ver'] = global_app_ver_str;
                uploadParameters['device_id'] = global_device_id_str;

                // Add additional name value pairs to upload if we are trying to create an account
                if (document.getElementById('new_user_AccType_New').checked) 
                {
                    uploadParameters['email'] = ReplaceQuotes(document.getElementById('new_user_email').value, 1);
                    uploadParameters['pw'] = ReplaceQuotes(document.getElementById('new_user_pw').value, 1);
                    if (document.getElementById('new_user_tUnitsRadio_F').checked)
                    {
                        uploadParameters['t_units'] = 'F';
                    }
                    else
                    {
                        uploadParameters['t_units'] = 'C';
                    }
                    uploadParameters['create_new'] = '1';
                    
                    uploadParameters['device_type'] = determine_device_type();
                    if (BUILD_TARGET == BUILD_4_CCL)
                    {
                        uploadParameters['bkgnd'] = ReplaceQuotes(document.getElementById('ReferSelect').value, 1);
                    }
                    else
                    {
                        // Request free trial
                        if (document.getElementById('new_user_trial').checked)
                        {
                            uploadParameters['acc_code'] = '2';
                        }
                        else
                        {
                            uploadParameters['acc_code'] = '1';
                        }
                    }
                }
                else
                {
                    uploadParameters['create_new'] = '0';
                    uploadParameters['device_type'] = determine_device_type();
                }
				
                // Use jQuery to upload the data to the server
                $.ajax({
                    type: 'POST',
                    // The URL of the request
                    url: url_str,
                    // Values to upload
                    data: uploadParameters,
					error: function(w,t,f) {
											    printDebug(w + ' ' + t + ' ' + f);
										   },
                    // The success callback with result from server
                    success: function(newContent) {
                        // Handles response this function and advance to the next state.  Notice that the tx
                        // cannot be passed to this legitimately because it is not being created as a call
                        // to this registered function (it only has a newContent argument) because this 
                        // callback has nothing to do with databases.  Therefore we will have to re-establish
                        // the tx variable when we want to resume database operations.
                        new_user_TryLogin(state+1, newContent, '');
                    },
                    dataType: 'html'
                });
            }
            break;
            
        case 2:
            var error_or_warning = CheckForStandardErrors(newContent);
            var desiredStrStart=new Array();
            var desiredStrEnd=new Array();
            var respParamsStr=new Array();
            var continue_execution = 1;
            
            HideAct_Legacy();
            HideAct();
            
            // Check for server returned status errors
            if ((error_or_warning >= 0) && (error_or_warning != g_LOGIN_INVALID))
            {
                // Only display error if one is found
                continue_execution = HandleServerErrorOrWarning(error_or_warning);
            }
            if (continue_execution == 0)
            {
                // Stop execution because of a fatal error
                printDebug('Halting execution due to server returned error.');
                printStatus('Server Offline?');
                hideStatusSpinner();
                break;
            }

            // Itemize fields to look for in server response
            var index_Username_Not_Avail = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='USERNAME_NOT_AVAIL';
            desiredStrEnd[desiredStrEnd.length]="";
            
            var index_Email_Not_Avail = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='EMAIL_NOT_AVAIL';
            desiredStrEnd[desiredStrEnd.length]="";
            
            var index_Account_Created = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='ACCOUNT_CREATED';
            desiredStrEnd[desiredStrEnd.length]="";
            
            var index_Server_Prefix = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='SERVER_PREFIX=';
            desiredStrEnd[desiredStrEnd.length]=" ";
            
            var index_PW_Reset = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='PW_RESET';
            desiredStrEnd[desiredStrEnd.length]="";
            
            var index_Login_Invalid = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='LOGIN_INVALID';
            desiredStrEnd[desiredStrEnd.length]="";
            
            var index_Login_Ok = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='LOGIN_OK';
            desiredStrEnd[desiredStrEnd.length]="";
            
            var index_CCL_Access_Code_Invalid = desiredStrStart.length;
            desiredStrStart[desiredStrStart.length]='ACC_CODE_INVALID';
            desiredStrEnd[desiredStrEnd.length]="";
               
            // Parse the response to find the desired values
            respParamsStr = parse_server_response(newContent, desiredStrStart, desiredStrEnd);

            // Clear status (under expectation that remaining tasks will take insignificant time)
             printStatus('');
            
            // Scan the responses
            if (respParamsStr[index_Username_Not_Avail] == '1')
            {
                ShowPopupMessage("The username is specified is already taken.  If you already setup this account, please enter the username and password and select that you want to link to an existing account.  Otherwise please enter another username and try again.", 'Username Taken', '');
                printDebug('Username taken');
                break;
            }
            if (respParamsStr[index_Email_Not_Avail] == '1')
            {
                ShowPopupMessage("The email address you specified already has an existing account.  If you want to associate this app with that account, please enter your login information and select the option to link to an existing account, then try again.", 'Email Taken', '');
                printDebug('Email taken');
                break;
            }
            var site_url = 'MyFertilityCharts.com';
            if (BUILD_TARGET == BUILD_4_CCL)
            {
                site_url = 'CyclePro<i>Go</i>.com';
            }
            if (respParamsStr[index_PW_Reset] == '1')
            {
                ShowPopupMessage("The account you are trying to link to has had its password reset due to too many failed attempts to login.  Please visit " + site_url + " and use the forgotten password link to recover your password.", 'Reset Password', '<a href="' + global_server_prefix + 'forgot.aspx" target="_blank" onclick="return go2url(this);"><span class="divPopLink">Recover Password</span></a>');
                printDebug('Password reset');
                break;
            } 
            if (respParamsStr[index_Login_Invalid] == '1')
            {
                printDebug('Invalid login');
                ShowPopupMessage("The username and password you entered is not associated with a valid account at " + site_url + ".  Please re-enter the username and password and try again or setup a new account if you do not already have one.", 'Invalid Password', '<a href="' + global_server_prefix + 'forgot.aspx" target="_blank" onclick="return go2url(this);"><span class="divPopLink">Recover Password</span></a>');
                break;
            }  
            // Look for success
            if ((respParamsStr[index_Account_Created] == '1') || (respParamsStr[index_Login_Ok] == '1'))
            {
                printDebug('Success!');
                
                // Save off global variables for use later by the app after the user agrees to Terms of Use
                if (document.getElementById('new_user_tUnitsRadio_F').checked)
                {
                    global_t_units = 'F';
                }
                else
                {
                    global_t_units = 'C';
                }
                global_user_email = ReplaceQuotes(document.getElementById('new_user_email').value, 1);
                global_username = ReplaceQuotes(document.getElementById('new_user_un').value, 1);
                global_password = ReplaceQuotes(document.getElementById('new_user_pw').value, 1);
                if (document.getElementById('new_user_remember').checked)
                {
                    global_pw_prompt = '0';
                }
                else
                {
                    global_pw_prompt = '1';
                }
                
                // To use the temporary debug site (webedition_stageA), uncomment the following line and change the initial declaration.  
                // This is the line that swaps to use the real site instead of the alternate URL that this is initially defined to use.
                global_server_prefix = respParamsStr[index_Server_Prefix];  
                
                // Warn them that the access code was invalid, but don't prevent them from continuing
                if (respParamsStr[index_CCL_Access_Code_Invalid] == '1')
                {
                    ShowPopupMessage("The CCL user code and access code you provided were not valid or are not associated with the email address you signed up with. You can configure these later by visiting CycleProGo.com and logging in with the same username and password you just specified. In the meantime, you should continue setting up the app.", 'CCL Membership', '');
                    printDebug('CCL Access Code failure');
                }
                
                // Since successful, show the Terms of Use page
                TransitionToSubscreen("startup_tos", "none");
                
                // Android needs to make sure toggle tap is off.  For some reason it still turns itself back on in the Terms of Use screen
                 if (global_is_android)
                 {
                    HeaderAndFooter_Hide();
                    HeaderAndFooter_TapToggle(false);
                    setTimeout("HeaderAndFooter_TapToggle(false);", 1000);
                    setTimeout("HeaderAndFooter_TapToggle(false);", 2500);
                }
            } 
            break;

        default:
            break;
        }
        return;
    }
    
    function tos_Agree()
    {
        // Makes sure that focus returns to the top of the screen so they can see the status messages telling them
        // that authentication is being performed with the remote server.
        window.scrollTo(0,0);
        // Create the database for the user which will run the app upon completion
        ShowAct();
        initial_startup(1, '', 0, 1);
    }
    
    function tos_Decline()
    {
        // Pop up status message
        ShowPopupMessage("You cannot use this app unless you agree to the terms of use and waiver of liability.  Please uninstall the app from your device.", 'Access Denied', '');
    }
    
    function CloseTutorial()
	{
		ShowAct();
        navToMainCalendar(1);
	}
    
	// Functions are called whenever the user selects left or right.  
    function next_tip_of_day(direction)
	{
		global_tip_of_day_index = global_tip_of_day_index + direction;
		load_tipofday(1, '');
	}
    
    function next_tutorial(direction)
    {
        var NUM_TUTORIAL_STEPS = 9;
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            NUM_TUTORIAL_STEPS = 8;
        }
        var cur_step = 0;
        var page_suffix = GetCurrentPage();
        window.scrollTo(0,0);
        
        // Find which is visible
        for (var i=0; i<NUM_TUTORIAL_STEPS; i++)
        {
            if (document.getElementById(page_suffix + '_step' + i).style.display != 'none')
            {
                cur_step = i;
                break;
            }
        }
        
        // Advance and make next one visible
        document.getElementById(page_suffix + '_step' + cur_step).style.display = 'none';
        cur_step = (cur_step + direction + NUM_TUTORIAL_STEPS) % NUM_TUTORIAL_STEPS;
        document.getElementById(page_suffix + '_step' + cur_step).style.display = 'block';
    }

   function load_tipofday(state, tx)
    {
        var NUMBER_OF_TIPS;
		
		switch(BUILD_TARGET)
        {
        case BUILD_4_DOSP:
            NUMBER_OF_TIPS = 250;
            break;
        case BUILD_4_CCL:
            NUMBER_OF_TIPS = 14;
            break;
        case BUILD_4_MFC:
            NUMBER_OF_TIPS = 9;
            break;
        default:
            NUMBER_OF_TIPS = 9;
            break;
        }
        
		switch(state)
        {
        case 1:
            // Open database
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_LoadTipOfDay_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_LoadTipOfDay_1 = -1;
                                    load_tipofday(state+1, tx);
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_LoadTipOfDay_1 > 0)
                                    {
                                        global_db_ios_fail_LoadTipOfDay_1 = global_db_ios_fail_LoadTipOfDay_1 - 1;
                                        printDebug('iOS db.transaction failed load_tipofday state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_LoadTipOfDay_1));
                                        load_tipofday(state, tx);
                                    }
                                    else if (global_db_ios_fail_LoadTipOfDay_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            break;
            
        case 2:
			//Make sure we don't wrap around
			global_tip_of_day_index = ((global_tip_of_day_index) % NUMBER_OF_TIPS);
			if (global_tip_of_day_index < 0)
			{
				global_tip_of_day_index = NUMBER_OF_TIPS - 1;
			}	
			
			// Increment to show the next tip next time. 
            strSql = 'UPDATE User_Info_DB SET tip_of_day_index=' + ((global_tip_of_day_index+1) % NUMBER_OF_TIPS) + ' WHERE 1';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                successCB();
                            },
                            errorCB
                         ); 
            
			// App variations
			switch (BUILD_TARGET)
			{
			case BUILD_4_CCL:
				tipStr = getCCLQuotes(global_tip_of_day_index);
				break;
                
			case BUILD_4_DOSP:
				tipStr = getDaughtersQuotes(global_tip_of_day_index);
				break;
			
			default:
				// Load the tip and display it
				switch(global_tip_of_day_index)
				{
				case 0:
					tipStr = "Record the start of your most recent cycle by clicking on the date your period started on the calendar and then checking the Menstruation box.";
					break;
				case 1:
					tipStr = "After selecting a date, use the arrows at the top of the screen to switch between various symptoms which can be recorded for the given date.";
					break;
				case 2:
					tipStr = "To get the most out of this app, you should record daily symptoms like your basal body temperature, cervical mucus observations, or other daily symptoms.  See the startup tutorial for more information (Connect > Startup Tutorial)";
					break;
				case 3:
                    if (global_is_android)
                    {
                        tipStr = "You can pan left and right to view portions of your chart that may not fit on the screen.";
                    }
                    else
                    {
                        tipStr = "You can swipe your finger left and right to navigate to other screens instead of using the arrows at the top of the app.";
                    }
                    break;
				case 4:
					tipStr = "You can also access your data on your computer at MyFertilityCharts.com.  This is a great way to view and print your charts for reference.";
					break;
				case 5:
					tipStr = "Your significant other can install this same app on their mobile device to see your fertility.  As long as they enter your same username and password when they set it up, they will also be able to view your charts and enter data too.";
					break;
				case 6:
					tipStr = "The 'Sync' button immediately backs up your data on a secure remote server.  This is performed periodically in the background.  Explicitly doing this is useful if you plan to access your data online, on another device, or you want to download updates just made seconds ago on another device.";
					break;
				case 7:
					tipStr = "If you lose your phone, you can also access your data at MyFertilityCharts.com.  When you get a new phone, you can reinstall the app and configure it with your account to regain full access to all data previously recorded on your old phone.  You can change your password too if you are worried about someone using your old phone to gain access.";
					break;
				case 8:
					tipStr = "Can't wait to finish taking your temperature so you can go back to sleep?  Start running the app on your phone and get ready to enter your temperature while you are waiting for the thermometer to finish.  This way you can enter your temperature as soon as it completes and be finished.";
					break;
				case 9:
					tipStr = "Some analysis is done in the cloud.  Synchronization is required and normally happens whenever you view the calendar screen.  You can also force it to happen by pushing the 'Sync' button.  If analysis is not updating right away, make sure you are connected to the internet and use the Sync button to force synchronization.";
					break;
				default:
					tipStr = "Index not found.";
					break;
				}	
			}
            document.getElementById('divTipOfTheDay').innerHTML = tipStr;
        }
        // All done
        return;
    }
    
    function tipofday_ok(state, param_1, param_2)
    {
        var tx = param_1;
        var create = param_2;
        var strSql = '';

        // Callback State Machine
        printDebug("State " + state + " of tipofday_ok");
        switch(state)
        {
        case 1:
            // Only need to update the database if they turn off tips of the day
            if (document.getElementById('tipofday_showCheckbox').checked == true)
            {
                // Run the app: show calendar screen
                TransitionToSubscreen("calendar", "none");
                break;
            }
            
            // Otherwise we must update the database to turn off tips of the day
            
            // Open database
            db = window.openDatabase("Database", "1.0", "MyFertilityCharts Database", 2500000);
            global_db_ios_fail_TipOfDayOk_1 = DB_IOS_RETRY_LIMIT;
            db.transaction(     function(tx) 
                                {
                                    global_db_ios_fail_TipOfDayOk_1 = -1;
                                    tipofday_ok(state+1, tx, '');
                                },
                                errorCB,
                                function(tx)
                                {
                                    // Success callback refires if the iOS bug failed to fire the transaction code because the user scrolled or tapped.
                                    if (global_db_ios_fail_TipOfDayOk_1 > 0)
                                    {
                                        global_db_ios_fail_TipOfDayOk_1 = global_db_ios_fail_TipOfDayOk_1 - 1;
                                        printDebug('iOS db.transaction failed tipofday_ok state 1. Retry #' + (DB_IOS_RETRY_LIMIT - global_db_ios_fail_TipOfDayOk_1));
                                        tipofday_ok(state, param_1, param_2);
                                    }
                                    else if (global_db_ios_fail_TipOfDayOk_1 == 0)
                                    {
                                        printDebug('<font color=Red>Giving up after hitting max retries for iOS db bug.</font>');
                                    }
                                    else
                                    {
                                        successCB();
                                    }
                                }
                           );
            break;
        case 2:
            // Update the database
            var strSql = 'UPDATE User_Info_DB SET tip_of_day_enabled=0 WHERE 1;';
            suspend_scrolling(true, '');
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                suspend_scrolling(false, 0);
                                successCB();
                            },
                            errorCB
                         ); 
            
            // Run the app: show calendar screen
            TransitionToSubscreen("calendar", "none");
            break;
        }
        return;
    }

    function checkTipOfDayOrLaunchApp(tx)
    {
        printDebug('running checkTipOfDayOrLaunchApp');
        if (global_tip_of_day)
        {
            // Show the tip of the day screen
            TransitionToSubscreen("startup_tipofday", "none");
        }
        else
        {
            // Run the app: show calendar screen
            TransitionToSubscreen("calendar", "none");
        }
        return;
    }
    
    function InitPasswordScreen()
    {
        // Pre-load the username if set to do so
        if (global_remember_username)
        {
            document.getElementById('pw_prompt_un').value = global_username;
        }
    }
    function determine_device_type()
    {
        var deviceType = "unknow";
        if (isIOS())
        {
            if (BUILD_TARGET == BUILD_4_DOSP)
            {
                deviceType = "Apl-Da";
            }
            else
            {
                deviceType = "Apple";
            }
        }
        else if(isKindleFire())
        {
            if (BUILD_TARGET == BUILD_4_DOSP)
            {
                deviceType = "Kdl-Da";
            }
            else
            {
                deviceType = "Kindle";
            }
        }
        else if (isAndroid())
        {
            if (BUILD_TARGET == BUILD_4_DOSP)
            {
                deviceType = "Drd-Da";
            }
            else
            {
                deviceType = "Droid";
            }
        }
        return deviceType;
    }
    function get_app_store_url()
    {
        var appStoreUrl = 'http://www.amazon.com/Clocking-Edge-LLC-Fertility-Charts/dp/B0084F03S2/ref=sr_1_1?';
        if (global_is_ios)
        {
            appStoreUrl = 'http://itunes.com/apps/myfertilitycharts';
        }
        else if(isKindleFire())
        {
            appStoreUrl = 'http://www.amazon.com/Clocking-Edge-LLC-Fertility-Charts/dp/B0084F03S2/ref=sr_1_1?';
        }
        else if (global_is_android)
        {
            if (BUILD_TARGET == BUILD_4_CCL)
            {
                appStoreUrl = 'https://play.google.com/store/apps/details?id=com.cycleprogo.ccl&hl=en';
            }
            else
            {
                appStoreUrl = 'https://play.google.com/store/apps/details?id=com.myfertilitycharts.mfc3&hl=en';
            }
        }
        return appStoreUrl;
    }
    
    function getPregDbCreateStr()
    {
        var strSql;
        strSql = 'CREATE TABLE IF NOT EXISTS Preg_DB (preg_started INTEGER NOT NULL PRIMARY KEY, ';
        strSql += 'preg_len INTEGER, preg_status, pdata_chg INTEGER, pdata_pnd INTEGER);';
        return strSql;
    }
    
    function getGroupsDbCreateStr()
    {
        var strSql;
        strSql = 'CREATE TABLE IF NOT EXISTS Groups_DB (id INTEGER NOT NULL PRIMARY KEY, gcode, desc);';
        return strSql;
    }   
    function initGroupsDbTable(tx)
    {
        var strSql;
        strSql = "INSERT INTO Groups_DB (gcode, desc) VALUES ('support','Technical Support');";
        tx.executeSql( strSql );
        if (BUILD_TARGET == BUILD_4_CCL)
        {
            strSql = "INSERT INTO Groups_DB (gcode, desc) VALUES ('askteacher','Ask a Teacher');";
            tx.executeSql( strSql );
        }
    }       
    
    function upgrade_db(previous_version, tx)
    {
        printDebug('upgrading db from ' + previous_version);
        
        // Perform upgrade from v1 to v2 
        if (previous_version <= 2)
        {
            // Add survey tracking ID to user table
            strSql = 'ALTER TABLE User_Info_DB ADD survey_id INTEGER;';
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                //success;
                            },
                            errorCB
                         );
            strSql = 'UPDATE User_Info_DB SET survey_id=0 WHERE 1;';
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                //success;
                            },
                            errorCB
                         );

            // Create pregnancy table
            strSql = getPregDbCreateStr();
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                //success;
                            },
                            errorCB
                         );
                         
            // Create groups table
            strSql = getGroupsDbCreateStr();
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                //success;
                            },
                            errorCB
                         );      
            // Initialize Groups Table
            initGroupsDbTable(tx);

            // Upgrade complete.  Rev DB version
            strSql = 'UPDATE User_Info_DB SET db_ver=2 WHERE 1;';
            tx.executeSql(  strSql, 
                            [], 
                            function(tx, results) 
                            {
                                //success;
                            },
                            errorCB
                         );          
        }
        
        // Perform upgrade from v2 to v3 
        if (previous_version <= 3)
        {
            // future placeholder
        }
    }

 
